/// <reference types="react" />
export interface BasePropsType {
    /**
     * @description 组件额外的 CSS className
     */
    className?: string;
}
export interface BaseFormItemType<V = any> extends BaseFormItemTypeWithoutFocus<V> {
    autoFocus?: boolean;
    tabIndex?: number;
    ref?: React.Ref<{
        focus: () => void;
        blur: () => void;
    }>;
    onFocus?: (v: V) => void;
    onBlur?: (v: V) => void;
}
export interface BaseFormItemTypeWithoutFocus<V = any> {
    id?: string;
    name?: string;
    disabled?: boolean;
    onChange?: (v: V) => void;
}
export interface IH5ClickProps {
    /**
     * @description React 点击事件 使用
     */
    onClick?: (e: React.SyntheticEvent) => void;
}
