// 用于在全局创建组件，如 alert, actionSheet
// 如果是组件渲染模式，则使用 hooks.useContainer
import * as ReactDOM from 'react-dom';
import error from './error';
var singleFlag = {};
// singleFlag, 用于标记全局在同一时间只会显示一个
export default (function (Content, flag) {
  if (flag) {
    if (singleFlag[flag]) {
      error(false, flag, "there is already ".concat(flag, " exist"));
    }
    singleFlag[flag] = true;
  }
  var div = document.createElement('div');
  document.body.appendChild(div);
  var timeout = null;
  function close() {
    if (flag) {
      singleFlag[flag] = undefined;
    }
    if (timeout) {
      clearTimeout(timeout);
    }
    if (div) {
      ReactDOM.unmountComponentAtNode(div);
      if (div.parentNode) {
        div.parentNode.removeChild(div);
      }
    }
  }
  ReactDOM.render(Content, div);
  return close;
});