/**
 * 获取指定元素的滚动偏移值
 * @param id
 */
export declare function getElementScrollOffset(id: string): Promise<{
    scrollLeft: number;
    scrollTop: number;
}>;
/**
 * 获取指定元素的左滚动偏移
 * @param id
 */
export declare function getScrollLeft(id: string): Promise<number>;
/**
 * 获取指定元素的顶部滚动偏移
 * @param id
 */
export declare function getScrollTop(id: string): Promise<number>;
/**
 * 获取指定元素的 rect 值
 * @param id
 */
export declare function getElementBoundingClientRect(id: string): Promise<{
    left: number;
    bottom: number;
    top: number;
    right: number;
    width: number;
    height: number;
    x: number;
    y: number;
} | DOMRect>;
/**
 * 根据指定 Id 获取元素宽度
 * @param id
 */
export declare function getWidth(id: string): Promise<number>;
/**
 * 根据指定 Id 获取元素高度
 * @param id
 */
export declare function getHeight(id: string): Promise<number>;
/**
 * 根据指定 Id 获取元素距离父级元素左侧距离
 * @param id
 */
export declare function getLeft(id: string): Promise<number>;
/**
 * 根据指定 Id 获取元素距离父级元素顶部距离
 * @param id
 */
export declare function getTop(id: string): Promise<number>;
/**
 * 根据指定 Id 获取元素距离父级元素底部距离
 * @param id
 */
export declare function getBottom(id: string): Promise<number>;
/**
 * 根据指定 Id 获取元素距离父级元素右侧距离
 * @param id
 */
export declare function getRight(id: string): Promise<number>;
export declare function getBoundingRect(id: string): Promise<{
    left: number;
    bottom: number;
    top: number;
    right: number;
    width: number;
    height: number;
    x: number;
    y: number;
} | DOMRect>;
