import { Globals } from 'dd-react-spring-web';
import { useSyncExternalStore } from 'use-sync-external-store/shim';
import 'regenerator-runtime/runtime.js';
var reduced = false;
var subscribers = new Set();
function notify() {
  subscribers.forEach(function (subscriber) {
    subscriber();
  });
}
export function reduceMotion() {
  reduced = true;
  notify();
  Globals.assign({
    skipAnimation: true
  });
}
export function restoreMotion() {
  reduced = false;
  notify();
  Globals.assign({
    skipAnimation: false
  });
}
export function isMotionReduced() {
  return reduced;
}
export function useMotionReduced() {
  return useSyncExternalStore(function (onStoreChange) {
    subscribers.add(onStoreChange);
    return function () {
      subscribers["delete"](onStoreChange);
    };
  }, isMotionReduced);
}