var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import React, { useCallback } from 'react';
import classnames from 'classnames';
import Popover from '../popover';
var prefixCls = 'dtm-action-sheet';
var PcActionSheet = function PcActionSheet(props) {
  var options = props.options,
    callback = props.callback,
    children = props.children;
  var _a = __read(React.useState(false), 2),
    visible = _a[0],
    setVisible = _a[1];
  var _b = __read(React.useState(-1), 2),
    selectIdx = _b[0],
    setSelectIdx = _b[1];
  var renderItem = useCallback(function (item, index) {
    var _a;
    var isPure = typeof item === 'string' || /*#__PURE__*/React.isValidElement(item);
    return /*#__PURE__*/React.createElement("div", {
      className: classnames(prefixCls + '-item-desktop', props.className, (_a = {}, _a[prefixCls + '-item-desktop-danger'] = !isPure && item.danger, _a[prefixCls + '-item-desktop-disabled'] = !isPure && item.disabled, _a)),
      onClick: function onClick() {
        if (!isPure && item.disabled) {
          return;
        }
        setVisible(false);
        setSelectIdx(index);
        callback({
          index: index
        });
      }
    }, isPure ? item : item.value);
  }, [callback]);
  return /*#__PURE__*/React.createElement(Popover, {
    placement: 'bottomRight',
    visible: visible,
    onVisibleChange: function onVisibleChange(visible) {
      return setVisible(visible);
    },
    arrow: false,
    overlay: /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-desktop-popover")
    }, options.items.map(function (item, index) {
      return /*#__PURE__*/React.createElement("div", {
        key: index,
        className: props.options.className
      }, renderItem(item, index));
    }))
  }, children && /*#__PURE__*/React.isValidElement(children) && /*#__PURE__*/React.cloneElement(children, {
    extra: selectIdx > -1 ? options.items[selectIdx] : null,
    onClick: function onClick() {
      var _a, _b;
      (_b = (_a = children.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a);
      setVisible(!visible);
    }
  }));
};
export default PcActionSheet;