var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import * as React from 'react';
import classnames from 'classnames';
import Dialog from 'rmc-dialog';
import { promisify, createGlobalElement } from '../_internal';
import { useMobile } from '../hooks';
import './style/index';
import PcActionSheet from './PcActionSheet';
var prefixCls = 'dtm-action-sheet';
var Item = function Item(props) {
  var _a;
  var cls = classnames(props.className, (_a = {}, _a[prefixCls + '-danger'] = !!props.danger, _a[prefixCls + '-disabled'] = !!props.disabled, _a));
  return /*#__PURE__*/React.createElement("div", {
    className: cls,
    onClick: props.onPress
  }, props.children);
};
var closeFn = null;
var renderItem = function renderItem(item, index, cb) {
  var fixedItem = {};
  if (typeof item === 'string' || /*#__PURE__*/React.isValidElement(item)) {
    fixedItem.value = item;
  } else {
    fixedItem = item;
  }
  return /*#__PURE__*/React.createElement(Item, {
    danger: fixedItem.danger,
    disabled: fixedItem.disabled,
    key: index,
    className: prefixCls + '-item',
    onPress: function onPress() {
      return cb(index, fixedItem.disabled);
    }
  }, fixedItem.value);
};
var createActionSheet = function createActionSheet(options, callback, className) {
  var _a;
  var content = /*#__PURE__*/React.createElement(React.Fragment, null, options.title && /*#__PURE__*/React.createElement("div", {
    className: prefixCls + '-title'
  }, options.title), /*#__PURE__*/React.createElement("div", {
    className: prefixCls + '-list'
  }, options.items.map(function (item, i) {
    return renderItem(item, i, cb);
  })), /*#__PURE__*/React.createElement(Item, {
    className: prefixCls + '-cancel',
    onPress: function onPress() {
      return cb(-1);
    }
  }, (_a = options.cancelText) !== null && _a !== void 0 ? _a : '取消'));
  var close = createGlobalElement(
  /*#__PURE__*/
  // @ts-ignore
  React.createElement(Dialog, {
    visible: true,
    title: "",
    footer: "",
    wrapClassName: className,
    prefixCls: prefixCls,
    transitionName: 'dtm-slide-up',
    maskTransitionName: 'dtm-fade',
    onClose: function onClose() {
      return cb(-1);
    },
    maskClosable: options.maskClosable,
    className: options === null || options === void 0 ? void 0 : options.className
  }, content), 'ActionSheet');
  closeFn = function closeFn() {
    close();
    callback({
      index: -1
    });
  };
  function cb(index, disabled) {
    if (disabled) {
      return;
    }
    close();
    callback({
      index: index
    });
  }
};
// type ActionSheetType = React.FC<ActionSheetProps> & {
//   ActionSheet: ActionSheetType;
//   show: CreateActionSheet;
//   close: () => void;
// };
/**
 * JSX 用法兼容 & PC 端调用
 */
var ActionSheet = function ActionSheet(props) {
  var isMobile = useMobile();
  if (isMobile) {
    return /*#__PURE__*/React.createElement("div", {
      onClick: function onClick() {
        return createActionSheet(props.options, props.callback, props.className);
      }
    }, props.children);
  } else {
    return /*#__PURE__*/React.createElement(PcActionSheet, __assign({}, props));
  }
};
ActionSheet.displayName = 'ActionSheet';
export default {
  ActionSheet: ActionSheet,
  show: promisify(createActionSheet),
  close: function close() {
    closeFn === null || closeFn === void 0 ? void 0 : closeFn();
  }
};