import { useEffect, useRef } from 'react';
import useForceUpdate from './useForceUpdate';
import ResponsiveObserve from '../../_internal/responsiveObserve';
function useBreakpoint(refreshOnChange) {
  if (refreshOnChange === void 0) {
    refreshOnChange = true;
  }
  var screensRef = useRef({});
  var forceUpdate = useForceUpdate();
  useEffect(function () {
    var token = ResponsiveObserve.subscribe(function (supportScreens) {
      screensRef.current = supportScreens;
      if (refreshOnChange) {
        forceUpdate();
      }
    });
    return function () {
      return ResponsiveObserve.unsubscribe(token);
    };
  }, []);
  return screensRef.current;
}
export default useBreakpoint;