import React from 'react';
import './style/index';
import { NativeProps } from '../_internal/native-props';
import { AvatarSize } from './SizeContext';
export declare const dtAvatarPrefix: string;
export type AvatarProps = {
    /**
     * @description 图片类头像的资源地址或显示元素
     */
    src?: string | React.ReactNode;
    /**
     * @description 图像无法显示时的替代文本
     */
    nick?: string;
    /**
     * @description 头像尺寸 number | large | small | default | { xs: number, sm: number, ...}
     */
    size?: AvatarSize;
    /**
     * @description 是否允许拖动，仅用于图片类头像
     * @default  false
     */
    draggable?: boolean;
    /**
     * @description CORS属性设置
     */
    crossOrigin?: 'anonymous' | 'use-credentials' | '';
    /**
     * @description 图片加载失败的事件，返回 false 会关闭组件默认的 fallback 行为
     */
    onError?: () => boolean;
} & NativeProps;
declare const Avatar: React.FC<AvatarProps>;
export default Avatar;
