import React from 'react';
import './style/index';
import { dtMobilePrefix } from '../style/index';
import classnames from 'classnames';
import { withNativeProps } from '../_internal/native-props';
import { mergeProps } from '../_internal/with-default-props';
import InternalAvatar from './avatar';
export var dtAvatarPrefix = "".concat(dtMobilePrefix, "-avatar");
var defaultProps = {};
var Avatar = /*#__PURE__*/React.memo(function (p) {
  var props = mergeProps(defaultProps, p);
  var className = props.className,
    src = props.src,
    size = props.size,
    draggable = props.draggable,
    nick = props.nick,
    crossOrigin = props.crossOrigin,
    onError = props.onError;
  var wrapCls = classnames(dtAvatarPrefix, className);
  return withNativeProps(props, /*#__PURE__*/React.createElement(InternalAvatar, {
    prefixCls: dtAvatarPrefix,
    className: wrapCls,
    size: size,
    src: src,
    alt: nick,
    draggable: draggable,
    crossOrigin: crossOrigin,
    onError: onError
  }));
});
Avatar.displayName = 'Avatar';
export default Avatar;