import classNames from 'classnames';
import React from 'react';
import { withNativeProps } from '../_internal/native-props';
import { dtMobilePrefix } from '../style';
var classPrefix = "".concat(dtMobilePrefix, "-badge");
import './style/index';
export var dot = /*#__PURE__*/React.createElement(React.Fragment, null);
export var Badge = function Badge(props) {
  var color = props.color,
    children = props.children;
  var content = React.useMemo(function () {
    var content = props.content,
      text = props.text,
      _a = props.overflowCount,
      overflowCount = _a === void 0 ? 99 : _a;
    if (typeof text === 'number' && overflowCount && text > overflowCount) {
      return "".concat(overflowCount, "+");
    } else if (text) {
      return text;
    }
    return content;
  }, [props.content, props.text, props.overflowCount]);
  var isDot = content === dot || content === undefined;
  var badgeCls = classNames("".concat(classPrefix), !!children && "".concat(classPrefix, "-fixed"), isDot && "".concat(classPrefix, "-dot"), props.bordered && "".concat(classPrefix, "-bordered"));
  var element = content || content === 0 || content === undefined ? withNativeProps(props, /*#__PURE__*/React.createElement("div", {
    className: badgeCls,
    style: {
      '--color': color
    }
  }, !isDot && /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-content")
  }, content))) : null;
  return children ? (/*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(classPrefix, "-wrapper"), props.className),
    style: props.style
  }, children, element)) : element;
};