import React from 'react';
import { prefixCls } from './index';
import RightArrow2Outlined from 'dd-icons/lib/RightArrow2Outlined';
var BreadcrumbItem = function BreadcrumbItem(props) {
  var baseClassName = "".concat(prefixCls, "-item-name");
  var ref = React.useRef(null);
  var href = props.href,
    isLast = props.isLast,
    children = props.children,
    onClick = props.onClick;
  var className = isLast ? "".concat(baseClassName, " ").concat(baseClassName, "-last") : baseClassName;
  var scrollLastItemIntoView = function scrollLastItemIntoView() {
    if (isLast && ref.current) {
      if (ref.current.parentElement) {
        ref.current.parentElement.scrollLeft = ref.current.offsetLeft;
      }
    }
  };
  React.useEffect(function () {
    scrollLastItemIntoView();
  });
  var link = React.useMemo(function () {
    return href && !isLast ? (/*#__PURE__*/React.createElement("a", {
      href: href,
      className: className
    }, children)) : (/*#__PURE__*/React.createElement("div", {
      className: className
    }, /*#__PURE__*/React.createElement("span", null, children)));
  }, [href, isLast, children]);
  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-item"),
    onClick: onClick,
    ref: ref
  }, link, !isLast && /*#__PURE__*/React.createElement(RightArrow2Outlined, {
    className: "".concat(prefixCls, "-item-icon"),
    "aria-label": "right-arrow-icon"
  }));
};
export default BreadcrumbItem;