import React, { cloneElement } from 'react';
import BreadcrumbItem from './BreadcrumbItem';
import './style/index';
import { dtMobilePrefix } from '../style/index';
import classNames from 'classnames';
import { withNativeProps } from '../_internal/native-props';
import { useMobile } from '../hooks';
export var prefixCls = "".concat(dtMobilePrefix, "-breadcrumb");
var Breadcrumb = /*#__PURE__*/React.memo(function (props) {
  var _a;
  var breadcrumbs = props.breadcrumbs,
    children = props.children,
    className = props.className;
  var handleClick = React.useCallback(function (index) {
    if (typeof props.onClick === 'function') {
      props.onClick(index);
    }
  }, []);
  var isMobile = useMobile();
  var crumbs = React.useMemo(function () {
    if (breadcrumbs && breadcrumbs.length > 0) {
      return breadcrumbs.map(function (route, index) {
        return /*#__PURE__*/React.createElement(BreadcrumbItem, {
          key: route,
          isLast: index === breadcrumbs.length - 1,
          onClick: function onClick() {
            return handleClick(index);
          }
        }, route);
      });
    } else if (children) {
      return React.Children.map(children, function (ele, index) {
        if (!ele) {
          return ele;
        }
        return /*#__PURE__*/cloneElement(ele, {
          key: index
        });
      });
    }
  }, [breadcrumbs, children]);
  return withNativeProps(props, /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, " ").concat(className), (_a = {}, _a["".concat(prefixCls, "-desktop")] = !isMobile, _a))
  }, crumbs));
});
Breadcrumb.displayName = 'Breadcrumb';
export default Breadcrumb;