import * as React from 'react';
import './style/index';
import { BasePropsType, IH5ClickProps } from '../_internal/BasePropsType';
import { NativeProps } from '../_internal/native-props';
export declare const dtMobileButtonPrefix: string;
export type ButtonType = 'primary' | 'secondary' | 'danger' | 'link';
export type ButtonSize = 'large' | 'small' | 'middle';
interface IButtonProps extends BasePropsType {
    /**
     * @description 按钮类型
     * @default "secondary"
     */
    type?: 'primary' | 'secondary' | 'danger' | 'link';
    /**
     * @description 按钮Size
     * @default inline 模式下 size 默认为 middle
     */
    size?: 'large' | 'small' | 'middle';
    /**
     * @description 是否禁用状态
     * @default false
     */
    disabled?: boolean;
    /**
     * @description loading状态
     * @default false
     */
    loading?: boolean;
    /**
     * @description 是否设置为行内按钮
     * @default mobile场景下为false，desktop场景下为true
     */
    inline?: boolean;
    /**
     * @description icon 组件
     * @default '-'
     */
    icon?: React.ReactNode | string;
    /**
     * @description html类型，常适用于表单
     */
    htmlType?: 'button' | 'submit' | 'reset';
}
export type ButtonProps = IH5ClickProps & IButtonProps & NativeProps<'--text-color' | '--background-color'>;
declare const Button: React.FC<React.PropsWithChildren<ButtonProps>>;
export default Button;
