var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import './style/index';
import classnames from 'classnames';
import TouchFeedback from 'rmc-feedback';
import Icon from '../icon';
import { dtMobilePrefix } from '../style/index';
import { withNativeProps } from '../_internal/native-props';
import { useMobile } from '../hooks';
export var dtMobileButtonPrefix = "".concat(dtMobilePrefix, "-button");
var hiddenStyle = {
  width: 0,
  height: 0,
  overflow: 'hidden',
  padding: 0,
  margin: 0,
  border: 0
};
var Button = /*#__PURE__*/React.memo(function (props) {
  var _a;
  var isMobile = useMobile();
  var children = props.children,
    className = props.className,
    _b = props.type,
    type = _b === void 0 ? 'secondary' : _b,
    size = props.size,
    _c = props.inline,
    inline = _c === void 0 ? isMobile ? false : true : _c,
    disabled = props.disabled,
    icon = props.icon,
    loading = props.loading,
    _onClick = props.onClick,
    htmlType = props.htmlType,
    restProps = __rest(props, ["children", "className", "type", "size", "inline", "disabled", "icon", "loading", "onClick", "htmlType"]);
  var buttonRef = React.useRef(null);
  var prefixCls = dtMobileButtonPrefix;
  var finalSize = size;
  // inline size 默认为 middle
  if (!finalSize && inline) {
    finalSize = 'middle';
  }
  var iconEl;
  if (loading) {
    iconEl = /*#__PURE__*/React.createElement(Icon, {
      "aria-hidden": "true",
      type: 'loading',
      size: finalSize === 'small' ? 'xxs' : finalSize === 'middle' ? 'xs' : 'md',
      className: "".concat(prefixCls, "-icon")
    });
  } else if (icon) {
    iconEl = icon;
  }
  var wrapCls = classnames(prefixCls, className, (_a = {}, _a["".concat(prefixCls, "-primary")] = type === 'primary', _a["".concat(prefixCls, "-warning")] = type === 'danger', _a["".concat(prefixCls, "-link")] = type === 'link', _a["".concat(prefixCls, "-secondary")] = type === 'secondary', _a["".concat(prefixCls, "-").concat(finalSize)] = finalSize, _a["".concat(prefixCls, "-inline")] = inline, _a["".concat(prefixCls, "-disabled")] = disabled, _a["".concat(prefixCls, "-loading")] = loading, _a["".concat(prefixCls, "-icon")] = !!iconEl, _a["".concat(prefixCls, "-desktop")] = !isMobile, _a));
  return withNativeProps(props,
  /*#__PURE__*/
  // @ts-ignore
  React.createElement(TouchFeedback, {
    activeClassName: "".concat(prefixCls, "-active"),
    disabled: disabled
  }, /*#__PURE__*/React.createElement("a", __assign({
    role: "button",
    className: wrapCls
  }, restProps, {
    onClick: function onClick(e) {
      var _a;
      !disabled && _onClick && _onClick(e);
      !disabled && ((_a = buttonRef.current) === null || _a === void 0 ? void 0 : _a.click());
    },
    "aria-disabled": disabled
  }), iconEl, /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-text")
  }, children), htmlType && (/*#__PURE__*/React.createElement("button", {
    ref: function ref(el) {
      return buttonRef.current = el;
    },
    onClick: function onClick(e) {
      return e.stopPropagation();
    },
    style: hiddenStyle,
    type: htmlType
  })))));
});
Button.displayName = 'Button';
export default Button;