var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var __spreadArray = this && this.__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { forwardRef, useImperativeHandle } from 'react';
import { convertPageToDayjs, convertValueToRange } from './convert';
import { withNativeProps } from '../_internal/native-props';
import { mergeProps } from '../_internal/with-default-props';
import { dtMobilePrefix } from '../style';
import classNames from 'classnames';
import dayjs from 'dayjs';
import isoWeek from 'dayjs/plugin/isoWeek';
import { useConfig } from '../config-provider';
import './style/index';
import { usePropsValue } from '../_internal/use-props-value';
import { DownArrow2Outlined, LeftArrow2Outlined, RightArrow2Outlined } from 'dd-icons';
import RMCMultiPicker from 'rmc-picker/lib/MultiPicker';
import RMCPicker from 'rmc-picker/lib/Picker';
import { DateManager, Mode } from '../_internal/getDate';
dayjs.extend(isoWeek);
export var ModeType;
(function (ModeType) {
  ModeType["YEAR"] = "year";
  ModeType["MONTH"] = "month";
  ModeType["DAY"] = "day";
})(ModeType || (ModeType = {}));
var prefixCls = "".concat(dtMobilePrefix, "-calendar");
var defaultProps = {
  weekStartsOn: 'Sunday',
  defaultValue: null,
  allowClear: true
  // prevMonthButton: <ArrowLeft />,
  // prevYearButton: <ArrowLeftDouble />,
  // nextMonthButton: <ArrowLeft />,
  // nextYearButton: <ArrowLeftDouble />,
};
var Calendar = /*#__PURE__*/forwardRef(function (p, ref) {
  var props = mergeProps(defaultProps, p);
  var today = dayjs();
  var _a = __read(usePropsValue({
      value: props.value === undefined ? undefined : convertValueToRange(props.selectionMode, props.value),
      defaultValue: convertValueToRange(props.selectionMode, props.defaultValue),
      onChange: function onChange(v) {
        var _a, _b;
        if (props.selectionMode === 'single') {
          (_a = props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, v ? v[0] : null);
        } else if (props.selectionMode === 'range') {
          (_b = props.onChange) === null || _b === void 0 ? void 0 : _b.call(props, v);
        }
      }
    }), 2),
    dateRange = _a[0],
    setDateRange = _a[1];
  React.useEffect(function () {
    if (props.value === undefined) {
      setDateRange(null);
      setCurrent(dayjs().date(1));
    }
  }, [props.value]);
  var _b = __read(React.useState(function () {
      return dayjs(dateRange ? dateRange[0] : today).date(1);
    }), 2),
    current = _b[0],
    setCurrent = _b[1];
  useImperativeHandle(ref, function () {
    return {
      jumpTo: function jumpTo(pageOrPageGenerator) {
        var page;
        if (typeof pageOrPageGenerator === 'function') {
          page = pageOrPageGenerator({
            year: current.year(),
            month: current.month() + 1
          });
        } else {
          page = pageOrPageGenerator;
        }
        setCurrent(convertPageToDayjs(page));
      },
      jumpToToday: function jumpToToday() {
        setCurrent(dayjs().date(1));
      }
    };
  });
  var _c = __read(React.useState(false), 2),
    intermediate = _c[0],
    setIntermediate = _c[1];
  var _d = __read(React.useState(ModeType.DAY), 2),
    mode = _d[0],
    setMode = _d[1];
  var wrapCls = classNames(prefixCls, props.className);
  var locale = useConfig().locale;
  var dateManager = React.useRef();
  var markItems = __spreadArray([], __read(locale.Calendar.markItems), false);
  if (props.weekStartsOn === 'Sunday') {
    var item = markItems.pop();
    if (item) markItems.unshift(item);
  }
  var maxDay = React.useMemo(function () {
    return props.max && dayjs(props.max);
  }, [props.max]);
  var minDay = React.useMemo(function () {
    return props.min && dayjs(props.min);
  }, [props.min]);
  var handlePageChange = React.useCallback(function (action, num, type) {
    var _a;
    var nxtCurrent = current[action](num, type);
    if (action === 'subtract' && props.minPage) {
      var minPage = convertPageToDayjs(props.minPage);
      if (nxtCurrent.isBefore(minPage, type)) {
        return;
      }
    }
    if (action === 'add' && props.maxPage) {
      var maxPage = convertPageToDayjs(props.maxPage);
      if (nxtCurrent.isAfter(maxPage, type)) {
        return;
      }
    }
    if (props.selectionMode === 'single' && !props.ignorePageChanged) {
      (_a = props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, nxtCurrent.toDate());
    }
    setCurrent(nxtCurrent);
  }, [current, props.maxPage, props.minPage, props.ignorePageChanged]);
  var renderLabel = React.useCallback(function (isBegin, isEnd, date) {
    if (props.renderLabel) return props.renderLabel(date, isBegin, isEnd);else if (props.selectionMode === 'range') {
      if (isBegin) {
        return locale.Calendar.begin;
      } else if (isEnd) {
        return locale.Calendar.end;
      }
    }
  }, [props.renderLabel, props.selectionMode]);
  var renderCells = function renderCells() {
    var cells = [];
    var iterator = current.subtract(current.isoWeekday(), 'day');
    if (props.weekStartsOn === 'Monday') {
      iterator = iterator.add(1, 'day');
    }
    var _loop_1 = function _loop_1() {
      var _a;
      var d = iterator;
      var isSelect = false;
      var isBegin = false;
      var isEnd = false;
      var isSelectRowBegin = false;
      var isSelectRowEnd = false;
      if (dateRange) {
        var _b = __read(dateRange, 2),
          begin = _b[0],
          end = _b[1];
        isBegin = d.isSame(begin, 'day');
        isEnd = d.isSame(end, 'day');
        isSelect = isBegin || isEnd || d.isAfter(begin, 'day') && d.isBefore(end, 'day');
        if (isSelect) {
          isSelectRowBegin = (cells.length % 7 === 0 || d.isSame(d.startOf('month'), 'day')) && !isBegin;
          isSelectRowEnd = (cells.length % 7 === 6 || d.isSame(d.endOf('month'), 'day')) && !isEnd;
        }
      }
      var inThisMonth = d.month() === current.month();
      var disabled = props.shouldDisableDate ? props.shouldDisableDate(d.toDate()) : maxDay && d.isAfter(maxDay, 'day') || minDay && d.isBefore(minDay, 'day');
      var isFuture = d.isAfter(today, 'day');
      cells.push(/*#__PURE__*/React.createElement("div", {
        key: d.valueOf(),
        className: classNames("".concat(prefixCls, "-cell"), disabled && "".concat(prefixCls, "-cell-disabled"), !inThisMonth && "".concat(prefixCls, "-cell-not-in-view"), props.enableDisabledFuture && isFuture && "".concat(prefixCls, "-cell-future-disabled"), inThisMonth && (_a = {}, _a["".concat(prefixCls, "-cell-today")] = d.isSame(today, 'day') && !isSelect, _a["".concat(prefixCls, "-cell-selected")] = isSelect, _a["".concat(prefixCls, "-cell-selected-begin")] = isBegin, _a["".concat(prefixCls, "-cell-selected-end")] = isEnd, _a["".concat(prefixCls, "-cell-selected-row-begin")] = isSelectRowBegin, _a["".concat(prefixCls, "-cell-selected-row-end")] = isSelectRowEnd, _a)),
        onClick: function onClick() {
          if (!props.selectionMode) return;
          if (disabled) return;
          var date = d.toDate();
          if (!inThisMonth) {
            setCurrent(d.clone().date(1));
          }
          function shouldClear() {
            if (!props.allowClear) return false;
            if (!dateRange) return false;
            var _a = __read(dateRange, 2),
              begin = _a[0],
              end = _a[1];
            return d.isSame(begin, 'date') && d.isSame(end, 'day');
          }
          if (props.selectionMode === 'single') {
            if (props.allowClear && shouldClear()) {
              setDateRange(null);
              return;
            }
            setDateRange([date, date]);
          } else if (props.selectionMode === 'range') {
            if (!dateRange) {
              setDateRange([date, date]);
              setIntermediate(true);
              return;
            }
            if (shouldClear()) {
              setDateRange(null);
              setIntermediate(false);
              return;
            }
            if (intermediate) {
              var another = dateRange[0];
              setDateRange(another > date ? [date, another] : [another, date]);
              setIntermediate(false);
            } else {
              setDateRange([date, date]);
              setIntermediate(true);
            }
          }
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-cell-label")
      }, renderLabel(isBegin, isEnd, d.toDate())), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-cell-date")
      }, props.renderDate ? props.renderDate(d.toDate()) : d.isSame(today, 'day') && !isSelect ? (/*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-cell-date-today")
      }, locale.Calendar.renderToday(d.date()))) : d.date())));
      iterator = iterator.add(1, 'day');
    };
    while (cells.length < 6 * 7) {
      _loop_1();
    }
    return cells;
  };
  var handleScrollChange = React.useCallback(function (v) {
    var year = v[0];
    var month = v[1];
    var curYear = current.year();
    var curMonth = current.month();
    var changeMonth = function changeMonth() {
      if (month > curMonth) {
        handlePageChange('add', month - curMonth, 'month');
      } else if (month < curMonth) {
        handlePageChange('subtract', curMonth - month, 'month');
      }
    };
    if (year > curYear) {
      handlePageChange('add', year - curYear, 'year');
      changeMonth();
    } else if (year < curYear) {
      handlePageChange('subtract', curYear - year, 'year');
      changeMonth();
    } else {
      changeMonth();
    }
  }, [current]);
  var _e = React.useMemo(function () {
      if (dateManager.current === undefined) {
        dateManager.current = new DateManager({
          minDate: props.min,
          maxDate: props.max
        });
      }
      return dateManager.current.getValueCols(current.toDate(), Mode.MONTH, false, locale, prefixCls, false);
    }, [props.min, props.max, current, prefixCls]),
    value = _e.value,
    cols = _e.cols;
  var isCurrentMonth = current.isSame(today, 'month');
  var header = /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-header")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-title"),
    onClick: function onClick() {
      return setMode(function (mode) {
        return mode === ModeType.MONTH ? ModeType.DAY : ModeType.MONTH;
      });
    }
  }, locale.Calendar.renderYearAndMonth(current.year(), current.month() + 1), mode === ModeType.MONTH ? (/*#__PURE__*/React.createElement(DownArrow2Outlined, {
    className: "".concat(prefixCls, "-header-operate")
  })) : (/*#__PURE__*/React.createElement(RightArrow2Outlined, {
    className: "".concat(prefixCls, "-header-operate")
  }))), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-operate")
  }, /*#__PURE__*/React.createElement(LeftArrow2Outlined, {
    className: "".concat(prefixCls, "-header-operate"),
    onClick: function onClick() {
      return handlePageChange('subtract', 1, 'month');
    }
  }), /*#__PURE__*/React.createElement(RightArrow2Outlined, {
    className: "".concat(prefixCls, "-header-operate ").concat(isCurrentMonth && props.enableDisabledFuture ? 'disabled' : ''),
    onClick: function onClick() {
      if (isCurrentMonth && props.enableDisabledFuture) return;
      handlePageChange('add', 1, 'month');
    }
  })));
  var mark = /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-mark")
  }, markItems.map(function (item, index) {
    return /*#__PURE__*/React.createElement("div", {
      key: index,
      className: "".concat(prefixCls, "-mark-cell")
    }, item);
  }));
  var body = /*#__PURE__*/React.createElement(React.Fragment, null, mode === ModeType.DAY ? (/*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-cells"), props.selectionMode === 'range' && "".concat(prefixCls, "-cells-range-select"))
  }, renderCells())) : (/*#__PURE__*/React.createElement(RMCMultiPicker, {
    style: {
      flexDirection: 'row',
      alignItems: 'center',
      display: 'flex'
    },
    prefixCls: "".concat(prefixCls, "-multi-picker"),
    onScrollChange: handleScrollChange,
    selectedValue: [current.year(), current.month()]
  }, cols.map(function (col, index) {
    return /*#__PURE__*/React.createElement(RMCPicker, {
      key: col.key,
      style: {
        flex: 1
      },
      prefixCls: "".concat(dtMobilePrefix, "-picker-col")
    }, col.props.children.map(function (item) {
      return /*#__PURE__*/React.createElement(RMCPicker.Item, {
        key: item.value,
        value: Number(item.value)
      }, item.label);
    }));
  }))));
  return withNativeProps(props, /*#__PURE__*/React.createElement("div", {
    className: wrapCls
  }, props.renderHeader === undefined ? header : props.renderHeader(handlePageChange), mode === ModeType.DAY && mark, body, props.renderFooter && props.renderFooter()));
});
Calendar.displayName = 'Calendar';
export default Calendar;