var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import classnames from 'classnames';
import React from 'react';
import ReactCarousel from 'rmc-nuka-carousel';
var Carousel = /** @class */function (_super) {
  __extends(Carousel, _super);
  function Carousel(props) {
    var _this = _super.call(this, props) || this;
    _this.onChange = function (index) {
      _this.setState({
        selectedIndex: index
      }, function () {
        if (_this.props.afterChange) {
          _this.props.afterChange(index);
        }
      });
    };
    _this.state = {
      selectedIndex: _this.props.selectedIndex
    };
    return _this;
  }
  Carousel.prototype.render = function () {
    var _a;
    var _b = this.props,
      infinite = _b.infinite,
      selectedIndex = _b.selectedIndex,
      beforeChange = _b.beforeChange,
      afterChange = _b.afterChange,
      dots = _b.dots,
      restProps = __rest(_b, ["infinite", "selectedIndex", "beforeChange", "afterChange", "dots"]);
    var prefixCls = restProps.prefixCls,
      dotActiveStyle = restProps.dotActiveStyle,
      dotStyle = restProps.dotStyle,
      className = restProps.className,
      vertical = restProps.vertical;
    var newProps = __assign(__assign({}, restProps), {
      wrapAround: infinite,
      slideIndex: selectedIndex,
      beforeSlide: beforeChange
    });
    var Decorators = [];
    if (dots) {
      Decorators = [{
        component: function component(_a) {
          var slideCount = _a.slideCount,
            slidesToScroll = _a.slidesToScroll,
            currentSlide = _a.currentSlide;
          var arr = [];
          for (var i = 0; i < slideCount; i += slidesToScroll) {
            arr.push(i);
          }
          var dotDom = arr.map(function (index) {
            var _a;
            var dotCls = classnames("".concat(prefixCls, "-wrap-dot"), (_a = {}, _a["".concat(prefixCls, "-wrap-dot-active")] = index === currentSlide, _a));
            var currentDotStyle = index === currentSlide ? dotActiveStyle : dotStyle;
            return /*#__PURE__*/React.createElement("div", {
              className: dotCls,
              key: index
            }, /*#__PURE__*/React.createElement("span", {
              style: currentDotStyle
            }));
          });
          return /*#__PURE__*/React.createElement("div", {
            className: "".concat(prefixCls, "-wrap")
          }, dotDom);
        },
        position: 'BottomCenter'
      }];
    }
    var wrapCls = classnames(prefixCls, className, (_a = {}, _a["".concat(prefixCls, "-vertical")] = vertical, _a));
    return /*#__PURE__*/React.createElement(ReactCarousel, __assign({}, newProps, {
      className: wrapCls,
      decorators: Decorators,
      afterSlide: this.onChange
    }));
  };
  Carousel.defaultProps = {
    prefixCls: 'am-carousel',
    dots: true,
    arrows: false,
    autoplay: false,
    infinite: false,
    cellAlign: 'center',
    selectedIndex: 0,
    dotStyle: {},
    dotActiveStyle: {}
  };
  return Carousel;
}(React.Component);
export default Carousel;