var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import * as React from 'react';
import classnames from 'classnames';
import { useControlledByChecked } from '../hooks';
import { Labelable } from '../rmc';
import { getDataAttr } from '../_internal';
import SelectedMiniOutlined from 'dingtalk-design-icons/lib/SelectedMiniOutlined';
import SquareHalfMiniOutlined from 'dingtalk-design-icons/lib/SquareHalfMiniOutlined';
import { GroupContext } from './Group';
import { useMobile } from '../hooks';
var Checkbox = function Checkbox(props) {
  var _a;
  var _b, _c;
  var className = props.className,
    prefixCls = props.prefixCls,
    disabled = props.disabled,
    indeterminate = props.indeterminate;
  var checkboxGroup = React.useContext(GroupContext);
  var onGroupChange = function onGroupChange(bingo) {
    var _a;
    (_a = checkboxGroup === null || checkboxGroup === void 0 ? void 0 : checkboxGroup.onChange) === null || _a === void 0 ? void 0 : _a.call(checkboxGroup, props.value, bingo);
  };
  // hack，in checkbox, controlled/uncontrolled value mean checked
  var _d = useControlledByChecked(__assign({
      checked: ((_b = checkboxGroup === null || checkboxGroup === void 0 ? void 0 : checkboxGroup.checkedValues) === null || _b === void 0 ? void 0 : _b.indexOf) && ((_c = checkboxGroup === null || checkboxGroup === void 0 ? void 0 : checkboxGroup.checkedValues) === null || _c === void 0 ? void 0 : _c.indexOf(props.value)) !== -1,
      onChange: (checkboxGroup === null || checkboxGroup === void 0 ? void 0 : checkboxGroup.onChange) && onGroupChange
    }, props)),
    checked = _d.checked,
    onChange = _d.onChange;
  var handleLableChange = function handleLableChange(e) {
    var v = e.target.checked;
    onChange(v);
  };
  var checkboxIcon = null;
  var isMobile = useMobile();
  if (isMobile) {
    var checkboxInnerIcon = null;
    if (indeterminate) {
      checkboxInnerIcon = /*#__PURE__*/React.createElement(SquareHalfMiniOutlined, {
        className: classnames("".concat(prefixCls, "-indeterminate-icon"), {
          disabled: disabled
        })
      });
    } else if (checked) {
      checkboxInnerIcon = /*#__PURE__*/React.createElement(SelectedMiniOutlined, {
        className: classnames("".concat(prefixCls, "-checked-icon"), {
          disabled: disabled
        })
      });
    }
    checkboxIcon = /*#__PURE__*/React.createElement("div", {
      className: classnames("".concat(prefixCls, "-icon"), {
        disabled: disabled,
        checked: checked || indeterminate
      })
    }, checkboxInnerIcon);
  } else {
    checkboxIcon = /*#__PURE__*/React.createElement("span", {
      className: classnames('dtd-checkbox-inner', {
        'dtd-checkbox-inner-checked': checked,
        'dtd-checkbox-inner-indeterminate': indeterminate,
        'dtd-checkbox-inner-disabled': disabled
      })
    });
  }
  return /*#__PURE__*/React.createElement("div", __assign({
    className: classnames(prefixCls, className, (_a = {}, _a["".concat(prefixCls, "-desktop")] = !isMobile, _a))
  }, getDataAttr(props)), /*#__PURE__*/React.createElement(Labelable, __assign({
    onChange: handleLableChange
  }, Labelable.getProps(props), {
    checked: checked,
    value: props.value,
    type: "checkbox",
    name: props.name || (checkboxGroup === null || checkboxGroup === void 0 ? void 0 : checkboxGroup.name)
  }), checkboxIcon, !!props.children && /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-text")
  }, props.children)));
};
Checkbox.displayName = 'Checkbox';
Checkbox.defaultProps = {
  defaultChecked: false
};
export default Checkbox;