var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import * as React from 'react';
import classnames from 'classnames';
import List from '../list';
import { getDataAttr } from '../_internal';
import Checkbox from './Checkbox';
import { GroupContext } from './Group';
import { dtMobileCheckboxItemPrefix as prefixCls, dtMobileCheckboxPrefix } from '../style/index';
export var Item = function Item(props) {
  var cls = classnames(prefixCls, props.className);
  var context = React.useContext(GroupContext);
  var disabled = React.useMemo(function () {
    if ((context === null || context === void 0 ? void 0 : context.disabled) === undefined) {
      return props.disabled;
    }
    if ((context === null || context === void 0 ? void 0 : context.disabled) !== props.disabled) {
      return context === null || context === void 0 ? void 0 : context.disabled;
    }
  }, [context, props.disabled]);
  return /*#__PURE__*/React.createElement("label", __assign({
    className: cls
  }, getDataAttr(props)), /*#__PURE__*/React.createElement(List.Item, {
    className: "".concat(prefixCls, "-item"),
    disabled: disabled,
    hideDivider: props.hideDivider,
    thumb: /*#__PURE__*/React.createElement(Checkbox, {
      value: props.value,
      disabled: disabled || props.disabled,
      id: props.id,
      prefixCls: dtMobileCheckboxPrefix
    })
  }, props.children));
};
Item.displayName = 'CheckboxItem';
export default Item;