import React from 'react';
import './style/index';
import { NativeProps } from '../_internal/native-props';
export declare const dtMobileCollapsePrefix: string;
export type CollapseProps = {
    /**
     * @description 手风琴模式
     * @default false
     */
    according?: boolean;
    /**
     * @description 默认展开面板的key。手风琴模式: string | null。非手风琴模式: string[]
     */
    defaultActiveKey?: string | string[];
    /**
     * @description 当前展开面板的key。手风琴模式: string | null。非手风琴模式: string[]
     */
    activeKey?: string | string[];
    /**
     * @description 切换面板时触发
     */
    onChange?: (activeKey: string | string[]) => void;
} & NativeProps;
declare const Collapse: React.FC<CollapseProps>;
export default Collapse;
