var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var __spreadArray = this && this.__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
import React from 'react';
import './style/index';
import { dtMobilePrefix } from '../style/index';
import { withNativeProps } from '../_internal/native-props';
import classnames from 'classnames';
import { usePropsValue } from '../_internal/use-props-value';
export var dtMobileCollapsePrefix = "".concat(dtMobilePrefix, "-collapse"); // 设置折叠面板样式前缀
var Collapse = /*#__PURE__*/React.memo(function (props) {
  var children = props.children,
    according = props.according,
    defaultActiveKey = props.defaultActiveKey,
    activeKey = props.activeKey,
    onChange = props.onChange;
  var prefixCls = dtMobileCollapsePrefix;
  var _a = __read(usePropsValue({
      value: activeKey,
      defaultValue: defaultActiveKey ? defaultActiveKey : according ? '' : [],
      onChange: onChange
    }), 2),
    currentActiveKey = _a[0],
    setCurrentActiveKey = _a[1];
  var handlePanelCollapse = function handlePanelCollapse(key, collapse) {
    if (according) {
      // 手风琴模式，所有的非当前项的都折叠
      collapse && setCurrentActiveKey('');
      !collapse && setCurrentActiveKey(key);
    } else {
      // 普通模式下，仅仅改变当前index对应的列表的状态就可以
      if (collapse) {
        if (typeof currentActiveKey !== 'string') {
          setCurrentActiveKey(currentActiveKey === null || currentActiveKey === void 0 ? void 0 : currentActiveKey.filter(function (item) {
            return item !== key;
          }));
        }
      } else {
        if (typeof currentActiveKey !== 'string' && currentActiveKey) {
          setCurrentActiveKey(__spreadArray(__spreadArray([], __read(currentActiveKey), false), [key], false));
        }
      }
    }
  };
  return withNativeProps(props, /*#__PURE__*/React.createElement("div", null, React.Children.map(children, function (child, index) {
    var _a;
    if (!child) return;
    var wrapCls = classnames("".concat(prefixCls, "-panelContainer"), (_a = {}, _a["".concat(prefixCls, "-panelContainer-first")] = index === 0, _a));
    return /*#__PURE__*/React.createElement("div", {
      className: wrapCls,
      key: child.key
    }, /*#__PURE__*/React.cloneElement(child, {
      onCollapse: function onCollapse(collapse) {
        return handlePanelCollapse(child.key, collapse);
      },
      collapse: according ? currentActiveKey !== child.key : !(currentActiveKey === null || currentActiveKey === void 0 ? void 0 : currentActiveKey.includes(child.key))
    }));
  })));
});
Collapse.displayName = 'Collapse';
export default Collapse;