var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import React, { useState, useRef, useEffect } from 'react';
import { dtMobilePrefix } from '../style/index';
import { withNativeProps } from '../_internal/native-props';
import DownArrow2Outlined from 'dd-icons/lib/DownArrow2Outlined';
import classnames from 'classnames';
import { useMobile } from '../hooks';
export var dtMobileCollapsePrefix = "".concat(dtMobilePrefix, "-collapse"); // 设置折叠面板样式前缀
export var Panel = /*#__PURE__*/React.memo(function (props) {
  var _a, _b, _c, _d;
  var children = props.children,
    title = props.title,
    collapse = props.collapse,
    onCollapse = props.onCollapse,
    icon = props.icon,
    disabled = props.disabled,
    onClick = props.onClick,
    arrow = props.arrow;
  var prefixCls = dtMobileCollapsePrefix; // 样式前缀的缩写
  var _e = __read(useState(0), 2),
    height = _e[0],
    setHeight = _e[1];
  var contentRef = useRef(null);
  var isMobile = useMobile();
  useEffect(function () {
    contentRef.current ? setHeight(contentRef.current.offsetHeight) : setHeight(0);
  });
  var handleCollapse = function handleCollapse(e) {
    onCollapse && onCollapse(!collapse); // 向父组件传递折叠状态的改变
    onClick && onClick(e);
  };
  var wrapCls = classnames("".concat(prefixCls, "-panel"), (_a = {}, _a["".concat(prefixCls, "-panel-disabled")] = disabled, _a));
  return withNativeProps(props, /*#__PURE__*/React.createElement("div", {
    className: wrapCls
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames("".concat(prefixCls, "-header"), (_b = {}, _b["".concat(prefixCls, "-header-pc")] = !isMobile, _b)),
    onClick: disabled ? undefined : handleCollapse
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-header-left")
  }, icon && (/*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-header-icon")
  }, typeof icon === 'function' ? icon() : icon)), title), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-header-right")
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames("".concat(prefixCls, "-arrow"), (_c = {}, _c["".concat(prefixCls, "-arrow-rotate")] = !collapse, _c))
  }, !arrow && /*#__PURE__*/React.createElement(DownArrow2Outlined, null), arrow && typeof arrow !== 'function' && arrow), arrow && typeof arrow === 'function' && (/*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-arrow")
  }, arrow(collapse))))), /*#__PURE__*/React.createElement("div", {
    className: classnames("".concat(prefixCls, "-content-box")),
    style: {
      height: collapse ? '0px' : "".concat(height, "px")
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames("".concat(prefixCls, "-content"), (_d = {}, _d["".concat(prefixCls, "-content-pc")] = !isMobile, _d)),
    ref: contentRef
  }, children))));
});
Panel.displayName = 'Collapse.Panel';
export default Panel;