var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import React, { useContext } from 'react';
import zhCN from '../locales/zh_CN';
export var defaultConfigRef = {
  current: {
    locale: zhCN,
    config: {
      adapt: true
    }
  }
};
export function setDefaultConfig(p) {
  var _a = p.config,
    config = _a === void 0 ? getDefaultConfig().config : _a,
    _b = p.locale,
    locale = _b === void 0 ? getDefaultConfig().locale : _b;
  defaultConfigRef.current = {
    locale: locale,
    config: config
  };
}
;
export function getDefaultConfig() {
  return defaultConfigRef.current;
}
;
var ConfigContext = /*#__PURE__*/React.createContext(null);
export var ConfigProvider = function ConfigProvider(props) {
  var _a = props.config,
    config = _a === void 0 ? getDefaultConfig().config : _a,
    _b = props.locale,
    locale = _b === void 0 ? getDefaultConfig().locale : _b;
  var children = props.children;
  var parentConfig = useConfig();
  return /*#__PURE__*/React.createElement(ConfigContext.Provider, {
    value: __assign(__assign({}, parentConfig), {
      locale: locale,
      config: config
    })
  }, children);
};
export function useConfig() {
  var _a;
  return (_a = useContext(ConfigContext)) !== null && _a !== void 0 ? _a : getDefaultConfig();
}