var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
/* tslint:disable:jsx-no-multiline-js */
import React from 'react';
import RCDatePicker from '../rmc/DatePicker';
import PopupDatePicker from '../rmc/DatePicker/Popup';
import CloseOutlined from 'dingtalk-design-icons/lib/CloseOutlined';
import zh_CN from './locale/zh_CN';
import { dtPickerPrefix, dtMobilePrefix } from '../style/index';
import { formatFn } from './utils';
import Popover from '../popover';
import './style';
import PcikerPanel from 'rc-picker/lib/PickerPanel';
import generateConfig from 'rc-picker/lib/generate/dateFns';
import { usePropsValue } from '../_internal/use-props-value';
import RightArrow2Outlined from 'dd-icons/lib/RightArrow2Outlined';
import { useMobile } from '../hooks';
import en_US from './locale/en_US';
export { isUntilNowDate } from '../rmc/DatePicker';
var datePickerPrefix = "".concat(dtMobilePrefix, "-date-picker");
var DateFormInnerNode = function DateFormInnerNode(props) {
  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(datePickerPrefix, "-form-inner-node"),
    onClick: props.onClick
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(datePickerPrefix, "-form-inner-node-content")
  }, props.extra), /*#__PURE__*/React.createElement(RightArrow2Outlined, {
    className: "".concat(datePickerPrefix, "-form-inner-node-arrow")
  }));
};
var blockEvent = function blockEvent(e) {
  e.stopPropagation();
  e.preventDefault();
  e.nativeEvent.stopImmediatePropagation();
  e.nativeEvent.stopPropagation();
};
var DesktopAdapter = function DesktopAdapter(props) {
  var _a, _b;
  var children = props.children,
    onOk = props.onOk,
    onChange = props.onChange,
    value = props.value,
    onVisibleChange = props.onVisibleChange,
    _c = props.locale,
    locale = _c === void 0 ? zh_CN : _c,
    _d = props.showSecond,
    showSecond = _d === void 0 ? false : _d,
    _e = props.placement,
    placement = _e === void 0 ? 'bottomRight' : _e,
    adaptForm = props.adaptForm;
  var _f = __read(usePropsValue({
      defaultValue: (_a = props.visible) !== null && _a !== void 0 ? _a : false,
      value: props.visible,
      onChange: props.onVisibleChange
    }), 2),
    visible = _f[0],
    setVisible = _f[1];
  var extra = locale.extra;
  var childrenNode = null;
  if (children && /*#__PURE__*/React.isValidElement(children)) {
    childrenNode = children;
  } else if (adaptForm && !children) {
    childrenNode = /*#__PURE__*/React.createElement(DateFormInnerNode, null);
  }
  var showHour = React.useMemo(function () {
    return props.showHour || props.mode === 'datetime' || props.mode === 'time';
  }, [props.showHour, props.mode]);
  var showMinute = React.useMemo(function () {
    return props.showMinute || props.mode === 'datetime' || props.mode === 'time';
  }, [props.showHour, props.mode]);
  var mode = React.useMemo(function () {
    var _a;
    if (props.mode === 'date' || props.mode === 'datetime') {
      return 'date';
    } else {
      return (_a = props.mode) !== null && _a !== void 0 ? _a : 'date';
    }
  }, [props.mode]);
  var onOK = React.useCallback(function (val) {
    setVisible(false);
    onOk === null || onOk === void 0 ? void 0 : onOk(val);
  }, []);
  var disableData = React.useCallback(function (date) {
    if (props.disabledDate) {
      return props.disabledDate(date);
    }
    if (props.minDate && date < props.minDate) {
      return true;
    }
    if (props.maxDate && date > props.maxDate) {
      return true;
    }
    return false;
  }, [props.disabledDate, props.minDate, props.maxDate]);
  var onSelect = React.useCallback(function (val) {
    var _a;
    if (props.mode === 'date' || props.mode === 'year' || props.mode === 'month') {
      (_a = props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, val);
      onOK === null || onOK === void 0 ? void 0 : onOK(val);
      setVisible(false);
    }
  }, [props.mode, props.onChange, onOK]);
  var innerLocale = locale.locale === 'zh_CN' ? __assign(__assign({}, zh_CN), locale) : __assign(__assign({}, en_US), locale);
  return /*#__PURE__*/React.createElement(Popover, {
    visible: visible,
    onVisibleChange: onVisibleChange,
    placement: placement,
    overlay: /*#__PURE__*/React.createElement("div", {
      onClick: blockEvent,
      onMouseDown: blockEvent,
      onTouchStart: blockEvent
    }, /*#__PURE__*/React.createElement(PcikerPanel, {
      prefixCls: datePickerPrefix,
      generateConfig: generateConfig,
      className: props.className,
      locale: innerLocale,
      value: value,
      picker: mode,
      showTime: (showHour || showMinute) && {
        showHour: showHour,
        showMinute: showMinute,
        showSecond: showSecond,
        format: !showSecond ? 'HH:mm' : 'HH:mm:ss'
      },
      onOk: onOK,
      disabledDate: disableData,
      onSelect: onSelect,
      onChange: onChange
    })),
    arrow: false,
    align: (_b = props.align) !== null && _b !== void 0 ? _b : {
      offset: [-16, 0]
    }
  }, childrenNode && /*#__PURE__*/React.isValidElement(childrenNode) && /*#__PURE__*/React.cloneElement(childrenNode, {
    extra: value ? (/*#__PURE__*/React.createElement("span", {
      className: "".concat(datePickerPrefix, "-format-value")
    }, formatFn({
      props: props
    }, value))) : (props === null || props === void 0 ? void 0 : props.extra) || extra,
    onClick: function onClick() {
      var _a, _b;
      childrenNode && /*#__PURE__*/React.isValidElement(childrenNode) && ((_b = (_a = childrenNode === null || childrenNode === void 0 ? void 0 : childrenNode.props) === null || _a === void 0 ? void 0 : _a.onClick) === null || _b === void 0 ? void 0 : _b.call(_a));
      setVisible(!visible);
    }
  }));
};
var DatePicker = /** @class */function (_super) {
  __extends(DatePicker, _super);
  function DatePicker() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.setScrollValue = function (v) {
      _this.scrollValue = v;
    };
    _this.onOk = function (v) {
      // 当未滚动时，onOk v 为 undefined，默认为最新日期
      if (v === undefined) {
        v = _this.props.value || _this.props.minDate || new Date();
      }
      if (_this.scrollValue !== undefined) {
        v = _this.scrollValue;
      }
      if (_this.props.onChange) {
        _this.props.onChange(v);
      }
      if (_this.props.onOk) {
        _this.props.onOk(v);
      }
    };
    _this.onVisibleChange = function (visible) {
      _this.scrollValue = undefined;
      if (_this.props.onVisibleChange) {
        _this.props.onVisibleChange(visible);
      }
    };
    return _this;
  }
  DatePicker.prototype.render = function () {
    var _a, _b, _c, _d;
    // tslint:disable-next-line:no-this-assignment
    var props = this.props;
    var children = props.children,
      value = props.value,
      popupPrefixCls = props.popupPrefixCls,
      adaptForm = props.adaptForm;
    // 兜底支持中/英文
    var locale = (_a = props.locale) !== null && _a !== void 0 ? _a : zh_CN;
    var defaultLocale = ((_b = props.locale) === null || _b === void 0 ? void 0 : _b.locale) === 'zh_CN' ? zh_CN : en_US;
    var _e = locale.okText,
      okText = _e === void 0 ? defaultLocale.okText : _e,
      _f = locale.extra,
      extra = _f === void 0 ? defaultLocale.extra : _f,
      _g = locale.DatePickerLocale,
      DatePickerLocale = _g === void 0 ? defaultLocale.DatePickerLocale : _g;
    /**
     * 注意:
     * 受控 表示 通过设置 value 属性、组件的最终状态跟 value 设置值一致。
     * 默认不设置 value 或 只设置 defaultValue 表示非受控。
     *
     * DatePickerView 对外通过 value “只支持 受控” 模式（可以使用 defaultDate 支持 非受控 模式，但不对外）
     * PickerView 对外通过 value “只支持 受控” 模式
     *
     * DatePicker / Picker 对外只有 value 属性 (没有 defaultValue)，
     * 其中 List 展示部分 “只支持 受控” 模式，
     * 弹出的 选择器部分 会随外部 value 改变而变、同时能自由滚动
     * （即不会因为传入的 value 不变而不能滚动 (不像原生 input 的受控行为)）
     *
     */
    var datePicker = /*#__PURE__*/React.createElement(React.Fragment, null, (_c = props.renderHeader) === null || _c === void 0 ? void 0 : _c.call(props), /*#__PURE__*/React.createElement(RCDatePicker, {
      minuteStep: props.minuteStep,
      locale: DatePickerLocale,
      minDate: props.minDate,
      maxDate: props.maxDate,
      mode: props.mode,
      pickerPrefixCls: props.pickerPrefixCls,
      prefixCls: props.prefixCls,
      defaultDate: value || new Date(),
      use12Hours: props.use12Hours,
      showUntilNow: props.showUntilNow,
      onValueChange: props.onValueChange,
      onScrollChange: this.setScrollValue,
      className: props.className
    }), (_d = props.renderFooter) === null || _d === void 0 ? void 0 : _d.call(props));
    if (this.props.isMobile) {
      var childrenNode = null;
      if (children && /*#__PURE__*/React.isValidElement(children)) {
        childrenNode = children;
      } else if (adaptForm && !children) {
        childrenNode = /*#__PURE__*/React.createElement(DateFormInnerNode, null);
      }
      var childrenNodeWrap = childrenNode && /*#__PURE__*/React.cloneElement(childrenNode, {
        extra: value ? (/*#__PURE__*/React.createElement("span", {
          className: "".concat(datePickerPrefix, "-format-value")
        }, formatFn(this, value))) : this.props.extra || extra
      });
      return /*#__PURE__*/React.createElement(PopupDatePicker, __assign({
        datePicker: datePicker,
        WrapComponent: "div",
        transitionName: "dtm-slide-up",
        maskTransitionName: "dtm-fade"
      }, props, {
        prefixCls: popupPrefixCls,
        date: value || new Date(),
        dismissText: this.props.dismissText || /*#__PURE__*/React.createElement(CloseOutlined, null),
        okText: this.props.okText || okText,
        onOk: this.onOk,
        onVisibleChange: this.onVisibleChange,
        onFixOk: this.onOk
      }), childrenNodeWrap);
    } else {
      return /*#__PURE__*/React.createElement(DesktopAdapter, __assign({}, this.props));
    }
  };
  DatePicker.defaultProps = {
    mode: 'datetime',
    prefixCls: dtPickerPrefix,
    pickerPrefixCls: "".concat(dtPickerPrefix, "-col"),
    popupPrefixCls: "".concat(dtPickerPrefix, "-popup"),
    minuteStep: 1,
    use12Hours: false
  };
  return DatePicker;
}(React.Component);
export default (function (props) {
  var isMobile = useMobile();
  return /*#__PURE__*/React.createElement(DatePicker, __assign({}, props, {
    isMobile: isMobile
  }));
});