var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React from 'react';
import classnames from 'classnames';
import { dtDropdownPrefix } from '../style/index';
import Popover from '../popover';
import { useMobile } from '../hooks';
import './style/index';
/**
 * 下拉菜单
 */
var Dropdown = /*#__PURE__*/React.memo(function (_a) {
  var _b;
  var children = _a.children,
    menu = _a.menu,
    onVisibleChange = _a.onVisibleChange,
    highlightElement = _a.highlightElement,
    rest = __rest(_a, ["children", "menu", "onVisibleChange", "highlightElement"]);
  var overlay = null;
  var isMobile = useMobile();
  if (menu && menu.length > 0) {
    overlay = /*#__PURE__*/React.createElement("div", {
      className: classnames("".concat(dtDropdownPrefix, "-menu"), (_b = {}, _b["".concat(dtDropdownPrefix, "-menu-pc")] = !isMobile, _b))
    }, menu.map(function (item, index) {
      var _a;
      var onClick = function onClick() {
        item.onClick && item.onClick();
        onVisibleChange && onVisibleChange(false);
      };
      return /*#__PURE__*/React.createElement("div", {
        key: index,
        className: classnames("".concat(dtDropdownPrefix, "-menu-item"), (_a = {}, _a["".concat(dtDropdownPrefix, "-menu-item-disabled")] = item.disabled, _a)),
        onClick: item.disabled ? undefined : onClick
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(dtDropdownPrefix, "-menu-item-inner")
      }, item.icon && (/*#__PURE__*/React.createElement("div", {
        className: "".concat(dtDropdownPrefix, "-menu-item-icon-wrap")
      }, item.icon)), item.title && (/*#__PURE__*/React.createElement("div", {
        className: "".concat(dtDropdownPrefix, "-menu-item-title")
      }, item.title))));
    }));
  }
  var element = children;
  if (highlightElement) {
    element = /*#__PURE__*/React.cloneElement(element, {
      style: {
        // @hack popover zIndex 为 1999
        zIndex: 2000
      }
    });
  }
  return /*#__PURE__*/React.createElement(Popover, __assign({
    overlay: overlay,
    arrow: false,
    onVisibleChange: onVisibleChange
  }, rest), /*#__PURE__*/React.createElement("div", null, element));
});
Dropdown.displayName = 'Dropdown';
Dropdown.defaultProps = {
  trigger: 'click'
};
export default Dropdown;