import _typeof from "@babel/runtime/helpers/esm/typeof";
import { lightMin, darkBig, lightBig, darkMin } from './config';
/**
 *
 * @param type
 * @param isDark
 * @param isBig 是否用大尺寸图片(180*180,目前用于排版为纵向时)
 * @param img
 * @returns
 */
export var getEmptySvg = function getEmptySvg(type, isDark, isBig, img) {
  if (img) {
    if (isDark) return typeof img === 'string' ? img : img.dark;else return typeof img === 'string' ? img : img.light;
  } else if (type) {
    if (isDark && isBig) {
      return darkBig[type];
    } else if (isDark) {
      return darkMin[type];
    } else if (isBig) {
      return lightBig[type];
    } else {
      return lightMin[type];
    }
  }
};
export var prefersDarkMode = function prefersDarkMode() {
  var theme = 'light';
  try {
    if ((typeof document === "undefined" ? "undefined" : _typeof(document)) === 'object' && document.documentElement.getAttribute('data-dingtalk-theme') === 'dark') {
      theme = 'dark';
    }
  } catch (ex) {}
  return theme === 'dark';
};