import React from 'react';
import { FormInstance as RCFormInstance, FormProps as RcFormProps } from 'rc-field-form';
import { ListProps } from '../list';
import { NativeProps } from '../_internal/native-props';
import { FormContextType } from './context';
import './style/index';
export type FormInstance = Pick<RCFormInstance, 'getFieldValue' | 'getFieldsValue' | 'getFieldError' | 'getFieldsError' | 'isFieldTouched' | 'isFieldsTouched' | 'resetFields' | 'setFields' | 'setFieldValue' | 'setFieldsValue' | 'submit' | 'validateFields'>;
export type FormProps = Pick<RcFormProps, 'form' | 'initialValues' | 'name' | 'preserve' | 'validateMessages' | 'validateTrigger' | 'onFieldsChange' | 'onFinish' | 'onFinishFailed' | 'onValuesChange' | 'children'> & NativeProps & Partial<FormContextType> & Partial<RCFormInstance> & {
    mode?: ListProps['mode'];
};
export declare const Form: React.ForwardRefExoticComponent<Pick<RcFormProps<any>, "form" | "children" | "preserve" | "name" | "initialValues" | "validateMessages" | "validateTrigger" | "onFieldsChange" | "onFinish" | "onFinishFailed" | "onValuesChange"> & NativeProps<never> & Partial<FormContextType> & Partial<RCFormInstance<any>> & {
    mode?: ListProps['mode'];
} & React.RefAttributes<FormInstance>>;
