var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React, { forwardRef } from 'react';
import classnames from 'classnames';
import RcForm from 'rc-field-form';
import List from '../list';
import { Header } from './Header';
import { traverseReactNode } from '../_internal/traverse-react-node';
import { defaultFormContext, FormContext } from './context';
import './style/index';
import { dtMobileFormPrefix } from '../style/index';
export var Form = /*#__PURE__*/forwardRef(function (props, ref) {
  var className = props.className,
    mode = props.mode,
    children = props.children,
    disabled = props.disabled,
    requiredMarkStyle = props.requiredMarkStyle,
    hasFeedback = props.hasFeedback,
    layout = props.layout,
    formProps = __rest(props, ["className", "mode", "children", "disabled", "requiredMarkStyle", "hasFeedback", "layout"]);
  var lists = [];
  var currentHeader = null;
  var items = [];
  var count = 0;
  function collect() {
    if (items.length === 0) return;
    count += 1;
    lists.push(/*#__PURE__*/React.createElement(List, {
      renderHeader: currentHeader,
      key: count,
      mode: mode
    }, items));
    items = [];
  }
  traverseReactNode(props.children, function (child) {
    if (/*#__PURE__*/React.isValidElement(child)) {
      if (child.type === Header) {
        collect();
        currentHeader = child.props.children;
        return;
      }
    }
    items.push(child);
  });
  collect();
  return /*#__PURE__*/React.createElement(RcForm, __assign({
    className: classnames(className, dtMobileFormPrefix)
  }, formProps, {
    ref: ref
  }), /*#__PURE__*/React.createElement(FormContext.Provider, {
    value: {
      name: formProps.name,
      hasFeedback: hasFeedback,
      layout: layout,
      requiredMarkStyle: requiredMarkStyle,
      disabled: disabled
    }
  }, lists));
});
Form.displayName = 'Form';
Form.defaultProps = __assign({}, defaultFormContext);