var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import classnames from 'classnames';
import * as React from 'react';
import TouchFeedback from 'rmc-feedback';
import Carousel from '../carousel';
import Flex from '../flex';
import { dtGridPrefix } from '../style';
import './style';
var Grid = /** @class */function (_super) {
  __extends(Grid, _super);
  function Grid() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.state = {
      initialSlideWidth: 0 // only used in carousel model
    };
    _this.renderCarousel = function (rowsArr, pageCount, rowCount) {
      var prefixCls = _this.props.prefixCls;
      var carouselMaxRow = _this.props.carouselMaxRow;
      var pagesArr = [];
      for (var pageIndex = 0; pageIndex < pageCount; pageIndex++) {
        var pageRows = [];
        for (var ii = 0; ii < carouselMaxRow; ii++) {
          var rowIndex = pageIndex * carouselMaxRow + ii;
          if (rowIndex < rowCount) {
            pageRows.push(rowsArr[rowIndex]);
          } else {
            // 空节点为了确保末尾页的最后未到底的行有底线(样式中last-child会没线)
            pageRows.push(/*#__PURE__*/React.createElement("div", {
              key: "gridline-".concat(rowIndex)
            }));
          }
        }
        pagesArr.push(/*#__PURE__*/React.createElement("div", {
          key: "pageitem-".concat(pageIndex),
          className: "".concat(prefixCls, "-carousel-page")
        }, pageRows));
      }
      return pagesArr;
    };
    _this.renderItem = function (dataItem, index, columnNum, renderItem) {
      var prefixCls = _this.props.prefixCls;
      var itemEl = null;
      if (renderItem) {
        itemEl = renderItem(dataItem, index);
      } else {
        if (dataItem) {
          var icon = dataItem.icon,
            text = dataItem.text;
          itemEl = /*#__PURE__*/React.createElement("div", {
            className: "".concat(prefixCls, "-item-inner-content column-num-").concat(columnNum)
          }, /*#__PURE__*/React.isValidElement(icon) ? icon : /*#__PURE__*/React.createElement("img", {
            className: "".concat(prefixCls, "-icon"),
            src: icon
          }), /*#__PURE__*/React.createElement("div", {
            className: "".concat(prefixCls, "-text")
          }, text));
        }
      }
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-item-content")
      }, itemEl);
    };
    _this.getRows = function (rowCount, dataLength) {
      // tslint:disable:prefer-const
      var _a = _this.props,
        columnNum = _a.columnNum,
        data = _a.data,
        renderItem = _a.renderItem,
        prefixCls = _a.prefixCls,
        _onClick = _a.onClick,
        activeStyle = _a.activeStyle,
        activeClassName = _a.activeClassName,
        itemStyle = _a.itemStyle;
      var rowsArr = [];
      columnNum = columnNum;
      var rowWidth = "".concat(100 / columnNum, "%");
      var colStyle = __assign({
        width: rowWidth
      }, itemStyle);
      for (var i = 0; i < rowCount; i++) {
        var rowArr = [];
        var _loop_1 = function _loop_1(j) {
          var dataIndex = i * columnNum + j;
          var itemEl = void 0;
          if (dataIndex < dataLength) {
            var el_1 = data && data[dataIndex];
            itemEl =
            /*#__PURE__*/
            // @ts-ignore
            React.createElement(TouchFeedback, {
              key: "griditem-".concat(dataIndex),
              activeClassName: activeClassName ? activeClassName : "".concat(prefixCls, "-item-active"),
              activeStyle: activeStyle
            }, /*#__PURE__*/React.createElement(Flex.Item, {
              className: "".concat(prefixCls, "-item"),
              onClick: function onClick() {
                return _onClick && _onClick(el_1, dataIndex);
              },
              style: colStyle
            }, _this.renderItem(el_1, dataIndex, columnNum, renderItem)));
          } else {
            itemEl = /*#__PURE__*/React.createElement(Flex.Item, {
              key: "griditem-".concat(dataIndex),
              className: "".concat(prefixCls, "-item ").concat(prefixCls, "-null-item"),
              style: colStyle
            });
          }
          rowArr.push(itemEl);
        };
        for (var j = 0; j < columnNum; j++) {
          _loop_1(j);
        }
        rowsArr.push(/*#__PURE__*/React.createElement(Flex, {
          justify: "center",
          align: "stretch",
          key: "gridline-".concat(i)
        }, rowArr));
      }
      return rowsArr;
    };
    return _this;
  }
  Grid.prototype.componentDidMount = function () {
    this.setState({
      initialSlideWidth: document.documentElement.clientWidth
    });
  };
  Grid.prototype.render = function () {
    var _a;
    var _b = this.props,
      prefixCls = _b.prefixCls,
      className = _b.className,
      data = _b.data,
      hasLine = _b.hasLine,
      isCarousel = _b.isCarousel,
      square = _b.square,
      activeStyle = _b.activeStyle,
      activeClassName = _b.activeClassName,
      restProps = __rest(_b, ["prefixCls", "className", "data", "hasLine", "isCarousel", "square", "activeStyle", "activeClassName"]);
    var columnNum = restProps.columnNum,
      carouselMaxRow = restProps.carouselMaxRow,
      onClick = restProps.onClick,
      renderItem = restProps.renderItem,
      restPropsForCarousel = __rest(restProps, ["columnNum", "carouselMaxRow", "onClick", "renderItem"]);
    var initialSlideWidth = this.state.initialSlideWidth;
    columnNum = columnNum;
    carouselMaxRow = carouselMaxRow;
    var dataLength = data && data.length || 0;
    var rowCount = Math.ceil(dataLength / columnNum);
    var rowsArr;
    var renderEl;
    if (isCarousel) {
      if (initialSlideWidth < 0) {
        // carousel  server render. because carousel dependes on document
        return null;
      }
      if (rowCount % carouselMaxRow !== 0) {
        rowCount = rowCount + carouselMaxRow - rowCount % carouselMaxRow;
      }
      var pageCount = Math.ceil(rowCount / carouselMaxRow);
      rowsArr = this.getRows(rowCount, dataLength);
      var carouselProps = {};
      if (pageCount <= 1) {
        carouselProps = {
          dots: false,
          dragging: false,
          swiping: false
        };
      }
      renderEl = /*#__PURE__*/React.createElement(Carousel, __assign({
        initialSlideWidth: initialSlideWidth
      }, restPropsForCarousel, carouselProps), this.renderCarousel(rowsArr, pageCount, rowCount));
    } else {
      rowsArr = this.getRows(rowCount, dataLength);
      renderEl = rowsArr;
    }
    var cls = classnames(prefixCls, className, (_a = {}, _a["".concat(prefixCls, "-square")] = square, _a["".concat(prefixCls, "-line")] = hasLine, _a["".concat(prefixCls, "-carousel")] = isCarousel, _a));
    return /*#__PURE__*/React.createElement("div", {
      className: cls
    }, renderEl);
  };
  Grid.defaultProps = {
    data: [],
    hasLine: true,
    isCarousel: false,
    columnNum: 4,
    carouselMaxRow: 2,
    prefixCls: dtGridPrefix,
    square: true,
    itemStyle: {}
  };
  return Grid;
}(React.Component);
export default Grid;