import * as React from 'react';
import { uuid } from '../_internal';
var lockClassName = 'amd-body-scroll-lock-';
// 为什么用 className 的形式?
// 考虑到使用 inline style 会导致多个同时使用时对现有样式的干扰，因此这里采用外加 className 的方式来处理
export default (function (lock) {
  // 生成一个随机的 classNam
  // overflow: hidden; height: 100vh
  var lockClassNameX = React.useRef(lockClassName + uuid());
  React.useLayoutEffect(function () {
    if (lock) {
      document.body.classList.add(lockClassNameX.current);
      document.documentElement.classList.add(lockClassNameX.current);
    } else {
      document.body.classList.remove(lockClassNameX.current);
      document.documentElement.classList.remove(lockClassNameX.current);
    }
    return function () {
      document.body.classList.remove(lockClassNameX.current);
      document.documentElement.classList.remove(lockClassNameX.current);
    };
  }, [lock]);
});