/**
 * 用于创建 createPortal 需要的 body 下面的 dom
 * 如果想用 api 创建，则使用 _internal.createGlobalElement
 *
 * @param id id 标记
 * @param visible?, 是否需要渲染该 dom，一般条件与 React.createPortal 的渲染条件一样
 *
 * @returns dom 返回的 dom , 在 !visible 的时候是 null
 *
 * const dom = useContainer('numeric-keypad', visible)
 *
 * {visible && React.createPortal(<div />, dom)}
 */
export default function useContainer(id: string, visible?: boolean): HTMLDivElement | null;
