var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import { useState, useEffect, useCallback } from 'react';
import { error } from '../_internal';
// 用于受控和非受控组件
export default function useControlled(_value, _defaultValue, _onChange) {
  var controlled = _value != null;
  // controlled 的时候, _value 必有值
  var initValue = controlled ? _value : _defaultValue;
  // 必须提供 defaultValue. 否则会导致下层依赖的 input 由非受控模式切换到受控模式
  if (initValue == null) {
    error(false, 'chore', 'undefined defaultValue with uncontrolled');
  }
  var _a = __read(useState(initValue), 2),
    value = _a[0],
    setValue = _a[1];
  // 受控模式更新 value
  useEffect(function () {
    if (controlled) {
      setValue(_value);
    }
  }, [_value, controlled]);
  var onChange = useCallback(function (v) {
    // 非受控模式更新 value
    if (!controlled) {
      setValue(v);
    }
    _onChange === null || _onChange === void 0 ? void 0 : _onChange(v);
  }, [controlled, _onChange]);
  return {
    value: value,
    onChange: onChange
  };
}
export function useControlledByValue(props) {
  return useControlled(props.value, props.defaultValue, props.onChange);
}
export function useControlledByChecked(props) {
  var _a = useControlled(props.checked, props.defaultChecked, props.onChange),
    value = _a.value,
    onChange = _a.onChange;
  return {
    checked: value,
    onChange: onChange
  };
}