/**
 * 在有清除图标的输入框中，需要将 focus 的状态共享出来
 *
 * showClear = focus && value
 */
var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import * as React from 'react';
var useFocus = function useFocus(value, props) {
  var tRef = React.useRef();
  var _a = __read(React.useState(false), 2),
    focus = _a[0],
    setFocus = _a[1];
  var clear = function clear() {
    if (tRef.current) {
      clearTimeout(tRef.current);
    }
  };
  React.useEffect(function () {
    return clear;
  }, []);
  function isTouchScreen() {
    return 'ontouchstart' in window;
  }
  var handleFocus = function handleFocus() {
    var _a;
    if (!focus) {
      setFocus(true);
      (_a = props.onFocus) === null || _a === void 0 ? void 0 : _a.call(props, value);
    }
  };
  var handleBlur = function handleBlur() {
    var _a;
    if (focus) {
      setFocus(false);
      (_a = props.onBlur) === null || _a === void 0 ? void 0 : _a.call(props, value);
    }
  };
  return {
    focus: focus,
    onFocus: function onFocus() {
      clear();
      handleFocus();
    },
    onBlur: function onBlur() {
      // hack, 仅在 pc 的时候
      // 可能是 Touchable pc 实现有问题
      if (!isTouchScreen()) {
        tRef.current = setTimeout(function () {
          handleBlur();
        }, 200);
      } else {
        // @hack 解决 input-item clear 问题
        tRef.current = setTimeout(function () {
          handleBlur();
        }, 0);
      }
    }
  };
};
export default useFocus;