import React, { useContext, useEffect } from 'react';
import { withNativeProps } from '../_internal/native-props';
import { IndexBarContext } from './context';
import { dtMobilePrefix } from '../style/index';
export var dtMobileIndexBarPrefix = "".concat(dtMobilePrefix, "-indexBar-anchor");
export var Panel = function Panel(props) {
  var setIndexes = useContext(IndexBarContext).setIndexes;
  useEffect(function () {
    setIndexes(function (val) {
      return val.concat([props.index]);
    });
    return function () {
      setIndexes(function (val) {
        return val.filter(function (x) {
          return x !== props.index;
        });
      });
    };
  }, [props.index]);
  return withNativeProps(props, /*#__PURE__*/React.createElement("div", {
    "data-index": props.index,
    className: dtMobileIndexBarPrefix
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(dtMobileIndexBarPrefix, "-title")
  }, props.title || props.index), props.children));
};