var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import React, { useState } from 'react';
import classNames from 'classnames';
import { dtMobilePrefix } from '../style/index';
import Popover from '../popover';
var dtMobileIndexBarPrefix = "".concat(dtMobilePrefix, "-indexBar");
// 显示的字母侧边栏
export var Sidebar = function Sidebar(props) {
  var _a;
  var _b = __read(useState(false), 2),
    interacting = _b[0],
    setInteracting = _b[1];
  return /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(dtMobileIndexBarPrefix, "-sidebar"), (_a = {}, _a["".concat(dtMobileIndexBarPrefix, "-sidebar-interacting")] = interacting, _a)),
    onMouseDown: function onMouseDown() {
      setInteracting(true);
    },
    onMouseUp: function onMouseUp() {
      setInteracting(false);
    },
    onTouchStart: function onTouchStart() {
      setInteracting(true);
    },
    onTouchEnd: function onTouchEnd() {
      setInteracting(false);
    },
    onTouchMove: function onTouchMove(e) {
      if (!interacting) return; // 只有在交互时才会触发
      var _a = e.touches[0],
        clientX = _a.clientX,
        clientY = _a.clientY;
      var target = document.elementFromPoint(clientX, clientY); //计算当前滑动到元素
      if (!target) return;
      var index = target.dataset['index']; // 得到当前元素的序号
      if (index) {
        props.onActive(index); // 激活当前序号
      }
    }
  }, props.indexes.map(function (index, idxPos) {
    var _a;
    var active = index === props.activeIndex;
    return /*#__PURE__*/React.createElement("div", {
      className: "".concat(dtMobileIndexBarPrefix, "-sidebar-row"),
      onMouseDown: function onMouseDown() {
        props.onActive(index);
      },
      onTouchStart: function onTouchStart() {
        props.onActive(index);
      },
      onMouseEnter: function onMouseEnter() {
        if (interacting) {
          props.onActive(index);
        }
      },
      "data-index": index,
      key: index
    }, /*#__PURE__*/React.createElement(Popover, {
      placement: "right",
      dark: true,
      overlay: /*#__PURE__*/React.createElement("div", {
        className: classNames("".concat(dtMobileIndexBarPrefix, "-sidebar-popover"))
      }, index),
      visible: interacting && active
    }, /*#__PURE__*/React.createElement("div", {
      className: classNames("".concat(dtMobileIndexBarPrefix, "-sidebar-item"), (_a = {}, _a["".concat(dtMobileIndexBarPrefix, "-sidebar-item-active")] = active, _a)),
      "data-index": index
    }, /*#__PURE__*/React.createElement("div", null, index))));
  }));
};