var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import React, { memo, useState } from 'react';
import classnames from 'classnames';
import { dtInpageGuidePrefix } from '../style/index';
import CloseOutlined from 'dingtalk-design-icons/lib/CloseOutlined';
import './style/index';
import { useMobile } from '../hooks';
var InpageGuide = /*#__PURE__*/memo(function (props) {
  var _a;
  var icon = props.icon,
    closable = props.closable,
    className = props.className,
    title = props.title,
    desc = props.desc,
    actionText = props.actionText,
    onActionClick = props.onActionClick,
    type = props.type,
    imgSrc = props.imgSrc;
  var isMobile = useMobile();
  var _b = __read(useState(true), 2),
    show = _b[0],
    setShow = _b[1];
  var wrapPrefixCls = function wrapPrefixCls(name) {
    return "".concat(dtInpageGuidePrefix, "-").concat(name);
  };
  var onClose = function onClose() {
    setShow(false);
  };
  var cls = classnames(dtInpageGuidePrefix, "".concat(dtInpageGuidePrefix, "-").concat(type), className, (_a = {}, _a["".concat(dtInpageGuidePrefix, "-hidden")] = !show, _a["".concat(dtInpageGuidePrefix, "-desktop")] = !isMobile, _a));
  return /*#__PURE__*/React.createElement("div", {
    className: cls
  }, icon && /*#__PURE__*/React.createElement("div", {
    className: wrapPrefixCls("icon-wrap")
  }, icon), /*#__PURE__*/React.createElement("div", {
    className: wrapPrefixCls('main-content')
  }, /*#__PURE__*/React.createElement("div", {
    className: wrapPrefixCls('title')
  }, title), /*#__PURE__*/React.createElement("div", {
    className: wrapPrefixCls('desc')
  }, desc), actionText && /*#__PURE__*/React.createElement("div", {
    className: wrapPrefixCls('action'),
    onClick: onActionClick
  }, actionText)), imgSrc && /*#__PURE__*/React.createElement("div", {
    className: wrapPrefixCls('img-wrap')
  }, /*#__PURE__*/React.createElement("img", {
    src: imgSrc
  })), closable && /*#__PURE__*/React.createElement(CloseOutlined, {
    className: wrapPrefixCls('close-icon'),
    onClick: onClose
  }));
});
InpageGuide.defaultProps = {
  type: 'normal',
  closable: true
};
InpageGuide.displayName = 'InpageGuide';
export default InpageGuide;