var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import './style/index';
import * as React from 'react';
import classnames from 'classnames';
import CloseCircleFilled from 'dingtalk-design-icons/lib/CloseCircleFilled';
import { getDataAttr } from '../_internal';
import { useMobile } from '../hooks';
import { withError } from '../rmc';
import { useFocus } from '../hooks';
import useCompositionChange from './useCompositionChange';
import { useControllableValue } from 'ahooks';
import { dtMobileInputItemPrefix as prefixCls } from '../style/index';
/**
 * @deprecated 请使用 Input 组件替代，功能保持一致。
 */
export var InputItem = function InputItem(props) {
  var _a;
  var id = props.id,
    name = props.name,
    className = props.className,
    placeholder = props.placeholder,
    disabled = props.disabled,
    autoFocus = props.autoFocus,
    clear = props.clear,
    type = props.type,
    maxLength = props.maxLength,
    inputMode = props.inputMode,
    readonly = props.readonly,
    // provide by withError
    // @ts-ignore
    forwardRef = props.forwardRef;
  var isMobile = useMobile();
  var dataProps = getDataAttr(props);
  var _b = __read(useControllableValue(props), 2),
    value = _b[0],
    onChange = _b[1];
  var _c = useFocus(value, props),
    focus = _c.focus,
    onFocus = _c.onFocus,
    onBlur = _c.onBlur;
  var inputRef = /*#__PURE__*/React.createRef();
  React.useImperativeHandle(forwardRef, function () {
    return {
      focus: function focus() {
        var _a, _b;
        (_b = (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.focus) === null || _b === void 0 ? void 0 : _b.call(_a);
      },
      blur: function blur() {
        var _a, _b;
        (_b = (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.blur) === null || _b === void 0 ? void 0 : _b.call(_a);
      }
    };
  });
  var _d = useCompositionChange(value, onChange),
    fixedValue = _d.value,
    onComposition = _d.onComposition,
    fixedOnChange = _d.onChange;
  // 清除按钮
  var handleClear = function handleClear() {
    fixedOnChange('');
  };
  var showClear = clear && focus && value && value.length > 0;
  var wrap = function wrap() {
    var _a, _b;
    var _c, _d;
    var inputCls = classnames("".concat(prefixCls, "-input"), (_a = {}, _a["".concat(prefixCls, "-input-clear")] = showClear, _a));
    var inputComp = /*#__PURE__*/React.createElement("input", {
      id: id,
      name: name,
      ref: inputRef,
      value: fixedValue,
      inputMode: inputMode,
      type: type,
      placeholder: placeholder,
      readOnly: readonly,
      disabled: disabled,
      className: inputCls,
      autoFocus: autoFocus,
      onBlur: onBlur,
      onFocus: onFocus,
      maxLength: maxLength,
      onCompositionStart: (_c = props.onCompositionStart) !== null && _c !== void 0 ? _c : onComposition,
      onCompositionEnd: (_d = props.onCompositionEnd) !== null && _d !== void 0 ? _d : onComposition,
      onChange: function onChange(e) {
        return fixedOnChange(e.target.value);
      }
    });
    var clearComp = showClear ? (/*#__PURE__*/React.createElement(CloseCircleFilled, {
      className: "".concat(prefixCls, "-clear"),
      onClick: handleClear
    })) : null;
    return /*#__PURE__*/React.createElement("label", null, isMobile ? (/*#__PURE__*/React.createElement(React.Fragment, null, inputComp, clearComp)) : (/*#__PURE__*/React.createElement("span", {
      className: classnames("".concat(prefixCls, "-desktop-input"), (_b = {}, _b["".concat(prefixCls, "-desktop-input-focus")] = focus, _b["".concat(prefixCls, "-desktop-input-disabled")] = disabled, _b))
    }, inputComp, clearComp)));
  };
  var itemCls = classnames(prefixCls, className, (_a = {}, _a["".concat(prefixCls, "-disabled")] = disabled, _a["".concat(prefixCls, "-desktop-input-item")] = !isMobile, _a));
  return /*#__PURE__*/React.createElement("div", __assign({
    className: itemCls
  }, dataProps), wrap());
};
InputItem.displayName = 'InputItem';
InputItem.defaultProps = {
  className: '',
  disabled: false,
  placeholder: '',
  autoFocus: false,
  defaultValue: '',
  clear: false,
  type: 'text'
};
export default withError(InputItem, {
  forwardRef: true
});