var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import * as React from 'react';
// 修复中文输入法 onChange 的问题
var useCompositionChange = function useCompositionChange(value, onChange) {
  var _a = __read(React.useState(null), 2),
    cpValue = _a[0],
    setCpValue = _a[1];
  var cpLock = React.useRef(false);
  var handleChange = function handleChange(v, forceChange) {
    if (forceChange === void 0) {
      forceChange = false;
    }
    if (cpLock.current && !forceChange) {
      // 临时值锁
      setCpValue(v);
      return;
    }
    // 没有 lock 的时候，清除临时值
    cpValue !== null && setCpValue(null);
    onChange(v);
  };
  return {
    value: cpValue || value,
    onComposition: function onComposition(e) {
      if (e.type === 'compositionend' && cpLock.current) {
        var v = e.target.value;
        // hack safari 可能会触发两次 end, 所以需要在 lock 的时候才强制触发 change
        // hack chrome 的 onChange 先于 onCompositionEnd 触发，这里需要补充一次
        handleChange(v, true);
        cpLock.current = false;
      } else {
        cpLock.current = true;
      }
    },
    onChange: function onChange(v) {
      return handleChange(v);
    }
  };
};
export default useCompositionChange;