import React from 'react';
import { BasePropsType } from '../_internal';
import './style/index';
import { NativeProps } from '../_internal/native-props';
export declare const dtMobileIntroBoardPrefix: string;
export type IJumpLinkProps = {
    /**
     * @description 跳转链接的文字描述
     * @default "-"
     */
    title: string;
    /**
     * @description 点击跳转链接的回调函数
     * @default "-"
     */
    onClick: () => void;
} & NativeProps;
export type IIntroBoardProps = {
    /**
     * @description 新功能推荐的标题
     * @default "-"
     */
    title?: string;
    /**
     * @description 新功能推荐的描述
     * @default "-"
     */
    desc?: string;
    /**
     * @description 新功能推荐的描述表情
     * @default "-"
     */
    emotion?: React.ReactElement;
    /**
     * @description 点击关闭推荐框触发的回调事件
     * @default "-"
     */
    onClose?: () => void;
    /**
     * @description 跳转链接的描述
     * @default "-"
     */
    jumpLink?: IJumpLinkProps;
} & BasePropsType & NativeProps<'--bottom'>;
declare const IntroBoard: React.FC<IIntroBoardProps>;
export default IntroBoard;
