var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import React from 'react';
import './style/index';
import { dtMobilePrefix } from '../style/index';
import classnames from 'classnames';
import { withNativeProps } from '../_internal/native-props';
import CloseOutlined from 'dd-icons/lib/CloseOutlined';
export var dtMobileIntroBoardPrefix = "".concat(dtMobilePrefix, "-intro-board");
var IntroBoard = /*#__PURE__*/React.memo(function (props) {
  var _a;
  var _b = __read(React.useState(true), 2),
    visible = _b[0],
    setVisible = _b[1];
  var className = props.className,
    title = props.title,
    desc = props.desc,
    jumpLink = props.jumpLink,
    emotion = props.emotion;
  var prefixCls = dtMobileIntroBoardPrefix;
  var wrapCls = classnames(prefixCls, className);
  var _onClick = React.useCallback(function () {
    if (jumpLink && typeof jumpLink.onClick === 'function') {
      jumpLink.onClick();
    }
  }, [jumpLink]);
  var onClose = React.useCallback(function () {
    setVisible(false);
    if (props.onClose && typeof props.onClose === 'function') {
      props.onClose();
    }
  }, [props.onClose]);
  return withNativeProps(props, /*#__PURE__*/React.createElement("div", {
    className: wrapCls,
    style: {
      visibility: visible ? 'visible' : 'hidden'
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-info-container"),
    onClick: function onClick() {
      return _onClick();
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-info-title-container")
  }, emotion, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-info-title")
  }, title)), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-info-desc")
  }, desc)), /*#__PURE__*/React.createElement("div", {
    onClick: function onClick() {
      return _onClick();
    },
    className: "".concat(prefixCls, "-jump-link")
  }, (_a = props.jumpLink) === null || _a === void 0 ? void 0 : _a.title), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-close-hot-spot"),
    onClick: function onClick() {
      return onClose();
    }
  }, /*#__PURE__*/React.createElement(CloseOutlined, {
    className: "".concat(prefixCls, "-close-icon")
  }))));
});
IntroBoard.displayName = 'IntroBoard';
export default IntroBoard;