var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import * as React from 'react';
import classnames from 'classnames';
import RightArrow2Outlined from 'dd-icons/lib/RightArrow2Outlined';
import TouchFeedback from 'rmc-feedback';
import { dtMobileListPrefix as prefixCls } from '../style/index';
import { useMobile } from '../hooks';
import { withNativeProps } from '../_internal/native-props';
var Brief = /*#__PURE__*/React.memo(function (props) {
  if (!props.children) {
    return null;
  }
  return /*#__PURE__*/React.createElement("div", {
    className: classnames("".concat(prefixCls, "-brief"), props.className)
  }, props.children);
});
Brief.displayName = 'Brief';
export var Item = /*#__PURE__*/React.memo(function (props) {
  var _a, _b, _c, _d, _e;
  var _f = props.hideDivider,
    hideDivider = _f === void 0 ? false : _f,
    className = props.className,
    error = props.error,
    align = props.align,
    wrap = props.wrap,
    disabled = props.disabled,
    children = props.children,
    brief = props.brief,
    thumb = props.thumb,
    extra = props.extra,
    arrow = props.arrow,
    onClick = props.onClick,
    rest = __rest(props, ["hideDivider", "className", "error", "align", "wrap", "disabled", "children", "brief", "thumb", "extra", "arrow", "onClick"]);
  var isMobile = useMobile();
  var _g = __read(React.useState({
      coverRippleStyle: {
        display: 'none'
      },
      RippleClicked: false
    }), 2),
    ripple = _g[0],
    setRipple = _g[1];
  var debounceTimeout = React.useRef(null);
  React.useEffect(function () {
    if (ripple.RippleClicked) {
      debounceTimeout.current = setTimeout(function () {
        setRipple({
          coverRippleStyle: {
            display: 'none'
          },
          RippleClicked: false
        });
      }, 1000);
    }
    return function () {
      if (debounceTimeout.current) {
        clearTimeout(debounceTimeout.current);
        debounceTimeout.current = null;
      }
    };
  }, [ripple]);
  var RippleClicked = ripple.RippleClicked,
    coverRippleStyle = ripple.coverRippleStyle;
  var handlePress = function handlePress(ev) {
    onClick === null || onClick === void 0 ? void 0 : onClick(ev);
  };
  var wrapCls = classnames("".concat(prefixCls, "-item"), className, (_a = {}, _a["".concat(prefixCls, "-item-disabled")] = disabled, _a["".concat(prefixCls, "-item-error")] = error, _a["".concat(prefixCls, "-item-top")] = align === 'top', _a["".concat(prefixCls, "-item-middle")] = align === 'middle', _a["".concat(prefixCls, "-item-bottom")] = align === 'bottom', _a["".concat(prefixCls, "-item-desktop")] = !isMobile, _a["".concat(prefixCls, "-item-hover")] = !isMobile && onClick, _a));
  var rippleCls = classnames("".concat(prefixCls, "-ripple"), (_b = {}, _b["".concat(prefixCls, "-ripple-animate")] = RippleClicked, _b));
  var lineCls = classnames("".concat(prefixCls, "-line"), (_c = {}, _c["".concat(prefixCls, "-line-wrap")] = wrap, _c["".concat(prefixCls, "-line-desktop")] = !isMobile, _c["".concat(prefixCls, "-line-mobile")] = isMobile, _c["".concat(prefixCls, "-line-hide-divider")] = hideDivider, _c));
  var arrowCls = classnames("".concat(prefixCls, "-arrow"), (_d = {}, _d["".concat(prefixCls, "-arrow-horizontal")] = arrow === true || arrow !== 'down' && arrow !== 'up' && arrow !== 'empty', _d["".concat(prefixCls, "-arrow-vertical")] = arrow === 'down' || arrow === 'up', _d["".concat(prefixCls, "-arrow-vertical-up")] = arrow === 'up', _d));
  var thumbCls = classnames("".concat(prefixCls, "-thumb"), (_e = {}, _e["".concat(prefixCls, "-thumb-brief")] = !!brief, _e));
  var content = /*#__PURE__*/React.createElement("div", {
    onClick: handlePress,
    className: wrapCls
  }, thumb ? (/*#__PURE__*/React.createElement("div", {
    className: thumbCls
  }, typeof thumb === 'string' ? /*#__PURE__*/React.createElement("img", {
    className: "".concat(thumbCls, "-img"),
    src: thumb
  }) : thumb)) : null, /*#__PURE__*/React.createElement("div", {
    className: lineCls
  }, children !== undefined && (/*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-content")
  }, children, brief && /*#__PURE__*/React.createElement(Brief, null, brief))), extra !== undefined && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-extra")
  }, extra), (arrow || onClick) && arrow !== 'empty' && (/*#__PURE__*/React.createElement(RightArrow2Outlined, {
    className: arrowCls,
    "aria-hidden": "true"
  }))), /*#__PURE__*/React.createElement("div", {
    style: coverRippleStyle,
    className: rippleCls
  }));
  return (
    /*#__PURE__*/
    // @ts-ignore
    React.createElement(TouchFeedback, __assign({}, rest, {
      activeClassName: "".concat(prefixCls, "-item-active"),
      disabled: disabled || !onClick
    }), withNativeProps(props, content))
  );
});
Item.displayName = 'ListItem';
Item.defaultProps = {
  align: 'middle',
  error: false,
  wrap: false
};
export default Item;