var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import React, { useMemo, useRef, useState } from 'react';
import { useUnmountedRef } from 'ahooks';
import { withNativeProps } from '../_internal/native-props';
import { useLockScroll } from '../_internal/use-lock-scroll';
import { useSpring, animated } from 'dd-react-spring-web';
import { renderToContainer } from '../_internal/render-to-container';
import { mergeProps } from '../_internal/with-default-props';
import { useConfig } from '../config-provider';
import { ShouldRender } from '../_internal/should-render';
import { withStopPropagation } from '../_internal/with-stop-propagation';
import 'regenerator-runtime/runtime.js';
import { dtMobilePrefix } from '../style';
import "./style/index.css";
var classPrefix = "".concat(dtMobilePrefix, "-mask");
var opacityRecord = {
  "default": 0.55,
  thin: 0.35,
  thick: 0.75
};
var defaultProps = {
  visible: true,
  maskShow: true,
  destroyOnClose: false,
  forceRender: false,
  color: 'black',
  opacity: 'default',
  disableBodyScroll: true,
  getContainer: null,
  stopPropagation: ['click']
};
var colorRecord = {
  black: '0, 0, 0',
  white: '255, 255, 255'
};
var Mask = function Mask(p) {
  var props = mergeProps(defaultProps, p);
  var locale = useConfig().locale;
  var ref = useRef(null);
  useLockScroll(ref, props.visible && props.disableBodyScroll);
  var background = useMemo(function () {
    var _a;
    var opacity = (_a = opacityRecord[props.opacity]) !== null && _a !== void 0 ? _a : props.opacity;
    var rgb = colorRecord[props.color];
    return rgb ? "rgba(".concat(rgb, ", ").concat(opacity, ")") : props.color;
  }, [props.color, props.opacity]);
  var _a = __read(useState(props.visible), 2),
    active = _a[0],
    setActive = _a[1];
  var unmountedRef = useUnmountedRef();
  var opacity = useSpring({
    opacity: props.visible ? 1 : 0,
    config: {
      precision: 0.01,
      mass: 1,
      tension: 250,
      friction: 30,
      clamp: true
    },
    onStart: function onStart() {
      setActive(true);
    },
    onRest: function onRest() {
      var _a, _b;
      if (unmountedRef.current) return;
      setActive(props.visible);
      if (props.visible) {
        (_a = props.afterShow) === null || _a === void 0 ? void 0 : _a.call(props);
      } else {
        (_b = props.afterClose) === null || _b === void 0 ? void 0 : _b.call(props);
      }
    }
  }).opacity;
  var style = useMemo(function () {
    var result = __assign(__assign({}, props.style), {
      background: background,
      opacity: opacity,
      display: active ? undefined : 'none'
    });
    if (props.maskShow) {
      return result;
    } else {
      return __assign(__assign({}, result), {
        background: 'rgba(0 ,0 ,0 ,0)'
      });
    }
  }, [props.maskShow, props.style, opacity, active]);
  var node = withStopPropagation(props.stopPropagation, withNativeProps(props, /*#__PURE__*/React.createElement(animated.div, {
    className: classPrefix,
    ref: ref,
    style: style,
    onClick: function onClick(e) {
      var _a;
      if (e.target === e.currentTarget) {
        (_a = props.onMaskClick) === null || _a === void 0 ? void 0 : _a.call(props, e);
      }
    }
  }, props.onMaskClick && (/*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-aria-button"),
    role: "button",
    "aria-label": locale.Mask.name,
    onClick: props.onMaskClick
  })), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-content")
  }, props.children))));
  return /*#__PURE__*/React.createElement(ShouldRender, {
    active: active,
    forceRender: props.forceRender,
    destroyOnClose: props.destroyOnClose
  }, renderToContainer(props.getContainer, node));
};
export default Mask;