var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React, { useMemo } from 'react';
import RmcDialog from 'rmc-dialog';
import TouchFeedback from 'rmc-feedback';
import classnames from 'classnames';
import { dtMobileModalPrefix } from './interface';
import { useMobile } from '../hooks';
import './style/index';
var Dialog = function Dialog(props) {
  var _a;
  var children = props.children,
    actions = props.actions,
    visible = props.visible,
    onClose = props.onClose,
    className = props.className,
    title = props.title,
    fullContent = props.fullContent,
    transitionName = props.transitionName,
    maskClosable = props.maskClosable,
    otherProps = __rest(props, ["children", "actions", "visible", "onClose", "className", "title", "fullContent", "transitionName", "maskClosable"]);
  var isMobile = useMobile();
  var footer = useMemo(function () {
    if (actions && actions.length) {
      var operation = false;
      return /*#__PURE__*/React.createElement("div", {
        className: classnames("".concat(dtMobileModalPrefix, "-button-group-").concat(actions.length === 2 && !operation ? 'h' : 'v'), "".concat(dtMobileModalPrefix, "-button-group-").concat(operation ? 'operation' : 'normal')),
        role: "group"
      }, actions === null || actions === void 0 ? void 0 : actions.map(function (item, i) {
        var button = {
          style: item.style,
          text: item.text,
          onClick: item.onClick
        };
        var buttonStyle = {};
        if (button.style) {
          buttonStyle = button.style;
          if (typeof buttonStyle === 'string') {
            var styleMap = {
              cancel: {},
              "default": {},
              destructive: {
                color: 'red'
              }
            };
            buttonStyle = styleMap[buttonStyle] || {};
          }
        }
        var onClickFn = function onClickFn(e) {
          e.preventDefault();
          if (button.onClick) {
            button.onClick();
          }
        };
        return (
          /*#__PURE__*/
          // @ts-ignore
          React.createElement(TouchFeedback, {
            activeClassName: "".concat(dtMobileModalPrefix, "-button-active"),
            key: i
          }, /*#__PURE__*/React.createElement("a", {
            className: "".concat(dtMobileModalPrefix, "-button"),
            role: "button",
            style: buttonStyle,
            onClick: onClickFn
          }, button.text || "Button"))
        );
      }));
    }
  }, [actions]);
  var cls = classnames(className, (_a = {}, _a["".concat(dtMobileModalPrefix, "-transparent")] = true, _a["".concat(dtMobileModalPrefix, "-full-content")] = fullContent, _a["".concat(dtMobileModalPrefix, "-desktop")] = !isMobile, _a));
  return /*#__PURE__*/React.createElement(RmcDialog, __assign({}, otherProps, {
    closable: false,
    title: title,
    maskClosable: maskClosable,
    visible: visible,
    onClose: onClose,
    className: cls,
    prefixCls: dtMobileModalPrefix,
    footer: footer,
    // transitionName={transitionName || `${dtMobilePrefix}-fade`}
    // maskTransitionName={`${dtMobilePrefix}-fade`}
    bodyStyle: !children ? {
      padding: 8
    } : {}
  }), children);
};
export default Dialog;