var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import React from 'react';
import ReactDOM from 'react-dom';
import Dialog from './Dialog';
import { dtMobileModalPrefix } from './interface';
import { dtMobilePrefix } from '../style';
var alert = function alert(title, message, actions, maskClosable) {
  if (actions === void 0) {
    actions = [{
      text: '确定'
    }];
  }
  if (!title && !message) {
    // console.log('Must specify either an alert title, or message, or both');
    return {
      close: function close() {}
    };
  }
  var div = document.createElement('div');
  document.body.appendChild(div);
  function close() {
    ReactDOM.unmountComponentAtNode(div);
    if (div && div.parentNode) {
      div.parentNode.removeChild(div);
    }
  }
  var renderActions = (actions || []).map(function (item) {
    var originClick = item.onClick;
    return __assign(__assign({}, item), {
      onClick: function onClick() {
        close();
        originClick && originClick();
      }
    });
  });
  var prefixCls = dtMobileModalPrefix;
  ReactDOM.render(/*#__PURE__*/React.createElement(Dialog, {
    title: title,
    actions: renderActions,
    visible: true,
    transitionName: "".concat(dtMobilePrefix, "-zoom"),
    onClose: function onClose() {
      close();
    },
    maskClosable: maskClosable
  }, !!message && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-alert-content")
  }, message)), div);
  return {
    close: close
  };
};
export default alert;