import * as React from 'react';
export interface ModalProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'title'> {
    /**
     * @description 是否可见
     * @default false
     */
    visible: boolean;
    /**
     * @description 点击蒙层是否允许关闭
     * @default true
     */
    maskClosable?: boolean;
    /**
     * @description 关闭回调
     * @default '-'
     */
    onClose?: () => void;
    /**
     * @description 标题
     * @default '-'
     */
    title?: string | React.ReactNode;
    /**
     * @description 底部操作配置
     * @default []
     */
    actions?: ModalAction[];
    /**
     * @description 去除默认样式，完全自定义弹窗内容
     * @default false
     */
    fullContent?: boolean;
}
export interface ModalAction {
    /**
     * @description 行动点文案
     */
    text: string;
    /**
     * @description 行动点点击事件
     */
    onClick?: (...args: any[]) => void | Promise<any>;
    /**
     * @description 行动点样式
     */
    style?: React.CSSProperties;
}
export type Callback = (valueOrLogin: string, password?: string) => void;
export type CallbackOrActions<T> = Callback | ModalAction[];
export declare const dtMobileModalPrefix: string;
