import React from 'react';
import './style/index';
import { NativeProps } from '../_internal/native-props';
export type NavbarProps = {
    /**
     * @description 导航左边内容
     * @default 退出按钮
     */
    leftContent?: React.ReactNode;
    /**
     * @description 导航右边内容
     */
    rightContent?: React.ReactNode;
    /**
     * @descrption 点击左侧退出按钮触发的回调事件
     */
    onLeftClick?: () => void;
} & NativeProps;
declare const NavBar: React.FC<React.PropsWithChildren<NavbarProps>>;
export default NavBar;
