import React, { memo } from 'react';
import classNames from 'classnames';
import { dtMobilePrefix } from '../style/index';
import './style/index';
import { useMobile } from '../hooks';
import LeftArrow2Outlined from 'dd-icons/lib/LeftArrow2Outlined';
import { withNativeProps } from '../_internal/native-props';
var dtNavBarPrefix = "".concat(dtMobilePrefix, "-nav-bar");
var NavBar = /*#__PURE__*/memo(function (props) {
  var _a;
  var leftContent = props.leftContent,
    rightContent = props.rightContent,
    onLeftClick = props.onLeftClick,
    className = props.className;
  var isMobile = useMobile();
  var wrapCls = classNames(dtNavBarPrefix, className, (_a = {}, _a["".concat(dtNavBarPrefix, "-desktop")] = !isMobile, _a));
  return withNativeProps(props, /*#__PURE__*/React.createElement("div", {
    className: classNames(wrapCls)
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(dtNavBarPrefix, "-left"),
    role: "button"
  }, onLeftClick && (/*#__PURE__*/React.createElement("div", {
    className: "".concat(dtNavBarPrefix, "-back"),
    onClick: onLeftClick
  }, !leftContent && (/*#__PURE__*/React.createElement("span", {
    className: "".concat(dtNavBarPrefix, "-back-arrow")
  }, /*#__PURE__*/React.createElement(LeftArrow2Outlined, null))))), leftContent), /*#__PURE__*/React.createElement("div", {
    className: "".concat(dtNavBarPrefix, "-title")
  }, props.children), /*#__PURE__*/React.createElement("div", {
    className: "".concat(dtNavBarPrefix, "-right")
  }, rightContent)));
});
NavBar.displayName = 'NavBar';
export default NavBar;