"use strict";

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
exports.__esModule = true;
var NoticeBar_1 = require("../rmc/NoticeBar");
var classnames_1 = require("classnames");
var react_1 = require("react");
require("./style/index");
var index_1 = require("../style/index");
var NoticeTipOutlined_1 = require("dingtalk-design-icons/lib/NoticeTipOutlined");
var EliminateOutlined_1 = require("dd-icons/lib/EliminateOutlined");
var WarningOutlined_1 = require("dd-icons/lib/WarningOutlined");
var native_props_1 = require("../_internal/native-props");
var config_provider_1 = require("../config-provider");
var _internal_1 = require("../_internal");
var NoticeBar = function NoticeBar(props) {
  var _a;
  var type = props.type,
    text = props.text,
    className = props.className,
    onClick = props.onClick,
    icon = props.icon,
    children = props.children,
    _props = __rest(props, ["type", "text", "className", "onClick", "icon", "children"]);
  var wrapCls = classnames_1["default"](index_1.dtMobileNoticeBarPrefix + "-" + type, className, (_a = {}, _a[index_1.dtMobileNoticeBarPrefix + "-desktop"] = !_internal_1.isMobile, _a));
  var locale = config_provider_1.useConfig().locale;
  var handleClick = react_1.useCallback(function () {
    typeof onClick === 'function' && onClick();
  }, [onClick]);
  var showIcon = react_1["default"].createElement(NoticeTipOutlined_1["default"], null);
  switch (type) {
    case 'error':
      showIcon = react_1["default"].createElement(EliminateOutlined_1["default"], null);
      break;
    case 'warn':
      showIcon = react_1["default"].createElement(WarningOutlined_1["default"], null);
      break;
  }
  if (icon) {
    showIcon = icon;
  }
  return native_props_1.withNativeProps(props, react_1["default"].createElement(NoticeBar_1["default"], __assign({
    prefixCls: index_1.dtMobileNoticeBarPrefix,
    onClick: handleClick,
    marqueeProps: {
      loop: false,
      leading: 0,
      trailing: 0,
      className: 'abc',
      style: {
        whiteSpace: 'pre-wrap',
        display: '-webkit-box',
        WebkitBoxOrient: 'vertical'
      }
    },
    icon: showIcon,
    className: wrapCls
  }, _props), text !== null && text !== void 0 ? text : locale.NoticeBar.text));
};
NoticeBar.displayName = 'NoticeBar';
exports["default"] = NoticeBar;