var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import { default as RmcNoticeBar } from '../rmc/NoticeBar';
import classnames from 'classnames';
import React, { useCallback } from 'react';
import './style/index';
import { dtMobileNoticeBarPrefix } from '../style/index';
import NoticeTipOutlined from 'dingtalk-design-icons/lib/NoticeTipOutlined';
import EliminateOutlined from 'dd-icons/lib/EliminateOutlined';
import WarningOutlined from 'dd-icons/lib/WarningOutlined';
import { withNativeProps } from '../_internal/native-props';
import { useConfig } from '../config-provider';
import { useMobile } from '../hooks';
export var NoticeBarType;
(function (NoticeBarType) {
  NoticeBarType["INFO"] = "info";
  NoticeBarType["WARN"] = "warn";
  NoticeBarType["ERROR"] = "error";
})(NoticeBarType || (NoticeBarType = {}));
var NoticeBar = function NoticeBar(props) {
  var _a;
  var type = props.type,
    text = props.text,
    className = props.className,
    onClick = props.onClick,
    onClose = props.onClose,
    icon = props.icon,
    children = props.children,
    _props = __rest(props, ["type", "text", "className", "onClick", "onClose", "icon", "children"]);
  var isMobile = useMobile();
  var wrapCls = classnames("".concat(dtMobileNoticeBarPrefix, "-").concat(type), className, (_a = {}, _a["".concat(dtMobileNoticeBarPrefix, "-desktop")] = !isMobile, _a["".concat(dtMobileNoticeBarPrefix, "-trigger")] = !!onClick, _a));
  var locale = useConfig().locale;
  var handleClick = useCallback(function () {
    typeof onClose === 'function' && onClose() || typeof onClick === 'function' && onClick();
  }, [onClick, onClose]);
  var showIcon = /*#__PURE__*/React.createElement(NoticeTipOutlined, null);
  switch (type) {
    case NoticeBarType.ERROR:
      showIcon = /*#__PURE__*/React.createElement(EliminateOutlined, null);
      break;
    case NoticeBarType.WARN:
      showIcon = /*#__PURE__*/React.createElement(WarningOutlined, null);
      break;
  }
  if (icon) {
    showIcon = icon;
  }
  return withNativeProps(props, /*#__PURE__*/React.createElement(RmcNoticeBar, __assign({
    prefixCls: dtMobileNoticeBarPrefix,
    onClick: onClick,
    onClose: onClose,
    marqueeProps: {
      loop: false,
      leading: 0,
      trailing: 0,
      className: 'abc',
      style: {
        whiteSpace: 'pre-wrap',
        display: '-webkit-box',
        WebkitBoxOrient: 'vertical'
      }
    },
    icon: showIcon,
    className: wrapCls
  }, _props), text !== null && text !== void 0 ? text : locale.NoticeBar.text));
};
NoticeBar.displayName = 'NoticeBar';
export default NoticeBar;