var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React, { useMemo, useEffect, useCallback } from 'react';
import cls from 'classnames';
import 'dingtalk-jsapi/entry/union';
import setTitle from 'dingtalk-jsapi/api/biz/navigation/setTitle';
import setLeft from 'dingtalk-jsapi/api/biz/navigation/setLeft';
import setRight from 'dingtalk-jsapi/api/biz/navigation/setRight';
import setMenu from 'dingtalk-jsapi/api/biz/navigation/setMenu';
import quit$ from 'dingtalk-jsapi/api/biz/navigation/quit';
import close$ from 'dingtalk-jsapi/api/biz/navigation/close';
import LeftArrow2Outlined from 'dd-icons/lib/LeftArrow2Outlined';
import CloseOutlined from 'dd-icons/lib/CloseOutlined';
import { isInDingTalk } from '../_internal/env';
import { useMobile } from '../hooks';
import Button from '../button';
import { PageContainerActionType } from './interface';
import { dtMobilePrefix } from '../style/index';
import './style/index';
import { setSafeHeight } from '../_internal/set-safe-height';
var prefixCls = "".concat(dtMobilePrefix, "-page-container");
var PageContainer = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _a, _b;
  var children = props.children,
    className = props.className,
    _native = props["native"],
    title = props.title,
    _c = props.full,
    full = _c === void 0 ? true : _c,
    hasBack = props.hasBack,
    actions = props.actions,
    extra = props.extra,
    strongMainAction = props.strongMainAction,
    fullScreen = props.fullScreen,
    onBeforeBack = props.onBeforeBack,
    onBeforeClose = props.onBeforeClose,
    restProps = __rest(props, ["children", "className", "native", "title", "full", "hasBack", "actions", "extra", "strongMainAction", "fullScreen", "onBeforeBack", "onBeforeClose"]);
  var isMobile = useMobile();
  var mainAction = useMemo(function () {
    return (actions || []).find(function (item) {
      return item.type === PageContainerActionType.OK;
    });
  }, [actions]);
  var closeAction = useMemo(function () {
    return (actions || []).find(function (item) {
      return item.type === PageContainerActionType.CANCEL;
    });
  }, [actions]);
  var otherAction = useMemo(function () {
    return (actions || []).find(function (item) {
      return item.type === PageContainerActionType.DEFAULT || item.type === undefined;
    });
  }, [actions]);
  var normalActions = useMemo(function () {
    return (actions || []).filter(function (item) {
      return !item.type;
    });
  }, [actions]);
  var back = useCallback(function () {
    history.back();
  }, []);
  var close = useCallback(function () {
    if (isMobile) {
      close$({});
    } else {
      quit$({});
    }
  }, []);
  useEffect(function () {
    if (fullScreen) {
      setSafeHeight();
    }
    if (isMobile) {
      if (_native && isInDingTalk) {
        if (title) {
          setTitle({
            title: title
          });
        }
        if (hasBack) {
          setLeft({
            android: true,
            control: true,
            onSuccess: function onSuccess() {
              if (onBeforeBack) {
                onBeforeBack(back);
              } else {
                back();
              }
            }
          });
        }
        // 移动端右上角动作按钮
        if (mainAction && otherAction && !strongMainAction && typeof mainAction.text === 'string' && typeof otherAction.text === 'string') {
          setMenu({
            items: [{
              id: PageContainerActionType.DEFAULT,
              text: otherAction.text
            }, {
              id: PageContainerActionType.OK,
              text: mainAction.text
            }],
            onSuccess: function onSuccess(data) {
              var _a, _b;
              if (data.id === PageContainerActionType.DEFAULT) {
                (_a = otherAction.onClick) === null || _a === void 0 ? void 0 : _a.call(otherAction, close);
              } else if (data.id === PageContainerActionType.OK) {
                (_b = mainAction.onClick) === null || _b === void 0 ? void 0 : _b.call(mainAction, close);
              }
            }
          });
        } else if (mainAction && !strongMainAction && typeof mainAction.text === 'string') {
          setRight({
            show: true,
            control: 'onClick' in mainAction,
            text: mainAction.text,
            onSuccess: function onSuccess() {
              if (mainAction.onClick) {
                mainAction.onClick(close);
              }
            },
            // @ts-ignore
            style: '2'
          });
        } else {
          setRight({
            show: false
          });
        }
      }
    }
  }, [_native, title, onBeforeBack, mainAction, strongMainAction, fullScreen]);
  var Header = useMemo(function () {
    if (_native && isInDingTalk) {
      return null;
    }
    var Close = /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-icon-action"),
      onClick: function onClick() {
        if (onBeforeClose) {
          onBeforeClose(close);
        } else {
          close();
        }
      }
    }, /*#__PURE__*/React.createElement(CloseOutlined, null));
    return /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-header")
    }, (hasBack || isMobile) && (/*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-header-left")
    }, hasBack ? (/*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-icon-action"),
      onClick: function onClick() {
        if (onBeforeBack) {
          onBeforeBack(back);
        } else {
          back();
        }
      }
    }, /*#__PURE__*/React.createElement(LeftArrow2Outlined, null))) : isMobile && Close)), /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-header-title")
    }, title), /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-header-right")
    }, (normalActions || []).map(function (item, index) {
      return /*#__PURE__*/React.createElement("div", {
        key: index,
        className: "".concat(prefixCls, "-icon-action"),
        onClick: function onClick() {
          item.onClick && item.onClick(close);
        }
      }, item.icon);
    }), !!normalActions.length && !isMobile && (/*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-header-right-divider")
    })), isMobile ? mainAction && !strongMainAction && (/*#__PURE__*/React.createElement("div", {
      style: {
        marginRight: '16px'
      },
      onClick: function onClick() {
        mainAction.onClick && mainAction.onClick(close);
      }
    }, mainAction.text)) : Close));
  }, [_native, title, onBeforeClose, onBeforeBack, normalActions, mainAction, strongMainAction, close]);
  var Footer = useMemo(function () {
    if (!extra) {
      if (isMobile) {
        if (!mainAction || !strongMainAction) {
          return null;
        }
      } else {
        if (!mainAction && !closeAction) {
          return null;
        }
      }
    }
    return /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-footer")
    }, !!extra && /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-extra")
    }, extra), /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-footer-actions")
    }, !!otherAction && !closeAction && (/*#__PURE__*/React.createElement(Button, {
      className: "".concat(prefixCls, "-footer-action"),
      disabled: otherAction.disabled,
      loading: otherAction.loading,
      icon: otherAction.icon,
      onClick: function onClick() {
        otherAction.onClick && otherAction.onClick(close);
      }
    }, otherAction.text)), !!closeAction && (/*#__PURE__*/React.createElement(Button, {
      className: "".concat(prefixCls, "-footer-action"),
      disabled: closeAction.disabled,
      loading: closeAction.loading,
      icon: closeAction.icon,
      onClick: function onClick() {
        if (onBeforeClose) {
          onBeforeClose(close);
        } else {
          close();
        }
      }
    }, closeAction.text)), !!mainAction && (/*#__PURE__*/React.createElement(Button, {
      className: "".concat(prefixCls, "-footer-action"),
      type: "primary",
      disabled: mainAction.disabled,
      loading: mainAction.loading,
      icon: mainAction.icon,
      onClick: function onClick() {
        mainAction.onClick && mainAction.onClick(close);
      }
    }, mainAction.text))));
  }, [strongMainAction, extra, onBeforeClose, mainAction, closeAction]);
  var sharedCls = cls(prefixCls, (_a = {}, _a["".concat(prefixCls, "-pc")] = !isMobile, _a), className);
  if (Header || Footer) {
    return /*#__PURE__*/React.createElement("div", __assign({}, restProps, {
      className: cls(sharedCls, (_b = {}, _b["".concat(prefixCls, "-full")] = full, _b)),
      ref: ref
    }), fullScreen && !_native && /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-safe-area-header")
    }), Header, /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-body")
    }, children), Footer);
  } else {
    return /*#__PURE__*/React.createElement("div", __assign({}, restProps, {
      className: cls(sharedCls, "".concat(prefixCls, "-simple")),
      ref: ref
    }), children);
  }
});
PageContainer.displayName = 'PageContainer';
export { PageContainerActionType };
export default PageContainer;