import * as React from 'react';
import { PickerData, PickerPropsType } from './PropsType';
import './style';
export interface AbstractPickerProps extends PickerPropsType {
    pickerPrefixCls?: string;
    popupPrefixCls?: string;
    isMobile?: boolean;
}
export declare function getDefaultProps(): {
    triggerType: string;
    prefixCls: string;
    pickerPrefixCls: string;
    popupPrefixCls: string;
    format: (values: React.ReactNode[]) => string | React.ReactNode[];
    cols: number;
    cascade: boolean;
    title: string;
};
export default abstract class AbstractPicker extends React.Component<React.PropsWithChildren<AbstractPickerProps>, any> {
    protected abstract popupProps: {};
    private scrollValue;
    state: {
        visible: boolean;
        value: any[];
    };
    getSel: () => string | React.ReactNode[] | undefined;
    getPickerCol: () => React.JSX.Element[];
    onOk: (v: any) => void;
    setScrollValue: (v: any) => void;
    setCasecadeScrollValue: (v: any) => void;
    fixOnOk: (cascader: any) => void;
    onPickerChange: (v: any) => void;
    onVisibleChange: (visible: boolean) => void;
    onClickItem: (v: any, index: number) => void;
    renderListPicker: (item: PickerData | PickerData[], idx: number) => React.JSX.Element;
    render(): React.JSX.Element;
}
