var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var __spreadArray = this && this.__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
/* tslint:disable:jsx-no-multiline-js */
import treeFilter from 'array-tree-filter';
import * as React from 'react';
import RMCCascader from 'rmc-cascader/lib/Cascader';
import RMCPopupCascader from 'rmc-cascader/lib/Popup';
import RMCMultiPicker from 'rmc-picker/lib/MultiPicker';
import RMCPicker from 'rmc-picker/lib/Picker';
import CloseOutlined from 'dingtalk-design-icons/lib/CloseOutlined';
import { dtPickerPrefix } from '../style';
import Popover from '../popover';
import RightArrow2Outlined from 'dd-icons/lib/RightArrow2Outlined';
import './style';
export function getDefaultProps() {
  var defaultFormat = function defaultFormat(values) {
    // label is JSX.Element or other
    if (values.length > 0 && typeof values[0] !== 'string') {
      return values;
    }
    return values.join(',');
  };
  return {
    triggerType: 'onClick',
    prefixCls: dtPickerPrefix,
    pickerPrefixCls: "".concat(dtPickerPrefix, "-col"),
    popupPrefixCls: "".concat(dtPickerPrefix, "-popup"),
    format: defaultFormat,
    cols: 3,
    cascade: true,
    title: ''
  };
}
var AbstractPicker = /** @class */function (_super) {
  __extends(AbstractPicker, _super);
  function AbstractPicker() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.state = {
      visible: false,
      value: new Array(_this.props.data.length).fill(null)
    };
    _this.getSel = function () {
      var value = [];
      if (_this.props.isMobile) {
        value = _this.props.value || [];
      } else {
        var curState = _this.state.value.map(function (ele) {
          return ele === null || ele === void 0 ? void 0 : ele.value;
        });
        if (curState.filter(Boolean).length === 0 && _this.props.value) {
          value = _this.props.value;
        } else {
          value = curState;
        }
      }
      var treeChildren;
      var data = _this.props.data;
      if (_this.props.cascade) {
        treeChildren = treeFilter(data, function (c, level) {
          return c.value === value[level];
        });
      } else {
        if (value.filter(function (v) {
          return v !== undefined;
        }).length === 0) {
          treeChildren = [];
        } else {
          treeChildren = value.map(function (v, i) {
            return data[i].filter(function (d) {
              return d.value === v;
            })[0];
          });
        }
      }
      return _this.props.format && _this.props.format(treeChildren.map(function (v) {
        return v === null || v === void 0 ? void 0 : v.label;
      }));
    };
    _this.getPickerCol = function () {
      var _a = _this.props,
        data = _a.data,
        pickerPrefixCls = _a.pickerPrefixCls,
        itemStyle = _a.itemStyle,
        indicatorStyle = _a.indicatorStyle;
      return data.map(function (col, index) {
        return /*#__PURE__*/React.createElement(RMCPicker, {
          key: index,
          prefixCls: pickerPrefixCls,
          style: {
            flex: 1
          },
          itemStyle: itemStyle,
          indicatorStyle: indicatorStyle
        }, col.map(function (item) {
          return /*#__PURE__*/React.createElement(RMCPicker.Item, {
            key: item.value,
            value: item.value
          }, item.label);
        }));
      });
    };
    _this.onOk = function (v) {
      if (_this.scrollValue !== undefined) {
        v = _this.scrollValue;
      }
      if (_this.props.onChange) {
        _this.props.onChange(v);
      }
      if (_this.props.onOk) {
        _this.props.onOk(v);
      }
    };
    _this.setScrollValue = function (v) {
      _this.scrollValue = v;
    };
    _this.setCasecadeScrollValue = function (v) {
      // 级联情况下保证数据正确性，滚动过程中只有当最后一级变化时才变更数据
      if (v && _this.scrollValue) {
        var length_1 = _this.scrollValue.length;
        if (length_1 === v.length && _this.scrollValue[length_1 - 1] === v[length_1 - 1]) {
          return;
        }
      }
      _this.setScrollValue(v);
    };
    _this.fixOnOk = function (cascader) {
      if (cascader && cascader.onOk !== _this.onOk) {
        cascader.onOk = _this.onOk;
        cascader.forceUpdate();
      }
    };
    _this.onPickerChange = function (v) {
      _this.setScrollValue(v);
      if (_this.props.onPickerChange) {
        _this.props.onPickerChange(v);
      }
    };
    _this.onVisibleChange = function (visible) {
      _this.setScrollValue(undefined);
      if (_this.props.onVisibleChange) {
        _this.props.onVisibleChange(visible);
      }
    };
    _this.onClickItem = function (v, index) {
      if (index === _this.props.data.length - 1) {
        _this.setState({
          visible: false
        });
      }
      var value = __spreadArray([], __read(_this.state.value), false).map(function (item, idx) {
        return idx === index ? v : item;
      });
      _this.setState({
        value: value
      });
      if (_this.props.onPickerChange) {
        _this.props.onPickerChange([v === null || v === void 0 ? void 0 : v.value]);
      }
      if (_this.props.onChange) {
        _this.props.onChange([v === null || v === void 0 ? void 0 : v.value]);
      }
    };
    _this.renderListPicker = function (item, idx) {
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(dtPickerPrefix, "-desktop-popover-list")
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(dtPickerPrefix, "-desktop-popover-list-content")
      }, !Array.isArray(item) ? (/*#__PURE__*/React.createElement("div", {
        className: "".concat(dtPickerPrefix, "-desktop-popover-list-item")
      }, item.label)) : item.map(function (ele, index) {
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(dtPickerPrefix, "-desktop-popover-list-item"),
          onClick: function onClick() {
            return _this.onClickItem(ele, idx);
          },
          key: index
        }, ele.label, idx !== _this.props.data.length - 1 && (/*#__PURE__*/React.createElement(RightArrow2Outlined, {
          className: "".concat(dtPickerPrefix, "-desktop-popover-list-item-right-icon")
        })));
      })));
    };
    return _this;
  }
  AbstractPicker.prototype.render = function () {
    var _this = this;
    var _a = this.props,
      children = _a.children,
      _b = _a.value,
      value = _b === void 0 ? [] : _b,
      popupPrefixCls = _a.popupPrefixCls,
      itemStyle = _a.itemStyle,
      indicatorStyle = _a.indicatorStyle,
      okText = _a.okText,
      dismissText = _a.dismissText,
      extra = _a.extra,
      cascade = _a.cascade,
      prefixCls = _a.prefixCls,
      pickerPrefixCls = _a.pickerPrefixCls,
      data = _a.data,
      cols = _a.cols,
      onOk = _a.onOk,
      restProps = __rest(_a, ["children", "value", "popupPrefixCls", "itemStyle", "indicatorStyle", "okText", "dismissText", "extra", "cascade", "prefixCls", "pickerPrefixCls", "data", "cols", "onOk"]);
    var cascader;
    var popupMoreProps = {};
    if (cascade) {
      cascader = /*#__PURE__*/React.createElement(RMCCascader, {
        prefixCls: prefixCls,
        pickerPrefixCls: pickerPrefixCls,
        data: data,
        cols: cols,
        onChange: this.onPickerChange,
        onScrollChange: this.setCasecadeScrollValue,
        pickerItemStyle: itemStyle,
        indicatorStyle: indicatorStyle
      });
    } else {
      cascader = /*#__PURE__*/React.createElement(RMCMultiPicker, {
        style: {
          flexDirection: 'row',
          alignItems: 'center'
        },
        prefixCls: prefixCls,
        onScrollChange: this.setScrollValue
      }, this.getPickerCol());
      popupMoreProps = {
        pickerValueProp: 'selectedValue',
        pickerValueChangeProp: 'onValueChange'
      };
    }
    return /*#__PURE__*/React.createElement(React.Fragment, null, this.props.isMobile ? (/*#__PURE__*/React.createElement(RMCPopupCascader, __assign({
      cascader: cascader
    }, this.popupProps, restProps, {
      prefixCls: popupPrefixCls,
      value: value,
      dismissText: dismissText || /*#__PURE__*/React.createElement(CloseOutlined, null),
      okText: okText
    }, popupMoreProps, {
      ref: this.fixOnOk,
      onVisibleChange: this.onVisibleChange
    }), children && typeof children !== 'string' && /*#__PURE__*/React.isValidElement(children) && /*#__PURE__*/React.cloneElement(children, {
      extra: this.getSel() || extra
    }))) : (/*#__PURE__*/React.createElement(Popover, {
      visible: this.state.visible && !this.props.disabled,
      onVisibleChange: function onVisibleChange(visible) {
        return _this.setState({
          visible: visible
        });
      },
      placement: 'bottomRight',
      arrow: false,
      align: {
        offset: [-16, -16]
      },
      overlay: /*#__PURE__*/React.createElement("div", {
        className: "".concat(dtPickerPrefix, "-desktop-popover")
      }, this.props.data.map(function (item, idx) {
        return _this.renderListPicker(item, idx);
      }))
    }, children && typeof children !== 'string' && /*#__PURE__*/React.isValidElement(children) && /*#__PURE__*/React.cloneElement(children, {
      extra: this.getSel() || extra,
      onClick: function onClick() {
        var _a, _b;
        (_b = (_a = children.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a);
        _this.setState({
          visible: !_this.state.visible
        });
      }
    }))));
  };
  return AbstractPicker;
}(React.Component);
export default AbstractPicker;