var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React from 'react';
import Popover from '../popover';
import classnames from 'classnames';
import CloseOutlined from 'dingtalk-design-icons/lib/CloseOutlined';
import { dtPopguidePrefix, dtPopoverPrefix } from '../style/index';
import './style/index';
var TextItem = /*#__PURE__*/React.memo(function (props) {
  var prefix = "".concat(dtPopoverPrefix, "-text-item");
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(prefix)
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames("".concat(prefix, "-text"))
  }, props.text), props.closable && /*#__PURE__*/React.createElement("div", {
    className: classnames("".concat(prefix, "-close")),
    onClick: props.onClose
  }, /*#__PURE__*/React.createElement(CloseOutlined, null)));
});
TextItem.defaultProps = {
  text: '',
  closable: true
};
TextItem.displayName = 'PopoverTextItem';
var ImgTextItem = /*#__PURE__*/React.memo(function (props) {
  var _a;
  var prefix = "".concat(dtPopoverPrefix, "-img-text-item");
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(prefix)
  }, props.imgSrc && /*#__PURE__*/React.createElement("img", {
    className: classnames("".concat(prefix, "-img")),
    src: props.imgSrc
  }), /*#__PURE__*/React.createElement("div", {
    className: classnames("".concat(prefix, "-text-content"))
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames("".concat(prefix, "-text-content-title"))
  }, props.title), props.desc && /*#__PURE__*/React.createElement("div", {
    className: classnames("".concat(prefix, "-text-content-desc"))
  }, props.desc)), props.closable && /*#__PURE__*/React.createElement("div", {
    className: classnames("".concat(prefix, "-close"), (_a = {}, _a["".concat(prefix, "-close-center")] = !props.desc || !props.title, _a)),
    onClick: props.onClose
  }, /*#__PURE__*/React.createElement(CloseOutlined, null)));
});
ImgTextItem.defaultProps = {
  title: '',
  closable: true
};
ImgTextItem.displayName = 'PopoverImgTextItem';
var Popguide = function Popguide(props) {
  var placement = props.placement,
    visible = props.visible,
    title = props.title,
    subTitle = props.subTitle,
    image = props.image,
    onClose = props.onClose,
    onVisibleChange = props.onVisibleChange,
    otherProps = __rest(props, ["placement", "visible", "title", "subTitle", "image", "onClose", "onVisibleChange"]);
  var overlay = null;
  var onInnerClose = React.useCallback(function () {
    if (onVisibleChange) {
      onVisibleChange(false);
    }
    if (onClose) {
      onClose();
    }
  }, [onClose, onVisibleChange]);
  if (image || subTitle) {
    overlay = /*#__PURE__*/React.createElement(ImgTextItem, {
      title: title,
      imgSrc: image,
      desc: subTitle,
      onClose: onInnerClose
    });
  } else {
    overlay = /*#__PURE__*/React.createElement(TextItem, {
      text: title,
      onClose: onInnerClose
    });
  }
  // @ts-ignore
  return /*#__PURE__*/React.createElement(Popover, __assign({
    overlayClassName: "".concat(dtPopguidePrefix, "-popover"),
    dark: true,
    placement: placement,
    visible: visible,
    overlay: overlay,
    onVisibleChange: onVisibleChange
  }, otherProps));
};
Popguide.displayName = 'Popguide';
export default Popguide;