var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import React from 'react';
import classnames from 'classnames';
import Tooltip from 'rc-tooltip';
import { dtPopoverPrefix } from '../style/index';
import './style/index';
import { usePropsValue } from '../_internal/use-props-value';
var Popover = function Popover(_a) {
  var _b;
  var visible = _a.visible,
    placement = _a.placement,
    mask = _a.mask,
    maskClosable = _a.maskClosable,
    onVisibleChange = _a.onVisibleChange,
    overlay = _a.overlay,
    children = _a.children,
    trigger = _a.trigger,
    dark = _a.dark,
    overlayClassName = _a.overlayClassName,
    contentClassName = _a.contentClassName,
    _c = _a.arrow,
    arrow = _c === void 0 ? true : _c,
    getPopupContainer = _a.getPopupContainer,
    rest = __rest(_a, ["visible", "placement", "mask", "maskClosable", "onVisibleChange", "overlay", "children", "trigger", "dark", "overlayClassName", "contentClassName", "arrow", "getPopupContainer"]);
  var _d = __read(usePropsValue({
      value: visible,
      onChange: onVisibleChange,
      defaultValue: visible || false
    }), 2),
    innervisible = _d[0],
    setInnerVisible = _d[1];
  return /*#__PURE__*/React.createElement(Tooltip, __assign({
    overlayClassName: classnames(overlayClassName, (_b = {}, _b["".concat(dtPopoverPrefix, "-dark")] = dark, _b["".concat(dtPopoverPrefix, "-hide-arrow")] = !arrow, _b)),
    prefixCls: classnames(dtPopoverPrefix),
    overlay: /*#__PURE__*/React.createElement("div", {
      className: classnames("".concat(dtPopoverPrefix, "-inner-wrapper"))
    }, overlay),
    trigger: trigger,
    visible: innervisible,
    // @ts-ignore the next is visible on trigger
    mask: mask,
    placement: placement,
    maskClosable: maskClosable,
    onVisibleChange: setInnerVisible,
    getTooltipContainer: getPopupContainer
  }, rest), /*#__PURE__*/React.createElement("div", {
    className: contentClassName
  }, children && /*#__PURE__*/React.isValidElement(children) && /*#__PURE__*/React.cloneElement(children, {
    onClick: function onClick() {
      var _a, _b;
      (_b = (_a = children.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a);
      trigger !== 'none' && setInnerVisible(!visible);
    }
  })));
};
Popover.displayName = 'Popover';
Popover.defaultProps = {
  trigger: 'click'
};
export default Popover;