var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import classNames from 'classnames';
import React, { useState, useRef } from 'react';
import { useIsomorphicLayoutEffect, useUnmountedRef } from 'ahooks';
import { withNativeProps } from '../_internal/native-props';
import { mergeProps } from '../_internal/with-default-props';
import Mask from '../mask';
import { useLockScroll } from '../_internal/use-lock-scroll';
import { renderToContainer } from '../_internal/render-to-container';
import { useSpring, animated } from 'dd-react-spring-web';
import { withStopPropagation } from '../_internal/with-stop-propagation';
import { ShouldRender } from '../_internal/should-render';
import CloseOutlined from 'dd-icons/lib/CloseOutlined';
import { defaultPopupBaseProps } from './popup-base-props';
import { useInnerVisible } from '../_internal/use-inner-visible';
import { useConfig } from '../config-provider';
import { useDrag } from 'dd-use-gesture-react';
import { dtMobilePrefix } from '../style';
import { convertToPx } from '../_internal/convertToPx';
import { useMobile } from '../hooks';
var classPrefix = "".concat(dtMobilePrefix, "-popup");
var defaultProps = __assign(__assign({}, defaultPopupBaseProps), {
  position: 'bottom'
});
export var Popup = function Popup(p) {
  var _a, _b;
  var props = mergeProps(defaultProps, p);
  var locale = useConfig().locale;
  var isMobile = useMobile();
  var bodyCls = classNames("".concat(classPrefix, "-body"), props.bodyClassName, "".concat(classPrefix, "-body-position-").concat(props.position));
  var _c = __read(useState(props.visible), 2),
    active = _c[0],
    setActive = _c[1];
  useIsomorphicLayoutEffect(function () {
    if (props.visible) {
      setActive(true);
    }
  }, [props.visible]);
  var ref = useRef(null);
  var _d = __read(React.useState(convertToPx((_a = props.bodyStyle) === null || _a === void 0 ? void 0 : _a.width, true, ref.current)), 2),
    width = _d[0],
    setWidth = _d[1];
  useLockScroll(ref, props.disableBodyScroll && active ? 'strict' : false);
  // const springProps = useSpring({ width, immediate: (key) => key === 'width' });
  var unmountedRef = useUnmountedRef();
  var percent = useSpring({
    percent: props.visible ? 0 : 100,
    config: {
      precision: 0.1,
      mass: 1,
      tension: 300,
      friction: 30
    },
    onRest: function onRest() {
      var _a, _b;
      if (unmountedRef.current) return;
      setActive(props.visible);
      if (props.visible) {
        (_a = props.afterShow) === null || _a === void 0 ? void 0 : _a.call(props);
      } else {
        (_b = props.afterClose) === null || _b === void 0 ? void 0 : _b.call(props);
      }
    }
  }).percent;
  var bind = useDrag(function (_a) {
    var _b;
    var _c = __read(_a.swipe, 2),
      swipeY = _c[1];
    if (swipeY === 1 && props.position === 'bottom' || swipeY === -1 && props.position === 'top') {
      (_b = props.onClose) === null || _b === void 0 ? void 0 : _b.call(props);
    }
  }, {
    axis: 'y',
    enabled: ['top', 'bottom'].includes(props.position)
  });
  var maskVisible = useInnerVisible(active && props.visible);
  React.useEffect(function () {
    if (!props.canDrag || !ref.current) {
      return;
    }
    var resizeHandle = document.getElementById('resize-handle');
    var isResizing = false;
    function mouseDownHandler(e) {
      var _a;
      isResizing = true;
      var prevX = e.clientX;
      (_a = window.getSelection()) === null || _a === void 0 ? void 0 : _a.removeAllRanges(); // 取消复制的部分
      var mouseMoveHandler = function mouseMoveHandler(e) {
        var _a, _b, _c;
        (_a = window.getSelection()) === null || _a === void 0 ? void 0 : _a.removeAllRanges(); // 取消复制的部分
        if (!isResizing) return;
        if (!ref.current) return;
        var rect = ref.current.getBoundingClientRect();
        var newWidth = Math.min(Math.max(rect.width, props.minWidth), (_b = props.maxWidth) !== null && _b !== void 0 ? _b : document.body.clientWidth);
        var width = newWidth + (prevX - e.clientX);
        ref.current.style.width = width + 'px';
        (_c = props.onWidthChange) === null || _c === void 0 ? void 0 : _c.call(props, width);
        prevX = e.clientX;
      };
      function mouseUpHandler() {
        window.removeEventListener('mousemove', mouseMoveHandler);
        window.removeEventListener('mouseup', mouseUpHandler);
        isResizing = false;
      }
      window.addEventListener('mousemove', mouseMoveHandler);
      window.addEventListener('mouseup', mouseUpHandler);
    }
    resizeHandle === null || resizeHandle === void 0 ? void 0 : resizeHandle.addEventListener('mousedown', mouseDownHandler);
    return function () {
      resizeHandle === null || resizeHandle === void 0 ? void 0 : resizeHandle.removeEventListener('mousedown', mouseDownHandler);
    };
  }, [ref.current, props.canDrag, props.minWidth, props.maxWidth, props.onWidthChange]);
  React.useEffect(function () {
    var _a;
    setWidth(convertToPx((_a = props.bodyStyle) === null || _a === void 0 ? void 0 : _a.width, true, ref.current));
  }, [(_b = props.bodyStyle) === null || _b === void 0 ? void 0 : _b.width, ref.current]);
  var node = withStopPropagation(props.stopPropagation, withNativeProps(props, /*#__PURE__*/React.createElement("div", __assign({
    className: classPrefix,
    onClick: props.onClick,
    style: {
      visibility: active ? 'visible' : 'hidden',
      touchAction: ['top', 'bottom'].includes(props.position) ? 'none' : 'auto'
    }
  }, bind()), props.mask && (/*#__PURE__*/React.createElement(Mask, {
    visible: maskVisible,
    forceRender: props.forceRender,
    destroyOnClose: props.destroyOnClose,
    onMaskClick: function onMaskClick(e) {
      var _a, _b;
      (_a = props.onMaskClick) === null || _a === void 0 ? void 0 : _a.call(props, e);
      if (props.closeOnMaskClick) {
        (_b = props.onClose) === null || _b === void 0 ? void 0 : _b.call(props);
      }
    },
    className: props.maskClassName,
    opacity: props.maskTransparent ? 0 : undefined,
    style: props.maskStyle,
    disableBodyScroll: false,
    stopPropagation: props.stopPropagation
  })), /*#__PURE__*/React.createElement(animated.div, {
    className: bodyCls,
    style: __assign(__assign({}, props.bodyStyle), {
      width: width,
      minWidth: !isMobile ? props.minWidth : undefined,
      maxWidth: !isMobile ? props.maxWidth : undefined,
      userSelect: 'none',
      transform: percent.to(function (v) {
        if (props.position === 'bottom') {
          return "translate(0, ".concat(v, "%)");
        }
        if (props.position === 'top') {
          return "translate(0, -".concat(v, "%)");
        }
        if (props.position === 'left') {
          return "translate(-".concat(v, "%, 0)");
        }
        if (props.position === 'right') {
          return "translate(".concat(v, "%, 0)");
        }
        return 'none';
      })
    }),
    ref: ref
  }, props.showCloseButton && (/*#__PURE__*/React.createElement("a", {
    className: classNames("".concat(classPrefix, "-close-icon"), 'adm-plain-anchor'),
    onClick: function onClick() {
      var _a;
      (_a = props.onClose) === null || _a === void 0 ? void 0 : _a.call(props);
    },
    role: "button"
  }, /*#__PURE__*/React.createElement(CloseOutlined, null))), props.canDrag && /*#__PURE__*/React.createElement("div", {
    id: "resize-handle",
    className: "".concat(classPrefix, "-resize-handle")
  }), props.children))));
  return /*#__PURE__*/React.createElement(ShouldRender, {
    active: active,
    forceRender: props.forceRender,
    destroyOnClose: props.destroyOnClose
  }, renderToContainer(props.getContainer, node));
};