import React from 'react';
import './style/index';
import { dtProgressBarPrefix, ProgressStatus } from './index';
import CheckOutlined from 'dd-icons/lib/CheckOutlined';
import WarnFilled from 'dd-icons/lib/WarnFilled';
import classNames from 'classnames';
import { withNativeProps } from '../_internal/native-props';
import { useMobile } from '../hooks';
import classnames from 'classnames';
export var ProgressCircle = /*#__PURE__*/React.memo(function (p) {
  var _a;
  var percent = p.percent,
    status = p.status,
    circleSize = p.circleSize;
  var isMobile = useMobile();
  var Tag = React.useMemo(function () {
    var _a, _b, _c;
    switch (status) {
      case ProgressStatus.loading:
        return /*#__PURE__*/React.createElement("div", {
          className: classnames("".concat(dtProgressBarPrefix, "-circle-tag ").concat(dtProgressBarPrefix, "-circle-tag-loading"), (_a = {}, _a["".concat(dtProgressBarPrefix, "-circle-tag-desktop")] = !isMobile, _a))
        }, percent, "%");
      case ProgressStatus.error:
        return /*#__PURE__*/React.createElement("div", {
          className: classnames("".concat(dtProgressBarPrefix, "-circle-tag ").concat(dtProgressBarPrefix, "-circle-tag-error"), (_b = {}, _b["".concat(dtProgressBarPrefix, "-circle-tag-desktop")] = !isMobile, _b))
        }, /*#__PURE__*/React.createElement(WarnFilled, null));
      case ProgressStatus.success:
        return /*#__PURE__*/React.createElement("div", {
          className: classnames("".concat(dtProgressBarPrefix, "-circle-tag ").concat(dtProgressBarPrefix, "-circle-tag-success"), (_c = {}, _c["".concat(dtProgressBarPrefix, "-circle-tag-desktop")] = !isMobile, _c))
        }, /*#__PURE__*/React.createElement(CheckOutlined, null));
      default:
        return null;
    }
  }, [status, percent]);
  var style = {
    '--percent': (_a = percent === null || percent === void 0 ? void 0 : percent.toString()) !== null && _a !== void 0 ? _a : '0'
  };
  return withNativeProps(p, /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(dtProgressBarPrefix, "-circle"), "".concat(dtProgressBarPrefix, "-circle-").concat(circleSize)),
    style: style
  }, /*#__PURE__*/React.createElement("svg", {
    className: classNames("".concat(dtProgressBarPrefix, "-circle-svg"))
  }, /*#__PURE__*/React.createElement("circle", {
    className: "".concat(dtProgressBarPrefix, "-circle-track")
  }), /*#__PURE__*/React.createElement("circle", {
    className: classNames("".concat(dtProgressBarPrefix, "-circle-fill"), "".concat(dtProgressBarPrefix, "-circle-").concat(status))
  })), Tag));
});