import React from 'react';
import './style/index';
import { dtProgressBarPrefix, ProgressStatus } from './index';
import AchieveFilled from 'dd-icons/lib/AchieveFilled';
import WarningFilled from 'dd-icons/lib/WarningFilled';
import classNames from 'classnames';
export var ProgressLine = /*#__PURE__*/React.memo(function (p) {
  var percent = p.percent,
    status = p.status;
  var Tag = React.useMemo(function () {
    switch (status) {
      case ProgressStatus.loading:
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(dtProgressBarPrefix, "-tag ").concat(dtProgressBarPrefix, "-tag-loading")
        }, percent, "%");
      case ProgressStatus.error:
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(dtProgressBarPrefix, "-tag ").concat(dtProgressBarPrefix, "-tag-error")
        }, /*#__PURE__*/React.createElement(WarningFilled, null));
      case ProgressStatus.success:
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(dtProgressBarPrefix, "-tag ").concat(dtProgressBarPrefix, "-tag-success")
        }, /*#__PURE__*/React.createElement(AchieveFilled, null));
      default:
        return null;
    }
  }, [status, percent]);
  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(dtProgressBarPrefix, "-line-container")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(dtProgressBarPrefix, "-line")
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(dtProgressBarPrefix, "-fill"), "".concat(dtProgressBarPrefix, "-").concat(status)),
    style: {
      width: "".concat(percent, "%")
    }
  })), Tag);
});