import React from 'react';
import { BasePropsType } from '../_internal';
import './style/index';
import { NativeProps } from '../_internal/native-props';
export declare const dtProgressBarPrefix: string;
export type IProgressBarProps = {
    /**
     * @description 当前进度,百分比
     * @default 0
     */
    percent?: number;
    /**
     * @description 进度条类型
     * @default 'line''
     */
    type?: 'line' | 'circle';
    /**
     * @description 进度条状态
     * @default 'loading'
     */
    status?: 'loading' | 'error';
    /**
     * @description 进度条圆圈模式大小
     * @default 'normal'
     */
    circleSize?: 'normal' | 'small';
} & BasePropsType & NativeProps<'--line-width'>;
export declare enum ProgressStatus {
    loading = "loading",
    error = "error",
    success = "success"
}
declare const ProgressBar: React.FC<IProgressBarProps>;
export default ProgressBar;
