var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import * as React from 'react';
import classnames from 'classnames';
import { withError } from '../rmc';
import { useControlledByValue } from '../hooks';
import List from '../list';
import { dtMobileRadioGroupPrefix as prefixCls } from '../style/index';
var Group = function Group(props) {
  var className = props.className,
    name = props.name,
    disabled = props.disabled,
    children = props.children,
    renderHeader = props.renderHeader,
    renderFooter = props.renderFooter;
  var _a = useControlledByValue(props),
    value = _a.value,
    onChange = _a.onChange;
  var cls = classnames(prefixCls, className);
  return /*#__PURE__*/React.createElement(List, {
    renderHeader: renderHeader,
    renderFooter: renderFooter,
    className: cls
  }, React.Children.map(children, function (child, _index) {
    // 如果 child 不是 React.Element 直接报错
    return /*#__PURE__*/React.cloneElement(child, __assign({
      name: name,
      onChange: onChange,
      checkedValue: value
    }, !!disabled ? {
      disabled: disabled
    } : {}));
  }));
};
Group.displayName = 'RadioGroup';
Group.defaultProps = {
  defaultValue: ''
};
export default withError(Group);