var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import * as React from 'react';
import Radio from './Radio';
import { getDataAttr } from '../_internal';
import { useMobile } from '../hooks';
import List from '../list';
import { dtMobileRadioPrefix } from '../style/index';
var prefixCls = dtMobileRadioPrefix;
export var Item = function Item(props) {
  // 以下属性从 group cloneElement 传递而来
  // @ts-ignore
  var name = props.name,
    _onChange = props.onChange,
    checkedValue = props.checkedValue,
    brief = props.brief;
  var checked = checkedValue === props.value;
  var isMobile = useMobile();
  return /*#__PURE__*/React.createElement("label", __assign({
    className: prefixCls
  }, getDataAttr(props)), isMobile ? (/*#__PURE__*/React.createElement(List.Item, {
    disabled: props.disabled,
    hideDivider: props.hideDivider,
    extra: /*#__PURE__*/React.createElement(Radio, {
      value: props.value,
      disabled: props.disabled,
      name: name,
      id: props.id,
      onChange: function onChange(bingo) {
        return _onChange(props.value, bingo);
      },
      checked: checked
    }),
    brief: brief
  }, props.children)) : (/*#__PURE__*/React.createElement(List.Item, {
    className: "dtd-radio-item",
    disabled: props.disabled,
    hideDivider: props.hideDivider,
    brief: brief,
    thumb: /*#__PURE__*/React.createElement(Radio, {
      value: props.value,
      disabled: props.disabled,
      name: name,
      id: props.id,
      onChange: function onChange(bingo) {
        return _onChange(props.value, bingo);
      },
      checked: checked
    })
  }, props.children)));
};
Item.displayName = 'RadioItem';
export default Item;