var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import React, { useCallback } from 'react';
import classnames from 'classnames';
import SelectedOutlined from 'dingtalk-design-icons/lib/SelectedOutlined';
import { Labelable } from '../rmc';
import { useMobile } from '../hooks';
import { useControlledByChecked } from '../hooks';
import { dtMobileRadioPrefix as prefixCls } from '../style';
export var Radio = function Radio(props) {
  var _a = useControlledByChecked(props),
    checked = _a.checked,
    onChange = _a.onChange;
  var isMobile = useMobile();
  var handleLableChange = useCallback(function (e) {
    var v = e.target.checked;
    onChange(v);
  }, [onChange]);
  var radioIcon = null;
  if (isMobile) {
    radioIcon = checked && /*#__PURE__*/React.createElement(SelectedOutlined, {
      className: "".concat(prefixCls, "-checked-icon")
    });
  } else {
    radioIcon = /*#__PURE__*/React.createElement("span", {
      className: classnames('dtd-radio-inner', {
        'dtd-radio-inner-checked': checked,
        'dtd-radio-inner-disabled': props.disabled
      })
    });
  }
  return /*#__PURE__*/React.createElement(Labelable, __assign({
    onChange: handleLableChange
  }, Labelable.getProps(props), {
    checked: checked,
    value: props.value,
    type: "radio"
  }), radioIcon);
};
Radio.defaultProps = {
  defaultChecked: false
};
export default Radio;