import React from 'react';
import classNames from 'classnames';
import { withNativeProps } from '../_internal/native-props';
import StarFilled from 'dd-icons/lib/StarFilled';
import { useControlledByValue } from '../hooks';
import Toast from '../toast';
var classPrefix = "dtm-rate";
export var Rate = function Rate(props) {
  var _a;
  var _b;
  var _c = useControlledByValue(props),
    value = _c.value,
    onChange = _c.onChange;
  var starList = Array(props.count).fill(null);
  function renderStar(v, half) {
    var _a;
    return /*#__PURE__*/React.createElement("div", {
      className: classNames("".concat(classPrefix, "-star"), (_a = {}, _a["".concat(classPrefix, "-star-active")] = value >= v, _a["".concat(classPrefix, "-star-half")] = half, _a["".concat(classPrefix, "-star-readonly")] = props.readOnly, _a)),
      onClick: function onClick() {
        if (props.readOnly) {
          if (props.warningDesc) {
            Toast.fail({
              content: props.warningDesc
            });
          }
          return;
        }
        ;
        if (props.allowClear && value === v) {
          onChange(0);
        } else {
          onChange(v);
        }
      }
    }, props.character);
  }
  return withNativeProps(props, /*#__PURE__*/React.createElement("div", {
    className: classPrefix
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-star-container")
  }, starList.map(function (_, i) {
    return /*#__PURE__*/React.createElement("div", {
      key: i,
      className: classNames("".concat(classPrefix, "-box"))
    }, props.allowHalf && renderStar(i + 0.5, true), renderStar(i + 1, false));
  })), props.showLabel && ((_b = props.labels) === null || _b === void 0 ? void 0 : _b[value]) && (/*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(classPrefix, "-label"), (_a = {}, _a["".concat(classPrefix, "-label-nostar")] = value === 0, _a))
  }, props.labels[value]))));
};
Rate.defaultProps = {
  count: 5,
  allowHalf: false,
  character: /*#__PURE__*/React.createElement(StarFilled, null),
  defaultValue: 0,
  readOnly: false,
  allowClear: true,
  labels: ['你的反馈很重要', '非常不满意，我要吐槽', '不满意，我要吐槽', '一般般，还需要改善', '比较满意，仍待提升', '太棒了，我想夸一夸']
};
Rate.displayName = 'Rate';