import React from 'react';
import IDatePickerProps from './IDatePickerProps';
import { DateManager } from '../../_internal/getDate';
declare class DatePicker extends React.Component<IDatePickerProps, any> {
    static defaultProps: {
        prefixCls: string;
        pickerPrefixCls: string;
        locale: {
            year: string;
            month: string;
            day: string;
            hour: string;
            minute: string;
            am: string;
            pm: string;
        };
        mode: string;
        disabled: boolean;
        minuteStep: number;
        onDateChange(): void;
        use12Hours: boolean;
    };
    state: {
        date: any;
    };
    dateManager: DateManager;
    constructor(props: any);
    componentWillReceiveProps(nextProps: any): void;
    getNewDate: (values: any, index: any) => Date;
    onValueChange: (values: any, index: any) => void;
    onScrollChange: (values: any, index: any) => void;
    setHours(date: any, hour: any): void;
    setAmPm(date: any, index: any): void;
    getDate(): Date;
    getValue(): Date;
    getDisplayHour(rawHour: any): any;
    getTimeData(date: any): {
        cols: {
            key: string;
            props: {
                children: any[];
            };
        }[];
        selMinute: any;
    };
    renderColLabel(value: any, local: any): React.JSX.Element;
    render(): React.JSX.Element;
}
/**
 * 判断是否是至今的日期
 * @param date
 * @returns
 */
export declare const isUntilNowDate: (date: Date) => boolean;
export default DatePicker;
