var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
// @ts-nocheck
import React from 'react';
import MultiPicker from 'rmc-picker/lib/MultiPicker';
import Picker from 'rmc-picker/lib/Picker';
import defaultLocale from './locale/en_US';
import classnames from 'classnames';
import { DateManager, defaultMinDate } from '../../_internal/getDate';
function getDaysInMonth(date) {
  return new Date(date.getFullYear(), date.getMonth() + 1, 0).getDate();
}
function pad(n) {
  return n < 10 ? "0".concat(n) : n + '';
}
function cloneDate(date) {
  return new Date(+date);
}
function setMonth(date, month) {
  date.setDate(Math.min(date.getDate(), getDaysInMonth(new Date(date.getFullYear(), month))));
  date.setMonth(month);
}
// 至今，特殊年份替代
var UNTIL_NOW_YEAR = 10000;
var UNTIL_NOW_TEXT = '至今';
// const SO_FAR_DATE = new Date(UNTIL_NOW_YEAR.toString()).getTime();
var DATETIME = 'datetime';
var DATE = 'date';
var TIME = 'time';
var MONTH = 'month';
var YEAR = 'year';
var ONE_DAY = 24 * 60 * 60 * 1000;
var DatePicker = /** @class */function (_super) {
  __extends(DatePicker, _super);
  function DatePicker(props) {
    var _this = _super.call(this, props) || this;
    _this.state = {
      date: _this.props.date || _this.props.defaultDate
    };
    _this.getNewDate = function (values, index) {
      var value = parseInt(values[index], 10);
      var props = _this.props;
      var mode = props.mode;
      var newValue = cloneDate(_this.getDate());
      if (mode === DATETIME || mode === DATE || mode === YEAR || mode === MONTH) {
        switch (index) {
          case 0:
            newValue.setFullYear(value);
            break;
          case 1:
            // Note: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/setMonth
            // e.g. from 2017-03-31 to 2017-02-28
            setMonth(newValue, value);
            break;
          case 2:
            newValue.setDate(value);
            break;
          case 3:
            _this.setHours(newValue, value);
            break;
          case 4:
            newValue.setMinutes(value);
            break;
          case 5:
            _this.setAmPm(newValue, value);
            break;
          default:
            break;
        }
      } else if (mode === TIME) {
        switch (index) {
          case 0:
            _this.setHours(newValue, value);
            break;
          case 1:
            newValue.setMinutes(value);
            break;
          case 2:
            _this.setAmPm(newValue, value);
            break;
          default:
            break;
        }
      }
      console.log('🚀 ~ file: DatePicker.tsx:119 ~ DatePicker ~ newValue:', newValue);
      return _this.dateManager.clipDate(newValue, _this.props.mode);
    };
    _this.onValueChange = function (values, index) {
      var props = _this.props;
      var newValue = _this.getNewDate(values, index);
      if (!('date' in props)) {
        _this.setState({
          date: newValue
        });
      }
      if (props.onDateChange) {
        props.onDateChange(newValue);
      }
      if (props.onValueChange) {
        props.onValueChange(values, index);
      }
    };
    _this.onScrollChange = function (values, index) {
      var props = _this.props;
      if (props.onScrollChange) {
        var newValue = _this.getNewDate(values, index);
        props.onScrollChange(newValue, values, index);
      }
    };
    _this.dateManager = new DateManager({
      minDate: _this.props.minDate,
      maxDate: _this.props.maxDate
    });
    return _this;
  }
  DatePicker.prototype.componentWillReceiveProps = function (nextProps) {
    if ('date' in nextProps) {
      this.setState({
        date: nextProps.date || nextProps.defaultDate
      });
    }
  };
  DatePicker.prototype.setHours = function (date, hour) {
    if (this.props.use12Hours) {
      var dh = date.getHours();
      var nhour = hour;
      nhour = dh >= 12 ? hour + 12 : hour;
      nhour = nhour >= 24 ? 0 : nhour; // Make sure no more than one day
      date.setHours(nhour);
    } else {
      date.setHours(hour);
    }
  };
  DatePicker.prototype.setAmPm = function (date, index) {
    if (index === 0) {
      date.setTime(+date - ONE_DAY / 2);
    } else {
      date.setTime(+date + ONE_DAY / 2);
    }
  };
  DatePicker.prototype.getDate = function () {
    return this.dateManager.clipDate(this.state.date || defaultMinDate, this.props.mode);
  };
  // used by rmc-picker/lib/PopupMixin.js
  DatePicker.prototype.getValue = function () {
    return this.getDate();
  };
  DatePicker.prototype.getDisplayHour = function (rawHour) {
    // 12 hour am (midnight 00:00) -> 12 hour pm (noon 12:00) -> 12 hour am (midnight 00:00)
    if (this.props.use12Hours) {
      if (rawHour === 0) {
        rawHour = 12;
      }
      if (rawHour > 12) {
        rawHour -= 12;
      }
      return rawHour;
    }
    return rawHour;
  };
  DatePicker.prototype.getTimeData = function (date) {
    var _a = this.props,
      _b = _a.minHour,
      minHour = _b === void 0 ? 0 : _b,
      _c = _a.maxHour,
      maxHour = _c === void 0 ? 23 : _c,
      _d = _a.minMinute,
      minMinute = _d === void 0 ? 0 : _d,
      _e = _a.maxMinute,
      maxMinute = _e === void 0 ? 59 : _e;
    var _f = this.props,
      mode = _f.mode,
      locale = _f.locale,
      minuteStep = _f.minuteStep,
      use12Hours = _f.use12Hours,
      defaultDate = _f.defaultDate;
    var minDateMinute = this.dateManager.getMinMinute();
    var maxDateMinute = this.dateManager.getMaxMinute();
    var minDateHour = this.dateManager.getMinHour();
    var maxDateHour = this.dateManager.getMaxHour();
    var curDate = this.dateManager.getDate();
    var hour = date.getHours();
    if (mode === DATETIME) {
      var year = date.getFullYear();
      var month = date.getMonth();
      var day = date.getDate();
      var minDateYear = this.dateManager.getMinYear();
      var maxDateYear = this.dateManager.getMaxYear();
      var minDateMonth = this.dateManager.getMinMonth();
      var maxDateMonth = this.dateManager.getMaxMonth();
      var minDateDay = this.dateManager.getMinDay();
      var maxDateDay = this.dateManager.getMaxDay();
      if (minDateYear === year && minDateMonth === month && minDateDay === day) {
        minHour = minDateHour;
        if (minDateHour === hour) {
          minMinute = minDateMinute;
        }
      }
      if (maxDateYear === year && maxDateMonth === month && maxDateDay === day) {
        maxHour = maxDateHour;
        if (maxDateHour === hour) {
          maxMinute = maxDateMinute;
        }
      }
    } else {
      minHour = minDateHour;
      if (minDateHour === hour) {
        minMinute = minDateMinute;
      }
      maxHour = maxDateHour;
      if (maxDateHour === hour) {
        maxMinute = maxDateMinute;
      }
    }
    var hours = [];
    if (defaultDate.getMonth() !== this.dateManager.getMinMonth() || defaultDate.getDate() !== this.dateManager.getMinDay()) {
      minHour = 0;
      minMinute = 0;
    }
    if (minHour === 0 && maxHour === 0 || minHour !== 0 && maxHour !== 0) {
      minHour = this.getDisplayHour(minHour);
    } else if (minHour === 0 && use12Hours) {
      minHour = 1;
      hours.push({
        value: '0',
        label: locale.hour ? this.renderColLabel(12, locale.hour) : '12'
      });
    }
    maxHour = this.getDisplayHour(maxHour);
    for (var i = minHour; i <= maxHour; i++) {
      hours.push({
        value: i + '',
        label: locale.hour ? this.renderColLabel(i, locale.hour) : pad(i)
      });
    }
    var minutes = [];
    var selMinute = date.getMinutes();
    for (var i = minMinute; i <= maxMinute; i += minuteStep) {
      minutes.push({
        value: i + '',
        label: locale.minute ? this.renderColLabel(i, locale.minute) : pad(i)
      });
      if (selMinute > i && selMinute < i + minuteStep) {
        minutes.push({
          value: selMinute + '',
          label: locale.minute ? this.renderColLabel(selMinute, locale.minute) : pad(selMinute)
        });
      }
    }
    var cols = [{
      key: 'hours',
      props: {
        children: hours
      }
    }, {
      key: 'minutes',
      props: {
        children: minutes
      }
    }].concat(use12Hours ? [{
      key: 'ampm',
      props: {
        children: [{
          value: '0',
          label: locale.am
        }, {
          value: '1',
          label: locale.pm
        }]
      }
    }] : []);
    return {
      cols: cols,
      selMinute: selMinute
    };
  };
  // 钉钉特有
  DatePicker.prototype.renderColLabel = function (value, local) {
    return /*#__PURE__*/React.createElement("span", {
      className: "".concat(this.props.prefixCls, "-col-item-text")
    }, value, /*#__PURE__*/React.createElement("span", {
      className: "".concat(this.props.prefixCls, "-col-item-text-unit")
    }, local));
  };
  DatePicker.prototype.render = function () {
    var _a = this.props,
      mode = _a.mode,
      showUntilNow = _a.showUntilNow,
      locale = _a.locale,
      prefixCls = _a.prefixCls,
      use12Hours = _a.use12Hours,
      disabled = _a.disabled,
      pickerPrefixCls = _a.pickerPrefixCls,
      rootNativeProps = _a.rootNativeProps,
      className = _a.className,
      style = _a.style,
      itemStyle = _a.itemStyle,
      formatDay = _a.formatDay,
      formatMonth = _a.formatMonth;
    var _b = this.dateManager.getValueCols(this.state.date, mode, showUntilNow, locale, prefixCls, use12Hours, this.getTimeData(this.getDate()), formatMonth, formatDay),
      value = _b.value,
      cols = _b.cols;
    var multiStyle = __assign({
      flexDirection: 'row',
      alignItems: 'center'
    }, style);
    return /*#__PURE__*/React.createElement(MultiPicker, {
      style: multiStyle,
      rootNativeProps: rootNativeProps,
      className: classnames('date-picker', "date-picker-col-".concat(cols.length), className),
      prefixCls: prefixCls,
      selectedValue: value,
      onValueChange: this.onValueChange,
      onScrollChange: this.onScrollChange
    }, cols.map(function (p) {
      return /*#__PURE__*/React.createElement(Picker, {
        style: {
          flex: 1
        },
        key: p.key,
        disabled: disabled,
        prefixCls: pickerPrefixCls,
        itemStyle: itemStyle
      }, p.props.children.map(function (item) {
        return /*#__PURE__*/React.createElement(Picker.Item, {
          key: item.value,
          value: item.value
        }, item.label);
      }));
    }));
  };
  DatePicker.defaultProps = {
    prefixCls: 'rmc-date-picker',
    pickerPrefixCls: 'rmc-picker',
    locale: defaultLocale,
    mode: DATE,
    disabled: false,
    minuteStep: 1,
    onDateChange: function onDateChange() {},
    use12Hours: false
  };
  return DatePicker;
}(React.Component);
/**
 * 判断是否是至今的日期
 * @param date
 * @returns
 */
export var isUntilNowDate = function isUntilNowDate(date) {
  return date.getFullYear() === UNTIL_NOW_YEAR;
};
export default DatePicker;