import * as React from 'react';
import { createPortal } from 'react-dom';
import RMCDialog from 'rmc-dialog';
import classnames from 'classnames';
import { useBodyScrollLock } from '../../hooks';
import { useContainer } from '../../hooks';
import "./index.css";
var Dialog = function Dialog(props) {
  var prefixCls = 'amd-dialog';
  var dom = useContainer('dialog', props.visible);
  useBodyScrollLock(props.visible);
  var cls = classnames(props.className, "".concat(prefixCls, "-").concat(props.position));
  var transitionNameMap = {
    center: 'amd-zoom',
    top: 'amd-slide-down',
    bottom: 'amd-slide-up',
    left: 'amd-slide-right',
    right: 'amd-slide-left'
  };
  // 这里不需要 fade-out/zoom-out 的动效，直接关掉
  if (!props.visible) {
    return null;
  }
  return /*#__PURE__*/createPortal(
  /*#__PURE__*/
  // @ts-ignore
  React.createElement(RMCDialog, {
    visible: props.visible,
    title: "",
    className: cls,
    prefixCls: prefixCls,
    transitionName: transitionNameMap[props.position],
    maskTransitionName: "amd-fade",
    maskClosable: props.maskClosable,
    onClose: props.onClose,
    footer: props.footer,
    closable: false
  }, props.children), dom);
};
Dialog.defaultProps = {
  position: 'center'
};
export default Dialog;