// 用于像 NumericInput 这类，在键盘上输入的时候，不触发 input 的 blur 方法
// 同时为了键盘本身是一个封闭空间，把冒泡也禁掉
import * as React from 'react';
var EventInside = function EventInside(props) {
  var child = React.Children.only(props.children);
  var stopAll = function stopAll(e) {
    if (!props.allowDefault) {
      e.preventDefault();
    }
    e.stopPropagation();
  };
  // @ts-ignore
  return /*#__PURE__*/React.cloneElement(child, {
    // 移动端
    onTouchStart: stopAll,
    // pc 端
    onMouseDown: stopAll,
    onClick: stopAll,
    onContextMenu: stopAll,
    style: {
      touchAction: 'none'
    }
  });
};
EventInside.defaultProps = {
  allowDefault: false
};
export default EventInside;