// @ts-nocheck
/*
 * https://github.com/jasonslyvia/react-marquee
 * remove PC
 * support React Element for text prop
 */
var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import * as React from 'react';
import * as ReactDOM from 'react-dom';
var Marquee = /** @class */function (_super) {
  __extends(Marquee, _super);
  function Marquee() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.state = {
      animatedWidth: 0,
      overflowWidth: 0
    };
    return _this;
  }
  Marquee.prototype.componentDidMount = function () {
    this._measureText();
    this._startAnimation();
  };
  Marquee.prototype.componentDidUpdate = function () {
    this._measureText();
    if (!this._marqueeTimer) {
      this._startAnimation();
    }
  };
  Marquee.prototype.componentWillUnmount = function () {
    clearTimeout(this._marqueeTimer);
  };
  Marquee.prototype.render = function () {
    var _this = this;
    var _a = this.props,
      prefixCls = _a.prefixCls,
      className = _a.className,
      text = _a.text;
    var style = __assign({
      position: 'relative',
      right: this.state.animatedWidth,
      whiteSpace: 'nowrap',
      display: 'inline-block'
    }, this.props.style);
    return /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-marquee-wrap ").concat(className),
      style: {
        overflow: 'hidden'
      },
      role: "marquee"
    }, /*#__PURE__*/React.createElement("div", {
      ref: function ref(el) {
        return _this.textRef = el;
      },
      className: "".concat(prefixCls, "-marquee"),
      style: style
    }, text));
  };
  Marquee.prototype._startAnimation = function () {
    var _this = this;
    if (this._marqueeTimer) {
      window.clearTimeout(this._marqueeTimer);
    }
    var fps = this.props.fps;
    var TIMEOUT = 1 / fps * 1000;
    var isLeading = this.state.animatedWidth === 0;
    var timeout = isLeading ? this.props.leading : TIMEOUT;
    var _animate = function animate() {
      var overflowWidth = _this.state.overflowWidth;
      var animatedWidth = _this.state.animatedWidth + 1;
      var isRoundOver = animatedWidth > overflowWidth;
      if (isRoundOver) {
        if (_this.props.loop) {
          animatedWidth = 0;
        } else {
          return;
        }
      }
      if (isRoundOver && _this.props.trailing) {
        _this._marqueeTimer = window.setTimeout(function () {
          _this.setState({
            animatedWidth: animatedWidth
          });
          _this._marqueeTimer = window.setTimeout(_animate, TIMEOUT);
        }, _this.props.trailing);
      } else {
        _this.setState({
          animatedWidth: animatedWidth
        });
        _this._marqueeTimer = window.setTimeout(_animate, TIMEOUT);
      }
    };
    if (this.state.overflowWidth !== 0) {
      this._marqueeTimer = window.setTimeout(_animate, timeout);
    }
  };
  Marquee.prototype._measureText = function () {
    var container = ReactDOM.findDOMNode(this);
    var node = this.textRef;
    if (container && node) {
      var containerWidth = container.offsetWidth;
      var textWidth = node.offsetWidth;
      var overflowWidth = textWidth - containerWidth;
      if (overflowWidth !== this.state.overflowWidth) {
        this.setState({
          overflowWidth: overflowWidth
        });
      }
    }
  };
  Marquee.defaultProps = {
    text: '',
    loop: false,
    leading: 500,
    trailing: 800,
    fps: 40,
    className: ''
  };
  return Marquee;
}(React.Component);
export default Marquee;