var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import classnames from 'classnames';
import * as React from 'react';
import Marquee from './Marquee';
import NoticeTipOutlined from 'dingtalk-design-icons/lib/NoticeTipOutlined';
import CloseOutlined from 'dingtalk-design-icons/lib/CloseOutlined';
import { isMobile } from '../../_internal';
var NoticeBar = /** @class */function (_super) {
  __extends(NoticeBar, _super);
  function NoticeBar(props) {
    var _this = _super.call(this, props) || this;
    _this.onClick = function (event) {
      var _a = _this.props,
        mode = _a.mode,
        onClick = _a.onClick;
      if (onClick) {
        onClick();
        event.stopPropagation();
      }
    };
    _this.onClose = function (event) {
      var _a, _b;
      var mode = _this.props.mode;
      if (mode === 'closable') {
        _this.setState({
          show: false
        });
      }
      (_b = (_a = _this.props).onClose) === null || _b === void 0 ? void 0 : _b.call(_a);
      event.stopPropagation();
    };
    _this.state = {
      show: true
    };
    return _this;
  }
  NoticeBar.prototype.render = function () {
    var _a;
    var _b = this.props,
      mode = _b.mode,
      icon = _b.icon,
      onClick = _b.onClick,
      children = _b.children,
      className = _b.className,
      prefixCls = _b.prefixCls,
      action = _b.action,
      extra = _b.extra,
      marqueeProps = _b.marqueeProps,
      restProps = __rest(_b, ["mode", "icon", "onClick", "children", "className", "prefixCls", "action", "extra", "marqueeProps"]);
    var extraProps = {};
    var operationDom = null;
    if (extra) {
      operationDom = /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-extra")
      }, extra);
    }
    if (mode === 'closable') {
      operationDom = /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-operation"),
        role: "button",
        "aria-label": "close",
        onClick: this.onClose
      }, action ? action : /*#__PURE__*/React.createElement(CloseOutlined, null));
    }
    var wrapCls = classnames(prefixCls, className);
    return this.state.show ? (/*#__PURE__*/React.createElement("div", __assign({
      className: wrapCls
    }, restProps, extraProps, {
      role: "alert",
      onClick: this.onClick
    }), icon && (
    /*#__PURE__*/
    // tslint:disable-next-line:jsx-no-multiline-js
    React.createElement("div", {
      className: classnames("".concat(prefixCls, "-icon"), (_a = {}, _a["".concat(prefixCls, "-icon-desktop")] = !isMobile, _a)),
      "aria-hidden": "true"
    }, icon)), /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-content")
    }, /*#__PURE__*/React.createElement(Marquee, __assign({
      prefixCls: prefixCls,
      text: children
    }, marqueeProps))), operationDom)) : null;
  };
  NoticeBar.defaultProps = {
    prefixCls: 'am-notice-bar',
    mode: '',
    icon: /*#__PURE__*/React.createElement(NoticeTipOutlined, null),
    onClick: function onClick() {}
  };
  return NoticeBar;
}(React.Component);
export default NoticeBar;