import * as React from 'react';
var ScrollView = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var divRef = /*#__PURE__*/React.createRef();
  React.useImperativeHandle(ref, function () {
    return divRef.current;
  });
  var handleScroll = function handleScroll() {
    var _a, _b, _c, _d, _e;
    var offsetLeft = (_a = divRef.current) === null || _a === void 0 ? void 0 : _a.scrollLeft;
    var offsetRight = ((_b = divRef.current) === null || _b === void 0 ? void 0 : _b.scrollWidth) - ((_c = divRef.current) === null || _c === void 0 ? void 0 : _c.offsetWidth) - ((_d = divRef.current) === null || _d === void 0 ? void 0 : _d.scrollLeft);
    (_e = props.onScroll) === null || _e === void 0 ? void 0 : _e.call(props, {
      offsetLeft: offsetLeft,
      offsetRight: offsetRight
    });
  };
  React.useLayoutEffect(function () {
    // hack, 初始化的时候计算不准确，设置延迟
    setTimeout(function () {
      var _a;
      handleScroll();
      (_a = props.onInit) === null || _a === void 0 ? void 0 : _a.call(props);
    }, 100);
  }, []);
  return /*#__PURE__*/React.createElement("div", {
    ref: divRef,
    className: props.className,
    onScroll: handleScroll
  }, props.children);
});
export default ScrollView;