var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
// @ts-nocheck
import classnames from 'classnames';
import * as React from 'react';
import TouchFeedback from 'rmc-feedback';
import getDataAttr from '../_util/getDataAttr';
import { getComponentLocale } from '../_util/getLocale';
import { defaultProps } from './PropsType';
import SearchOutlined from 'dingtalk-design-icons/lib/SearchOutlined';
import zhCN from './locale/zh_CN';
function onNextFrame(cb) {
  if (window.requestAnimationFrame) {
    return window.requestAnimationFrame(cb);
  }
  return window.setTimeout(cb, 1);
}
function clearNextFrameAction(nextFrameId) {
  if (window.cancelAnimationFrame) {
    window.cancelAnimationFrame(nextFrameId);
  } else {
    window.clearTimeout(nextFrameId);
  }
}
var SearchBar = /** @class */function (_super) {
  __extends(SearchBar, _super);
  function SearchBar(props) {
    var _this = _super.call(this, props) || this;
    _this.onSubmit = function (e) {
      e.preventDefault();
      if (_this.props.onSubmit) {
        _this.props.onSubmit(_this.state.value || '');
      }
      if (_this.inputRef) {
        _this.inputRef.blur();
      }
    };
    _this.onChange = function (e) {
      if (!_this.state.focus) {
        _this.setState({
          focus: true
        });
      }
      var value = e.target.value;
      if (!('value' in _this.props)) {
        _this.setState({
          value: value
        });
      }
      if (_this.props.onChange) {
        _this.props.onChange(value);
      }
    };
    _this.onFocus = function () {
      _this.setState({
        focus: true
      });
      _this.firstFocus = true;
      if (_this.props.onFocus) {
        _this.props.onFocus();
      }
    };
    _this.onBlur = function () {
      _this.onBlurTimeout = onNextFrame(function () {
        if (!_this.blurFromOnClear) {
          if (document.activeElement !== _this.inputRef) {
            _this.setState({
              focus: false
            });
          }
        }
        _this.blurFromOnClear = false;
      });
      if (_this.props.onBlur) {
        // fix autoFocus item blur with flash
        setTimeout(function () {
          // fix ios12 wechat browser click failure after input
          if (document.body) {
            document.body.scrollTop = document.body.scrollTop;
          }
        }, 100);
        _this.props.onBlur();
      }
    };
    _this.onClear = function () {
      _this.doClear();
    };
    _this.doClear = function (blurFromOnClear) {
      if (blurFromOnClear === void 0) {
        blurFromOnClear = true;
      }
      _this.blurFromOnClear = blurFromOnClear;
      if (!('value' in _this.props)) {
        _this.setState({
          value: ''
        });
      }
      if (_this.props.onClear) {
        _this.props.onClear('');
      }
      if (_this.props.onChange) {
        _this.props.onChange('');
      }
      if (blurFromOnClear) {
        _this.focus();
      }
    };
    _this.onCancel = function () {
      if (_this.props.onCancel) {
        _this.props.onCancel(_this.state.value || '');
      } else {
        _this.doClear(false);
      }
    };
    _this.focus = function () {
      if (_this.inputRef) {
        _this.inputRef.focus();
      }
    };
    var value;
    if ('value' in props) {
      value = props.value || '';
    } else if ('defaultValue' in props) {
      value = props.defaultValue;
    } else {
      value = '';
    }
    _this.state = {
      value: value,
      focus: false
    };
    return _this;
  }
  SearchBar.prototype.componentDidMount = function () {
    if (this.rightBtnRef) {
      var initBtn = window.getComputedStyle(this.rightBtnRef);
      this.rightBtnInitMarginleft = initBtn.marginLeft;
    }
    this.componentDidUpdate();
  };
  SearchBar.prototype.componentDidUpdate = function () {
    if (this.syntheticPhRef) {
      if (this.inputContainerRef && this.inputContainerRef.className.indexOf("".concat(this.props.prefixCls, "-start")) > -1) {
        // 检测是否包含名为 ${this.props.prefixCls}-start 样式，生成动画
        // offsetWidth 某些时候是向上取整，某些时候是向下取整，不能用
        if (this.syntheticPhContainerRef) {
          var realWidth = this.syntheticPhContainerRef.getBoundingClientRect().width; // 包含小数
          this.syntheticPhRef.style.width = "".concat(Math.ceil(realWidth), "px");
        }
        if (!this.props.showCancelButton && this.rightBtnRef) {
          this.rightBtnRef.style.marginRight = '0';
        }
      } else {
        this.syntheticPhRef.style.width = '100%';
        if (!this.props.showCancelButton && this.rightBtnRef) {
          this.rightBtnRef.style.marginRight = "-".concat(this.rightBtnRef.offsetWidth + (this.rightBtnInitMarginleft != null ? parseInt(this.rightBtnInitMarginleft, 10) : 0), "px");
        }
      }
    }
  };
  SearchBar.prototype.componentWillReceiveProps = function (nextProps) {
    if ('value' in nextProps && nextProps.value !== this.state.value) {
      this.setState({
        value: nextProps.value
      });
    }
  };
  SearchBar.prototype.componentWillUnmount = function () {
    if (this.onBlurTimeout) {
      clearNextFrameAction(this.onBlurTimeout);
      this.onBlurTimeout = null;
    }
  };
  SearchBar.prototype.render = function () {
    var _a, _b, _c;
    var _this = this;
    var _d = this.props,
      prefixCls = _d.prefixCls,
      showCancelButton = _d.showCancelButton,
      disabled = _d.disabled,
      placeholder = _d.placeholder,
      className = _d.className,
      style = _d.style,
      maxLength = _d.maxLength;
    // tslint:disable-next-line:variable-name
    var _locale = getComponentLocale(this.props, this.context, 'SearchBar', function () {
      return zhCN;
    });
    var cancelText = _locale.cancelText;
    var _e = this.state,
      value = _e.value,
      focus = _e.focus;
    var wrapCls = classnames(prefixCls, className, (_a = {}, _a["".concat(prefixCls, "-start")] = !!(focus || value && value.length > 0), _a));
    var clearCls = classnames("".concat(prefixCls, "-clear"), (_b = {}, _b["".concat(prefixCls, "-clear-show")] = !!(focus && value && value.length > 0), _b));
    var cancelCls = classnames("".concat(prefixCls, "-cancel"), (_c = {}, _c["".concat(prefixCls, "-cancel-show")] = !!(showCancelButton || focus || value && value.length > 0), _c["".concat(prefixCls, "-cancel-anim")] = this.firstFocus, _c));
    return /*#__PURE__*/React.createElement("form", {
      onSubmit: this.onSubmit,
      className: wrapCls,
      style: style,
      ref: function ref(el) {
        return _this.inputContainerRef = el;
      },
      action: "#"
    }, /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-input")
    }, /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-synthetic-ph"),
      ref: function ref(el) {
        return _this.syntheticPhRef = el;
      }
    }, /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-synthetic-ph-container"),
      ref: function ref(el) {
        return _this.syntheticPhContainerRef = el;
      }
    }, /*#__PURE__*/React.createElement(SearchOutlined, {
      className: "".concat(prefixCls, "-synthetic-ph-icon")
    }), /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-synthetic-ph-placeholder"),
      // tslint:disable-next-line:jsx-no-multiline-js
      style: {
        visibility: placeholder && !value ? 'visible' : 'hidden'
      }
    }, placeholder))), /*#__PURE__*/React.createElement("input", __assign({
      type: "search",
      className: "".concat(prefixCls, "-value"),
      value: value,
      disabled: disabled,
      placeholder: placeholder,
      onChange: this.onChange,
      onFocus: this.onFocus,
      onBlur: this.onBlur,
      onCompositionStart: this.props.onCompositionStart,
      onCompositionEnd: this.props.onCompositionEnd,
      ref: function ref(el) {
        return _this.inputRef = el;
      },
      maxLength: maxLength
    }, getDataAttr(this.props))), /*#__PURE__*/React.createElement(TouchFeedback, {
      activeClassName: "".concat(prefixCls, "-clear-active"),
      onMouseDown: this.onClear
    }, /*#__PURE__*/React.createElement("a", {
      className: clearCls
    }))), /*#__PURE__*/React.createElement("div", {
      className: cancelCls,
      onClick: this.onCancel,
      ref: function ref(el) {
        return _this.rightBtnRef = el;
      }
    }, this.props.cancelText || cancelText));
  };
  SearchBar.defaultProps = defaultProps;
  return SearchBar;
}(React.Component);
export default SearchBar;