var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React from 'react';
import Gesture from 'rc-gesture';
import { setPxStyle, getTransformPropValue, getPxStyle } from './util';
var StateType = /** @class */function () {
  function StateType() {
    this.transform = '';
    this.isMoving = false;
    this.showPrev = false;
    this.showNext = false;
  }
  return StateType;
}();
export { StateType };
var DefaultTabBar = /** @class */function (_super) {
  __extends(DefaultTabBar, _super);
  function DefaultTabBar(props) {
    var _this = _super.call(this, props) || this;
    _this.onPan = function () {
      var lastOffset = 0;
      var finalOffset = 0;
      var getLastOffset = function getLastOffset(isVertical) {
        if (isVertical === void 0) {
          isVertical = _this.isTabBarVertical();
        }
        var offset = +"".concat(lastOffset).replace('%', '');
        if ("".concat(lastOffset).indexOf('%') >= 0) {
          offset /= 100;
          offset *= isVertical ? _this.layout.clientHeight : _this.layout.clientWidth;
        }
        return offset;
      };
      return {
        onPanStart: function onPanStart() {
          _this.setState({
            isMoving: true
          });
        },
        onPanMove: function onPanMove(status) {
          if (!status.moveStatus || !_this.layout) return;
          var isVertical = _this.isTabBarVertical();
          var offset = getLastOffset() + (isVertical ? status.moveStatus.y : status.moveStatus.x);
          var canScrollOffset = isVertical ? -_this.layout.scrollHeight + _this.layout.clientHeight : -_this.layout.scrollWidth + _this.layout.clientWidth;
          offset = Math.min(offset, 0);
          offset = Math.max(offset, canScrollOffset);
          setPxStyle(_this.layout, offset, 'px', isVertical);
          finalOffset = offset;
          _this.setState({
            showPrev: -offset > 0,
            showNext: offset > canScrollOffset
          });
        },
        onPanEnd: function onPanEnd() {
          var isVertical = _this.isTabBarVertical();
          lastOffset = finalOffset;
          _this.setState({
            isMoving: false,
            transform: getPxStyle(finalOffset, 'px', isVertical)
          });
        },
        setCurrentOffset: function setCurrentOffset(offset) {
          return lastOffset = offset;
        }
      };
    }();
    _this.getTransformByIndex = function (props) {
      var activeTab = props.activeTab,
        tabs = props.tabs,
        _a = props.page,
        page = _a === void 0 ? 0 : _a;
      var isVertical = _this.isTabBarVertical();
      var size = _this.getTabSize(page, tabs.length);
      var center = page / 2;
      var pos = Math.min(activeTab, tabs.length - center - 0.5);
      var skipSize = Math.min(-(pos - center + 0.5) * size, 0);
      _this.onPan.setCurrentOffset("".concat(skipSize, "%"));
      return {
        transform: getPxStyle(skipSize, '%', isVertical),
        showPrev: activeTab > center - 0.5 && tabs.length > page,
        showNext: activeTab < tabs.length - center - 0.5 && tabs.length > page
      };
    };
    _this.onPress = function (index) {
      var _a = _this.props,
        goToTab = _a.goToTab,
        onTabClick = _a.onTabClick,
        tabs = _a.tabs;
      onTabClick && onTabClick(tabs[index], index);
      goToTab && goToTab(index);
    };
    _this.isTabBarVertical = function (position) {
      if (position === void 0) {
        position = _this.props.tabBarPosition;
      }
      return position === 'left' || position === 'right';
    };
    _this.renderTab = function (t, i, size, isTabBarVertical) {
      var _a = _this.props,
        prefixCls = _a.prefixCls,
        renderTab = _a.renderTab,
        activeTab = _a.activeTab,
        tabBarTextStyle = _a.tabBarTextStyle,
        tabBarActiveTextColor = _a.tabBarActiveTextColor,
        tabBarInactiveTextColor = _a.tabBarInactiveTextColor,
        instanceId = _a.instanceId;
      var textStyle = __assign({}, tabBarTextStyle);
      var cls = "".concat(prefixCls, "-tab");
      var ariaSelected = false;
      if (activeTab === i) {
        cls += " ".concat(cls, "-active");
        ariaSelected = true;
        if (tabBarActiveTextColor) {
          textStyle.color = tabBarActiveTextColor;
        }
      } else if (tabBarInactiveTextColor) {
        textStyle.color = tabBarInactiveTextColor;
      }
      return /*#__PURE__*/React.createElement("div", {
        key: "t_".concat(i),
        style: __assign(__assign({}, textStyle), isTabBarVertical ? {
          height: "".concat(size, "%")
        } : {
          width: "".concat(size, "%")
        }),
        id: "m-tabs-".concat(instanceId, "-").concat(i),
        role: "tab",
        "aria-selected": ariaSelected,
        className: cls,
        onClick: function onClick() {
          return _this.onPress(i);
        }
      }, renderTab ? renderTab(t) : t.title);
    };
    _this.setContentLayout = function (div) {
      div && (_this.layout = div);
    };
    _this.getTabSize = function (page, tabLength) {
      return 100 / Math.min(page, tabLength);
    };
    _this.state = __assign(__assign({}, new StateType()), _this.getTransformByIndex(props));
    return _this;
  }
  DefaultTabBar.prototype.componentWillReceiveProps = function (nextProps) {
    if (this.props.activeTab !== nextProps.activeTab || this.props.tabs !== nextProps.tabs || this.props.tabs.length !== nextProps.tabs.length) {
      this.setState(__assign({}, this.getTransformByIndex(nextProps)));
    }
  };
  DefaultTabBar.prototype.render = function () {
    var _this = this;
    var _a = this.props,
      prefixCls = _a.prefixCls,
      animated = _a.animated,
      _b = _a.tabs,
      tabs = _b === void 0 ? [] : _b,
      _c = _a.page,
      page = _c === void 0 ? 0 : _c,
      _d = _a.activeTab,
      activeTab = _d === void 0 ? 0 : _d,
      tabBarBackgroundColor = _a.tabBarBackgroundColor,
      tabBarUnderlineStyle = _a.tabBarUnderlineStyle,
      tabBarPosition = _a.tabBarPosition,
      renderUnderline = _a.renderUnderline;
    var _e = this.state,
      isMoving = _e.isMoving,
      transform = _e.transform,
      showNext = _e.showNext,
      showPrev = _e.showPrev;
    var isTabBarVertical = this.isTabBarVertical();
    var needScroll = tabs.length > page;
    var size = this.getTabSize(page, tabs.length);
    var Tabs = tabs.map(function (t, i) {
      return _this.renderTab(t, i, size, isTabBarVertical);
    });
    var cls = prefixCls;
    if (animated && !isMoving) {
      cls += " ".concat(prefixCls, "-animated");
    }
    var style = {
      backgroundColor: tabBarBackgroundColor || ''
    };
    var transformStyle = needScroll ? __assign({}, getTransformPropValue(transform)) : {};
    var _f = this.onPan,
      setCurrentOffset = _f.setCurrentOffset,
      onPan = __rest(_f, ["setCurrentOffset"]);
    var underlineProps = {
      style: __assign(__assign(__assign({}, isTabBarVertical ? {
        height: "".concat(size, "%")
      } : {
        width: "".concat(size, "%")
      }), isTabBarVertical ? {
        top: "".concat(size * activeTab, "%")
      } : {
        left: "".concat(size * activeTab, "%")
      }), tabBarUnderlineStyle),
      className: "".concat(prefixCls, "-underline")
    };
    return /*#__PURE__*/React.createElement("div", {
      className: "".concat(cls, " ").concat(prefixCls, "-").concat(tabBarPosition),
      style: style
    }, showPrev && /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-prevpage")
    }), /*#__PURE__*/React.createElement(Gesture, __assign({}, onPan, {
      direction: isTabBarVertical ? 'vertical' : 'horizontal'
    }), /*#__PURE__*/React.createElement("div", {
      role: "tablist",
      className: "".concat(prefixCls, "-content"),
      style: transformStyle,
      ref: this.setContentLayout
    }, Tabs, renderUnderline ? renderUnderline(underlineProps) : /*#__PURE__*/React.createElement("div", __assign({}, underlineProps)))), showNext && /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-nextpage")
    }));
  };
  DefaultTabBar.defaultProps = {
    prefixCls: 'rmc-tabs-tab-bar',
    animated: true,
    tabs: [],
    goToTab: function goToTab() {},
    activeTab: 0,
    page: 5,
    tabBarUnderlineStyle: {},
    tabBarBackgroundColor: '#fff',
    tabBarActiveTextColor: '',
    tabBarInactiveTextColor: '',
    tabBarTextStyle: {}
  };
  return DefaultTabBar;
}(React.PureComponent);
export { DefaultTabBar };