var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import React from 'react';
import Gesture from 'rc-gesture';
import { TabPane } from './TabPane';
import { DefaultTabBar } from './DefaultTabBar';
import { getTransformPropValue, setTransform, setPxStyle } from './util';
import { Tabs as Component, StateType as BaseStateType } from './Tabs.base';
var getPanDirection = function getPanDirection(direction) {
  switch (direction) {
    case 2:
    case 4:
      return 'horizontal';
    case 8:
    case 16:
      return 'vertical';
    default:
      return 'none';
  }
};
var StateType = /** @class */function (_super) {
  __extends(StateType, _super);
  function StateType() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.contentPos = '';
    _this.isMoving = false;
    return _this;
  }
  return StateType;
}(BaseStateType);
export { StateType };
var Tabs = /** @class */function (_super) {
  __extends(Tabs, _super);
  function Tabs(props) {
    var _this = _super.call(this, props) || this;
    _this.onPan = function () {
      var lastOffset = 0;
      var finalOffset = 0;
      var panDirection;
      var getLastOffset = function getLastOffset(isVertical) {
        if (isVertical === void 0) {
          isVertical = _this.isTabVertical();
        }
        var offset = +"".concat(lastOffset).replace('%', '');
        if ("".concat(lastOffset).indexOf('%') >= 0) {
          offset /= 100;
          offset *= isVertical ? _this.layout.clientHeight : _this.layout.clientWidth;
        }
        return offset;
      };
      return {
        onPanStart: function onPanStart(status) {
          if (!_this.props.swipeable || !_this.props.animated) return;
          panDirection = getPanDirection(status.direction);
          _this.setState({
            isMoving: true
          });
        },
        onPanMove: function onPanMove(status) {
          var _a = _this.props,
            swipeable = _a.swipeable,
            animated = _a.animated,
            useLeftInsteadTransform = _a.useLeftInsteadTransform;
          if (!status.moveStatus || !_this.layout || !swipeable || !animated) return;
          var isVertical = _this.isTabVertical();
          var offset = getLastOffset();
          if (isVertical) {
            offset += panDirection === 'horizontal' ? 0 : status.moveStatus.y;
          } else {
            offset += panDirection === 'vertical' ? 0 : status.moveStatus.x;
          }
          var canScrollOffset = isVertical ? -_this.layout.scrollHeight + _this.layout.clientHeight : -_this.layout.scrollWidth + _this.layout.clientWidth;
          offset = Math.min(offset, 0);
          offset = Math.max(offset, canScrollOffset);
          setPxStyle(_this.layout, offset, 'px', isVertical, useLeftInsteadTransform);
          finalOffset = offset;
        },
        onPanEnd: function onPanEnd() {
          if (!_this.props.swipeable || !_this.props.animated) return;
          lastOffset = finalOffset;
          var isVertical = _this.isTabVertical();
          var offsetIndex = _this.getOffsetIndex(finalOffset, isVertical ? _this.layout.clientHeight : _this.layout.clientWidth);
          _this.setState({
            isMoving: false
          });
          if (offsetIndex === _this.state.currentTab) {
            if (_this.props.usePaged) {
              setTransform(_this.layout.style, _this.getContentPosByIndex(offsetIndex, _this.isTabVertical(), _this.props.useLeftInsteadTransform));
            }
          } else {
            _this.goToTab(offsetIndex);
          }
        },
        setCurrentOffset: function setCurrentOffset(offset) {
          return lastOffset = offset;
        }
      };
    }();
    _this.onSwipe = function (status) {
      var _a = _this.props,
        tabBarPosition = _a.tabBarPosition,
        swipeable = _a.swipeable,
        usePaged = _a.usePaged;
      if (!swipeable || !usePaged || _this.isTabVertical()) return;
      // DIRECTION_NONE	1
      // DIRECTION_LEFT	2
      // DIRECTION_RIGHT	4
      // DIRECTION_UP	8
      // DIRECTION_DOWN	16
      // DIRECTION_HORIZONTAL	6
      // DIRECTION_VERTICAL	24
      // DIRECTION_ALL	30
      switch (tabBarPosition) {
        case 'top':
        case 'bottom':
          switch (status.direction) {
            case 2:
              if (!_this.isTabVertical()) {
                _this.goToTab(_this.prevCurrentTab + 1);
              }
            case 8:
              if (_this.isTabVertical()) {
                _this.goToTab(_this.prevCurrentTab + 1);
              }
              break;
            case 4:
              if (!_this.isTabVertical()) {
                _this.goToTab(_this.prevCurrentTab - 1);
              }
            case 16:
              if (_this.isTabVertical()) {
                _this.goToTab(_this.prevCurrentTab - 1);
              }
              break;
          }
          break;
      }
    };
    _this.setContentLayout = function (div) {
      div && (_this.layout = div);
    };
    _this.state = __assign(__assign(__assign({}, _this.state), new StateType()), {
      contentPos: _this.getContentPosByIndex(_this.getTabIndex(props), _this.isTabVertical(props.tabDirection), props.useLeftInsteadTransform)
    });
    return _this;
  }
  Tabs.prototype.goToTab = function (index, force, usePaged, props) {
    if (force === void 0) {
      force = false;
    }
    if (usePaged === void 0) {
      usePaged = this.props.usePaged;
    }
    if (props === void 0) {
      props = this.props;
    }
    var tabDirection = props.tabDirection,
      useLeftInsteadTransform = props.useLeftInsteadTransform;
    var newState = {};
    if (usePaged) {
      newState = {
        contentPos: this.getContentPosByIndex(index, this.isTabVertical(tabDirection), useLeftInsteadTransform)
      };
    }
    return _super.prototype.goToTab.call(this, index, force, newState, props);
  };
  Tabs.prototype.tabClickGoToTab = function (index) {
    this.goToTab(index, false, true);
  };
  Tabs.prototype.getContentPosByIndex = function (index, isVertical, useLeft) {
    if (useLeft === void 0) {
      useLeft = false;
    }
    var value = "".concat(-index * 100, "%");
    this.onPan.setCurrentOffset(value);
    if (useLeft) {
      return "".concat(value);
    } else {
      var translate = isVertical ? "0px, ".concat(value) : "".concat(value, ", 0px");
      // fix: content overlay TabBar on iOS 10. ( 0px -> 1px )
      return "translate3d(".concat(translate, ", 1px)");
    }
  };
  Tabs.prototype.renderContent = function (getSubElements) {
    var _this = this;
    if (getSubElements === void 0) {
      getSubElements = this.getSubElements();
    }
    var _a = this.props,
      prefixCls = _a.prefixCls,
      tabs = _a.tabs,
      animated = _a.animated,
      destroyInactiveTab = _a.destroyInactiveTab,
      useLeftInsteadTransform = _a.useLeftInsteadTransform;
    var _b = this.state,
      currentTab = _b.currentTab,
      isMoving = _b.isMoving,
      contentPos = _b.contentPos;
    var isTabVertical = this.isTabVertical();
    var contentCls = "".concat(prefixCls, "-content-wrap");
    if (animated && !isMoving) {
      contentCls += " ".concat(contentCls, "-animated");
    }
    var contentStyle = animated ? useLeftInsteadTransform ? __assign({
      position: 'relative'
    }, this.isTabVertical() ? {
      top: contentPos
    } : {
      left: contentPos
    }) : getTransformPropValue(contentPos) : __assign({
      position: 'relative'
    }, this.isTabVertical() ? {
      top: "".concat(-currentTab * 100, "%")
    } : {
      left: "".concat(-currentTab * 100, "%")
    });
    var instanceId = this.getTabBarBaseProps().instanceId;
    return /*#__PURE__*/React.createElement("div", {
      className: contentCls,
      style: contentStyle,
      ref: this.setContentLayout
    }, tabs.map(function (tab, index) {
      var cls = "".concat(prefixCls, "-pane-wrap");
      if (_this.state.currentTab === index) {
        cls += " ".concat(cls, "-active");
      } else {
        cls += " ".concat(cls, "-inactive");
      }
      var key = tab.key || "tab_".concat(index);
      // update tab cache
      if (_this.shouldRenderTab(index)) {
        _this.tabCache[index] = _this.getSubElement(tab, index, getSubElements);
      } else if (destroyInactiveTab) {
        _this.tabCache[index] = undefined;
      }
      return /*#__PURE__*/React.createElement(TabPane, {
        key: key,
        className: cls,
        active: currentTab === index,
        role: "tabpanel",
        "aria-hidden": currentTab !== index,
        "aria-labelledby": "m-tabs-".concat(instanceId, "-").concat(index),
        fixX: isTabVertical,
        fixY: !isTabVertical
      }, _this.tabCache[index]);
    }));
  };
  Tabs.prototype.render = function () {
    var _a = this.props,
      prefixCls = _a.prefixCls,
      size = _a.size,
      tabBarPosition = _a.tabBarPosition,
      tabDirection = _a.tabDirection,
      useOnPan = _a.useOnPan,
      noRenderContent = _a.noRenderContent,
      tabBarExtraContent = _a.tabBarExtraContent;
    var isTabVertical = this.isTabVertical(tabDirection);
    var tabBarProps = __assign({}, this.getTabBarBaseProps());
    var onPan = !isTabVertical && useOnPan ? this.onPan : {};
    var content = [/*#__PURE__*/React.createElement("div", {
      key: "tabBar",
      className: "".concat(prefixCls, "-tab-bar-wrap")
    }, this.renderTabBar(tabBarProps, DefaultTabBar), /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-tab-bar-extra-wrap")
    }, tabBarExtraContent)), !noRenderContent && (/*#__PURE__*/React.createElement(Gesture, __assign({
      key: "$content",
      onSwipe: this.onSwipe
    }, onPan), this.renderContent()))];
    return /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, " ").concat(prefixCls, "-").concat(tabDirection, " ").concat(prefixCls, "-").concat(tabBarPosition, " ").concat(prefixCls, "-").concat(size)
    }, tabBarPosition === 'top' || tabBarPosition === 'left' ? content : content.reverse());
  };
  Tabs.DefaultTabBar = DefaultTabBar;
  Tabs.defaultProps = __assign(__assign({}, Component.defaultProps), {
    prefixCls: 'rmc-tabs',
    useOnPan: true,
    size: 'medium'
  });
  return Tabs;
}(Component);
export { Tabs };