var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import React, { useCallback, useEffect, useRef, useState, useImperativeHandle } from 'react';
import { default as AntdSearchBar } from '../rmc/SearchBar';
import classnames from 'classnames';
import { useMobile } from '../hooks';
import './style/index';
import { dtMobileSearchbarPrefix } from '../style/index';
var SearchBar = /*#__PURE__*/React.memo(/*#__PURE__*/React.forwardRef(function (props, forwardRef) {
  var _a;
  var isMobile = useMobile();
  var className = props.className,
    onChange = props.onChange,
    onBlur = props.onBlur,
    onFocus = props.onFocus,
    cancelText = props.cancelText,
    _props = __rest(props, ["className", "onChange", "onBlur", "onFocus", "cancelText"]);
  var inputRef = useRef();
  var _b = __read(useState(function () {
      if (typeof _props.value !== 'undefined') {
        return _props.value;
      }
      return _props.defaultValue || '';
    }), 2),
    privateValue = _b[0],
    setPrivateValue = _b[1];
  var _c = __read(useState(false), 2),
    focus = _c[0],
    setFocus = _c[1];
  useEffect(function () {
    if (typeof _props.value !== 'undefined' && privateValue !== _props.value) {
      setPrivateValue(_props.value);
    }
  }, [_props.value, privateValue]);
  var handleChange = useCallback(function (value) {
    if (typeof onChange === 'function') {
      onChange(value);
    }
    if (typeof _props.value === 'undefined') {
      setPrivateValue(value);
    }
  }, [_props]);
  useImperativeHandle(forwardRef, function () {
    return {
      focus: function focus() {
        var _a, _b;
        (_b = (_a = inputRef === null || inputRef === void 0 ? void 0 : inputRef.current) === null || _a === void 0 ? void 0 : _a.focus) === null || _b === void 0 ? void 0 : _b.call(_a);
      },
      blur: function blur() {
        var _a, _b;
        (_b = (_a = inputRef === null || inputRef === void 0 ? void 0 : inputRef.current) === null || _a === void 0 ? void 0 : _a.blur) === null || _b === void 0 ? void 0 : _b.call(_a);
      }
    };
  });
  var handleFocus = function handleFocus() {
    if (!focus) {
      setFocus(true);
    }
    if (typeof onFocus === 'function') {
      onFocus(privateValue);
    }
  };
  var handleBlur = function handleBlur() {
    if (focus) {
      setFocus(false);
    }
    if (typeof onBlur === 'function') {
      onBlur(privateValue);
    }
  };
  var wrapCls = classnames(privateValue ? "".concat(dtMobileSearchbarPrefix, "-has-value") : '', cancelText === undefined ? "".concat(dtMobileSearchbarPrefix, "-hidden-cancel") : '', (_a = {}, _a["".concat(dtMobileSearchbarPrefix, "-desktop")] = !isMobile, _a["".concat(dtMobileSearchbarPrefix, "-desktop-focus")] = !isMobile && focus, _a["".concat(dtMobileSearchbarPrefix, "-focus")] = focus, _a), className);
  return /*#__PURE__*/React.createElement(AntdSearchBar, __assign({}, _props, {
    cancelText: cancelText,
    onFocus: handleFocus,
    onBlur: handleBlur,
    prefixCls: dtMobileSearchbarPrefix,
    onChange: handleChange,
    className: wrapCls,
    ref: function ref(_ref) {
      return inputRef.current = _ref;
    },
    showCancelButton: cancelText !== undefined
  }));
}));
SearchBar.displayName = 'SearchBar';
export default SearchBar;