var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import React, { useCallback, useState, useMemo } from 'react';
import './style/index';
import TouchFeedback from 'rmc-feedback';
import { dtMobilePrefix } from '../style';
import classnames from 'classnames';
import { useMobile } from '../hooks';
var dtMobileSegmentedControlPrefix = "".concat(dtMobilePrefix, "-segment");
var SegmentedControl = function SegmentedControl(props) {
  var _a;
  var _b, _c;
  var isMobile = useMobile();
  var defaultActiveIndex = props.defaultActiveIndex,
    texts = props.texts,
    disabled = props.disabled,
    onChange = props.onChange;
  var _d = __read(useState((_c = (_b = props.activeIndex) !== null && _b !== void 0 ? _b : defaultActiveIndex) !== null && _c !== void 0 ? _c : 0), 2),
    innerActiveIndex = _d[0],
    setInnerActiveIndex = _d[1];
  var activeIndex = useMemo(function () {
    var _a;
    return (_a = props.activeIndex) !== null && _a !== void 0 ? _a : innerActiveIndex;
  }, [props.activeIndex, innerActiveIndex]);
  var $setActiveIndex = useCallback(function (idx) {
    if (idx !== activeIndex) {
      onChange && onChange(idx);
    }
    setInnerActiveIndex(idx);
  }, [activeIndex, setInnerActiveIndex]);
  var _onClick = useCallback(function (idx) {
    if (disabled) return;
    $setActiveIndex(idx);
  }, [disabled, $setActiveIndex]);
  var renderSegmentItem = useCallback(function (idx, text) {
    var _a;
    var selected = activeIndex === idx;
    var itemCls = classnames("".concat(dtMobileSegmentedControlPrefix, "-item"), (_a = {}, _a["".concat(dtMobileSegmentedControlPrefix, "-item-selected")] = selected, _a["".concat(dtMobileSegmentedControlPrefix, "-item-desktop")] = !isMobile, _a["".concat(dtMobileSegmentedControlPrefix, "-hidden-divide")] = selected || activeIndex === idx + 1, _a));
    return (
      /*#__PURE__*/
      // @ts-ignore
      React.createElement(TouchFeedback, {
        key: idx,
        disabled: disabled,
        activeClassName: "".concat(dtMobileSegmentedControlPrefix, "-item-active")
      }, /*#__PURE__*/React.createElement("div", {
        className: itemCls,
        role: "tab",
        "aria-selected": selected && !disabled,
        "aria-disabled": disabled,
        onClick: function onClick() {
          return _onClick(idx);
        }
      }, text))
    );
  }, [activeIndex]);
  var wrapCls = classnames(props.className, dtMobileSegmentedControlPrefix, (_a = {}, _a["".concat(dtMobileSegmentedControlPrefix, "-disabled")] = disabled, _a));
  return /*#__PURE__*/React.createElement("div", {
    className: wrapCls,
    role: "tablist"
  }, (texts !== null && texts !== void 0 ? texts : []).map(function (text, idx) {
    return renderSegmentItem(idx, text);
  }));
};
SegmentedControl.displayName = 'SegmentedControl';
export default SegmentedControl;