import React from 'react';
export interface SelectData<T> {
    value: T;
    label: React.ReactNode;
    disabled?: boolean;
}
export interface SelectPropsType<T> {
    mode: 'single' | 'multiple';
    options: SelectData<T>[];
    usedetailValue?: boolean;
    value?: T | T[];
    placeholder?: string;
    defaultValue?: T | T[];
    onChange?: (value: SelectData<T>[] | SelectData<T> | T | T[], option: SelectData<T> | SelectData<T>[]) => void;
    title?: string | React.ReactNode;
    disabled?: boolean;
    okText?: string | React.ReactNode;
    renderSelection?: (selected: SelectData<T> | SelectData<T>[]) => React.ReactNode;
    children?: React.ReactNode;
    getContainer?: () => HTMLElement;
    maskClosable?: boolean;
    visible?: boolean;
    readonly?: boolean;
    arrow?: boolean | 'horizontal' | 'down' | 'up' | 'empty';
    onVisibleChange?: (visible?: boolean) => void;
}
