import React, { ReactNode } from 'react';
import { BasePropsType } from '../_internal';
import './style/index';
import { NativeProps } from '../_internal/native-props';
export declare const dtMobileSideBarPrefix: string;
export type IH5SideBarProps = {
    /**
     * @description 当前激活 item 的 key
     * @default "-"
     */
    activeKey?: string;
    /**
     * @description 初始化选中 item 的 key，如果没有设置 activeKey
     * @default "第一个 item 的 key"
     */
    defaultActiveKey?: string;
    /**
     * @description 切换面板的回调
     * @default "-"
     */
    onChange?: (key: string) => void;
} & BasePropsType & NativeProps<'--width' | '--height' | '--active-item-backgroundcolor'>;
export type IH5SideBarItemProps = {
    /**
     * @description 显示内容
     * @default "-"
     */
    title?: string;
    /**
     * @description item的key，对应activeKey
     * @default "-"
     */
    key?: string;
    /**
     * @description item左侧的icon元素
     * @default "-"
     */
    icon?: ReactNode;
    /**
     * @description item右侧的徽标元素
     * @default "-"
     */
    badge?: ReactNode;
} & NativeProps;
export declare const SideBarItem: React.FC<React.PropsWithChildren<IH5SideBarItemProps>>;
declare const _default: React.FC<React.PropsWithChildren<IH5SideBarProps>> & {
    Item: React.FC<React.PropsWithChildren<IH5SideBarItemProps>>;
};
export default _default;
