var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import React from 'react';
import './style/index';
import { dtMobilePrefix } from '../style/index';
import classnames from 'classnames';
import { withNativeProps } from '../_internal/native-props';
import { usePropsValue } from '../_internal/use-props-value';
import { attachPropertiesToComponent } from '../_internal/attach-properties-to-component';
export var dtMobileSideBarPrefix = "".concat(dtMobilePrefix, "-sidebar");
export var SideBarItem = function SideBarItem() {
  return null;
};
var SideBar = /*#__PURE__*/React.memo(function (props) {
  var _a;
  var className = props.className;
  var prefixCls = dtMobileSideBarPrefix;
  var firstActiveKey = '';
  var items = [];
  React.Children.forEach(props.children, function (child, index) {
    if (! /*#__PURE__*/React.isValidElement(child)) return;
    var key = child.key;
    if (typeof key !== 'string') return;
    if (index === 0) {
      firstActiveKey = key;
    }
    items.push(child);
  });
  var _b = __read(usePropsValue({
      value: props.activeKey,
      defaultValue: (_a = props.defaultActiveKey) !== null && _a !== void 0 ? _a : firstActiveKey,
      onChange: props.onChange
    }), 2),
    activeKey = _b[0],
    setActiveKey = _b[1];
  var wrapCls = classnames(prefixCls, className);
  return withNativeProps(props, /*#__PURE__*/React.createElement("div", {
    className: wrapCls
  }, items.map(function (item) {
    var _a;
    var active = item.key === activeKey;
    return withNativeProps(item.props, /*#__PURE__*/React.createElement("div", {
      key: item.key,
      className: classnames("".concat(dtMobileSideBarPrefix, "-item"), (_a = {}, _a["".concat(dtMobileSideBarPrefix, "-item-active")] = active, _a)),
      onClick: function onClick() {
        var key = item.key;
        if (key === undefined || key === null) return;
        setActiveKey(key.toString());
      }
    }, item.props.icon, /*#__PURE__*/React.createElement("div", {
      className: "".concat(dtMobileSideBarPrefix, "-item-text")
    }, item.props.title, item.props.badge && (/*#__PURE__*/React.createElement("div", {
      className: "".concat(dtMobileSideBarPrefix, "-item-badge-container")
    }, item.props.badge)))));
  })));
});
SideBar.displayName = 'SideBar';
export default attachPropertiesToComponent(SideBar, {
  Item: SideBarItem
});