var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import React from 'react';
import { useDrag } from 'dd-use-gesture-react';
import { dtSliderPrefix } from './index';
;
export var Thumb = function Thumb(props) {
  var value = props.value,
    min = props.min,
    max = props.max,
    disabled = props.disabled,
    onDrag = props.onDrag;
  var prevValue = React.useRef(value);
  var currentPosition = React.useMemo(function () {
    return {
      left: "".concat((value - min) / (max - min) * 100, "%"),
      right: 'auto'
    };
  }, [value, min, max]);
  var bind = useDrag(function (state) {
    var _a;
    if (disabled) return;
    if (state.first) {
      prevValue.current = value;
    }
    var x = state.xy[0] - state.initial[0];
    var sliderOffsetWith = (_a = props.trackRef.current) === null || _a === void 0 ? void 0 : _a.offsetWidth;
    if (!sliderOffsetWith) return;
    var diff = x / Math.ceil(sliderOffsetWith) * (max - min);
    onDrag(prevValue.current + diff, state.first, state.last);
  }, {
    axis: 'x',
    pointer: {
      touch: true
    }
  });
  return /*#__PURE__*/React.createElement("div", __assign({
    className: "".concat(dtSliderPrefix, "-thumb-container"),
    style: currentPosition
  }, bind()), /*#__PURE__*/React.createElement("div", {
    className: "".concat(dtSliderPrefix, "-thumb")
  }));
};