import React from 'react';
import './style/index';
interface ISnackbarProps {
    /**
     * 左侧 Icon 显示
     */
    icon?: React.ReactNode;
    /**
     * @description 文本内容
     */
    content?: string;
    /**
     * @description 行动按钮
     */
    actionText: string;
    /**
     * @description 显示时间
     */
    duration?: number;
    /**
     * @description 自定义类名
     */
    className?: string;
    /**
     * @description 行动按钮点击回调
     */
    onActionClick?: () => void;
}
declare const Snackbar: {
    show(params: ISnackbarProps): void;
    hide(): void;
};
export default Snackbar;
