import React from 'react';
// @ts-ignore
import Notification from 'rmc-notification';
import classnames from 'classnames';
import { dtSnackbarPrefix } from '../style';
import './style/index';
var messageInstance;
var messageNeedHide;
var getMessageInstance = function getMessageInstance(mask, callback, className) {
  var _a;
  Notification.newInstance({
    prefixCls: dtSnackbarPrefix,
    style: {},
    transitionName: "".concat(dtSnackbarPrefix, "-fade"),
    className: classnames(className, (_a = {}, _a["".concat(dtSnackbarPrefix, "-mask")] = mask, _a["".concat(dtSnackbarPrefix, "-nomask")] = !mask, _a))
  }, function (notification) {
    return callback && callback(notification);
  });
};
var notice = function notice(params) {
  messageNeedHide = false;
  getMessageInstance(false, function (notification) {
    var _a;
    var icon = params.icon,
      content = params.content,
      actionText = params.actionText,
      onActionClick = params.onActionClick;
    if (!notification) {
      return;
    }
    if (messageInstance) {
      messageInstance.destroy();
      messageInstance = null;
    }
    if (messageNeedHide) {
      notification.destroy();
      messageNeedHide = false;
      return;
    }
    messageInstance = notification;
    var handleClose = function handleClose() {
      setTimeout(function () {
        if (notification) {
          notification.destroy();
        }
        notification = null;
        messageInstance = null;
      }, 300);
    };
    var handleActionClick = function handleActionClick() {
      if (onActionClick) {
        onActionClick();
      }
      handleClose();
    };
    notification.notice({
      duration: (_a = params.duration) !== null && _a !== void 0 ? _a : 4,
      style: {},
      content: (/*#__PURE__*/React.createElement("div", {
        className: "".concat(dtSnackbarPrefix, "-text"),
        role: "alert",
        "aria-live": "assertive"
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(dtSnackbarPrefix, "-icon-wrap")
      }, icon), /*#__PURE__*/React.createElement("div", {
        className: "".concat(dtSnackbarPrefix, "-pure-text")
      }, content), /*#__PURE__*/React.createElement("div", {
        className: "".concat(dtSnackbarPrefix, "-action"),
        onClick: handleActionClick
      }, actionText))),
      closable: true,
      onClose: handleClose
    });
  }, params.className);
};
var Snackbar = {
  show: function show(params) {
    return notice(params);
  },
  hide: function hide() {
    if (messageInstance) {
      messageInstance.destroy();
      messageInstance = null;
    } else {
      messageNeedHide = true;
    }
  }
};
export default Snackbar;