var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import * as React from 'react';
import './style/index';
import classname from 'classnames';
import { withNativeProps } from '../_internal/native-props';
import { dtMobileSpinPrefix } from '../style/index';
var defaultIconSrc = 'https://img.alicdn.com/imgextra/i4/O1CN014kqXkX22y9iy5WhI6_!!6000000007188-2-tps-120-3720.png';
var Spin = /*#__PURE__*/React.memo(function (props) {
  var _a, _b, _c;
  var text = props.text,
    children = props.children,
    className = props.className,
    visible = props.visible,
    delay = props.delay,
    fixed = props.fixed,
    _d = props.played,
    played = _d === void 0 ? true : _d,
    _e = props.iconSrc,
    iconSrc = _e === void 0 ? defaultIconSrc : _e;
  var spinVisible = visible === undefined ? true : visible;
  // 用户传递类型异常时覆盖
  var realShow = !!spinVisible;
  var realDelay = isNaN(delay) ? 0 : delay;
  var _f = __read(React.useState(realDelay ? false : realShow), 2),
    status = _f[0],
    setStatus = _f[1];
  var timer = React.useRef(null);
  React.useEffect(function () {
    // 传入延时为0或非数字，立即展示
    if (realShow && realDelay === 0) {
      setStatus(true);
    }
    // 传入延时大于0且当前没有在展示中，延时加载
    if (realShow && delay > 0 && !status) {
      // 重新做延时调用
      timer.current = window.setTimeout(function () {
        setStatus(true);
      }, realDelay);
    }
    // 调用隐藏
    if (!realShow) {
      setStatus(false);
    }
    // 清除延时状态
    return function () {
      if (timer.current) {
        window.clearTimeout(timer.current);
        timer.current = null;
      }
    };
  }, [realShow]);
  var spinEl = withNativeProps(props, /*#__PURE__*/React.createElement("div", {
    className: classname(dtMobileSpinPrefix, (_a = {}, _a["".concat(className)] = !!className, _a["".concat(dtMobileSpinPrefix, "-visible")] = status, _a["".concat(dtMobileSpinPrefix, "-fixed")] = status && fixed, _a))
  }, /*#__PURE__*/React.createElement("div", {
    className: classname("".concat(dtMobileSpinPrefix, "-lightning"), (_b = {}, _b["".concat(dtMobileSpinPrefix, "-animation")] = played, _b)),
    style: {
      backgroundImage: "url(".concat(iconSrc, ")")
    }
  }), !!text && /*#__PURE__*/React.createElement("div", {
    className: "".concat(dtMobileSpinPrefix, "-hint")
  }, text)));
  if (children) {
    return withNativeProps(props, /*#__PURE__*/React.createElement("div", {
      className: "".concat(dtMobileSpinPrefix, "-nested-loading")
    }, /*#__PURE__*/React.createElement("div", null, spinEl), /*#__PURE__*/React.createElement("div", {
      className: classname("".concat(dtMobileSpinPrefix, "-container"), (_c = {}, _c["".concat(dtMobileSpinPrefix, "-blur")] = status, _c))
    }, children)));
  } else {
    return spinEl;
  }
});
Spin.displayName = 'Spin';
export default Spin;