import * as React from 'react';
import cls from 'classnames';
import { UpArrow1Outlined, DownArrowOutlined } from 'dd-icons';
import { useMobile } from '../hooks';
import './style/index';
import { dtMobilePrefix } from '../style/index';
export var dtMobileStatisticsPrefix = "".concat(dtMobilePrefix, "-statistics");
export var Statistic = function Statistic(props) {
  var _a;
  var title = props.title,
    value = props.value,
    unit = props.unit,
    compare = props.compare;
  var isMobile = useMobile();
  return /*#__PURE__*/React.createElement("div", {
    className: cls(dtMobileStatisticsPrefix, (_a = {}, _a["".concat(dtMobileStatisticsPrefix, "-desktop")] = !isMobile, _a))
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(dtMobileStatisticsPrefix, "-title")
  }, title), /*#__PURE__*/React.createElement("div", {
    className: "".concat(dtMobileStatisticsPrefix, "-measure")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(dtMobileStatisticsPrefix, "-measure-value")
  }, value), !!unit && /*#__PURE__*/React.createElement("div", {
    className: "".concat(dtMobileStatisticsPrefix, "-measure-unit")
  }, unit)), !!compare && (/*#__PURE__*/React.createElement("div", {
    className: "".concat(dtMobileStatisticsPrefix, "-compare")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(dtMobileStatisticsPrefix, "-compare-name")
  }, compare.title), /*#__PURE__*/React.createElement("div", {
    className: cls("".concat(dtMobileStatisticsPrefix, "-compare-value"), {
      up: compare.type === 'up',
      down: compare.type === 'down'
    })
  }, compare.value), /*#__PURE__*/React.createElement("div", {
    className: cls("".concat(dtMobileStatisticsPrefix, "-compare-icon"), {
      up: compare.type === 'up',
      down: compare.type === 'down'
    })
  }, compare.type === 'up' ? /*#__PURE__*/React.createElement(UpArrow1Outlined, null) : /*#__PURE__*/React.createElement(DownArrowOutlined, null)))));
};
Statistic.displayName = 'Statistic';
export default Statistic;