var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import React, { useEffect, useState } from 'react';
import './style/index';
import { dtMobilePrefix } from '../style/index';
import classnames from 'classnames';
import { withNativeProps } from '../_internal/native-props';
import { mergeProps } from '../_internal/with-default-props';
import { usePropsValue } from '../_internal/use-props-value';
import { bound } from '../_internal/bound';
import Button from '../button';
import Input from '../input';
import AdditionOutlined from 'dd-icons/lib/AdditionOutlined';
import Reduce2Outlined from 'dd-icons/lib/Reduce2Outlined';
import { useMobile } from '../hooks';
export var dtStepperPrefix = "".concat(dtMobilePrefix, "-stepper");
var defaultProps = {
  defaultValue: 0,
  step: 1,
  disabled: false,
  allowEmpty: false,
  size: 'small'
};
function convertValueToText(value) {
  if (value === null) return '';
  return value.toString();
}
function convertTextToValue(text) {
  if (text === '') return null;
  return parseFloat(text);
}
var Stepper = /*#__PURE__*/React.memo(function (p) {
  var _a, _b;
  var isMobile = useMobile();
  var props = mergeProps(defaultProps, p);
  var className = props.className,
    disabled = props.disabled,
    step = props.step,
    max = props.max,
    min = props.min,
    defaultValue = props.defaultValue,
    size = props.size,
    inputReadOnly = props.inputReadOnly;
  var _c = __read(usePropsValue(props), 2),
    value = _c[0],
    setValue = _c[1];
  var _d = __read(useState(function () {
      return convertValueToText(value);
    }), 2),
    inputValue = _d[0],
    setInputValue = _d[1];
  function setValueWithCheck(v) {
    if (isNaN(v)) return;
    var target = bound(v, props.min, props.max);
    if (props.digits || props.digits === 0) {
      target = parseFloat(target.toFixed(props.digits));
    }
    setValue(target);
  }
  var _e = __read(useState(false), 2),
    hasFocus = _e[0],
    setHasFocus = _e[1];
  useEffect(function () {
    if (!hasFocus) {
      setInputValue(convertValueToText(value));
    }
  }, [hasFocus]);
  useEffect(function () {
    if (!hasFocus) {
      setInputValue(convertValueToText(value));
    }
  }, [value]);
  var handleInputChange = function handleInputChange(v) {
    setInputValue(v);
    var value = convertTextToValue(v);
    if (value === null) {
      if (props.allowEmpty) {
        setValue(null);
      } else {
        setValue(defaultValue);
      }
    } else {
      setValueWithCheck(value);
    }
  };
  var handleMinus = function handleMinus(event) {
    event.stopPropagation();
    setValueWithCheck((value !== null && value !== void 0 ? value : 0) - step);
  };
  var handlePlus = function handlePlus(event) {
    event.stopPropagation();
    setValueWithCheck((value !== null && value !== void 0 ? value : 0) + step);
  };
  var minusDisabled = function minusDisabled() {
    if (disabled) return true;
    if (value === null) return false;
    if (min !== undefined) {
      return value <= min;
    }
    return false;
  };
  var plusDisabled = function plusDisabled() {
    if (disabled) return true;
    if (value === null) return false;
    if (max !== undefined) {
      return value >= max;
    }
    return false;
  };
  var wrapCls = classnames(dtStepperPrefix, className, "".concat(dtStepperPrefix, "-").concat(size), (_a = {}, _a["".concat(dtStepperPrefix, "-active")] = hasFocus, _a["".concat(dtStepperPrefix, "-desktop")] = !isMobile, _a));
  return withNativeProps(props, /*#__PURE__*/React.createElement("div", {
    className: wrapCls
  }, /*#__PURE__*/React.createElement(Button, {
    className: "".concat(dtStepperPrefix, "-minus"),
    onClick: function onClick(event) {
      return handleMinus(event);
    },
    disabled: minusDisabled()
  }, /*#__PURE__*/React.createElement(Reduce2Outlined, null)), /*#__PURE__*/React.createElement("div", {
    className: classnames("".concat(dtStepperPrefix, "-middle"), (_b = {}, _b["".concat(dtStepperPrefix, "-middle-disabled")] = disabled, _b))
  }, /*#__PURE__*/React.createElement(Input, {
    className: "".concat(dtStepperPrefix, "-input"),
    onFocus: function onFocus(v) {
      var _a;
      setHasFocus(true);
      var value = Number(v);
      (_a = props.onFocus) === null || _a === void 0 ? void 0 : _a.call(props, value);
    },
    readonly: inputReadOnly,
    value: inputValue,
    onChange: function onChange(val) {
      disabled || handleInputChange(val);
    },
    disabled: disabled,
    onBlur: function onBlur(v) {
      var _a;
      setHasFocus(false);
      var value = Number(v);
      (_a = props.onBlur) === null || _a === void 0 ? void 0 : _a.call(props, value);
    }
  })), /*#__PURE__*/React.createElement(Button, {
    className: "".concat(dtStepperPrefix, "-plus"),
    onClick: function onClick(event) {
      return handlePlus(event);
    },
    disabled: plusDisabled()
  }, /*#__PURE__*/React.createElement(AdditionOutlined, null))));
});
Stepper.displayName = 'Stepper';
export default Stepper;