var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import React from 'react';
import classnames from 'classnames';
import { withError, Labelable } from '../rmc';
import { getDataAttr } from '../_internal';
import { useControlledByChecked } from '../hooks';
import './style/index';
import { dtMobileSwitchPrefix as prefixCls } from '../style/index';
import TouchFeedback from 'rmc-feedback';
import { useMobile } from '../hooks';
export var Switch = function Switch(props) {
  var _a;
  var isMobile = useMobile();
  var disabled = props.disabled,
    className = props.className;
  var _b = useControlledByChecked(props),
    checked = _b.checked,
    onChange = _b.onChange;
  var handleLabelChange = function handleLabelChange(e) {
    var v = e.target.checked;
    onChange(v);
  };
  var wrapCls = classnames(prefixCls, className);
  var fakeInputCls = classnames("".concat(prefixCls, "-fake"), (_a = {}, _a["".concat(prefixCls, "-fake-disabled")] = disabled, _a["".concat(prefixCls, "-fake-checked")] = checked, _a["".concat(prefixCls, "-fake-desktop-checked")] = !isMobile && checked, _a["".concat(prefixCls, "-fake-desktop")] = !isMobile, _a));
  return (
    /*#__PURE__*/
    // @ts-ignore
    React.createElement(TouchFeedback, {
      activeClassName: "".concat(prefixCls, "-active"),
      disabled: disabled
    }, /*#__PURE__*/React.createElement("div", __assign({
      className: wrapCls
    }, getDataAttr(props)), /*#__PURE__*/React.createElement(Labelable, __assign({
      onClick: function onClick(event) {
        return event.stopPropagation();
      },
      onChange: handleLabelChange
    }, Labelable.getProps(props), {
      checked: checked,
      type: "checkbox"
    }), /*#__PURE__*/React.createElement("div", {
      className: fakeInputCls
    }))))
  );
};
Switch.displayName = 'Switch';
Switch.defaultProps = {
  disabled: false,
  defaultChecked: false
};
export default withError(Switch);