import type { BasePropsType } from '../../_internal';
import type { NativeProps } from '../../_internal/native-props';
export type TabbarProps = {
    /**
     * @description 当前激活item的key
     */
    activeKey?: string;
    /**
     * @description 如果没有设置activeKey时，初始化选中item的key
     */
    defaultActiveKey?: string;
    /**
     * @description 切换item的回调
     * @param key
     * @returns
     */
    onChange?: (key: string) => void;
    /**
     * @description 一行item最多的个数
     * @default 5
     */
    maxLineItems?: number;
    /**
     * @description 每一行的高度
     */
    itemHeight?: number;
    /**
     * @description 是否开启上滑拖动
     */
    openFloating?: boolean;
} & BasePropsType & NativeProps;
export { default as TabbarItem, } from './item';
export type { TabbarItemProps, } from './item';
