var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import React, { useRef } from 'react';
import './style/index';
import { dtMobilePrefix } from '../style/index';
import classnames from 'classnames';
import { withNativeProps } from '../_internal/native-props';
import Badge from '../badge';
import { usePropsValue } from '../_internal/use-props-value';
import { attachPropertiesToComponent } from '../_internal/attach-properties-to-component';
import { useSpring, animated } from 'dd-react-spring-web';
import { useDrag } from 'dd-use-gesture-react';
import { nearest } from '../_internal/nearest';
import { supportsPassive } from '../_internal/supports-passive';
export var dtMobiletabBarPrefix = "".concat(dtMobilePrefix, "-tabbar");
import 'regenerator-runtime/runtime.js';
export var TabbarItem = function TabbarItem() {
  return null;
};
var TABBAR_HEAER_HEIGHT = 14;
var TabBar = /*#__PURE__*/React.memo(function (props) {
  var _a, _b, _c, _d;
  // 得到tab的子元素并设置默认激活的key
  var firstActiveKey = undefined;
  var maxLineItems = (_a = props.maxLineItems) !== null && _a !== void 0 ? _a : 5;
  var itemHeight = (_b = props.itemHeight) !== null && _b !== void 0 ? _b : 78;
  var isOpenFloating = (_c = props.openFloating) !== null && _c !== void 0 ? _c : false;
  var items = [];
  React.Children.forEach(props.children, function (child, index) {
    if (! /*#__PURE__*/React.isValidElement(child)) return;
    var key = child.key;
    if (typeof key !== 'string') return;
    if (index === 0) {
      firstActiveKey = key;
    }
    items.push(child);
  });
  var isNeedUnFold = items.length > maxLineItems && isOpenFloating;
  // 设置tabbar的滑动监听事件
  var tabbarContainerRef = useRef(null);
  var elementRef = useRef(null);
  var headerRef = useRef(null);
  var _e = __read(React.useState(false), 2),
    setPulling = _e[1];
  var pullingRef = useRef(false);
  var itemLines = Math.ceil(items.length / maxLineItems);
  var maxHeight = itemLines * itemHeight;
  var anchors = Array(itemLines).fill(0).map(function (_ele, index) {
    return itemHeight * index;
  });
  var possibles = anchors.map(function (x) {
    return -x;
  }); // 利用possible达到固定地方停止的作用
  var bounds = {
    top: possibles[possibles.length - 1],
    bottom: possibles[0]
  };
  var _f = __read(useSpring(function () {
      return {
        y: bounds.bottom,
        config: {
          tension: 300
        }
      };
    }), 2),
    y = _f[0].y,
    api = _f[1];
  useDrag(function (state) {
    var _a = __read(state.offset, 2),
      offsetY = _a[1];
    if (state.first) {
      var target = state.event.target;
      var header = headerRef.current;
      if (header === target) {
        // 如果拖拽的元素是列表上面的按钮，直接设置拖动
        pullingRef.current = true;
      } else {
        var reachedTop = y.goal <= bounds.top;
        var content = tabbarContainerRef.current;
        if (!content) return;
        if (reachedTop) {
          if (content.scrollTop <= 0 && state.direction[1] > 0) {
            pullingRef.current = true;
          }
        } else {
          pullingRef.current = true;
        }
      }
    }
    setPulling(pullingRef.current);
    if (!pullingRef.current) return;
    var event = state.event;
    if (event.cancelable) {
      event.preventDefault();
    }
    event.stopPropagation();
    var nextY = offsetY;
    if (state.last) {
      pullingRef.current = false;
      setPulling(false);
      nextY = nearest(possibles, offsetY);
    }
    api.start({
      y: nextY
    });
  }, {
    axis: 'y',
    bounds: bounds,
    rubberband: true,
    from: function from() {
      return [0, y.get()];
    },
    pointer: {
      touch: true
    },
    target: elementRef,
    eventOptions: supportsPassive ? {
      passive: false
    } : false
  });
  var _g = __read(usePropsValue({
      value: props.activeKey,
      // @ts-ignore
      defaultValue: (_d = props.activeKey) !== null && _d !== void 0 ? _d : firstActiveKey,
      onChange: props.onChange
    }), 2),
    activeKey = _g[0],
    setActiveKey = _g[1];
  /**
   * 渲染每一个item
   * @param props
   * @param active
   * @returns
   */
  var renderContent = function renderContent(props, active) {
    var icon = props.icon,
      title = props.title;
    var iconElement = icon && (/*#__PURE__*/React.createElement("div", {
      className: "dtm-tabbar-item-icon"
    }, typeof icon === 'function' ? icon(active) // 可以用户自己设置icon激活的逻辑
    : icon));
    var titleElement = title && /*#__PURE__*/React.createElement("div", {
      className: "dtm-tabbar-item-text"
    }, title);
    if (iconElement) {
      return /*#__PURE__*/React.createElement(React.Fragment, null, typeof props.badge === 'string' ? (/*#__PURE__*/React.createElement(Badge, {
        text: props.badge.length ? props.badge : undefined,
        className: "dtm-tabbar-icon-badge"
      }, iconElement)) : iconElement, titleElement);
    } else if (titleElement) {
      return /*#__PURE__*/React.createElement(React.Fragment, null, typeof props.badge === 'string' ? (/*#__PURE__*/React.createElement(Badge, {
        text: props.badge.length ? props.badge : undefined,
        className: "dtm-tabbar-title-badge"
      }, titleElement)) : titleElement);
    }
    return null;
  };
  var renderContentContainer = function renderContentContainer() {
    return /*#__PURE__*/React.createElement("div", {
      className: "dtm-tabbar-item-container",
      ref: tabbarContainerRef,
      style: {
        gridTemplateColumns: "repeat(".concat(maxLineItems, ", 1fr)"),
        height: "".concat(itemHeight - TABBAR_HEAER_HEIGHT, "px")
      }
    }, isNeedUnFold && /*#__PURE__*/React.createElement("div", {
      className: "dtm-tabbar-divider",
      style: {
        top: "".concat(itemHeight, "px")
      }
    }), items.map(function (item, index) {
      var active = item.key === activeKey;
      return /*#__PURE__*/React.createElement("div", {
        key: item.key,
        onClick: function onClick() {
          var key = item.key;
          if (key === undefined || key === null) return;
          setActiveKey(key.toString());
        },
        className: classnames('dtm-tabbar-item', {
          'dtm-tabbar-item-active': active,
          'dtm-tabbar-item-not-first-line': index >= maxLineItems
        })
      }, renderContent(item.props, active));
    }));
  };
  // 获取类
  var className = props.className;
  var prefixCls = dtMobiletabBarPrefix;
  var wrapCls = classnames(prefixCls, className, {
    'dtm-tabbar-three': maxLineItems === 3,
    'dtm-tabbar-four': maxLineItems === 4,
    'dtm-tabbar-five': maxLineItems === 5
  });
  // 渲染
  return withNativeProps(props, /*#__PURE__*/React.createElement(React.Fragment, null, isNeedUnFold ? (/*#__PURE__*/React.createElement(animated.div, {
    ref: elementRef,
    className: wrapCls,
    style: {
      height: maxHeight,
      y: y
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "dtm-tabbar-unfold-btn",
    ref: headerRef
  }), renderContentContainer())) : (/*#__PURE__*/React.createElement("div", {
    className: wrapCls
  }, renderContentContainer()))));
});
TabBar.displayName = 'TabBar';
export default attachPropertiesToComponent(TabBar, {
  Item: TabbarItem
});