var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import classNames from 'classnames';
import React, { forwardRef, Fragment, useContext } from 'react';
import { useGuid } from '../_internal/hooks';
import { TabContext } from './tab';
var prefix = 'dtm-';
var TabItem = function TabItem(props, ref) {
  var _a, _b, _c, _d;
  var className = props.className,
    size = props.size,
    itemKey = props.itemKey,
    _e = props.title,
    title = _e === void 0 ? '' : _e,
    _f = props.icon,
    icon = _f === void 0 ? '' : _f,
    children = props.children,
    _g = props.disabled,
    disabled = _g === void 0 ? false : _g,
    others = __rest(props, ["className", "size", "itemKey", "title", "icon", "children", "disabled"]);
  var _h = useContext(TabContext),
    activeKey = _h.activeKey,
    change = _h.change,
    fullWidth = _h.fullWidth;
  var active = "".concat(activeKey) === "".concat(itemKey);
  var clsPrefix = "".concat(prefix, "tab-item");
  var curItemId = useGuid('tab-item-');
  var clses = {
    tab: classNames(clsPrefix, "".concat(clsPrefix, "--").concat(size), "".concat(clsPrefix, "--").concat(itemKey), (_a = {}, _a["".concat(clsPrefix, "--active")] = active && !disabled, _a["".concat(clsPrefix, "--fullwidth")] = fullWidth, _a["".concat(clsPrefix, "--disabled")] = disabled, _a), className),
    activeLine: "".concat(clsPrefix, "-active-line ").concat(clsPrefix, "-active-line--normal"),
    tabIcon: classNames("".concat(clsPrefix, "-icon"), "".concat(clsPrefix, "-icon--").concat(size), (_b = {}, _b["".concat(clsPrefix, "-icon--active")] = active, _b)),
    tabText: classNames("".concat(clsPrefix, "-text"), "".concat(clsPrefix, "-text--").concat(size), (_c = {}, _c["".concat(clsPrefix, "-text--active")] = active, _c))
  };
  var renderTitle = function renderTitle() {
    return /*#__PURE__*/React.createElement("div", {
      className: clses.tabText
    }, title);
  };
  var handleClick = function handleClick() {
    if (!disabled) {
      change(itemKey);
    }
  };
  return /*#__PURE__*/React.createElement("div", __assign({}, others, {
    id: curItemId,
    ref: ref,
    className: clses.tab,
    onClick: handleClick
  }), /*#__PURE__*/React.createElement(Fragment, null, icon ? {
    icon: icon
  } : null, renderTitle()), /*#__PURE__*/React.createElement("div", {
    className: classNames(clses.activeLine, (_d = {}, _d["".concat(clsPrefix, "-active-line--enter")] = active, _d["".concat(clsPrefix, "-active-line--exit")] = !active, _d))
  }));
};
TabItem.displayName = 'Tab.Item';
export default /*#__PURE__*/forwardRef(TabItem);