import { NativeProps } from './../_internal/native-props';
import { ReactNode } from 'react';
export interface TabContextProps {
    activeKey?: string | number;
    change: (key: string | number) => void;
    fullWidth?: boolean;
}
export interface TabItemProps {
    key?: any;
    title?: ReactNode;
    icon?: ReactNode;
    size?: 'small' | 'medium' | 'large';
    itemKey?: any;
    className?: string;
    disabled?: boolean;
}
export type TabProps = {
    activeKey?: string | number;
    defaultActiveKey?: string | number;
    fullWidth?: boolean;
    tabs?: TabItemProps[];
    size?: 'small' | 'medium' | 'large';
    tabBarExtraContent?: ReactNode;
    className?: string;
    /** 透明版本，常用于内嵌的 Tabs */
    transparent?: boolean;
    sticky?: boolean;
    onChange?: (key: string | number) => void;
    onTabClick?: (key: string | number) => void;
    children?: ReactNode;
    hideBottomDivider?: boolean;
    canExpand?: boolean;
} & NativeProps<'--tab-block-background' | '--tab-block-background-hover' | '--tab-block-background-active' | '--tab-item-color-active'>;
