var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import classnames from 'classnames';
import React, { useCallback, useMemo, useState } from 'react';
import CloseOutlined from 'dingtalk-design-icons/lib/CloseOutlined';
import { dtMobilePrefix } from '../style/index';
export var prefix = "".concat(dtMobilePrefix, "-tag");
var Tag = function Tag(props) {
  var className = props.className,
    children = props.children,
    onClose = props.onClose,
    icon = props.icon,
    _a = props.closable,
    closable = _a === void 0 ? false : _a,
    _b = props.size,
    size = _b === void 0 ? 'small' : _b,
    onClick = props.onClick,
    color = props.color;
  var _c = __read(useState(true), 2),
    show = _c[0],
    setShow = _c[1];
  var type = React.useMemo(function () {
    var _a;
    if (color) {
      switch (color) {
        case 'default':
          return 'normal';
        case 'primary':
          return 'blue';
        case 'success':
          return 'green';
        case 'warning':
          return 'orange';
        case 'danger':
          return 'red';
      }
    }
    return (_a = props.type) !== null && _a !== void 0 ? _a : 'normal';
  }, [props.type, props.color]);
  var style = React.useMemo(function () {
    if (color && !props.type) {
      return __assign(__assign({}, props.style), {
        color: color
      });
    }
    return props.style;
  }, [props.style, props.type, color]);
  var isFill = React.useMemo(function () {
    if (props.fill === 'solid') {
      return true;
    } else if (!props.fill && props.size === 'medium') {
      return true;
    }
    return false;
  }, [props.fill, props.size]);
  var wrapCls = classnames("".concat(prefix), "".concat(prefix, "-color-").concat(type), isFill && "".concat(prefix, "-fill"), "".concat(prefix, "-").concat(size === 'small' ? 'small' : 'normal'), className);
  var handleClose = useCallback(function () {
    if (onClose && typeof onClose === 'function') {
      onClose();
    }
    setShow(false);
  }, [onClose]);
  var closeIcon = useMemo(function () {
    if (!closable) {
      return null;
    }
    return /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefix, "-icon ").concat(prefix, "-close-icon"),
      onClick: handleClose
    }, /*#__PURE__*/React.createElement(CloseOutlined, null));
  }, [closable, handleClose]);
  var tagIcon = useMemo(function () {
    if (typeof icon === 'undefined') {
      return null;
    }
    if (typeof icon === 'function') {
      return /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefix, "-icon")
      }, icon());
    }
    return /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefix, "-icon")
    }, icon);
  }, [icon]);
  return show ? (/*#__PURE__*/React.createElement("div", {
    className: wrapCls,
    onClick: onClick,
    style: style
  }, tagIcon, /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefix, "-text")
  }, children), closeIcon)) : null;
};
Tag.displayName = 'Tag';
export default Tag;