import _typeof from "@babel/runtime/helpers/esm/typeof";
var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
/* tslint:disable:jsx-no-multiline-js */
import classnames from 'classnames';
import React from 'react';
import TouchFeedback from 'rmc-feedback';
import Splitter from 'grapheme-splitter';
var splitter = new Splitter();
function noop() {}
function fixControlledValue(value) {
  if (typeof value === 'undefined' || value === null) {
    return '';
  }
  return value;
}
var regexAstralSymbols = /[\uD800-\uDBFF][\uDC00-\uDFFF]|\n/g;
function countSymbols(text) {
  if (text === void 0) {
    text = '';
  }
  return splitter.splitGraphemes(text.replace(regexAstralSymbols, '_')).length;
}
var TextareaItem = /** @class */function (_super) {
  __extends(TextareaItem, _super);
  function TextareaItem(props) {
    var _this = _super.call(this, props) || this;
    _this.focus = function () {
      var _a, _b;
      _this.textareaRef.focus();
      _this.textareaRef.selectionStart = (_a = _this.props.value) === null || _a === void 0 ? void 0 : _a.length;
      _this.textareaRef.selectionEnd = (_b = _this.props.value) === null || _b === void 0 ? void 0 : _b.length;
    };
    _this.reAlignHeight = function () {
      var textareaDom = _this.textareaRef;
      textareaDom.style.height = ''; // 字数减少时能自动减小高度
      var height = textareaDom.scrollHeight;
      if (_typeof(_this.props.autoHeight) === 'object') {
        var computedStyle = window.getComputedStyle(textareaDom);
        var lineHeight = parseFloat(computedStyle.lineHeight);
        if (_this.props.autoHeight.minRows) {
          height = Math.max(height, _this.props.autoHeight.minRows * lineHeight);
        }
        if (_this.props.autoHeight.maxRows) {
          height = Math.min(height, _this.props.autoHeight.maxRows * lineHeight);
        }
      }
      textareaDom.style.height = "".concat(height, "px");
    };
    _this.onChange = function (e) {
      var value = e.target.value;
      if ('value' in _this.props) {
        _this.setState({
          value: _this.props.value
        });
      } else {
        _this.setState({
          value: value
        });
      }
      var onChange = _this.props.onChange;
      if (onChange) {
        onChange(value);
      }
      // 设置 defaultValue 时，用户输入不会触发 componentDidUpdate ，此处手工调用
      _this.componentDidUpdate();
    };
    _this.onBlur = function (e) {
      _this.debounceTimeout = setTimeout(function () {
        if (document.activeElement !== _this.textareaRef) {
          _this.setState({
            focus: false
          });
        }
      }, 100);
      var value = e.currentTarget.value;
      if (_this.props.onBlur) {
        _this.props.onBlur(value);
      }
    };
    _this.onFocus = function (e) {
      if (_this.debounceTimeout) {
        clearTimeout(_this.debounceTimeout);
        _this.debounceTimeout = null;
      }
      _this.setState({
        focus: true
      });
      var value = e.currentTarget.value;
      if (_this.props.onFocus) {
        _this.props.onFocus(value);
      }
    };
    _this.onKeyDown = function (e) {
      var _a = _this.props,
        onPressEnter = _a.onPressEnter,
        onKeyDown = _a.onKeyDown;
      var value = e.currentTarget.value;
      if (onKeyDown) {
        onKeyDown(e);
      }
      if (e.key === 'Enter' && onPressEnter) {
        onPressEnter(value);
      }
    };
    _this.onErrorClick = function () {
      if (_this.props.onErrorClick) {
        _this.props.onErrorClick();
      }
    };
    _this.clearInput = function () {
      _this.setState({
        value: ''
      });
      if (_this.props.onChange) {
        _this.props.onChange('');
      }
    };
    _this.state = {
      focus: false,
      value: props.value || props.defaultValue || ''
    };
    return _this;
  }
  TextareaItem.prototype.componentWillReceiveProps = function (nextProps) {
    if ('value' in nextProps) {
      this.setState({
        value: fixControlledValue(nextProps.value)
      });
    }
  };
  TextareaItem.prototype.componentDidMount = function () {
    if (this.props.autoHeight) {
      this.reAlignHeight();
    }
  };
  TextareaItem.prototype.componentDidUpdate = function (prevProps) {
    if (this.props.autoHeight && this.state.focus) {
      this.reAlignHeight();
    }
    if (this.props.autoHeight && (prevProps === null || prevProps === void 0 ? void 0 : prevProps.value) !== this.props.value) {
      this.reAlignHeight();
    }
  };
  TextareaItem.prototype.componentWillUnmount = function () {
    if (this.debounceTimeout) {
      clearTimeout(this.debounceTimeout);
      this.debounceTimeout = null;
    }
  };
  TextareaItem.prototype.render = function () {
    var _a, _b;
    var _this = this;
    var _c = this.props,
      prefixCls = _c.prefixCls,
      prefixListCls = _c.prefixListCls,
      editable = _c.editable,
      style = _c.style,
      clear = _c.clear,
      children = _c.children,
      error = _c.error,
      className = _c.className,
      count = _c.count,
      labelNumber = _c.labelNumber,
      title = _c.title,
      onErrorClick = _c.onErrorClick,
      autoHeight = _c.autoHeight,
      defaultValue = _c.defaultValue,
      otherProps = __rest(_c, ["prefixCls", "prefixListCls", "editable", "style", "clear", "children", "error", "className", "count", "labelNumber", "title", "onErrorClick", "autoHeight", "defaultValue"]);
    var disabled = otherProps.disabled;
    var _d = this.state,
      value = _d.value,
      focus = _d.focus;
    var hasCount = count > 0 && this.props.rows > 1;
    var wrapCls = classnames(className, "".concat(prefixListCls, "-item"), "".concat(prefixCls, "-item"), (_a = {}, _a["".concat(prefixCls, "-disabled")] = disabled, _a["".concat(prefixCls, "-item-single-line")] = this.props.rows === 1 && !autoHeight, _a["".concat(prefixCls, "-error")] = error, _a["".concat(prefixCls, "-focus")] = focus, _a["".concat(prefixCls, "-has-count")] = hasCount, _a));
    var labelCls = classnames("".concat(prefixCls, "-label"), (_b = {}, _b["".concat(prefixCls, "-label-2")] = labelNumber === 2, _b["".concat(prefixCls, "-label-3")] = labelNumber === 3, _b["".concat(prefixCls, "-label-4")] = labelNumber === 4, _b["".concat(prefixCls, "-label-5")] = labelNumber === 5, _b["".concat(prefixCls, "-label-6")] = labelNumber === 6, _b["".concat(prefixCls, "-label-7")] = labelNumber === 7, _b));
    var characterLength = countSymbols(value);
    var lengthCtrlProps = {};
    if (count > 0) {
      lengthCtrlProps.maxLength = count - characterLength + (value ? value.length : 0);
    }
    return /*#__PURE__*/React.createElement("div", {
      className: wrapCls
    }, title && /*#__PURE__*/React.createElement("div", {
      className: labelCls
    }, title), /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-control")
    }, /*#__PURE__*/React.createElement("textarea", __assign({
      ref: function ref(el) {
        return _this.textareaRef = el;
      }
    }, lengthCtrlProps, otherProps, {
      value: value,
      onChange: this.onChange,
      onBlur: this.onBlur,
      onFocus: this.onFocus,
      onKeyDown: this.onKeyDown,
      readOnly: !editable,
      style: style
    }))), clear && editable && value && characterLength > 0 && (
    /*#__PURE__*/
    // @ts-ignore
    React.createElement(TouchFeedback, {
      activeClassName: "".concat(prefixCls, "-clear-active")
    }, /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-clear"),
      onClick: this.clearInput
    }))), error && /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-error-extra"),
      onClick: this.onErrorClick
    }), hasCount && (/*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-count")
    }, /*#__PURE__*/React.createElement("span", null, value ? characterLength : 0), "/", count)));
  };
  TextareaItem.defaultProps = {
    prefixCls: 'am-textarea',
    prefixListCls: 'am-list',
    autoHeight: false,
    editable: true,
    disabled: false,
    placeholder: '',
    clear: false,
    rows: 1,
    onChange: noop,
    onBlur: noop,
    onFocus: noop,
    onErrorClick: noop,
    error: false,
    labelNumber: 5
  };
  return TextareaItem;
}(React.Component);
export default TextareaItem;