var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import React, { useImperativeHandle, useRef } from 'react';
import { default as AntdTextareaItem } from './antd2';
import { dtTextareaItemPrefix } from '../style/index';
import { useMobile } from '../hooks';
import './style/index';
var TextareaItem = /*#__PURE__*/React.memo(/*#__PURE__*/React.forwardRef(function (props, forwardRef) {
  var inputRef = useRef();
  useImperativeHandle(forwardRef, function () {
    return {
      focus: function focus() {
        var _a, _b;
        (_b = (_a = inputRef === null || inputRef === void 0 ? void 0 : inputRef.current) === null || _a === void 0 ? void 0 : _a.focus) === null || _b === void 0 ? void 0 : _b.call(_a);
      }
    };
  });
  var isMobile = useMobile();
  var className = isMobile ? '' : "".concat(dtTextareaItemPrefix, "-desktop");
  return /*#__PURE__*/React.createElement(AntdTextareaItem, __assign({}, props, {
    title: "",
    className: className,
    prefixCls: dtTextareaItemPrefix,
    prefixListCls: "",
    ref: inputRef
  }));
}));
TextareaItem.displayName = 'TextareaItem';
export default TextareaItem;