import type { ToastOptions } from './options';
export interface ToastAPI {
    /**
     * @description 普通toast，用于展示提示信息
     */
    show: (params: Omit<ToastOptions, 'onClose'>) => void;
    /**
     * @description 普通toast，但是可以自定义onClose事件
     */
    info: (params: ToastOptions) => void;
    /**
     * @description 成功toast
     */
    success: (params: ToastOptions) => void;
    /**
     * @description 失败toast
     */
    fail: (params: ToastOptions) => void;
    /**
     * @description loading态toast
     */
    loading: (params: ToastOptions) => void;
    /**
     * @description 自定义icon
     */
    config: (params: ToastOptions) => void;
    /**
     * @description 手动隐藏toast，
     */
    hide: () => void;
}
declare const _default: (props: ToastAPI) => null;
export default _default;
