/// <reference types="react" />
import type { GetContainer } from '../../_internal/render-to-container';
export declare enum ToastPosition {
    TOP = "top",
    MIDDLE = "middle"
}
export interface ToastOptions {
    /**
     * @description toast渲染的内容(除icon)
     */
    content: React.ReactNode | string;
    /**
     * @description 持续时间，单位：s
     * @defalt 2
     */
    duration?: number;
    /**
     * @description 是否有蒙层
     * @default false
     */
    mask?: boolean;
    /**
     * @description 出现的位置
     */
    position?: ToastPosition | 'top' | 'middle';
    /**
     * @description 传入的icon，采用Toast.config进行配置
     */
    icon?: React.ReactNode;
    /**
     * @description 蒙层下面元素是否可以点击(version >= 2.2.0)
     * @default false
     */
    maskClickable?: boolean;
    /**
     * @description 内容的展示方式，inline表示内容和icon采用内联元素样式展示
     */
    showType?: 'normal' | 'inline';
    /**
     * @description 自定义close关闭事件，pc端暂不支持(version >= 2.2.0)
     */
    onClose?: () => void;
    /**
     * @description 关闭多端适配的能力
     */
    adapt?: false;
    /**
     * @description 自定义轻提示的父容器
     */
    getContainer?: GetContainer;
}
declare const _default: (props: ToastOptions) => null;
export default _default;
