var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import React from 'react';
import { InternalToast } from './toast';
import { renderImperatively } from '../_internal/render-imperatively';
var currentHandler = null;
var currentTimeout = null;
export function show(props) {
  var element = /*#__PURE__*/React.createElement(InternalToast, __assign({}, props, {
    onClose: function onClose() {
      var _a;
      currentHandler = null;
      (_a = props.onClose) === null || _a === void 0 ? void 0 : _a.call(props);
    }
  }));
  if (currentHandler) {
    currentHandler.replace(element);
  } else {
    currentHandler = renderImperatively(element);
  }
  if (currentTimeout) {
    window.clearTimeout(currentTimeout);
  }
  if (props.duration) {
    currentTimeout = window.setTimeout(function () {
      clear();
    }, props.duration * 1000);
  }
  return currentHandler;
}
export function clear() {
  currentHandler === null || currentHandler === void 0 ? void 0 : currentHandler.close();
  currentHandler = null;
}