import { ToastPosition } from './api/options';
import { isMobile, isInDingTalk } from '../_internal';
import { adaptPC } from './adapt';
import { show } from './methods';
var defaultConfig = {
  duration: 2,
  mask: false,
  showType: 'inline',
  maskClickable: false
};
export function notice(content, type, duration, onClose, mask, position, showType, icon, maskClickable, adapt, getContainer) {
  if (duration === void 0) {
    duration = defaultConfig.duration;
  }
  if (mask === void 0) {
    mask = defaultConfig.mask;
  }
  if (position === void 0) {
    position = isMobile ? ToastPosition.MIDDLE : ToastPosition.TOP;
  }
  if (showType === void 0) {
    showType = defaultConfig.showType;
  }
  if (icon === void 0) {
    icon = null;
  }
  if (maskClickable === void 0) {
    maskClickable = defaultConfig.maskClickable;
  }
  if (adapt === void 0) {
    adapt = true;
  }
  // PC 端仅在钉钉内部才改变
  if (!isMobile && isInDingTalk && adapt) {
    return adaptPC(type, content, position, duration);
  }
  show({
    content: content,
    icon: type !== 'config' ? type : icon,
    duration: duration,
    onClose: onClose,
    maskVisible: mask,
    maskClickable: maskClickable,
    showType: showType,
    position: position,
    getContainer: getContainer
  });
}