import React, { useMemo } from 'react';
import classNames from 'classnames';
import WarningFilled from 'dd-icons/lib/WarningFilled';
import AchieveFilled from 'dd-icons/lib/AchieveFilled';
import CheckOutlined from 'dd-icons/lib/CheckOutlined';
import WarningOutlined from 'dd-icons/lib/WarningOutlined';
import HintFilled from 'dd-icons/lib/HintFilled';
import Mask from '../mask';
import { mergeProps } from '../_internal/with-default-props';
import Spin from '../spin';
import { dtMobilePrefix } from '../style';
import classnames from 'classnames';
import CloseOutlined from 'dd-icons/lib/CloseOutlined';
var prefixCls = "".concat(dtMobilePrefix, "-toast");
var defaultProps = {
  maskClickable: true,
  stopPropagation: ['click']
};
export var InternalToast = function InternalToast(p) {
  var props = mergeProps(defaultProps, p);
  var maskClickable = props.maskClickable,
    content = props.content,
    icon = props.icon,
    position = props.position;
  var iconElement = useMemo(function () {
    var _a;
    if (!icon) return null;
    switch (icon) {
      case 'success':
        if (props.showType === 'inline') {
          return /*#__PURE__*/React.createElement(AchieveFilled, {
            className: "".concat(prefixCls, "-icon-success")
          });
        } else {
          return /*#__PURE__*/React.createElement(CheckOutlined, {
            className: "".concat(prefixCls, "-icon-success")
          });
        }
      case 'fail':
        if (props.showType === 'inline') {
          return /*#__PURE__*/React.createElement(WarningFilled, {
            className: "".concat(prefixCls, "-icon-fail")
          });
        } else {
          return /*#__PURE__*/React.createElement(WarningOutlined, {
            className: "".concat(prefixCls, "-icon-fail")
          });
        }
      case 'loading':
        return /*#__PURE__*/React.createElement(Spin, {
          className: classnames("".concat(prefixCls, "-icon-loading"), (_a = {}, _a["".concat(prefixCls, "-loading-lightning")] = position === 'middle', _a["".concat(prefixCls, "-loading-lightning-top")] = position === 'top', _a))
        });
      case 'info':
        return /*#__PURE__*/React.createElement(HintFilled, {
          className: "".concat(prefixCls, "-icon-info")
        });
      default:
        return icon;
    }
  }, [icon]);
  var top = useMemo(function () {
    switch (position) {
      case 'top':
        return '12%';
      default:
        return '50%';
    }
  }, [position]);
  return /*#__PURE__*/React.createElement(Mask, {
    visible: props.visible,
    maskShow: props.maskVisible,
    destroyOnClose: true,
    opacity: 0,
    disableBodyScroll: !maskClickable,
    getContainer: props.getContainer,
    afterClose: props.onClose,
    style: {
      pointerEvents: maskClickable ? 'none' : 'auto'
    },
    className: classnames("".concat(prefixCls, "-mask"), !!props.getContainer && "".concat(prefixCls, "-mask-inner")),
    stopPropagation: props.stopPropagation
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames(props.showType === 'inline' ? "".concat(prefixCls, "-inline") : "".concat(prefixCls, "-normal"), !!props.getContainer ? "".concat(prefixCls, "-inner") : "".concat(prefixCls, "-wrap"))
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      top: top
    },
    className: classNames("".concat(prefixCls, "-main"), icon ? "".concat(prefixCls, "-main-icon") : "".concat(prefixCls, "-main-text"))
  }, iconElement && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-icon")
  }, iconElement), typeof content === 'string' ? (/*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-content")
  }, content)) : content, icon === 'loading' && props.showType === 'inline' && (/*#__PURE__*/React.createElement(CloseOutlined, {
    className: "".concat(prefixCls, "-close"),
    onClick: function onClick() {
      var _a;
      return (_a = props.onClose) === null || _a === void 0 ? void 0 : _a.call(props);
    }
  })))));
};