var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import * as React from 'react';
import classNames from 'classnames';
import CloseCircleFilled from 'dingtalk-design-icons/lib/CloseCircleFilled';
import List from '../list';
import { useMobile } from '../hooks';
var ListItem = /*#__PURE__*/React.forwardRef(function (_a, ref) {
  var _b, _c, _d, _e;
  var prefixCls = _a.prefixCls,
    className = _a.className,
    style = _a.style,
    listType = _a.listType,
    file = _a.file,
    items = _a.items,
    iconRender = _a.iconRender,
    itemRender = _a.itemRender,
    isImgUrl = _a.isImgUrl,
    showRemoveIcon = _a.showRemoveIcon,
    onPreview = _a.onPreview,
    onClose = _a.onClose,
    previewContent = _a.previewContent,
    showPreviewIcon = _a.showPreviewIcon,
    extraRender = _a.extraRender,
    uploadErrorLabel = _a.uploadErrorLabel;
  var isMobile = useMobile();
  var isError = React.useMemo(function () {
    var _a;
    if (((_a = file.error) === null || _a === void 0 ? void 0 : _a.type) === 'error') {
      return true;
    }
    return false;
  }, [file.error]);
  // This is used for legacy span make scrollHeight the wrong value.
  // We will force these to be `display: block` with non `picture`
  var spanClassName = "".concat(prefixCls, "-span");
  var iconNode = iconRender(file);
  var extraNode = extraRender(file);
  var icon = /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-text-icon")
  }, iconNode);
  if (listType === 'picture') {
    if (file.status === 'uploading' || !file.thumbUrl && !file.url) {
      var uploadingClassName = classNames((_b = {}, _b["".concat(prefixCls, "-list-item-thumbnail")] = true, _b["".concat(prefixCls, "-list-item-file")] = file.status !== 'uploading', _b));
      icon = /*#__PURE__*/React.createElement("div", {
        className: uploadingClassName
      }, iconNode);
    } else {
      var thumbnail = (isImgUrl === null || isImgUrl === void 0 ? void 0 : isImgUrl(file)) ? (/*#__PURE__*/React.createElement("img", {
        src: file.thumbUrl || file.url,
        alt: file.name,
        className: "".concat(prefixCls, "-list-item-image")
      })) : iconNode;
      var aClassName = classNames((_c = {}, _c["".concat(prefixCls, "-list-item-thumbnail")] = true, _c["".concat(prefixCls, "-list-item-file")] = isImgUrl && !isImgUrl(file), _c));
      icon = /*#__PURE__*/React.createElement("a", {
        className: aClassName,
        onClick: function onClick(e) {
          onPreview(file, e);
        },
        href: file.url || file.thumbUrl,
        target: "_blank",
        rel: "noopener noreferrer"
      }, thumbnail);
    }
  }
  var infoUploadingClass = classNames((_d = {}, _d["".concat(prefixCls, "-list-item")] = true, _d["".concat(prefixCls, "-list-item-").concat(file.status)] = true, _d["".concat(prefixCls, "-list-item-list-type-").concat(listType)] = true, _d));
  var linkProps = typeof file.linkProps === 'string' ? JSON.parse(file.linkProps) : file.linkProps;
  var removeIcon = showRemoveIcon && (/*#__PURE__*/React.createElement(CloseCircleFilled, {
    onClick: function onClick() {
      onClose(file);
    }
  }));
  var downloadOrDelete = /*#__PURE__*/React.createElement("span", {
    key: "download-delete",
    className: classNames("".concat(prefixCls, "-list-item-card-actions"), {
      picture: listType === 'picture'
    })
  }, removeIcon);
  var listItemNameClass = classNames("".concat(prefixCls, "-list-item-name"));
  var preview = /*#__PURE__*/React.createElement(List.Item, __assign({
    key: "view",
    wrap: true,
    className: listItemNameClass,
    brief: /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-list-item-brief")
    }, extraNode && !isError && (/*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-list-item-size")
    }, extraNode)), isError && (/*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-list-item-error")
    }, uploadErrorLabel || '上传失败')), showPreviewIcon && !isError && (/*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-list-item-brief-preview"),
      onClick: function onClick(e) {
        return onPreview(file, e);
      }
    }, previewContent))),
    extra: downloadOrDelete
  }, linkProps), /*#__PURE__*/React.createElement("p", {
    className: "".concat(prefixCls, "-list-item-title")
  }, file.name));
  var iconAndPreview = /*#__PURE__*/React.createElement("span", {
    className: spanClassName
  }, icon, listType === 'picture' ? downloadOrDelete : preview);
  var dom = /*#__PURE__*/React.createElement("div", {
    className: infoUploadingClass
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-list-item-info")
  }, iconAndPreview));
  var listContainerNameClass = classNames("".concat(prefixCls, "-list-").concat(listType, "-container"), className, (_e = {}, _e["".concat(prefixCls, "-list-").concat(listType, "-container-desktop")] = !isMobile, _e));
  return /*#__PURE__*/React.createElement("div", {
    className: listContainerNameClass,
    style: style,
    ref: ref
  }, itemRender ? itemRender(dom, file, items) : dom);
});
export default ListItem;