var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
import * as React from 'react';
import classNames from 'classnames';
import LoadingCircularOutlined from 'dingtalk-design-icons/lib/LoadingCircularOutlined';
import { previewImage, isImageUrl, formatBytes } from './utils';
import ListItem from './ListItem';
import { dtUploadPrefix as prefixCls } from '../style';
import { useMobile } from '../hooks';
export function useForceUpdate() {
  var _a = __read(React.useReducer(function (x) {
      return x + 1;
    }, 0), 2),
    forceUpdate = _a[1];
  return forceUpdate;
}
var InternalUploadList = function InternalUploadList(_a, ref) {
  var _b;
  var listType = _a.listType,
    previewFile = _a.previewFile,
    onPreview = _a.onPreview,
    onRemove = _a.onRemove,
    iconRender = _a.iconRender,
    isImgUrl = _a.isImageUrl,
    _c = _a.items,
    items = _c === void 0 ? [] : _c,
    showPreviewIcon = _a.showPreviewIcon,
    showRemoveIcon = _a.showRemoveIcon,
    itemRender = _a.itemRender,
    previewContent = _a.previewContent,
    extraRender = _a.extraRender,
    uploadErrorLabel = _a.uploadErrorLabel,
    extra = _a.extra;
  var forceUpdate = useForceUpdate();
  var isMobile = useMobile();
  React.useEffect(function () {
    if (listType !== 'picture') {
      return;
    }
    (items || []).forEach(function (file) {
      if (typeof document === 'undefined' || typeof window === 'undefined' || !window.FileReader || !window.File || !(file.originFileObj instanceof File || file.originFileObj && file.originFileObj instanceof Blob) || file.thumbUrl !== undefined) {
        return;
      }
      file.thumbUrl = '';
      if (previewFile) {
        previewFile(file.originFileObj).then(function (previewDataUrl) {
          // Need append '' to avoid dead loop
          file.thumbUrl = previewDataUrl || '';
          forceUpdate();
        });
      }
    });
  }, [listType, items, previewFile]);
  // ============================= Events =============================
  var onInternalPreview = function onInternalPreview(file, e) {
    if (!onPreview) {
      return;
    }
    e.preventDefault();
    return onPreview(file);
  };
  var onInternalClose = function onInternalClose(file) {
    onRemove === null || onRemove === void 0 ? void 0 : onRemove(file);
  };
  var internalExtraRender = function internalExtraRender(file) {
    if (extraRender) {
      return extraRender(file, listType);
    }
    return file.size ? formatBytes(file.size) : '';
  };
  var getFileIcon = React.useCallback(function (file) {
    var cls = "".concat(prefixCls, "-list-icon");
    switch (file.type) {
      case 'application/zip':
        return "".concat(cls, "-zip");
      case 'image/png':
      case 'image/jpg':
      case 'image/jpeg':
        return "".concat(cls, "-image");
      case 'application/pdf':
        return "".concat(cls, "-pdf");
      case 'video/mp4':
        return "".concat(cls, "-video");
      default:
        return "".concat(cls, "-default");
    }
  }, []);
  var internalIconRender = function internalIconRender(file) {
    if (iconRender) {
      return iconRender(file, listType);
    }
    var isLoading = file.status === 'uploading';
    var icon = isLoading ? (/*#__PURE__*/React.createElement(LoadingCircularOutlined, {
      className: "".concat(prefixCls, "-loading")
    })) : (/*#__PURE__*/React.createElement("div", {
      className: classNames("".concat(prefixCls, "-list-icon"), getFileIcon(file))
    }));
    return icon;
  };
  // Test needs
  React.useImperativeHandle(ref, function () {
    return {
      handlePreview: onInternalPreview
    };
  });
  var listClassNames = classNames((_b = {}, _b["".concat(prefixCls, "-list")] = true, _b["".concat(prefixCls, "-list-picture-desktop")] = !isMobile && listType === 'picture', _b["".concat(prefixCls, "-list-").concat(listType)] = true, _b));
  return /*#__PURE__*/React.createElement("div", {
    className: listClassNames
  }, items.map(function (item) {
    return /*#__PURE__*/React.createElement(ListItem, {
      prefixCls: prefixCls,
      key: item.uid,
      file: item,
      isImgUrl: isImgUrl,
      items: items,
      listType: listType,
      showPreviewIcon: showPreviewIcon,
      previewContent: previewContent,
      showRemoveIcon: showRemoveIcon && !item.disableRemove,
      iconRender: internalIconRender,
      itemRender: itemRender,
      extraRender: internalExtraRender,
      onPreview: onInternalPreview,
      onClose: onInternalClose,
      uploadErrorLabel: uploadErrorLabel
    });
  }), extra);
};
var UploadList = /*#__PURE__*/React.forwardRef(InternalUploadList);
UploadList.displayName = 'UploadList';
UploadList.defaultProps = {
  listType: 'text',
  showRemoveIcon: true,
  showPreviewIcon: true,
  previewFile: previewImage,
  isImageUrl: isImageUrl
};
export default UploadList;