import _typeof from "@babel/runtime/helpers/esm/typeof";
var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var __generator = this && this.__generator || function (thisArg, body) {
  var _ = {
      label: 0,
      sent: function sent() {
        if (t[0] & 1) throw t[1];
        return t[1];
      },
      trys: [],
      ops: []
    },
    f,
    y,
    t,
    g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;
  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");
    while (g && (g = 0, op[0] && (_ = 0)), _) try {
      if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
      if (y = 0, t) op = [op[0] & 2, t.value];
      switch (op[0]) {
        case 0:
        case 1:
          t = op;
          break;
        case 4:
          _.label++;
          return {
            value: op[1],
            done: false
          };
        case 5:
          _.label++;
          y = op[1];
          op = [0];
          continue;
        case 7:
          op = _.ops.pop();
          _.trys.pop();
          continue;
        default:
          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
            _ = 0;
            continue;
          }
          if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
            _.label = op[1];
            break;
          }
          if (op[0] === 6 && _.label < t[1]) {
            _.label = t[1];
            t = op;
            break;
          }
          if (t && _.label < t[2]) {
            _.label = t[2];
            _.ops.push(op);
            break;
          }
          if (t[2]) _.ops.pop();
          _.trys.pop();
          continue;
      }
      op = body.call(thisArg, _);
    } catch (e) {
      op = [6, e];
      y = 0;
    } finally {
      f = t = 0;
    }
    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};
var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var __spreadArray = this && this.__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
import * as React from 'react';
import RcUpload from 'rc-upload';
import useMergedState from 'rc-util/lib/hooks/useMergedState';
import classNames from 'classnames';
import { dtUploadPrefix as prefixCls } from '../style';
import UploadList from './UploadList';
import { file2Obj, getFileItem, removeFileItem, updateFileList } from './utils';
import AddCircleOutlined from 'dingtalk-design-icons/lib/AddCircleOutlined';
import { List } from 'dingtalk-design-mobile';
import './style';
import Divider from '../divider';
import { useMobile } from '../hooks';
import Button from '../button';
import UploadingOutlined from 'dd-icons/lib/UploadingOutlined';
import AdditionOutlined from 'dd-icons/lib/AdditionOutlined';
var LIST_IGNORE = "__LIST_IGNORE_".concat(Date.now(), "__");
var InternalUpload = function InternalUpload(props, ref) {
  var _a, _b;
  var fileList = props.fileList,
    defaultFileList = props.defaultFileList,
    onRemove = props.onRemove,
    showUploadList = props.showUploadList,
    listType = props.listType,
    onPreview = props.onPreview,
    onChange = props.onChange,
    previewFile = props.previewFile,
    disabled = props.disabled,
    iconRender = props.iconRender,
    isImageUrl = props.isImageUrl,
    className = props.className,
    itemRender = props.itemRender,
    maxCount = props.maxCount,
    label = props.label,
    previewContent = props.previewContent,
    extraRender = props.extraRender,
    type = props.type,
    value = props.value,
    uploadBtnLabel = props.uploadBtnLabel,
    uploadLabel = props.uploadLabel,
    uploadErrorLabel = props.uploadErrorLabel;
  var isMobile = useMobile();
  var _c = __read(useMergedState(defaultFileList || value || [], {
      value: fileList,
      postState: function postState(list) {
        return list !== null && list !== void 0 ? list : [];
      }
    }), 2),
    mergedFileList = _c[0],
    setMergedFileList = _c[1];
  var upload = React.useRef();
  var _d = __read(React.useState(false), 2),
    isError = _d[0],
    setIsError = _d[1];
  // Control mode will auto fill file uid if not provided
  React.useMemo(function () {
    var timestamp = Date.now();
    (fileList || []).forEach(function (file, index) {
      if (!file.uid && !Object.isFrozen(file)) {
        file.uid = "__AUTO__".concat(timestamp, "_").concat(index, "__");
      }
    });
  }, [fileList]);
  var onInternalChange = function onInternalChange(file, changedFileList, event) {
    var cloneList = __spreadArray([], __read(changedFileList), false);
    // Cut to match count
    if (maxCount === 1) {
      cloneList = cloneList.slice(-1);
    } else if (maxCount) {
      cloneList = cloneList.slice(0, maxCount);
    }
    setMergedFileList(cloneList);
    var changeInfo = {
      file: file,
      fileList: cloneList
    };
    if (event) {
      changeInfo.event = event;
    }
    onChange === null || onChange === void 0 ? void 0 : onChange(changeInfo);
  };
  var mergedBeforeUpload = function mergedBeforeUpload(file, fileListArgs) {
    return __awaiter(void 0, void 0, void 0, function () {
      var beforeUpload, parsedFile, result;
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            beforeUpload = props.beforeUpload;
            parsedFile = file;
            if (!beforeUpload) return [3 /*break*/, 2];
            return [4 /*yield*/, beforeUpload(file, fileListArgs)];
          case 1:
            result = _a.sent();
            if (result === false) {
              return [2 /*return*/, false];
            }
            // Hack for LIST_IGNORE, we add additional info to remove from the list
            delete file[LIST_IGNORE];
            if (result === LIST_IGNORE) {
              Object.defineProperty(file, LIST_IGNORE, {
                value: true,
                configurable: true
              });
              return [2 /*return*/, false];
            }
            if (_typeof(result) === 'object' && result) {
              parsedFile = result;
            }
            _a.label = 2;
          case 2:
            return [2 /*return*/, parsedFile];
        }
      });
    });
  };
  var onBatchStart = function onBatchStart(batchFileInfoList) {
    // Skip file which marked as `LIST_IGNORE`, these file will not add to file list
    var filteredFileInfoList = batchFileInfoList.filter(function (info) {
      return !info.file[LIST_IGNORE];
    });
    // Nothing to do since no file need upload
    if (!filteredFileInfoList.length) {
      return;
    }
    var objectFileList = filteredFileInfoList.map(function (info) {
      return file2Obj(info.file);
    });
    // Concat new files with prev files
    var newFileList = __spreadArray([], __read(mergedFileList), false);
    objectFileList.forEach(function (fileObj) {
      // Replace file if exist
      newFileList = updateFileList(fileObj, newFileList);
    });
    objectFileList.forEach(function (fileObj, index) {
      // Repeat trigger `onChange` event for compatible
      var triggerFileObj = fileObj;
      if (!filteredFileInfoList[index].parsedFile) {
        // `beforeUpload` return false
        var originFileObj = fileObj.originFileObj;
        if (originFileObj) {
          var clone = new File([originFileObj], originFileObj.name, {
            type: originFileObj.type
          });
          clone.uid = fileObj.uid;
          triggerFileObj = clone;
        }
      } else {
        // Inject `uploading` status
        fileObj.status = 'uploading';
      }
      onInternalChange(triggerFileObj, newFileList);
    });
  };
  var onSuccess = function onSuccess(response, file, xhr) {
    try {
      if (typeof response === 'string') {
        response = JSON.parse(response);
      }
    } catch (e) {
      /* do nothing */
    }
    // removed
    if (!getFileItem(file, mergedFileList)) {
      return;
    }
    var targetItem = file2Obj(file);
    targetItem.status = 'done';
    targetItem.percent = 100;
    targetItem.response = response;
    targetItem.xhr = xhr;
    var nextFileList = updateFileList(targetItem, mergedFileList);
    onInternalChange(targetItem, nextFileList);
  };
  var onProgress = function onProgress(e, file) {
    // removed
    if (!getFileItem(file, mergedFileList)) {
      return;
    }
    var targetItem = file2Obj(file);
    targetItem.status = 'uploading';
    targetItem.percent = e.percent;
    var nextFileList = updateFileList(targetItem, mergedFileList);
    onInternalChange(targetItem, nextFileList, e);
  };
  var onError = function onError(error, response, file) {
    // removed
    if (!getFileItem(file, mergedFileList)) {
      return;
    }
    setIsError(true);
    var targetItem = file2Obj(file);
    targetItem.error = error;
    targetItem.response = response;
    targetItem.status = 'error';
    var nextFileList = updateFileList(targetItem, mergedFileList);
    onInternalChange(targetItem, nextFileList);
  };
  var handleRemove = function handleRemove(file) {
    var currentFile;
    Promise.resolve(typeof onRemove === 'function' ? onRemove(file) : onRemove).then(function (ret) {
      var _a;
      // Prevent removing file
      if (ret === false) {
        return;
      }
      var removedFileList = removeFileItem(file, mergedFileList);
      if (removedFileList) {
        currentFile = __assign(__assign({}, file), {
          status: 'removed'
        });
        mergedFileList === null || mergedFileList === void 0 ? void 0 : mergedFileList.forEach(function (item) {
          var matchKey = currentFile.uid !== undefined ? 'uid' : 'name';
          if (item[matchKey] === currentFile[matchKey] && !Object.isFrozen(item)) {
            item.status = 'removed';
          }
        });
        (_a = upload.current) === null || _a === void 0 ? void 0 : _a.abort(currentFile);
        onInternalChange(currentFile, removedFileList);
      }
    });
  };
  // Test needs
  React.useImperativeHandle(ref, function () {
    return {
      onBatchStart: onBatchStart,
      onSuccess: onSuccess,
      onProgress: onProgress,
      onError: onError,
      fileList: mergedFileList,
      upload: upload.current
    };
  });
  var rcUploadProps = __assign(__assign({
    onBatchStart: onBatchStart,
    onError: onError,
    onProgress: onProgress,
    onSuccess: onSuccess
  }, props), {
    prefixCls: classNames(prefixCls, (_a = {}, _a["".concat(prefixCls, "-image-desktop")] = !isMobile && listType === 'picture', _a)),
    beforeUpload: mergedBeforeUpload,
    onChange: undefined
  });
  delete rcUploadProps.className;
  delete rcUploadProps.style;
  // Remove id to avoid open by label when trigger is hidden
  // !children: https://github.com/ant-design/ant-design/issues/14298
  // disabled: https://github.com/ant-design/ant-design/issues/16478
  //           https://github.com/ant-design/ant-design/issues/24197
  if (disabled) {
    delete rcUploadProps.id;
  }
  var renderUploadList = function renderUploadList(button) {
    if (!showUploadList) {
      return button;
    }
    var _a = typeof showUploadList === 'boolean' ? {} : showUploadList,
      showRemoveIcon = _a.showRemoveIcon,
      showPreviewIcon = _a.showPreviewIcon,
      removeIcon = _a.removeIcon;
    return /*#__PURE__*/React.createElement(UploadList, {
      listType: listType,
      items: mergedFileList,
      previewFile: previewFile,
      onPreview: onPreview,
      onRemove: handleRemove,
      previewContent: previewContent,
      showRemoveIcon: !disabled && showRemoveIcon,
      showPreviewIcon: showPreviewIcon,
      removeIcon: removeIcon,
      iconRender: iconRender,
      isImageUrl: isImageUrl,
      itemRender: itemRender,
      extraRender: extraRender,
      isError: isError,
      uploadErrorLabel: uploadErrorLabel,
      extra: !isMobile && listType === 'picture' && (/*#__PURE__*/React.createElement(RcUpload, __assign({}, rcUploadProps, {
        children: /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-pic-upload-btn-desktop-container")
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-pic-upload-btn-desktop")
        }, /*#__PURE__*/React.createElement(AdditionOutlined, {
          className: "".concat(prefixCls, "-pic-upload-btn-desktop-icon")
        }), uploadBtnLabel)),
        ref: upload
      })))
    });
  };
  var uploadButtonCls = classNames(prefixCls, (_b = {}, _b["".concat(prefixCls, "-select")] = true, _b["".concat(prefixCls, "-select-").concat(listType)] = true, _b["".concat(prefixCls, "-disabled")] = disabled, _b));
  var uploadButton = /*#__PURE__*/React.createElement("div", {
    className: uploadButtonCls
  }, type === 'select' ? (/*#__PURE__*/React.createElement(List.Item, {
    extra: /*#__PURE__*/React.createElement(RcUpload, __assign({}, rcUploadProps, {
      children: /*#__PURE__*/React.createElement(AddCircleOutlined, null),
      ref: upload
    }))
  }, label)) : (/*#__PURE__*/React.createElement(React.Fragment, null, isMobile ? (/*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-form-upload-btn")
  }, label, /*#__PURE__*/React.createElement(RcUpload, __assign({}, rcUploadProps, {
    children: /*#__PURE__*/React.createElement(AddCircleOutlined, null),
    ref: upload
  })))) : (/*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-form-upload-btn-desktop")
  }, label, isMobile || listType === 'text' && (/*#__PURE__*/React.createElement(RcUpload, __assign({}, rcUploadProps, {
    children: /*#__PURE__*/React.createElement(Button, null, /*#__PURE__*/React.createElement(UploadingOutlined, {
      className: "".concat(prefixCls, "-form-upload-btn-icon")
    }), uploadBtnLabel || '上传'),
    ref: upload
  }))))))));
  return /*#__PURE__*/React.createElement(React.Fragment, null, uploadButton, !isMobile && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-label-desktop")
  }, uploadLabel), renderUploadList(), type === 'select' && mergedFileList.length === 0 && (/*#__PURE__*/React.createElement(Divider, {
    className: "".concat(prefixCls, "-divider")
  })));
};
var Upload = /*#__PURE__*/React.forwardRef(InternalUpload);
Upload.LIST_IGNORE = LIST_IGNORE;
Upload.displayName = 'Upload';
Upload.defaultProps = {
  type: 'select',
  multiple: false,
  action: '',
  data: {},
  accept: '*/*',
  showUploadList: true,
  listType: 'text',
  className: '',
  disabled: false
};
export default Upload;