"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.convertToPx = convertToPx;
function extractWidthValueAndUnit(value) {
  var regex = /^(\d+(\.\d+)?)(vh|vw|%|px)?$/;
  var matches = value.match(regex);
  if (matches) {
    return {
      value: parseFloat(matches[1]),
      unit: matches[3] || 'px' // 如果没有匹配到单位，默认为 'px'
    };
  } else {
    return null;
  }
}
function convertVhToPx(value) {
  var viewportHeight = window.innerHeight;
  return value / 100 * viewportHeight;
}
function convertVwToPx(value) {
  var viewportWidth = window.innerWidth;
  return value / 100 * viewportWidth;
}
function convertPercentToPx(value, isWidth, ele) {
  var _a, _b, _c, _d;
  if (!ele) {
    return 0;
  }
  var parentWidth = (_b = (_a = ele.parentElement) === null || _a === void 0 ? void 0 : _a.offsetWidth) !== null && _b !== void 0 ? _b : 800;
  var parentHeight = (_d = (_c = ele.parentElement) === null || _c === void 0 ? void 0 : _c.offsetHeight) !== null && _d !== void 0 ? _d : 600;
  if (isWidth) {
    return value / 100 * parentWidth;
  } else {
    return value / 100 * parentHeight;
  }
}
function convertToPx(value, isWidth, ele) {
  var _a;
  if (!value) {
    return 0;
  }
  if (typeof value === 'number') {
    return value;
  }
  var valueWithUnit = extractWidthValueAndUnit(value);
  switch (valueWithUnit === null || valueWithUnit === void 0 ? void 0 : valueWithUnit.unit) {
    case 'vh':
      return convertVhToPx(valueWithUnit.value);
    case 'vw':
      return convertVwToPx(valueWithUnit.value);
    case '%':
      return convertPercentToPx(valueWithUnit.value, isWidth, ele);
    default:
      return (_a = valueWithUnit === null || valueWithUnit === void 0 ? void 0 : valueWithUnit.value) !== null && _a !== void 0 ? _a : 0;
  }
}