"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var ReactDOM = _interopRequireWildcard(require("react-dom"));
var _error = _interopRequireDefault(require("./error"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
// 用于在全局创建组件，如 alert, actionSheet
// 如果是组件渲染模式，则使用 hooks.useContainer

var singleFlag = {};
// singleFlag, 用于标记全局在同一时间只会显示一个
var _default = exports["default"] = function _default(Content, flag) {
  if (flag) {
    if (singleFlag[flag]) {
      (0, _error["default"])(false, flag, "there is already ".concat(flag, " exist"));
    }
    singleFlag[flag] = true;
  }
  var div = document.createElement('div');
  document.body.appendChild(div);
  var timeout = null;
  function close() {
    if (flag) {
      singleFlag[flag] = undefined;
    }
    if (timeout) {
      clearTimeout(timeout);
    }
    if (div) {
      ReactDOM.unmountComponentAtNode(div);
      if (div.parentNode) {
        div.parentNode.removeChild(div);
      }
    }
  }
  ReactDOM.render(Content, div);
  return close;
};