"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getBottom = getBottom;
exports.getBoundingRect = getBoundingRect;
exports.getElementBoundingClientRect = getElementBoundingClientRect;
exports.getElementScrollOffset = getElementScrollOffset;
exports.getHeight = getHeight;
exports.getLeft = getLeft;
exports.getRight = getRight;
exports.getScrollLeft = getScrollLeft;
exports.getScrollTop = getScrollTop;
exports.getTop = getTop;
exports.getWidth = getWidth;
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var __generator = void 0 && (void 0).__generator || function (thisArg, body) {
  var _ = {
      label: 0,
      sent: function sent() {
        if (t[0] & 1) throw t[1];
        return t[1];
      },
      trys: [],
      ops: []
    },
    f,
    y,
    t,
    g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;
  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");
    while (g && (g = 0, op[0] && (_ = 0)), _) try {
      if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
      if (y = 0, t) op = [op[0] & 2, t.value];
      switch (op[0]) {
        case 0:
        case 1:
          t = op;
          break;
        case 4:
          _.label++;
          return {
            value: op[1],
            done: false
          };
        case 5:
          _.label++;
          y = op[1];
          op = [0];
          continue;
        case 7:
          op = _.ops.pop();
          _.trys.pop();
          continue;
        default:
          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
            _ = 0;
            continue;
          }
          if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
            _.label = op[1];
            break;
          }
          if (op[0] === 6 && _.label < t[1]) {
            _.label = t[1];
            t = op;
            break;
          }
          if (t && _.label < t[2]) {
            _.label = t[2];
            _.ops.push(op);
            break;
          }
          if (t[2]) _.ops.pop();
          _.trys.pop();
          continue;
      }
      op = body.call(thisArg, _);
    } catch (e) {
      op = [6, e];
      y = 0;
    } finally {
      f = t = 0;
    }
    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};
/**
 * 获取指定元素的滚动偏移值
 * @param id
 */
function getElementScrollOffset(id) {
  return __awaiter(this, void 0, void 0, function () {
    var offset, ele, scrollLeft, scrollTop;
    return __generator(this, function (_a) {
      offset = {
        scrollLeft: 0,
        scrollTop: 0
      };
      ele = document.querySelector("#".concat(id));
      if (ele) {
        scrollLeft = ele.scrollLeft, scrollTop = ele.scrollTop;
        return [2 /*return*/, __assign(__assign({}, offset), {
          scrollLeft: scrollLeft,
          scrollTop: scrollTop
        })];
      }
      return [2 /*return*/, offset];
    });
  });
}
/**
 * 获取指定元素的左滚动偏移
 * @param id
 */
function getScrollLeft(id) {
  return __awaiter(this, void 0, void 0, function () {
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          return [4 /*yield*/, getElementScrollOffset(id)];
        case 1:
          return [2 /*return*/, _a.sent().scrollLeft];
      }
    });
  });
}
/**
 * 获取指定元素的顶部滚动偏移
 * @param id
 */
function getScrollTop(id) {
  return __awaiter(this, void 0, void 0, function () {
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          return [4 /*yield*/, getElementScrollOffset(id)];
        case 1:
          return [2 /*return*/, _a.sent().scrollTop];
      }
    });
  });
}
/**
 * 获取指定元素的 rect 值
 * @param id
 */
function getElementBoundingClientRect(id) {
  return __awaiter(this, void 0, void 0, function () {
    var ele, rect;
    return __generator(this, function (_a) {
      ele = document.querySelector("#".concat(id));
      rect = {
        left: 0,
        bottom: 0,
        top: 0,
        right: 0,
        width: 0,
        height: 0,
        x: 0,
        y: 0
      };
      if (ele) {
        return [2 /*return*/, ele.getBoundingClientRect()];
      } else {
        return [2 /*return*/, rect];
      }
      return [2 /*return*/];
    });
  });
}
/**
 * 根据指定 Id 获取元素宽度
 * @param id
 */
function getWidth(id) {
  return __awaiter(this, void 0, void 0, function () {
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          return [4 /*yield*/, getElementBoundingClientRect(id)];
        case 1:
          return [2 /*return*/, _a.sent().width];
      }
    });
  });
}
/**
 * 根据指定 Id 获取元素高度
 * @param id
 */
function getHeight(id) {
  return __awaiter(this, void 0, void 0, function () {
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          return [4 /*yield*/, getElementBoundingClientRect(id)];
        case 1:
          return [2 /*return*/, _a.sent().height];
      }
    });
  });
}
/**
 * 根据指定 Id 获取元素距离父级元素左侧距离
 * @param id
 */
function getLeft(id) {
  return __awaiter(this, void 0, void 0, function () {
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          return [4 /*yield*/, getElementBoundingClientRect(id)];
        case 1:
          return [2 /*return*/, _a.sent().left];
      }
    });
  });
}
/**
 * 根据指定 Id 获取元素距离父级元素顶部距离
 * @param id
 */
function getTop(id) {
  return __awaiter(this, void 0, void 0, function () {
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          return [4 /*yield*/, getElementBoundingClientRect(id)];
        case 1:
          return [2 /*return*/, _a.sent().top];
      }
    });
  });
}
/**
 * 根据指定 Id 获取元素距离父级元素底部距离
 * @param id
 */
function getBottom(id) {
  return __awaiter(this, void 0, void 0, function () {
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          return [4 /*yield*/, getElementBoundingClientRect(id)];
        case 1:
          return [2 /*return*/, _a.sent().bottom];
      }
    });
  });
}
/**
 * 根据指定 Id 获取元素距离父级元素右侧距离
 * @param id
 */
function getRight(id) {
  return __awaiter(this, void 0, void 0, function () {
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          return [4 /*yield*/, getElementBoundingClientRect(id)];
        case 1:
          return [2 /*return*/, _a.sent().right];
      }
    });
  });
}
function getBoundingRect(id) {
  return __awaiter(this, void 0, void 0, function () {
    var rect;
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          return [4 /*yield*/, getElementBoundingClientRect(id)];
        case 1:
          rect = _a.sent();
          return [2 /*return*/, rect !== null && rect !== void 0 ? rect : {}];
      }
    });
  });
}