import React from 'react';
export declare const defaultMaxDate: Date;
export declare const defaultMinDate: Date;
interface DateManagerProps {
    minDate?: Date;
    maxDate?: Date;
}
export declare enum Mode {
    DATETIME = "datetime",
    DATE = "date",
    TIME = "time",
    MONTH = "month",
    YEAR = "year"
}
export declare class DateManager {
    minDate: Date;
    maxDate: Date;
    constructor(props: DateManagerProps);
    getMinDate(): Date;
    getMaxDate(): Date;
    getMinYear(): number;
    getMaxYear(): number;
    getMinMonth(): number;
    getMaxMonth(): number;
    getMinDay(): number;
    getMaxDay(): number;
    getMinHour(): number;
    getMaxHour(): number;
    getMinMinute(): number;
    getMaxMinute(): number;
    getDate(date: Date, mode: Mode): Date;
    clipDate(date: Date, mode: Mode): Date;
    renderColLabel(value: number, local: string, prefixCls: string): React.JSX.Element;
    getDateData(d: Date, mode: Mode, showUntilNow: boolean, locale: any, prefixCls: string, formatMonth?: (month: number, date?: Date) => any, formatDay?: (day: number, date?: Date) => any): {
        key: string;
        props: {
            children: any[];
        };
    }[];
    getValueCols(d: Date, mode: Mode, showUntilNow: boolean, locale: any, prefixCls: string, use12Hours: boolean, time?: any, formatMonth?: (month: number, date?: Date) => any, formatDay?: (day: number, date?: Date) => any): {
        value: any[];
        cols: any[];
    };
}
export {};
