import React from 'react';
import type { ReactElement } from 'react';
export interface NativeProps<S extends string = never> {
    /**
     * @description 组件额外的 CSS className
     */
    className?: string;
    /**
     * @description 组件额外的 CSS Style
     */
    style?: React.CSSProperties & Partial<Record<S, string>>;
    tabIndex?: number;
}
export declare function withNativeProps<P extends NativeProps>(props: P, element: ReactElement): React.ReactElement<any, string | React.JSXElementConstructor<any>>;
