"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isMotionReduced = isMotionReduced;
exports.reduceMotion = reduceMotion;
exports.restoreMotion = restoreMotion;
exports.useMotionReduced = useMotionReduced;
var _ddReactSpringWeb = require("dd-react-spring-web");
var _shim = require("use-sync-external-store/shim");
require("regenerator-runtime/runtime.js");
var reduced = false;
var subscribers = new Set();
function notify() {
  subscribers.forEach(function (subscriber) {
    subscriber();
  });
}
function reduceMotion() {
  reduced = true;
  notify();
  _ddReactSpringWeb.Globals.assign({
    skipAnimation: true
  });
}
function restoreMotion() {
  reduced = false;
  notify();
  _ddReactSpringWeb.Globals.assign({
    skipAnimation: false
  });
}
function isMotionReduced() {
  return reduced;
}
function useMotionReduced() {
  return (0, _shim.useSyncExternalStore)(function (onStoreChange) {
    subscribers.add(onStoreChange);
    return function () {
      subscribers["delete"](onStoreChange);
    };
  }, isMotionReduced);
}