"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setSafeHeight = void 0;
function setTopSafeVar(v) {
  document.documentElement.style.setProperty('--top-safe-area', v);
}
function getSafeAreaInsetTop() {
  var tempElement = document.createElement('div');
  tempElement.style.cssText = "position: absolute; top: env(safe-area-inset-top);";
  document.body.appendChild(tempElement);
  getComputedStyle(tempElement).top;
  var top = getComputedStyle(tempElement).top;
  var insetTop = parseFloat(top);
  document.body.removeChild(tempElement);
  return insetTop;
}
var setSafeHeight = exports.setSafeHeight = function setSafeHeight() {
  var isIphone = navigator && navigator.userAgent.indexOf('iPhone') !== -1;
  var isIpad = navigator && navigator.userAgent.indexOf('iPad') !== -1;
  var isHarmony = navigator && navigator.userAgent.indexOf('OpenHarmony') !== -1;
  if (isIphone && window.screen) {
    if (window.screen.height >= 812 && window.devicePixelRatio >= 2) {
      setTopSafeVar('47px');
    } else {
      setTopSafeVar('20px');
    }
  } else if (isHarmony) {
    setTopSafeVar(getSafeAreaInsetTop() + 'px');
  } else if (isIpad) {
    setTopSafeVar('20px');
  } else {
    setTopSafeVar('0px');
  }
};