"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _rmcDialog = _interopRequireDefault(require("rmc-dialog"));
var _internal = require("../_internal");
var _hooks = require("../hooks");
require("./style/index");
var _PcActionSheet = _interopRequireDefault(require("./PcActionSheet"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var prefixCls = 'dtm-action-sheet';
var Item = function Item(props) {
  var _a;
  var cls = (0, _classnames["default"])(props.className, (_a = {}, _a[prefixCls + '-danger'] = !!props.danger, _a[prefixCls + '-disabled'] = !!props.disabled, _a));
  return /*#__PURE__*/React.createElement("div", {
    className: cls,
    onClick: props.onPress
  }, props.children);
};
var closeFn = null;
var renderItem = function renderItem(item, index, cb) {
  var fixedItem = {};
  if (typeof item === 'string' || /*#__PURE__*/React.isValidElement(item)) {
    fixedItem.value = item;
  } else {
    fixedItem = item;
  }
  return /*#__PURE__*/React.createElement(Item, {
    danger: fixedItem.danger,
    disabled: fixedItem.disabled,
    key: index,
    className: prefixCls + '-item',
    onPress: function onPress() {
      return cb(index, fixedItem.disabled);
    }
  }, fixedItem.value);
};
var createActionSheet = function createActionSheet(options, callback, className) {
  var _a;
  var content = /*#__PURE__*/React.createElement(React.Fragment, null, options.title && /*#__PURE__*/React.createElement("div", {
    className: prefixCls + '-title'
  }, options.title), /*#__PURE__*/React.createElement("div", {
    className: prefixCls + '-list'
  }, options.items.map(function (item, i) {
    return renderItem(item, i, cb);
  })), /*#__PURE__*/React.createElement(Item, {
    className: prefixCls + '-cancel',
    onPress: function onPress() {
      return cb(-1);
    }
  }, (_a = options.cancelText) !== null && _a !== void 0 ? _a : '取消'));
  var close = (0, _internal.createGlobalElement)(
  /*#__PURE__*/
  // @ts-ignore
  React.createElement(_rmcDialog["default"], {
    visible: true,
    title: "",
    footer: "",
    wrapClassName: className,
    prefixCls: prefixCls,
    transitionName: 'dtm-slide-up',
    maskTransitionName: 'dtm-fade',
    onClose: function onClose() {
      return cb(-1);
    },
    maskClosable: options.maskClosable,
    className: options === null || options === void 0 ? void 0 : options.className
  }, content), 'ActionSheet');
  closeFn = function closeFn() {
    close();
    callback({
      index: -1
    });
  };
  function cb(index, disabled) {
    if (disabled) {
      return;
    }
    close();
    callback({
      index: index
    });
  }
};
// type ActionSheetType = React.FC<ActionSheetProps> & {
//   ActionSheet: ActionSheetType;
//   show: CreateActionSheet;
//   close: () => void;
// };
/**
 * JSX 用法兼容 & PC 端调用
 */
var ActionSheet = function ActionSheet(props) {
  var isMobile = (0, _hooks.useMobile)();
  if (isMobile) {
    return /*#__PURE__*/React.createElement("div", {
      onClick: function onClick() {
        return createActionSheet(props.options, props.callback, props.className);
      }
    }, props.children);
  } else {
    return /*#__PURE__*/React.createElement(_PcActionSheet["default"], __assign({}, props));
  }
};
ActionSheet.displayName = 'ActionSheet';
var _default = exports["default"] = {
  ActionSheet: ActionSheet,
  show: (0, _internal.promisify)(createActionSheet),
  close: function close() {
    closeFn === null || closeFn === void 0 ? void 0 : closeFn();
  }
};