/// <reference types="react" />
export interface ActionSheetOptions {
    /**
     * @description 蒙层样式
     */
    className?: string;
    /**
     * @description 蒙层是否允许关闭
     * @default true
     */
    maskClosable?: boolean;
    /**
     * @description 标题
     */
    title?: React.ReactNode;
    /**
     * @description 行动项
     */
    items: (React.ReactNode | {
        value: React.ReactNode;
        danger?: boolean;
        disable?: boolean;
    })[];
    /**
     * @description 关闭弹层文案
     * @default 取消
     */
    cancelText?: string;
}
export interface ActionSheetProps {
    /**
     * @description 配置项
     */
    options: ActionSheetOptions;
    /**
     * @description 自定义类名
     */
    className?: string;
    /**
     * @description 点击后的回调
     */
    callback: (res: {
        index: number;
    }) => void;
    children: React.ReactNode;
}
export type ActionCallBack = (res: {
    index: number;
}) => void;
