import React, { FC } from 'react';
import { NativeProps } from '../_internal/native-props';
import './style/index';
export declare const dot: React.JSX.Element;
export type BadgeProps = {
    /**
     * @description 建议使用content替代，展示的数字或文案，当为数字时候，大于 overflowCount时显示为 ${overflowCount}+，为 0 时隐藏
     */
    text?: string | number;
    /**
     * @description 展示封顶的数字值
     * @default 99
     */
    overflowCount?: number;
    /**
     * @description 徽标内容：如果传 null ''，则不显示徽标；如果不传或传 Badge.dot，会显示小红点(version > 2.2.0)
     */
    content?: React.ReactNode | typeof dot;
    /**
     * @description 徽标背景色(version > 2.2.0)
     */
    color?: string;
    /**
     * @description 是否有描边(version > 2.2.0)
     * @default false
     */
    bordered?: boolean;
} & NativeProps<'--right' | '--top' | '--color' | '--z-index' | '--border-color'>;
export declare const Badge: FC<React.PropsWithChildren<BadgeProps>>;
