"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dot = exports.Badge = void 0;
var _classnames = _interopRequireDefault(require("classnames"));
var _react = _interopRequireDefault(require("react"));
var _nativeProps = require("../_internal/native-props");
var _style = require("../style");
require("./style/index");
var classPrefix = "".concat(_style.dtMobilePrefix, "-badge");
var dot = exports.dot = /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
var Badge = exports.Badge = function Badge(props) {
  var color = props.color,
    children = props.children;
  var content = _react["default"].useMemo(function () {
    var content = props.content,
      text = props.text,
      _a = props.overflowCount,
      overflowCount = _a === void 0 ? 99 : _a;
    if (typeof text === 'number' && overflowCount && text > overflowCount) {
      return "".concat(overflowCount, "+");
    } else if (text) {
      return text;
    }
    return content;
  }, [props.content, props.text, props.overflowCount]);
  var isDot = content === dot || content === undefined;
  var badgeCls = (0, _classnames["default"])("".concat(classPrefix), !!children && "".concat(classPrefix, "-fixed"), isDot && "".concat(classPrefix, "-dot"), props.bordered && "".concat(classPrefix, "-bordered"));
  var element = content || content === 0 || content === undefined ? (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", {
    className: badgeCls,
    style: {
      '--color': color
    }
  }, !isDot && /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(classPrefix, "-content")
  }, content))) : null;
  return children ? (/*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(classPrefix, "-wrapper"), props.className),
    style: props.style
  }, children, element)) : element;
};