"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _index = require("./index");
var _RightArrow2Outlined = _interopRequireDefault(require("dd-icons/lib/RightArrow2Outlined"));
var BreadcrumbItem = function BreadcrumbItem(props) {
  var baseClassName = "".concat(_index.prefixCls, "-item-name");
  var ref = _react["default"].useRef(null);
  var href = props.href,
    isLast = props.isLast,
    children = props.children,
    onClick = props.onClick;
  var className = isLast ? "".concat(baseClassName, " ").concat(baseClassName, "-last") : baseClassName;
  var scrollLastItemIntoView = function scrollLastItemIntoView() {
    if (isLast && ref.current) {
      if (ref.current.parentElement) {
        ref.current.parentElement.scrollLeft = ref.current.offsetLeft;
      }
    }
  };
  _react["default"].useEffect(function () {
    scrollLastItemIntoView();
  });
  var link = _react["default"].useMemo(function () {
    return href && !isLast ? (/*#__PURE__*/_react["default"].createElement("a", {
      href: href,
      className: className
    }, children)) : (/*#__PURE__*/_react["default"].createElement("div", {
      className: className
    }, /*#__PURE__*/_react["default"].createElement("span", null, children)));
  }, [href, isLast, children]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(_index.prefixCls, "-item"),
    onClick: onClick,
    ref: ref
  }, link, !isLast && /*#__PURE__*/_react["default"].createElement(_RightArrow2Outlined["default"], {
    className: "".concat(_index.prefixCls, "-item-icon"),
    "aria-label": "right-arrow-icon"
  }));
};
var _default = exports["default"] = BreadcrumbItem;