"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prefixCls = exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _BreadcrumbItem = _interopRequireDefault(require("./BreadcrumbItem"));
require("./style/index");
var _index2 = require("../style/index");
var _classnames = _interopRequireDefault(require("classnames"));
var _nativeProps = require("../_internal/native-props");
var _hooks = require("../hooks");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var prefixCls = exports.prefixCls = "".concat(_index2.dtMobilePrefix, "-breadcrumb");
var Breadcrumb = /*#__PURE__*/_react["default"].memo(function (props) {
  var _a;
  var breadcrumbs = props.breadcrumbs,
    children = props.children,
    className = props.className;
  var handleClick = _react["default"].useCallback(function (index) {
    if (typeof props.onClick === 'function') {
      props.onClick(index);
    }
  }, []);
  var isMobile = (0, _hooks.useMobile)();
  var crumbs = _react["default"].useMemo(function () {
    if (breadcrumbs && breadcrumbs.length > 0) {
      return breadcrumbs.map(function (route, index) {
        return /*#__PURE__*/_react["default"].createElement(_BreadcrumbItem["default"], {
          key: route,
          isLast: index === breadcrumbs.length - 1,
          onClick: function onClick() {
            return handleClick(index);
          }
        }, route);
      });
    } else if (children) {
      return _react["default"].Children.map(children, function (ele, index) {
        if (!ele) {
          return ele;
        }
        return /*#__PURE__*/(0, _react.cloneElement)(ele, {
          key: index
        });
      });
    }
  }, [breadcrumbs, children]);
  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefixCls, " ").concat(className), (_a = {}, _a["".concat(prefixCls, "-desktop")] = !isMobile, _a))
  }, crumbs));
});
Breadcrumb.displayName = 'Breadcrumb';
var _default = exports["default"] = Breadcrumb;