"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dtMobileButtonPrefix = exports["default"] = void 0;
var React = _interopRequireWildcard(require("react"));
require("./style/index");
var _classnames = _interopRequireDefault(require("classnames"));
var _rmcFeedback = _interopRequireDefault(require("rmc-feedback"));
var _icon = _interopRequireDefault(require("../icon"));
var _index2 = require("../style/index");
var _nativeProps = require("../_internal/native-props");
var _hooks = require("../hooks");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var dtMobileButtonPrefix = exports.dtMobileButtonPrefix = "".concat(_index2.dtMobilePrefix, "-button");
var hiddenStyle = {
  width: 0,
  height: 0,
  overflow: 'hidden',
  padding: 0,
  margin: 0,
  border: 0
};
var Button = /*#__PURE__*/React.memo(function (props) {
  var _a;
  var isMobile = (0, _hooks.useMobile)();
  var children = props.children,
    className = props.className,
    _b = props.type,
    type = _b === void 0 ? 'secondary' : _b,
    size = props.size,
    _c = props.inline,
    inline = _c === void 0 ? isMobile ? false : true : _c,
    disabled = props.disabled,
    icon = props.icon,
    loading = props.loading,
    _onClick = props.onClick,
    htmlType = props.htmlType,
    restProps = __rest(props, ["children", "className", "type", "size", "inline", "disabled", "icon", "loading", "onClick", "htmlType"]);
  var buttonRef = React.useRef(null);
  var prefixCls = dtMobileButtonPrefix;
  var finalSize = size;
  // inline size 默认为 middle
  if (!finalSize && inline) {
    finalSize = 'middle';
  }
  var iconEl;
  if (loading) {
    iconEl = /*#__PURE__*/React.createElement(_icon["default"], {
      "aria-hidden": "true",
      type: 'loading',
      size: finalSize === 'small' ? 'xxs' : finalSize === 'middle' ? 'xs' : 'md',
      className: "".concat(prefixCls, "-icon")
    });
  } else if (icon) {
    iconEl = icon;
  }
  var wrapCls = (0, _classnames["default"])(prefixCls, className, (_a = {}, _a["".concat(prefixCls, "-primary")] = type === 'primary', _a["".concat(prefixCls, "-warning")] = type === 'danger', _a["".concat(prefixCls, "-link")] = type === 'link', _a["".concat(prefixCls, "-secondary")] = type === 'secondary', _a["".concat(prefixCls, "-").concat(finalSize)] = finalSize, _a["".concat(prefixCls, "-inline")] = inline, _a["".concat(prefixCls, "-disabled")] = disabled, _a["".concat(prefixCls, "-loading")] = loading, _a["".concat(prefixCls, "-icon")] = !!iconEl, _a["".concat(prefixCls, "-desktop")] = !isMobile, _a));
  return (0, _nativeProps.withNativeProps)(props,
  /*#__PURE__*/
  // @ts-ignore
  React.createElement(_rmcFeedback["default"], {
    activeClassName: "".concat(prefixCls, "-active"),
    disabled: disabled
  }, /*#__PURE__*/React.createElement("a", __assign({
    role: "button",
    className: wrapCls
  }, restProps, {
    onClick: function onClick(e) {
      var _a;
      !disabled && _onClick && _onClick(e);
      !disabled && ((_a = buttonRef.current) === null || _a === void 0 ? void 0 : _a.click());
    },
    "aria-disabled": disabled
  }), iconEl, /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-text")
  }, children), htmlType && (/*#__PURE__*/React.createElement("button", {
    ref: function ref(el) {
      return buttonRef.current = el;
    },
    onClick: function onClick(e) {
      return e.stopPropagation();
    },
    style: hiddenStyle,
    type: htmlType
  })))));
});
Button.displayName = 'Button';
var _default = exports["default"] = Button;