"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ModeType = void 0;
var _react = _interopRequireWildcard(require("react"));
var _convert = require("./convert");
var _nativeProps = require("../_internal/native-props");
var _withDefaultProps = require("../_internal/with-default-props");
var _style = require("../style");
var _classnames = _interopRequireDefault(require("classnames"));
var _dayjs = _interopRequireDefault(require("dayjs"));
var _isoWeek = _interopRequireDefault(require("dayjs/plugin/isoWeek"));
var _configProvider = require("../config-provider");
require("./style/index");
var _usePropsValue = require("../_internal/use-props-value");
var _ddIcons = require("dd-icons");
var _MultiPicker = _interopRequireDefault(require("rmc-picker/lib/MultiPicker"));
var _Picker = _interopRequireDefault(require("rmc-picker/lib/Picker"));
var _getDate = require("../_internal/getDate");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var __spreadArray = void 0 && (void 0).__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
_dayjs["default"].extend(_isoWeek["default"]);
var ModeType;
(function (ModeType) {
  ModeType["YEAR"] = "year";
  ModeType["MONTH"] = "month";
  ModeType["DAY"] = "day";
})(ModeType || (exports.ModeType = ModeType = {}));
var prefixCls = "".concat(_style.dtMobilePrefix, "-calendar");
var defaultProps = {
  weekStartsOn: 'Sunday',
  defaultValue: null,
  allowClear: true
  // prevMonthButton: <ArrowLeft />,
  // prevYearButton: <ArrowLeftDouble />,
  // nextMonthButton: <ArrowLeft />,
  // nextYearButton: <ArrowLeftDouble />,
};
var Calendar = /*#__PURE__*/(0, _react.forwardRef)(function (p, ref) {
  var props = (0, _withDefaultProps.mergeProps)(defaultProps, p);
  var today = (0, _dayjs["default"])();
  var _a = __read((0, _usePropsValue.usePropsValue)({
      value: props.value === undefined ? undefined : (0, _convert.convertValueToRange)(props.selectionMode, props.value),
      defaultValue: (0, _convert.convertValueToRange)(props.selectionMode, props.defaultValue),
      onChange: function onChange(v) {
        var _a, _b;
        if (props.selectionMode === 'single') {
          (_a = props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, v ? v[0] : null);
        } else if (props.selectionMode === 'range') {
          (_b = props.onChange) === null || _b === void 0 ? void 0 : _b.call(props, v);
        }
      }
    }), 2),
    dateRange = _a[0],
    setDateRange = _a[1];
  _react["default"].useEffect(function () {
    if (props.value === undefined) {
      setDateRange(null);
      setCurrent((0, _dayjs["default"])().date(1));
    }
  }, [props.value]);
  var _b = __read(_react["default"].useState(function () {
      return (0, _dayjs["default"])(dateRange ? dateRange[0] : today).date(1);
    }), 2),
    current = _b[0],
    setCurrent = _b[1];
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      jumpTo: function jumpTo(pageOrPageGenerator) {
        var page;
        if (typeof pageOrPageGenerator === 'function') {
          page = pageOrPageGenerator({
            year: current.year(),
            month: current.month() + 1
          });
        } else {
          page = pageOrPageGenerator;
        }
        setCurrent((0, _convert.convertPageToDayjs)(page));
      },
      jumpToToday: function jumpToToday() {
        setCurrent((0, _dayjs["default"])().date(1));
      }
    };
  });
  var _c = __read(_react["default"].useState(false), 2),
    intermediate = _c[0],
    setIntermediate = _c[1];
  var _d = __read(_react["default"].useState(ModeType.DAY), 2),
    mode = _d[0],
    setMode = _d[1];
  var wrapCls = (0, _classnames["default"])(prefixCls, props.className);
  var locale = (0, _configProvider.useConfig)().locale;
  var dateManager = _react["default"].useRef();
  var markItems = __spreadArray([], __read(locale.Calendar.markItems), false);
  if (props.weekStartsOn === 'Sunday') {
    var item = markItems.pop();
    if (item) markItems.unshift(item);
  }
  var maxDay = _react["default"].useMemo(function () {
    return props.max && (0, _dayjs["default"])(props.max);
  }, [props.max]);
  var minDay = _react["default"].useMemo(function () {
    return props.min && (0, _dayjs["default"])(props.min);
  }, [props.min]);
  var handlePageChange = _react["default"].useCallback(function (action, num, type) {
    var _a;
    var nxtCurrent = current[action](num, type);
    if (action === 'subtract' && props.minPage) {
      var minPage = (0, _convert.convertPageToDayjs)(props.minPage);
      if (nxtCurrent.isBefore(minPage, type)) {
        return;
      }
    }
    if (action === 'add' && props.maxPage) {
      var maxPage = (0, _convert.convertPageToDayjs)(props.maxPage);
      if (nxtCurrent.isAfter(maxPage, type)) {
        return;
      }
    }
    if (props.selectionMode === 'single' && !props.ignorePageChanged) {
      (_a = props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, nxtCurrent.toDate());
    }
    setCurrent(nxtCurrent);
  }, [current, props.maxPage, props.minPage, props.ignorePageChanged]);
  var renderLabel = _react["default"].useCallback(function (isBegin, isEnd, date) {
    if (props.renderLabel) return props.renderLabel(date, isBegin, isEnd);else if (props.selectionMode === 'range') {
      if (isBegin) {
        return locale.Calendar.begin;
      } else if (isEnd) {
        return locale.Calendar.end;
      }
    }
  }, [props.renderLabel, props.selectionMode]);
  var renderCells = function renderCells() {
    var cells = [];
    var iterator = current.subtract(current.isoWeekday(), 'day');
    if (props.weekStartsOn === 'Monday') {
      iterator = iterator.add(1, 'day');
    }
    var _loop_1 = function _loop_1() {
      var _a;
      var d = iterator;
      var isSelect = false;
      var isBegin = false;
      var isEnd = false;
      var isSelectRowBegin = false;
      var isSelectRowEnd = false;
      if (dateRange) {
        var _b = __read(dateRange, 2),
          begin = _b[0],
          end = _b[1];
        isBegin = d.isSame(begin, 'day');
        isEnd = d.isSame(end, 'day');
        isSelect = isBegin || isEnd || d.isAfter(begin, 'day') && d.isBefore(end, 'day');
        if (isSelect) {
          isSelectRowBegin = (cells.length % 7 === 0 || d.isSame(d.startOf('month'), 'day')) && !isBegin;
          isSelectRowEnd = (cells.length % 7 === 6 || d.isSame(d.endOf('month'), 'day')) && !isEnd;
        }
      }
      var inThisMonth = d.month() === current.month();
      var disabled = props.shouldDisableDate ? props.shouldDisableDate(d.toDate()) : maxDay && d.isAfter(maxDay, 'day') || minDay && d.isBefore(minDay, 'day');
      var isFuture = d.isAfter(today, 'day');
      cells.push(/*#__PURE__*/_react["default"].createElement("div", {
        key: d.valueOf(),
        className: (0, _classnames["default"])("".concat(prefixCls, "-cell"), disabled && "".concat(prefixCls, "-cell-disabled"), !inThisMonth && "".concat(prefixCls, "-cell-not-in-view"), props.enableDisabledFuture && isFuture && "".concat(prefixCls, "-cell-future-disabled"), inThisMonth && (_a = {}, _a["".concat(prefixCls, "-cell-today")] = d.isSame(today, 'day') && !isSelect, _a["".concat(prefixCls, "-cell-selected")] = isSelect, _a["".concat(prefixCls, "-cell-selected-begin")] = isBegin, _a["".concat(prefixCls, "-cell-selected-end")] = isEnd, _a["".concat(prefixCls, "-cell-selected-row-begin")] = isSelectRowBegin, _a["".concat(prefixCls, "-cell-selected-row-end")] = isSelectRowEnd, _a)),
        onClick: function onClick() {
          if (!props.selectionMode) return;
          if (disabled) return;
          var date = d.toDate();
          if (!inThisMonth) {
            setCurrent(d.clone().date(1));
          }
          function shouldClear() {
            if (!props.allowClear) return false;
            if (!dateRange) return false;
            var _a = __read(dateRange, 2),
              begin = _a[0],
              end = _a[1];
            return d.isSame(begin, 'date') && d.isSame(end, 'day');
          }
          if (props.selectionMode === 'single') {
            if (props.allowClear && shouldClear()) {
              setDateRange(null);
              return;
            }
            setDateRange([date, date]);
          } else if (props.selectionMode === 'range') {
            if (!dateRange) {
              setDateRange([date, date]);
              setIntermediate(true);
              return;
            }
            if (shouldClear()) {
              setDateRange(null);
              setIntermediate(false);
              return;
            }
            if (intermediate) {
              var another = dateRange[0];
              setDateRange(another > date ? [date, another] : [another, date]);
              setIntermediate(false);
            } else {
              setDateRange([date, date]);
              setIntermediate(true);
            }
          }
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-cell-label")
      }, renderLabel(isBegin, isEnd, d.toDate())), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-cell-date")
      }, props.renderDate ? props.renderDate(d.toDate()) : d.isSame(today, 'day') && !isSelect ? (/*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-cell-date-today")
      }, locale.Calendar.renderToday(d.date()))) : d.date())));
      iterator = iterator.add(1, 'day');
    };
    while (cells.length < 6 * 7) {
      _loop_1();
    }
    return cells;
  };
  var handleScrollChange = _react["default"].useCallback(function (v) {
    var year = v[0];
    var month = v[1];
    var curYear = current.year();
    var curMonth = current.month();
    var changeMonth = function changeMonth() {
      if (month > curMonth) {
        handlePageChange('add', month - curMonth, 'month');
      } else if (month < curMonth) {
        handlePageChange('subtract', curMonth - month, 'month');
      }
    };
    if (year > curYear) {
      handlePageChange('add', year - curYear, 'year');
      changeMonth();
    } else if (year < curYear) {
      handlePageChange('subtract', curYear - year, 'year');
      changeMonth();
    } else {
      changeMonth();
    }
  }, [current]);
  var _e = _react["default"].useMemo(function () {
      if (dateManager.current === undefined) {
        dateManager.current = new _getDate.DateManager({
          minDate: props.min,
          maxDate: props.max
        });
      }
      return dateManager.current.getValueCols(current.toDate(), _getDate.Mode.MONTH, false, locale, prefixCls, false);
    }, [props.min, props.max, current, prefixCls]),
    value = _e.value,
    cols = _e.cols;
  var isCurrentMonth = current.isSame(today, 'month');
  var header = /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-header")
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-title"),
    onClick: function onClick() {
      return setMode(function (mode) {
        return mode === ModeType.MONTH ? ModeType.DAY : ModeType.MONTH;
      });
    }
  }, locale.Calendar.renderYearAndMonth(current.year(), current.month() + 1), mode === ModeType.MONTH ? (/*#__PURE__*/_react["default"].createElement(_ddIcons.DownArrow2Outlined, {
    className: "".concat(prefixCls, "-header-operate")
  })) : (/*#__PURE__*/_react["default"].createElement(_ddIcons.RightArrow2Outlined, {
    className: "".concat(prefixCls, "-header-operate")
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-operate")
  }, /*#__PURE__*/_react["default"].createElement(_ddIcons.LeftArrow2Outlined, {
    className: "".concat(prefixCls, "-header-operate"),
    onClick: function onClick() {
      return handlePageChange('subtract', 1, 'month');
    }
  }), /*#__PURE__*/_react["default"].createElement(_ddIcons.RightArrow2Outlined, {
    className: "".concat(prefixCls, "-header-operate ").concat(isCurrentMonth && props.enableDisabledFuture ? 'disabled' : ''),
    onClick: function onClick() {
      if (isCurrentMonth && props.enableDisabledFuture) return;
      handlePageChange('add', 1, 'month');
    }
  })));
  var mark = /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-mark")
  }, markItems.map(function (item, index) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: index,
      className: "".concat(prefixCls, "-mark-cell")
    }, item);
  }));
  var body = /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, mode === ModeType.DAY ? (/*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefixCls, "-cells"), props.selectionMode === 'range' && "".concat(prefixCls, "-cells-range-select"))
  }, renderCells())) : (/*#__PURE__*/_react["default"].createElement(_MultiPicker["default"], {
    style: {
      flexDirection: 'row',
      alignItems: 'center',
      display: 'flex'
    },
    prefixCls: "".concat(prefixCls, "-multi-picker"),
    onScrollChange: handleScrollChange,
    selectedValue: [current.year(), current.month()]
  }, cols.map(function (col, index) {
    return /*#__PURE__*/_react["default"].createElement(_Picker["default"], {
      key: col.key,
      style: {
        flex: 1
      },
      prefixCls: "".concat(_style.dtMobilePrefix, "-picker-col")
    }, col.props.children.map(function (item) {
      return /*#__PURE__*/_react["default"].createElement(_Picker["default"].Item, {
        key: item.value,
        value: Number(item.value)
      }, item.label);
    }));
  }))));
  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", {
    className: wrapCls
  }, props.renderHeader === undefined ? header : props.renderHeader(handlePageChange), mode === ModeType.DAY && mark, body, props.renderFooter && props.renderFooter()));
});
Calendar.displayName = 'Calendar';
var _default = exports["default"] = Calendar;