"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dtMobileCardPrefix = exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
require("./style/index");
var _index2 = require("../style/index");
var _classnames = _interopRequireDefault(require("classnames"));
var _nativeProps = require("../_internal/native-props");
var _withDefaultProps = require("../_internal/with-default-props");
var _button = _interopRequireDefault(require("../button"));
var _popover = _interopRequireDefault(require("../popover"));
var _MoreOutlined = _interopRequireDefault(require("dd-icons/lib/MoreOutlined"));
var _hooks = require("../hooks");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var dtMobileCardPrefix = exports.dtMobileCardPrefix = "".concat(_index2.dtMobilePrefix, "-card");
var defaultProps = {
  showDivider: false,
  type: 'column'
};
var Card = /*#__PURE__*/_react["default"].memo(function (p) {
  var _a, _b, _c;
  var props = (0, _withDefaultProps.mergeProps)(defaultProps, p);
  var className = props.className,
    text = props.text,
    title = props.title,
    topOperate = props.topOperate,
    showDivider = props.showDivider,
    operations = props.operations,
    imageSrc = props.imageSrc,
    type = props.type,
    leftOperate = props.leftOperate,
    children = props.children;
  var prefixCls = dtMobileCardPrefix;
  var isMobile = (0, _hooks.useMobile)();
  var wrapCls = (0, _classnames["default"])(prefixCls, className, (_a = {}, _a["".concat(dtMobileCardPrefix, "-image-row")] = type === 'row', _a["".concat(dtMobileCardPrefix, "-desktop")] = !isMobile, _a));
  var onClickOperation = (0, _react.useCallback)(function (func) {
    if (func && typeof func === 'function') {
      func();
    }
  }, []);
  var renderTopImage = (0, _react.useCallback)(function () {
    var _a;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(dtMobileCardPrefix, "-top-image")
    }, /*#__PURE__*/_react["default"].createElement("img", {
      src: imageSrc,
      className: (0, _classnames["default"])((_a = {}, _a["".concat(dtMobileCardPrefix, "-card-image-no-bottom-radius")] = (title || text || operations) && type === 'column', _a))
    }));
  }, [imageSrc, title, text, operations, type]);
  var renderTitle = (0, _react.useCallback)(function () {
    var _a;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(dtMobileCardPrefix, "-header")
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: (0, _classnames["default"])("".concat(dtMobileCardPrefix, "-title"), (_a = {}, _a["".concat(dtMobileCardPrefix, "-title-desktop")] = !isMobile, _a))
    }, title), topOperate ? (/*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(dtMobileCardPrefix, "-icon-container"),
      onClick: function onClick() {
        return onClickOperation(topOperate.onClick);
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(dtMobileCardPrefix, "-operations-icon")
    }, topOperate.icon), /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(dtMobileCardPrefix, "-operations-text")
    }, topOperate.text))) : null, !isMobile && operations && operations instanceof Array ? (/*#__PURE__*/_react["default"].createElement(_popover["default"], {
      placement: 'bottomRight',
      arrow: false,
      overlay: /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(dtMobileCardPrefix, "-desktop-popover")
      }, operations.map(function (operation) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: operation.key,
          onClick: operation.onClick,
          className: "".concat(dtMobileCardPrefix, "-desktop-popover-item")
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(dtMobileCardPrefix, "-desktop-popover-item-icon")
        }, operation.icon), /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(dtMobileCardPrefix, "-desktop-popover-item-text")
        }, operation.text));
      }))
    }, /*#__PURE__*/_react["default"].createElement(_MoreOutlined["default"], {
      className: "".concat(dtMobileCardPrefix, "-operations-container-icon-desktop")
    }))) : null);
  }, [title, topOperate]);
  var renderOperation = (0, _react.useCallback)(function () {
    var _a, _b, _c;
    if (type === 'column' && operations && operations instanceof Array && operations.length) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(dtMobileCardPrefix, "-operations-container")
      }, operations.map(function (ele, index) {
        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
          onClick: function onClick() {
            return onClickOperation(ele.onClick);
          },
          className: "".concat(dtMobileCardPrefix, "-operations")
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(dtMobileCardPrefix, "-operations-icon")
        }, ele.icon), /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(dtMobileCardPrefix, "-operations-text")
        }, ele.text)), index !== operations.length - 1 ? (/*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(dtMobileCardPrefix, "-operations-divider")
        })) : null);
      }));
    } else if (type === 'column' && operations && !(operations instanceof Array)) {
      var mainOperate_1 = operations.mainOperate,
        subOperate_1 = operations.subOperate,
        operate_1 = operations.operate;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(dtMobileCardPrefix, "-fix-operations-container")
      }, operate_1 && (/*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("".concat(dtMobileCardPrefix, "-operate"), (_a = {}, _a["".concat(dtMobileCardPrefix, "-operate-text")] = operate_1.text, _a)),
        onClick: function onClick() {
          return onClickOperation(operate_1.onClick);
        }
      }, operate_1.text || operate_1.node)), subOperate_1 && (/*#__PURE__*/_react["default"].createElement(_button["default"], {
        size: "middle",
        className: (0, _classnames["default"])("".concat(dtMobileCardPrefix, "-suboperate"), (_b = {}, _b["".concat(dtMobileCardPrefix, "-suboperate-text")] = subOperate_1.text, _b)),
        onClick: function onClick() {
          return onClickOperation(subOperate_1.onClick);
        }
      }, subOperate_1.text || subOperate_1.node)), mainOperate_1 && (/*#__PURE__*/_react["default"].createElement(_button["default"], {
        size: "middle",
        type: "primary",
        className: (0, _classnames["default"])("".concat(dtMobileCardPrefix, "-mainoperate"), (_c = {}, _c["".concat(dtMobileCardPrefix, "-mainoperate-text")] = mainOperate_1.text, _c)),
        onClick: function onClick() {
          return onClickOperation(mainOperate_1.onClick);
        }
      }, mainOperate_1.text || mainOperate_1.node)));
    }
    return null;
  }, [operations, type]);
  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", {
    className: wrapCls
  }, imageSrc && imageSrc.length ? renderTopImage() : null, /*#__PURE__*/_react["default"].createElement("div", null, title ? renderTitle() : null, text || children ? (/*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(dtMobileCardPrefix, "-desc-container"), (_b = {}, _b["".concat(dtMobileCardPrefix, "-desc-container-has-header")] = title, _b["".concat(dtMobileCardPrefix, "-desc-container-has-divider")] = showDivider && type === 'column', _b))
  }, text || children)) : null, type === 'row' && leftOperate ? (/*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(dtMobileCardPrefix, "-operate"), "".concat(dtMobileCardPrefix, "-left-operate"), (_c = {}, _c["".concat(dtMobileCardPrefix, "-operate-text")] = leftOperate.text, _c)),
    onClick: function onClick() {
      return onClickOperation(leftOperate.onClick);
    }
  }, leftOperate.text)) : null), isMobile && renderOperation()));
});
Card.displayName = 'Card';
var _default = exports["default"] = Card;