"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _hooks = require("../hooks");
var _rmc = require("../rmc");
var _internal = require("../_internal");
var _SelectedMiniOutlined = _interopRequireDefault(require("dingtalk-design-icons/lib/SelectedMiniOutlined"));
var _SquareHalfMiniOutlined = _interopRequireDefault(require("dingtalk-design-icons/lib/SquareHalfMiniOutlined"));
var _Group = require("./Group");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var Checkbox = function Checkbox(props) {
  var _a;
  var _b, _c;
  var className = props.className,
    prefixCls = props.prefixCls,
    disabled = props.disabled,
    indeterminate = props.indeterminate;
  var checkboxGroup = React.useContext(_Group.GroupContext);
  var onGroupChange = function onGroupChange(bingo) {
    var _a;
    (_a = checkboxGroup === null || checkboxGroup === void 0 ? void 0 : checkboxGroup.onChange) === null || _a === void 0 ? void 0 : _a.call(checkboxGroup, props.value, bingo);
  };
  // hack，in checkbox, controlled/uncontrolled value mean checked
  var _d = (0, _hooks.useControlledByChecked)(__assign({
      checked: ((_b = checkboxGroup === null || checkboxGroup === void 0 ? void 0 : checkboxGroup.checkedValues) === null || _b === void 0 ? void 0 : _b.indexOf) && ((_c = checkboxGroup === null || checkboxGroup === void 0 ? void 0 : checkboxGroup.checkedValues) === null || _c === void 0 ? void 0 : _c.indexOf(props.value)) !== -1,
      onChange: (checkboxGroup === null || checkboxGroup === void 0 ? void 0 : checkboxGroup.onChange) && onGroupChange
    }, props)),
    checked = _d.checked,
    onChange = _d.onChange;
  var handleLableChange = function handleLableChange(e) {
    var v = e.target.checked;
    onChange(v);
  };
  var checkboxIcon = null;
  var isMobile = (0, _hooks.useMobile)();
  if (isMobile) {
    var checkboxInnerIcon = null;
    if (indeterminate) {
      checkboxInnerIcon = /*#__PURE__*/React.createElement(_SquareHalfMiniOutlined["default"], {
        className: (0, _classnames["default"])("".concat(prefixCls, "-indeterminate-icon"), {
          disabled: disabled
        })
      });
    } else if (checked) {
      checkboxInnerIcon = /*#__PURE__*/React.createElement(_SelectedMiniOutlined["default"], {
        className: (0, _classnames["default"])("".concat(prefixCls, "-checked-icon"), {
          disabled: disabled
        })
      });
    }
    checkboxIcon = /*#__PURE__*/React.createElement("div", {
      className: (0, _classnames["default"])("".concat(prefixCls, "-icon"), {
        disabled: disabled,
        checked: checked || indeterminate
      })
    }, checkboxInnerIcon);
  } else {
    checkboxIcon = /*#__PURE__*/React.createElement("span", {
      className: (0, _classnames["default"])('dtd-checkbox-inner', {
        'dtd-checkbox-inner-checked': checked,
        'dtd-checkbox-inner-indeterminate': indeterminate,
        'dtd-checkbox-inner-disabled': disabled
      })
    });
  }
  return /*#__PURE__*/React.createElement("div", __assign({
    className: (0, _classnames["default"])(prefixCls, className, (_a = {}, _a["".concat(prefixCls, "-desktop")] = !isMobile, _a))
  }, (0, _internal.getDataAttr)(props)), /*#__PURE__*/React.createElement(_rmc.Labelable, __assign({
    onChange: handleLableChange
  }, _rmc.Labelable.getProps(props), {
    checked: checked,
    value: props.value,
    type: "checkbox",
    name: props.name || (checkboxGroup === null || checkboxGroup === void 0 ? void 0 : checkboxGroup.name)
  }), checkboxIcon, !!props.children && /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-text")
  }, props.children)));
};
Checkbox.displayName = 'Checkbox';
Checkbox.defaultProps = {
  defaultChecked: false
};
var _default = exports["default"] = Checkbox;