"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.GroupContext = void 0;
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _rmc = require("../rmc");
var _hooks = require("../hooks");
var _list = _interopRequireDefault(require("../list"));
var _style = require("../style");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var __spreadArray = void 0 && (void 0).__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
var GroupContext = exports.GroupContext = /*#__PURE__*/React.createContext(null);
var Group = function Group(props) {
  var className = props.className,
    name = props.name,
    disabled = props.disabled,
    children = props.children,
    renderHeader = props.renderHeader,
    renderFooter = props.renderFooter;
  var _a = (0, _hooks.useControlledByValue)(props),
    value = _a.value,
    onChange = _a.onChange;
  // 将 value 重新按 options 排序
  var sortValue = function sortValue(values) {
    var options = React.Children.map(children, function (child) {
      // @ts-ignore
      return child.props.value;
    }) || [];
    var existValues = options.filter(function (item) {
      return values.indexOf(item) !== -1;
    });
    // @hack 例如 checkbox 内嵌场景，无法知道排序，目前置于最后面
    var notExistValues = values.filter(function (value) {
      return existValues.indexOf(value) === -1;
    });
    return existValues.concat.apply(existValues, __spreadArray([], __read(notExistValues), false));
  };
  var handleSelect = function handleSelect(v, selected) {
    var nextValue = __spreadArray([], __read(value), false);
    // 新增
    if (selected && value.indexOf(v) === -1) {
      nextValue.push(v);
    } else if (!selected && value.indexOf(v) !== -1) {
      // 删除
      nextValue = nextValue.filter(function (item) {
        return item !== v;
      });
    }
    nextValue = sortValue(nextValue);
    onChange(nextValue);
  };
  var context = {
    name: name,
    onChange: handleSelect,
    disabled: disabled,
    checkedValues: value
  };
  var cls = (0, _classnames["default"])(_style.dtMobileCheckboxGroupPrefix, className);
  return /*#__PURE__*/React.createElement(GroupContext.Provider, {
    value: context
  }, /*#__PURE__*/React.createElement(_list["default"], {
    renderHeader: renderHeader,
    renderFooter: renderFooter,
    className: cls
  }, children));
};
Group.displayName = 'CheckboxGroup';
Group.defaultProps = {
  defaultValue: []
};
var _default = exports["default"] = (0, _rmc.withError)(Group);