"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Item = void 0;
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _list = _interopRequireDefault(require("../list"));
var _internal = require("../_internal");
var _Checkbox = _interopRequireDefault(require("./Checkbox"));
var _Group = require("./Group");
var _index = require("../style/index");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var Item = exports.Item = function Item(props) {
  var cls = (0, _classnames["default"])(_index.dtMobileCheckboxItemPrefix, props.className);
  var context = React.useContext(_Group.GroupContext);
  var disabled = React.useMemo(function () {
    if ((context === null || context === void 0 ? void 0 : context.disabled) === undefined) {
      return props.disabled;
    }
    if ((context === null || context === void 0 ? void 0 : context.disabled) !== props.disabled) {
      return context === null || context === void 0 ? void 0 : context.disabled;
    }
  }, [context, props.disabled]);
  return /*#__PURE__*/React.createElement("label", __assign({
    className: cls
  }, (0, _internal.getDataAttr)(props)), /*#__PURE__*/React.createElement(_list["default"].Item, {
    className: "".concat(_index.dtMobileCheckboxItemPrefix, "-item"),
    disabled: disabled,
    hideDivider: props.hideDivider,
    thumb: /*#__PURE__*/React.createElement(_Checkbox["default"], {
      value: props.value,
      disabled: disabled || props.disabled,
      id: props.id,
      prefixCls: _index.dtMobileCheckboxPrefix
    })
  }, props.children));
};
Item.displayName = 'CheckboxItem';
var _default = exports["default"] = Item;