"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dtMobileCollapsePrefix = exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
require("./style/index");
var _index2 = require("../style/index");
var _nativeProps = require("../_internal/native-props");
var _classnames = _interopRequireDefault(require("classnames"));
var _usePropsValue = require("../_internal/use-props-value");
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var __spreadArray = void 0 && (void 0).__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
var dtMobileCollapsePrefix = exports.dtMobileCollapsePrefix = "".concat(_index2.dtMobilePrefix, "-collapse"); // 设置折叠面板样式前缀
var Collapse = /*#__PURE__*/_react["default"].memo(function (props) {
  var children = props.children,
    according = props.according,
    defaultActiveKey = props.defaultActiveKey,
    activeKey = props.activeKey,
    onChange = props.onChange;
  var prefixCls = dtMobileCollapsePrefix;
  var _a = __read((0, _usePropsValue.usePropsValue)({
      value: activeKey,
      defaultValue: defaultActiveKey ? defaultActiveKey : according ? '' : [],
      onChange: onChange
    }), 2),
    currentActiveKey = _a[0],
    setCurrentActiveKey = _a[1];
  var handlePanelCollapse = function handlePanelCollapse(key, collapse) {
    if (according) {
      // 手风琴模式，所有的非当前项的都折叠
      collapse && setCurrentActiveKey('');
      !collapse && setCurrentActiveKey(key);
    } else {
      // 普通模式下，仅仅改变当前index对应的列表的状态就可以
      if (collapse) {
        if (typeof currentActiveKey !== 'string') {
          setCurrentActiveKey(currentActiveKey === null || currentActiveKey === void 0 ? void 0 : currentActiveKey.filter(function (item) {
            return item !== key;
          }));
        }
      } else {
        if (typeof currentActiveKey !== 'string' && currentActiveKey) {
          setCurrentActiveKey(__spreadArray(__spreadArray([], __read(currentActiveKey), false), [key], false));
        }
      }
    }
  };
  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", null, _react["default"].Children.map(children, function (child, index) {
    var _a;
    if (!child) return;
    var wrapCls = (0, _classnames["default"])("".concat(prefixCls, "-panelContainer"), (_a = {}, _a["".concat(prefixCls, "-panelContainer-first")] = index === 0, _a));
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: wrapCls,
      key: child.key
    }, /*#__PURE__*/_react["default"].cloneElement(child, {
      onCollapse: function onCollapse(collapse) {
        return handlePanelCollapse(child.key, collapse);
      },
      collapse: according ? currentActiveKey !== child.key : !(currentActiveKey === null || currentActiveKey === void 0 ? void 0 : currentActiveKey.includes(child.key))
    }));
  })));
});
Collapse.displayName = 'Collapse';
var _default = exports["default"] = Collapse;