"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dtMobileCollapsePrefix = exports["default"] = exports.Panel = void 0;
var _react = _interopRequireWildcard(require("react"));
var _index = require("../style/index");
var _nativeProps = require("../_internal/native-props");
var _DownArrow2Outlined = _interopRequireDefault(require("dd-icons/lib/DownArrow2Outlined"));
var _classnames = _interopRequireDefault(require("classnames"));
var _hooks = require("../hooks");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var dtMobileCollapsePrefix = exports.dtMobileCollapsePrefix = "".concat(_index.dtMobilePrefix, "-collapse"); // 设置折叠面板样式前缀
var Panel = exports.Panel = /*#__PURE__*/_react["default"].memo(function (props) {
  var _a, _b, _c, _d;
  var children = props.children,
    title = props.title,
    collapse = props.collapse,
    onCollapse = props.onCollapse,
    icon = props.icon,
    disabled = props.disabled,
    onClick = props.onClick,
    arrow = props.arrow;
  var prefixCls = dtMobileCollapsePrefix; // 样式前缀的缩写
  var _e = __read((0, _react.useState)(0), 2),
    height = _e[0],
    setHeight = _e[1];
  var contentRef = (0, _react.useRef)(null);
  var isMobile = (0, _hooks.useMobile)();
  (0, _react.useEffect)(function () {
    contentRef.current ? setHeight(contentRef.current.offsetHeight) : setHeight(0);
  });
  var handleCollapse = function handleCollapse(e) {
    onCollapse && onCollapse(!collapse); // 向父组件传递折叠状态的改变
    onClick && onClick(e);
  };
  var wrapCls = (0, _classnames["default"])("".concat(prefixCls, "-panel"), (_a = {}, _a["".concat(prefixCls, "-panel-disabled")] = disabled, _a));
  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", {
    className: wrapCls
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefixCls, "-header"), (_b = {}, _b["".concat(prefixCls, "-header-pc")] = !isMobile, _b)),
    onClick: disabled ? undefined : handleCollapse
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-header-left")
  }, icon && (/*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-header-icon")
  }, typeof icon === 'function' ? icon() : icon)), title), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-header-right")
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefixCls, "-arrow"), (_c = {}, _c["".concat(prefixCls, "-arrow-rotate")] = !collapse, _c))
  }, !arrow && /*#__PURE__*/_react["default"].createElement(_DownArrow2Outlined["default"], null), arrow && typeof arrow !== 'function' && arrow), arrow && typeof arrow === 'function' && (/*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-arrow")
  }, arrow(collapse))))), /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefixCls, "-content-box")),
    style: {
      height: collapse ? '0px' : "".concat(height, "px")
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefixCls, "-content"), (_d = {}, _d["".concat(prefixCls, "-content-pc")] = !isMobile, _d)),
    ref: contentRef
  }, children))));
});
Panel.displayName = 'Collapse.Panel';
var _default = exports["default"] = Panel;