/// <reference types="react" />
import { NativeProps } from '../_internal/native-props';
type CollapsePanelProps = {
    /**
     * @description 唯一标识符
     */
    key: string;
    /**
     * @description 标题
     */
    title?: string;
    /**
     * @description 父组件传来的改变collapse的函数
     */
    onCollapse?: (collapse: boolean) => void;
    /**
     * @description 是否折叠,父组件传来的折叠状态
     * @default false
     */
    collapse?: boolean;
    /**
     * @description icon图标
     */
    icon?: React.ReactNode;
    /**
     * @description 是否为禁用状态
     * @default false
     */
    disabled?: boolean;
    /**
     * @description 标题栏的点击事件
     */
    onClick?: (event: React.MouseEvent<Element, MouseEvent>) => void;
    /**
     * @description 自定义箭头。如果是ReactNode，会自动增加旋转动画效果
     */
    arrow?: React.ReactNode | ((collapse: boolean) => React.ReactNode);
} & NativeProps;
export type ICollapsePanelProps = Omit<CollapsePanelProps, 'onCollapse' | 'collapse'>;
declare const _default: (props: ICollapsePanelProps) => null;
export default _default;
