"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultConfigRef = exports.ConfigProvider = void 0;
exports.getDefaultConfig = getDefaultConfig;
exports.setDefaultConfig = setDefaultConfig;
exports.useConfig = useConfig;
var _react = _interopRequireWildcard(require("react"));
var _zh_CN = _interopRequireDefault(require("../locales/zh_CN"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var defaultConfigRef = exports.defaultConfigRef = {
  current: {
    locale: _zh_CN["default"],
    config: {
      adapt: true
    }
  }
};
function setDefaultConfig(p) {
  var _a = p.config,
    config = _a === void 0 ? getDefaultConfig().config : _a,
    _b = p.locale,
    locale = _b === void 0 ? getDefaultConfig().locale : _b;
  defaultConfigRef.current = {
    locale: locale,
    config: config
  };
}
;
function getDefaultConfig() {
  return defaultConfigRef.current;
}
;
var ConfigContext = /*#__PURE__*/_react["default"].createContext(null);
var ConfigProvider = exports.ConfigProvider = function ConfigProvider(props) {
  var _a = props.config,
    config = _a === void 0 ? getDefaultConfig().config : _a,
    _b = props.locale,
    locale = _b === void 0 ? getDefaultConfig().locale : _b;
  var children = props.children;
  var parentConfig = useConfig();
  return /*#__PURE__*/_react["default"].createElement(ConfigContext.Provider, {
    value: __assign(__assign({}, parentConfig), {
      locale: locale,
      config: config
    })
  }, children);
};
function useConfig() {
  var _a;
  return (_a = (0, _react.useContext)(ConfigContext)) !== null && _a !== void 0 ? _a : getDefaultConfig();
}