import { Locale } from 'rc-picker/lib/interface';
import * as React from 'react';
import type { AlignType } from 'rc-trigger/lib/interface';
import type { NativeProps } from '../_internal/native-props';
export interface DatePickerPropsType extends NativeProps {
    value?: Date;
    mode?: 'datetime' | 'date' | 'year' | 'month' | 'time';
    minDate?: Date;
    maxDate?: Date;
    onChange?: (value: Date) => void;
    onValueChange?: (vals: any, index: number) => void;
    visible?: boolean;
    onDismiss?: () => void;
    locale?: {
        okText?: string;
        dismissText?: string;
        extra?: string;
        locale: 'zh_CN' | 'en_US';
        DatePickerLocale?: {
            year: string;
            month: string;
            day: string;
            hour: string;
            minute: string;
            am?: string;
            pm?: string;
        };
    } & Omit<Partial<Locale>, 'locale'>;
    minuteStep?: number;
    disabled?: boolean;
    format?: string | ((value: Date) => string);
    extra?: string;
    dismissText?: React.ReactNode;
    okText?: React.ReactNode;
    title?: React.ReactNode;
    prefixCls?: string;
    className?: string;
    use12Hours?: boolean;
    showUntilNow?: boolean;
    pickerPrefixCls?: string;
    popupPrefixCls?: string;
    onOk?: (x: any) => void;
    onVisibleChange?: (visible: boolean) => void;
    showSecond?: boolean;
    showHour?: boolean;
    showMinute?: boolean;
    disabledDate?: (date: Date) => boolean;
    renderHeader?: () => React.ReactNode;
    renderFooter?: () => React.ReactNode;
    /**
     * 是否适配表单
     */
    adaptForm?: boolean;
    placement?: 'left' | 'right' | 'top' | 'bottom' | 'topLeft' | 'topRight' | 'bottomLeft' | 'bottomRight';
    align?: AlignType;
    isMobile?: boolean;
}
