"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
Object.defineProperty(exports, "isUntilNowDate", {
  enumerable: true,
  get: function get() {
    return _DatePicker.isUntilNowDate;
  }
});
var _react = _interopRequireDefault(require("react"));
var _DatePicker = _interopRequireWildcard(require("../rmc/DatePicker"));
var _Popup = _interopRequireDefault(require("../rmc/DatePicker/Popup"));
var _CloseOutlined = _interopRequireDefault(require("dingtalk-design-icons/lib/CloseOutlined"));
var _zh_CN = _interopRequireDefault(require("./locale/zh_CN"));
var _index = require("../style/index");
var _utils = require("./utils");
var _popover = _interopRequireDefault(require("../popover"));
require("./style");
var _PickerPanel = _interopRequireDefault(require("rc-picker/lib/PickerPanel"));
var _dateFns = _interopRequireDefault(require("rc-picker/lib/generate/dateFns"));
var _usePropsValue = require("../_internal/use-props-value");
var _RightArrow2Outlined = _interopRequireDefault(require("dd-icons/lib/RightArrow2Outlined"));
var _hooks = require("../hooks");
var _en_US = _interopRequireDefault(require("./locale/en_US"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __extends = void 0 && (void 0).__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
/* tslint:disable:jsx-no-multiline-js */

var datePickerPrefix = "".concat(_index.dtMobilePrefix, "-date-picker");
var DateFormInnerNode = function DateFormInnerNode(props) {
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(datePickerPrefix, "-form-inner-node"),
    onClick: props.onClick
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(datePickerPrefix, "-form-inner-node-content")
  }, props.extra), /*#__PURE__*/_react["default"].createElement(_RightArrow2Outlined["default"], {
    className: "".concat(datePickerPrefix, "-form-inner-node-arrow")
  }));
};
var blockEvent = function blockEvent(e) {
  e.stopPropagation();
  e.preventDefault();
  e.nativeEvent.stopImmediatePropagation();
  e.nativeEvent.stopPropagation();
};
var DesktopAdapter = function DesktopAdapter(props) {
  var _a, _b;
  var children = props.children,
    onOk = props.onOk,
    onChange = props.onChange,
    value = props.value,
    onVisibleChange = props.onVisibleChange,
    _c = props.locale,
    locale = _c === void 0 ? _zh_CN["default"] : _c,
    _d = props.showSecond,
    showSecond = _d === void 0 ? false : _d,
    _e = props.placement,
    placement = _e === void 0 ? 'bottomRight' : _e,
    adaptForm = props.adaptForm;
  var _f = __read((0, _usePropsValue.usePropsValue)({
      defaultValue: (_a = props.visible) !== null && _a !== void 0 ? _a : false,
      value: props.visible,
      onChange: props.onVisibleChange
    }), 2),
    visible = _f[0],
    setVisible = _f[1];
  var extra = locale.extra;
  var childrenNode = null;
  if (children && /*#__PURE__*/_react["default"].isValidElement(children)) {
    childrenNode = children;
  } else if (adaptForm && !children) {
    childrenNode = /*#__PURE__*/_react["default"].createElement(DateFormInnerNode, null);
  }
  var showHour = _react["default"].useMemo(function () {
    return props.showHour || props.mode === 'datetime' || props.mode === 'time';
  }, [props.showHour, props.mode]);
  var showMinute = _react["default"].useMemo(function () {
    return props.showMinute || props.mode === 'datetime' || props.mode === 'time';
  }, [props.showHour, props.mode]);
  var mode = _react["default"].useMemo(function () {
    var _a;
    if (props.mode === 'date' || props.mode === 'datetime') {
      return 'date';
    } else {
      return (_a = props.mode) !== null && _a !== void 0 ? _a : 'date';
    }
  }, [props.mode]);
  var onOK = _react["default"].useCallback(function (val) {
    setVisible(false);
    onOk === null || onOk === void 0 ? void 0 : onOk(val);
  }, []);
  var disableData = _react["default"].useCallback(function (date) {
    if (props.disabledDate) {
      return props.disabledDate(date);
    }
    if (props.minDate && date < props.minDate) {
      return true;
    }
    if (props.maxDate && date > props.maxDate) {
      return true;
    }
    return false;
  }, [props.disabledDate, props.minDate, props.maxDate]);
  var onSelect = _react["default"].useCallback(function (val) {
    var _a;
    if (props.mode === 'date' || props.mode === 'year' || props.mode === 'month') {
      (_a = props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, val);
      onOK === null || onOK === void 0 ? void 0 : onOK(val);
      setVisible(false);
    }
  }, [props.mode, props.onChange, onOK]);
  var innerLocale = locale.locale === 'zh_CN' ? __assign(__assign({}, _zh_CN["default"]), locale) : __assign(__assign({}, _en_US["default"]), locale);
  return /*#__PURE__*/_react["default"].createElement(_popover["default"], {
    visible: visible,
    onVisibleChange: onVisibleChange,
    placement: placement,
    overlay: /*#__PURE__*/_react["default"].createElement("div", {
      onClick: blockEvent,
      onMouseDown: blockEvent,
      onTouchStart: blockEvent
    }, /*#__PURE__*/_react["default"].createElement(_PickerPanel["default"], {
      prefixCls: datePickerPrefix,
      generateConfig: _dateFns["default"],
      className: props.className,
      locale: innerLocale,
      value: value,
      picker: mode,
      showTime: (showHour || showMinute) && {
        showHour: showHour,
        showMinute: showMinute,
        showSecond: showSecond,
        format: !showSecond ? 'HH:mm' : 'HH:mm:ss'
      },
      onOk: onOK,
      disabledDate: disableData,
      onSelect: onSelect,
      onChange: onChange
    })),
    arrow: false,
    align: (_b = props.align) !== null && _b !== void 0 ? _b : {
      offset: [-16, 0]
    }
  }, childrenNode && /*#__PURE__*/_react["default"].isValidElement(childrenNode) && /*#__PURE__*/_react["default"].cloneElement(childrenNode, {
    extra: value ? (/*#__PURE__*/_react["default"].createElement("span", {
      className: "".concat(datePickerPrefix, "-format-value")
    }, (0, _utils.formatFn)({
      props: props
    }, value))) : (props === null || props === void 0 ? void 0 : props.extra) || extra,
    onClick: function onClick() {
      var _a, _b;
      childrenNode && /*#__PURE__*/_react["default"].isValidElement(childrenNode) && ((_b = (_a = childrenNode === null || childrenNode === void 0 ? void 0 : childrenNode.props) === null || _a === void 0 ? void 0 : _a.onClick) === null || _b === void 0 ? void 0 : _b.call(_a));
      setVisible(!visible);
    }
  }));
};
var DatePicker = /** @class */function (_super) {
  __extends(DatePicker, _super);
  function DatePicker() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.setScrollValue = function (v) {
      _this.scrollValue = v;
    };
    _this.onOk = function (v) {
      // 当未滚动时，onOk v 为 undefined，默认为最新日期
      if (v === undefined) {
        v = _this.props.value || _this.props.minDate || new Date();
      }
      if (_this.scrollValue !== undefined) {
        v = _this.scrollValue;
      }
      if (_this.props.onChange) {
        _this.props.onChange(v);
      }
      if (_this.props.onOk) {
        _this.props.onOk(v);
      }
    };
    _this.onVisibleChange = function (visible) {
      _this.scrollValue = undefined;
      if (_this.props.onVisibleChange) {
        _this.props.onVisibleChange(visible);
      }
    };
    return _this;
  }
  DatePicker.prototype.render = function () {
    var _a, _b, _c, _d;
    // tslint:disable-next-line:no-this-assignment
    var props = this.props;
    var children = props.children,
      value = props.value,
      popupPrefixCls = props.popupPrefixCls,
      adaptForm = props.adaptForm;
    // 兜底支持中/英文
    var locale = (_a = props.locale) !== null && _a !== void 0 ? _a : _zh_CN["default"];
    var defaultLocale = ((_b = props.locale) === null || _b === void 0 ? void 0 : _b.locale) === 'zh_CN' ? _zh_CN["default"] : _en_US["default"];
    var _e = locale.okText,
      okText = _e === void 0 ? defaultLocale.okText : _e,
      _f = locale.extra,
      extra = _f === void 0 ? defaultLocale.extra : _f,
      _g = locale.DatePickerLocale,
      DatePickerLocale = _g === void 0 ? defaultLocale.DatePickerLocale : _g;
    /**
     * 注意:
     * 受控 表示 通过设置 value 属性、组件的最终状态跟 value 设置值一致。
     * 默认不设置 value 或 只设置 defaultValue 表示非受控。
     *
     * DatePickerView 对外通过 value “只支持 受控” 模式（可以使用 defaultDate 支持 非受控 模式，但不对外）
     * PickerView 对外通过 value “只支持 受控” 模式
     *
     * DatePicker / Picker 对外只有 value 属性 (没有 defaultValue)，
     * 其中 List 展示部分 “只支持 受控” 模式，
     * 弹出的 选择器部分 会随外部 value 改变而变、同时能自由滚动
     * （即不会因为传入的 value 不变而不能滚动 (不像原生 input 的受控行为)）
     *
     */
    var datePicker = /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, (_c = props.renderHeader) === null || _c === void 0 ? void 0 : _c.call(props), /*#__PURE__*/_react["default"].createElement(_DatePicker["default"], {
      minuteStep: props.minuteStep,
      locale: DatePickerLocale,
      minDate: props.minDate,
      maxDate: props.maxDate,
      mode: props.mode,
      pickerPrefixCls: props.pickerPrefixCls,
      prefixCls: props.prefixCls,
      defaultDate: value || new Date(),
      use12Hours: props.use12Hours,
      showUntilNow: props.showUntilNow,
      onValueChange: props.onValueChange,
      onScrollChange: this.setScrollValue,
      className: props.className
    }), (_d = props.renderFooter) === null || _d === void 0 ? void 0 : _d.call(props));
    if (this.props.isMobile) {
      var childrenNode = null;
      if (children && /*#__PURE__*/_react["default"].isValidElement(children)) {
        childrenNode = children;
      } else if (adaptForm && !children) {
        childrenNode = /*#__PURE__*/_react["default"].createElement(DateFormInnerNode, null);
      }
      var childrenNodeWrap = childrenNode && /*#__PURE__*/_react["default"].cloneElement(childrenNode, {
        extra: value ? (/*#__PURE__*/_react["default"].createElement("span", {
          className: "".concat(datePickerPrefix, "-format-value")
        }, (0, _utils.formatFn)(this, value))) : this.props.extra || extra
      });
      return /*#__PURE__*/_react["default"].createElement(_Popup["default"], __assign({
        datePicker: datePicker,
        WrapComponent: "div",
        transitionName: "dtm-slide-up",
        maskTransitionName: "dtm-fade"
      }, props, {
        prefixCls: popupPrefixCls,
        date: value || new Date(),
        dismissText: this.props.dismissText || /*#__PURE__*/_react["default"].createElement(_CloseOutlined["default"], null),
        okText: this.props.okText || okText,
        onOk: this.onOk,
        onVisibleChange: this.onVisibleChange,
        onFixOk: this.onOk
      }), childrenNodeWrap);
    } else {
      return /*#__PURE__*/_react["default"].createElement(DesktopAdapter, __assign({}, this.props));
    }
  };
  DatePicker.defaultProps = {
    mode: 'datetime',
    prefixCls: _index.dtPickerPrefix,
    pickerPrefixCls: "".concat(_index.dtPickerPrefix, "-col"),
    popupPrefixCls: "".concat(_index.dtPickerPrefix, "-popup"),
    minuteStep: 1,
    use12Hours: false
  };
  return DatePicker;
}(_react["default"].Component);
var _default = exports["default"] = function _default(props) {
  var isMobile = (0, _hooks.useMobile)();
  return /*#__PURE__*/_react["default"].createElement(DatePicker, __assign({}, props, {
    isMobile: isMobile
  }));
};