import React from 'react';
import './style/index';
import { NativeProps } from '../_internal/native-props';
export declare const dtMobileDivierPrefix: string;
export type DividerProps = {
    /**
     * @description 分割线中的文字
     * @default ''
     */
    text?: string;
    /**
     * @description 分割线文字居左or居右 ｜ 'left' or 'right'
     * @default ''
     */
    align?: 'left' | 'right';
    /**
     * @description 文字左边所带的图标 ｜ JSX.Element
     */
    icon?: JSX.Element;
    /**
     * @description 去除左右边距，宽度占满容器
     */
    full?: boolean;
    /**
     * @description 水平还是垂直类型
     * @default horizontal
     */
    type?: 'horizontal' | 'vertical';
} & NativeProps<'--line-color' | '--text-color'>;
declare const Divider: React.FC<DividerProps>;
export default Divider;
