"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _interface = require("./interface");
require("./style/index");
var _popover = _interopRequireDefault(require("../popover"));
var _hooks = require("../hooks");
var _style = require("../style");
var _pageContainer = _interopRequireDefault(require("../page-container"));
var _rmcDrawer = _interopRequireDefault(require("rmc-drawer"));
var _reactDom = _interopRequireDefault(require("react-dom"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var dtMobileDrawerPrefix = "".concat(_style.dtMobilePrefix, "-drawer");
var Drawer = /*#__PURE__*/_react["default"].memo(function (props) {
  var _a;
  var isMobile = (0, _hooks.useMobile)();
  var children = props.children,
    onVisibleChange = props.onVisibleChange,
    _b = props.mask,
    mask = _b === void 0 ? true : _b,
    _c = props.maskClosable,
    maskClosable = _c === void 0 ? true : _c,
    _d = props.topBordered,
    topBordered = _d === void 0 ? true : _d,
    position = props.position,
    size = props.size,
    _e = props.embedded,
    embedded = _e === void 0 ? false : _e,
    _f = props.getContainer,
    getContainer = _f === void 0 ? false : _f,
    className = props.className,
    title = props.title,
    actions = props.actions,
    lightweight = props.lightweight,
    trigger = props.trigger,
    onClose = props.onClose,
    beforeClose = props.beforeClose,
    restProps = __rest(props, ["children", "onVisibleChange", "mask", "maskClosable", "topBordered", "position", "size", "embedded", "getContainer", "className", "title", "actions", "lightweight", "trigger", "onClose", "beforeClose"]);
  var _g = __read((0, _react.useState)(props.visible), 2),
    visible = _g[0],
    setVisible = _g[1];
  (0, _react.useEffect)(function () {
    setVisible(props.visible);
  }, [props.visible]);
  // 点蒙层状态改变
  var onOpenChange = (0, _react.useCallback)(function (canVisible) {
    if (beforeClose) {
      beforeClose().then(function (res) {
        if (res) {
          setVisible(canVisible);
          onVisibleChange && onVisibleChange(canVisible);
        }
      });
    } else {
      setVisible(canVisible);
      onVisibleChange && onVisibleChange(canVisible);
    }
  }, [onVisibleChange, beforeClose]);
  var ref = _react["default"].useRef();
  (0, _react.useEffect)(function () {
    if (visible) {
      document.body.style.overflow = 'hidden';
    } else {
      onClose === null || onClose === void 0 ? void 0 : onClose();
    }
    return function () {
      if (visible) {
        document.body.style.overflow = '';
      }
    };
  }, [visible]);
  (0, _react.useEffect)(function () {
    if (mask && !maskClosable) {
      var mask_1 = document.querySelector('.dtm-drawer-overlay');
      mask_1 === null || mask_1 === void 0 ? void 0 : mask_1.addEventListener('click', function (event) {
        event.stopPropagation();
      });
    }
  }, [mask, maskClosable]);
  (0, _react.useEffect)(function () {
    if (!getContainer || ref.current) {
      return;
    }
    ref.current = document.createElement('div');
    if (typeof getContainer === 'function') {
      getContainer().appendChild(ref.current);
    } else {
      getContainer.appendChild(ref.current);
    }
    return function () {
      // if (typeof getContainer === 'function') {
      //   getContainer().removeChild(ref.current as Node);
      // } else {
      //   getContainer.removeChild(ref.current as Node);
      // }
    };
  }, [getContainer]);
  var drawerContent = (0, _react.useMemo)(function () {
    if (title || actions) {
      return /*#__PURE__*/_react["default"].createElement(_pageContainer["default"], {
        full: !isMobile,
        hasBack: !isMobile,
        title: title,
        actions: actions,
        onBeforeClose: function onBeforeClose() {
          onOpenChange(false);
        },
        onBeforeBack: function onBeforeBack() {
          onOpenChange(false);
        }
      }, children);
    }
    return children;
  }, [children, title, actions, onOpenChange]);
  var drawerDom = /*#__PURE__*/_react["default"].createElement(_rmcDrawer["default"], __assign({}, restProps, {
    enableDragHandle: false,
    prefixCls: dtMobileDrawerPrefix,
    className: (0, _classnames["default"])(className, (_a = {}, _a["".concat(dtMobileDrawerPrefix, "-embedded")] = embedded, _a["".concat(dtMobileDrawerPrefix, "-bordered")] = topBordered, _a), className),
    open: visible,
    onOpenChange: onOpenChange,
    position: position || (isMobile ? _interface.EPlacement.bottom : _interface.EPlacement.right),
    overlayStyle: {
      display: mask ? 'auto' : 'none'
    },
    sidebar: drawerContent || '',
    sidebarStyle: {
      width: '100%',
      height: isMobile ? size ? size === 'large' ? '83%' : '50%' : 'auto' : 'auto'
    }
  }), /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null));
  var PortalDrawer = ref.current ? /*#__PURE__*/_reactDom["default"].createPortal(drawerDom, ref.current) : null;
  var drawer = getContainer ? PortalDrawer : drawerDom;
  if (trigger) {
    if (lightweight) {
      return /*#__PURE__*/_react["default"].createElement(_popover["default"], {
        visible: visible,
        onVisibleChange: onOpenChange,
        overlay: children,
        placement: "bottomRight"
      }, /*#__PURE__*/_react["default"].cloneElement(trigger, {
        onClick: function onClick() {
          onOpenChange(!visible);
        }
      }));
    }
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].cloneElement(trigger, {
      onClick: function onClick() {
        onOpenChange(!visible);
      }
    }), drawer);
  }
  return drawer;
});
Drawer.displayName = 'Drawer';
var _default = exports["default"] = Drawer;