import React from 'react';
import type { PopoverProps } from '../popover';
import { DropDownMenuItem } from './types';
import './style/index';
/**
 * @description 下拉菜单
 */
export interface DropdownProps extends Omit<PopoverProps, 'overlay' | 'dark'> {
    /**
     * 是否高亮当前元素
     */
    highlightElement?: boolean;
    /**
     * 显示菜单数据
     */
    menu: DropDownMenuItem[];
}
/**
 * 下拉菜单
 */
declare const Dropdown: React.FC<DropdownProps>;
export default Dropdown;
