"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _index = require("../style/index");
var _popover = _interopRequireDefault(require("../popover"));
var _hooks = require("../hooks");
require("./style/index");
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
/**
 * 下拉菜单
 */
var Dropdown = /*#__PURE__*/_react["default"].memo(function (_a) {
  var _b;
  var children = _a.children,
    menu = _a.menu,
    onVisibleChange = _a.onVisibleChange,
    highlightElement = _a.highlightElement,
    rest = __rest(_a, ["children", "menu", "onVisibleChange", "highlightElement"]);
  var overlay = null;
  var isMobile = (0, _hooks.useMobile)();
  if (menu && menu.length > 0) {
    overlay = /*#__PURE__*/_react["default"].createElement("div", {
      className: (0, _classnames["default"])("".concat(_index.dtDropdownPrefix, "-menu"), (_b = {}, _b["".concat(_index.dtDropdownPrefix, "-menu-pc")] = !isMobile, _b))
    }, menu.map(function (item, index) {
      var _a;
      var onClick = function onClick() {
        item.onClick && item.onClick();
        onVisibleChange && onVisibleChange(false);
      };
      return /*#__PURE__*/_react["default"].createElement("div", {
        key: index,
        className: (0, _classnames["default"])("".concat(_index.dtDropdownPrefix, "-menu-item"), (_a = {}, _a["".concat(_index.dtDropdownPrefix, "-menu-item-disabled")] = item.disabled, _a)),
        onClick: item.disabled ? undefined : onClick
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(_index.dtDropdownPrefix, "-menu-item-inner")
      }, item.icon && (/*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(_index.dtDropdownPrefix, "-menu-item-icon-wrap")
      }, item.icon)), item.title && (/*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(_index.dtDropdownPrefix, "-menu-item-title")
      }, item.title))));
    }));
  }
  var element = children;
  if (highlightElement) {
    element = /*#__PURE__*/_react["default"].cloneElement(element, {
      style: {
        // @hack popover zIndex 为 1999
        zIndex: 2000
      }
    });
  }
  return /*#__PURE__*/_react["default"].createElement(_popover["default"], __assign({
    overlay: overlay,
    arrow: false,
    onVisibleChange: onVisibleChange
  }, rest), /*#__PURE__*/_react["default"].createElement("div", null, element));
});
Dropdown.displayName = 'Dropdown';
Dropdown.defaultProps = {
  trigger: 'click'
};
var _default = exports["default"] = Dropdown;