import * as React from 'react';
import './style/index';
import type { EmptyActionItem } from './api/action';
import { EmptyTypes } from './api/types';
import { NativeProps } from '../_internal/native-props';
export type EmptyProps = {
    /**
     * @description 空页面类型 (EmptyTypes)
     * @default EmptyTypes.NOCONTENT
     */
    type?: EmptyTypes | 'network' | 'permission' | 'exception' | 'search' | 'noContent' | 'recycleBinCleared' | 'uploadFile' | 'noConv' | 'messageRead' | 'messageUnread' | 'noNotice';
    /**
     * @description 自定义插图，支持暗夜模式与非暗夜模式
     * @default "{dark: '', light: ''} or ''"
     */
    img?: string | {
        light: string;
        dark: string;
    };
    /**
     * @description 主标题
     * @default "-"
     */
    title?: string;
    /**
     * @description 辅助文案
     * @default "-"
     */
    desc?: string;
    /**
     * @description 是否内联元素，是则不全屏展示
     * @default false
     */
    inline?: boolean;
    /**
     * @description 主按钮行动点
     */
    action?: EmptyActionItem;
    /**
     * @description 次按钮行动点
     */
    subAction?: EmptyActionItem;
    /**
     * @description 图片与描述的排版朝向(Version > 2.2.0)
     */
    direction?: 'column' | 'row';
} & NativeProps;
declare const Empty: React.FC<EmptyProps>;
export default Empty;
export type { EmptyActionItem };
export { EmptyTypes };
