"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "EmptyTypes", {
  enumerable: true,
  get: function get() {
    return _types.EmptyTypes;
  }
});
exports["default"] = void 0;
var _classnames = _interopRequireDefault(require("classnames"));
var React = _interopRequireWildcard(require("react"));
var _button = _interopRequireDefault(require("../button"));
var _style = require("../style");
require("./style/index");
var _types = require("./api/types");
var _nativeProps = require("../_internal/native-props");
var _configProvider = require("../config-provider");
var _utils = require("./utils");
var _reactSvg = require("react-svg");
var _hooks = require("../hooks");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var Empty = function Empty(props) {
  var _a, _b, _c;
  var className = props.className,
    _d = props.type,
    type = _d === void 0 ? _types.EmptyTypes.NOCONTENT : _d,
    title = props.title,
    action = props.action,
    desc = props.desc,
    img = props.img,
    inline = props.inline,
    subAction = props.subAction,
    _e = props.direction,
    direction = _e === void 0 ? 'column' : _e;
  var isMobile = (0, _hooks.useMobile)();
  var locale = (0, _configProvider.useConfig)().locale;
  var imgSrc = React.useMemo(function () {
    return (0, _utils.getEmptySvg)(type, (0, _utils.prefersDarkMode)(), direction === 'column', img);
  }, [type, img]);
  var renderImg = React.useCallback(function () {
    var _a;
    if (imgSrc && /\.(svg)(\?.*)?$/.test(imgSrc)) {
      return /*#__PURE__*/React.createElement(_reactSvg.ReactSVG, {
        src: imgSrc,
        className: "".concat(_style.dtMobileEmptyPagePrefix, "-img")
      });
    } else if (imgSrc) {
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(_style.dtMobileEmptyPagePrefix, "-top")
      }, /*#__PURE__*/React.createElement("img", {
        className: (0, _classnames["default"])("".concat(_style.dtMobileEmptyPagePrefix, "-img"), (_a = {}, _a["".concat(_style.dtMobileEmptyPagePrefix, "-img-pc")] = !isMobile, _a)),
        src: imgSrc
      }));
    }
  }, [imgSrc]);
  var renderAction = React.useCallback(function (action, defaultText, isSub) {
    var _a;
    return (action || defaultText) && ((action === null || action === void 0 ? void 0 : action.node) ? (/*#__PURE__*/React.createElement("div", {
      onClick: action.onClick
    }, action.node)) : (/*#__PURE__*/React.createElement(_button["default"], {
      type: (action === null || action === void 0 ? void 0 : action.type) || isSub ? 'secondary' : 'primary',
      size: "middle",
      inline: true,
      onClick: action === null || action === void 0 ? void 0 : action.onClick,
      className: (0, _classnames["default"])("".concat(_style.dtMobileEmptyPagePrefix, "-button"), (_a = {}, _a["".concat(_style.dtMobileEmptyPagePrefix, "-sub-button")] = isSub, _a))
    }, (action === null || action === void 0 ? void 0 : action.text) || defaultText)));
  }, []);
  var isNotShow = React.useCallback(function (content) {
    if (content !== undefined && !content.trim()) {
      return true;
    }
    return false;
  }, []);
  var config = React.useMemo(function () {
    var _a, _b, _c, _d, _e, _f, _g;
    // @ts-ignore
    var emptyLocale = (_a = locale.Empty) === null || _a === void 0 ? void 0 : _a[type];
    return {
      title: (_b = title !== null && title !== void 0 ? title : emptyLocale === null || emptyLocale === void 0 ? void 0 : emptyLocale.title) !== null && _b !== void 0 ? _b : '',
      desc: (_c = desc !== null && desc !== void 0 ? desc : emptyLocale === null || emptyLocale === void 0 ? void 0 : emptyLocale.describe) !== null && _c !== void 0 ? _c : '',
      btnName: (_e = (_d = action === null || action === void 0 ? void 0 : action.text) !== null && _d !== void 0 ? _d : emptyLocale === null || emptyLocale === void 0 ? void 0 : emptyLocale.btnName) !== null && _e !== void 0 ? _e : '',
      subBtnName: (_g = (_f = subAction === null || subAction === void 0 ? void 0 : subAction.text) !== null && _f !== void 0 ? _f : emptyLocale === null || emptyLocale === void 0 ? void 0 : emptyLocale.subBtnName) !== null && _g !== void 0 ? _g : ''
    };
  }, [type, locale, title, desc, subAction, action]);
  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])(_style.dtMobileEmptyPagePrefix, className, (_a = {}, _a["".concat(_style.dtMobileEmptyPagePrefix, "-inline")] = inline, _a["".concat(_style.dtMobileEmptyPagePrefix, "-desktop")] = !isMobile, _a))
  }, /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])("".concat(_style.dtMobileEmptyPagePrefix, "-content"), (_b = {}, _b["".concat(_style.dtMobileEmptyPagePrefix, "-content-row")] = direction === 'row', _b))
  }, renderImg(), /*#__PURE__*/React.createElement("div", {
    className: "".concat(_style.dtMobileEmptyPagePrefix, "-description")
  }, !isNotShow(config.title) && (/*#__PURE__*/React.createElement("h3", {
    className: "".concat(_style.dtMobileEmptyPagePrefix, "-title")
  }, config.title)), !isNotShow(config.desc) && (/*#__PURE__*/React.createElement("p", {
    className: "".concat(_style.dtMobileEmptyPagePrefix, "-descibe")
  }, config.desc)), /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])("".concat(_style.dtMobileEmptyPagePrefix, "-btn-container"), (_c = {}, _c["".concat(_style.dtMobileEmptyPagePrefix, "-btn-container-row")] = direction === 'row', _c))
  }, renderAction(subAction, config.subBtnName, true), renderAction(action, config.btnName, false))))));
};
Empty.displayName = 'Empty';
var _default = exports["default"] = Empty;