"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prefersDarkMode = exports.getEmptySvg = void 0;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _config = require("./config");
/**
 *
 * @param type
 * @param isDark
 * @param isBig 是否用大尺寸图片(180*180,目前用于排版为纵向时)
 * @param img
 * @returns
 */
var getEmptySvg = exports.getEmptySvg = function getEmptySvg(type, isDark, isBig, img) {
  if (img) {
    if (isDark) return typeof img === 'string' ? img : img.dark;else return typeof img === 'string' ? img : img.light;
  } else if (type) {
    if (isDark && isBig) {
      return _config.darkBig[type];
    } else if (isDark) {
      return _config.darkMin[type];
    } else if (isBig) {
      return _config.lightBig[type];
    } else {
      return _config.lightMin[type];
    }
  }
};
var prefersDarkMode = exports.prefersDarkMode = function prefersDarkMode() {
  var theme = 'light';
  try {
    if ((typeof document === "undefined" ? "undefined" : (0, _typeof2["default"])(document)) === 'object' && document.documentElement.getAttribute('data-dingtalk-theme') === 'dark') {
      theme = 'dark';
    }
  } catch (ex) {}
  return theme === 'dark';
};