"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Form = void 0;
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _rcFieldForm = _interopRequireDefault(require("rc-field-form"));
var _list = _interopRequireDefault(require("../list"));
var _Header = require("./Header");
var _traverseReactNode = require("../_internal/traverse-react-node");
var _context = require("./context");
require("./style/index");
var _index2 = require("../style/index");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var Form = exports.Form = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var className = props.className,
    mode = props.mode,
    children = props.children,
    disabled = props.disabled,
    requiredMarkStyle = props.requiredMarkStyle,
    hasFeedback = props.hasFeedback,
    layout = props.layout,
    formProps = __rest(props, ["className", "mode", "children", "disabled", "requiredMarkStyle", "hasFeedback", "layout"]);
  var lists = [];
  var currentHeader = null;
  var items = [];
  var count = 0;
  function collect() {
    if (items.length === 0) return;
    count += 1;
    lists.push(/*#__PURE__*/_react["default"].createElement(_list["default"], {
      renderHeader: currentHeader,
      key: count,
      mode: mode
    }, items));
    items = [];
  }
  (0, _traverseReactNode.traverseReactNode)(props.children, function (child) {
    if (/*#__PURE__*/_react["default"].isValidElement(child)) {
      if (child.type === _Header.Header) {
        collect();
        currentHeader = child.props.children;
        return;
      }
    }
    items.push(child);
  });
  collect();
  return /*#__PURE__*/_react["default"].createElement(_rcFieldForm["default"], __assign({
    className: (0, _classnames["default"])(className, _index2.dtMobileFormPrefix)
  }, formProps, {
    ref: ref
  }), /*#__PURE__*/_react["default"].createElement(_context.FormContext.Provider, {
    value: {
      name: formProps.name,
      hasFeedback: hasFeedback,
      layout: layout,
      requiredMarkStyle: requiredMarkStyle,
      disabled: disabled
    }
  }, lists));
});
Form.displayName = 'Form';
Form.defaultProps = __assign({}, _context.defaultFormContext);