import React from 'react';
import { FormInstance } from 'rc-field-form';
import { ListItemProps } from '../list';
import type { FieldProps } from 'rc-field-form/lib/Field';
import type { FormLayout } from './index';
import { NativeProps } from '../_internal/native-props';
type RenderChildren<Values = any> = (form: FormInstance<Values>) => React.ReactNode;
type RcFieldProps = Omit<FieldProps, 'children'>;
type ChildrenType<Values = any> = RenderChildren<Values> | React.ReactNode;
export type FormItemProps = Pick<RcFieldProps, 'dependencies' | 'valuePropName' | 'name' | 'rules' | 'messageVariables' | 'trigger' | 'validateTrigger' | 'shouldUpdate' | 'initialValue' | 'getValueFromEvent' | 'getValueProps' | 'normalize' | 'preserve' | 'validateFirst'> & Pick<ListItemProps, 'style' | 'extra' | 'arrow' | 'hideDivider'> & {
    label?: React.ReactNode;
    help?: React.ReactNode;
    hasFeedback?: boolean;
    position?: 'default' | 'thumb' | 'brief' | 'label';
    required?: boolean;
    noStyle?: boolean;
    disabled?: boolean;
    hidden?: boolean;
    layout?: FormLayout;
    childElementPosition?: 'normal' | 'right';
    children?: ChildrenType;
    onClick?: (e: React.MouseEvent) => void;
} & NativeProps;
export declare function toArray<T>(candidate?: T | T[] | false): T[];
declare const Item: React.FC<React.PropsWithChildren<FormItemProps>>;
export default Item;
