"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.toArray = toArray;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _react = _interopRequireWildcard(require("react"));
var _rcFieldForm = require("rc-field-form");
var _list = _interopRequireDefault(require("../list"));
var _index = require("../style/index");
var _classnames = _interopRequireDefault(require("classnames"));
var _error = _interopRequireDefault(require("../_internal/error"));
var _context = require("./context");
var _hooks = require("../hooks");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof3(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var __spreadArray = void 0 && (void 0).__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
// 是否为整行交互区域，此时Form Item所有区域都会触发相关事件
function detectLabelOneLine(name) {
  if (!name) {
    return false;
  }
  var map = {
    // Radio: true,
    // Checkbox: true,
    // Picker: true,
    // InputItem: true,
    // NumericInput: true,
    // Select: true,
  };
  return !!map[name];
}
function detectNotHover(name) {
  if (!name) {
    return false;
  }
  var map = {
    Upload: true
  };
  return !!map[name];
}
// 会去掉form所有样式，包括required tag与feedback
var noStyleComponentNameList = ['RadioGroup', 'CheckboxGroup', 'Picker'];
function toArray(candidate) {
  if (candidate === undefined || candidate === false) return [];
  return Array.isArray(candidate) ? candidate : [candidate];
}
var MemoInput = /*#__PURE__*/_react["default"].memo(function (_a) {
  var children = _a.children;
  return children;
}, function (prev, next) {
  return prev.value === next.value && prev.update === next.update;
});
var Item = function Item(props) {
  var _a;
  var
    // 样式相关
    className = props.className,
    // FormItem 相关
    label = props.label,
    hasFeedback = props.hasFeedback,
    name = props.name,
    extra = props.extra,
    // required,
    // noStyle,
    position = props.position,
    arrow = props.arrow,
    // Field 相关
    disabled = props.disabled,
    rules = props.rules,
    children = props.children,
    messageVariables = props.messageVariables,
    _b = props.trigger,
    trigger = _b === void 0 ? 'onChange' : _b,
    validateTrigger = props.validateTrigger,
    onClick = props.onClick,
    shouldUpdate = props.shouldUpdate,
    dependencies = props.dependencies,
    layout = props.layout,
    hideDivider = props.hideDivider,
    fieldProps = __rest(props, ["className", "label", "hasFeedback", "name", "extra", "position", "arrow", "disabled", "rules", "children", "messageVariables", "trigger", "validateTrigger", "onClick", "shouldUpdate", "dependencies", "layout", "hideDivider"]);
  var isMobile = (0, _hooks.useMobile)();
  var context = (0, _react.useContext)(_context.FormContext);
  var finalLayout = layout || context.layout;
  var finalPosition = position;
  if ((!position || position === 'default') && finalLayout === 'vertical') {
    finalPosition = 'brief';
  }
  var finalHasFeedback = hasFeedback === undefined ? context.hasFeedback : hasFeedback;
  var updateRef = _react["default"].useRef(0);
  updateRef.current += 1;
  // @ts-ignore
  var noStyle = noStyleComponentNameList.includes((_a = children === null || children === void 0 ? void 0 : children.type) === null || _a === void 0 ? void 0 : _a.displayName);
  // ===== Layout =====
  function renderLayout(baseChildren, _fieldId, meta, isRequired) {
    var _a, _b, _c, _d;
    var _e, _f, _g;
    if (noStyle) {
      return baseChildren;
    }
    var brief, thumb;
    var feedback = finalHasFeedback && meta && meta.errors.length > 0 ? meta.errors[0] : null;
    var feedbackNode = feedback && (/*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(_index.dtMobileFormItemPrefix, "-help")
    }, (_e = props.help) !== null && _e !== void 0 ? _e : feedback));
    var child = label;
    // 判断是否必选
    var required = isRequired;
    // 根据不同位置放置表单
    switch (finalPosition) {
      case 'brief':
        {
          brief = /*#__PURE__*/_react["default"].createElement("div", {
            className: (0, _classnames["default"])((_a = {}, _a["".concat(_index.dtMobileFormItemPrefix, "-default-label-required-brief")] = required, _a))
          }, baseChildren, " ", feedbackNode);
          break;
        }
      case 'label':
        {
          child = baseChildren;
          break;
        }
      case 'thumb':
        {
          thumb = baseChildren;
          break;
        }
      default:
        {
          child = /*#__PURE__*/_react["default"].createElement("div", {
            className: "".concat(_index.dtMobileFormItemPrefix, "-default")
          }, label && (/*#__PURE__*/_react["default"].createElement("div", {
            className: (0, _classnames["default"])("".concat(_index.dtMobileFormItemPrefix, "-default-label"), (_b = {}, _b["".concat(_index.dtMobileFormItemPrefix, "-default-label-required")] = required, _b["".concat(_index.dtMobileFormItemPrefix, "-default-label-desktop")] = !isMobile, _b))
          }, label)), /*#__PURE__*/_react["default"].createElement("div", {
            className: (0, _classnames["default"])("".concat(_index.dtMobileFormItemPrefix, "-default-field"), (_c = {}, _c["".concat(_index.dtMobileFormItemPrefix, "-default-field-desktop")] = !isMobile, _c))
          }, baseChildren));
          brief = feedbackNode;
        }
    }
    var fixedExtra = extra ? (
    /*#__PURE__*/
    // 不触发 label 效果
    _react["default"].createElement("div", {
      onClick: function onClick(e) {
        return e.preventDefault();
      }
    }, extra)) : undefined;
    // @ts-ignore
    var labelOneLine = detectLabelOneLine((_f = children === null || children === void 0 ? void 0 : children.type) === null || _f === void 0 ? void 0 : _f.displayName);
    // @ts-ignore
    var hideHover = detectNotHover((_g = children === null || children === void 0 ? void 0 : children.type) === null || _g === void 0 ? void 0 : _g.displayName);
    var content = /*#__PURE__*/_react["default"].createElement(_list["default"].Item, {
      thumb: thumb,
      extra: fixedExtra,
      brief: brief,
      arrow: arrow,
      disabled: disabled,
      onClick: onClick,
      hideDivider: hideDivider,
      className: (0, _classnames["default"])((_d = {}, _d["".concat(_index.dtMobileFormItemPrefix, "-hide-hover")] = hideHover, _d["".concat(_index.dtMobileFormItemPrefix, "-required")] = required, _d["".concat(_index.dtMobileFormItemPrefix, "-required-brief")] = required && finalPosition === 'brief', _d), className)
    }, child);
    if (!labelOneLine) {
      return content;
    }
    return /*#__PURE__*/_react["default"].createElement("label", null, content);
  }
  var isRenderProps = typeof children === 'function';
  if (!name && !isRenderProps && !props.dependencies) {
    return renderLayout(children, undefined, undefined, props.required);
  }
  var newRules = rules;
  if (rules && props.required) {
    newRules = __spreadArray(__spreadArray([], __read(rules), false), [{
      required: true
    }], false);
  } else if (props.required) {
    newRules = [{
      required: true
    }];
  }
  return /*#__PURE__*/_react["default"].createElement(_rcFieldForm.Field, __assign({}, fieldProps, {
    name: name,
    shouldUpdate: shouldUpdate,
    dependencies: dependencies,
    rules: newRules,
    trigger: trigger,
    validateTrigger: validateTrigger
  }), function (control, meta, context) {
    var childNode = null;
    var isRequired = !!(newRules && newRules.some(function (rule) {
      if (rule && (0, _typeof2["default"])(rule) === 'object' && rule.required) {
        return true;
      }
      return false;
    }));
    var fieldId = (toArray(name).length && meta ? meta.name : []).join('_');
    (0, _error["default"])(!(shouldUpdate && dependencies), 'Form.Item', "`shouldUpdate` and `dependencies` shouldn't be used together.");
    if (isRenderProps) {
      if ((shouldUpdate || dependencies) && !name) {
        childNode = children(context);
      } else {
        (0, _error["default"])(shouldUpdate || dependencies, 'Form.Item', '`children` of render props only work with `shouldUpdate` or `dependencies`.');
        (0, _error["default"])(!name, 'Form.Item', "Do not use `name` with `children` of render props since it's not a field.");
      }
      // not render props
    } else if (dependencies && !name) {
      (0, _error["default"])(false, 'Form.Item', 'Must set `name` or use render props when `dependencies` is set.');
    } else if (/*#__PURE__*/_react["default"].isValidElement(children)) {
      (0, _error["default"])(!children.props.defaultValue, 'Form.Item', 'Can not set `defaultValue` in Form.Item‘s child componment');
      var childProps_1 = __assign(__assign({}, children.props), control);
      if (!childProps_1.id) {
        childProps_1.id = fieldId;
      }
      if (disabled) {
        childProps_1.disabled = disabled;
      }
      // We should keep user origin event handler
      var triggers = new Set(__spreadArray(__spreadArray([], __read(toArray(trigger)), false), __read(toArray(validateTrigger)), false));
      triggers.forEach(function (eventName) {
        childProps_1[eventName] = function () {
          var _a, _b, _c;
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          (_a = control[eventName]) === null || _a === void 0 ? void 0 : _a.call.apply(_a, __spreadArray([control], __read(args), false));
          (_c = (_b = children.props)[eventName]) === null || _c === void 0 ? void 0 : _c.call.apply(_c, __spreadArray([_b], __read(args), false));
        };
      });
      childNode = /*#__PURE__*/_react["default"].createElement(MemoInput, {
        value: control[props.valuePropName || 'value'],
        update: updateRef.current
      }, /*#__PURE__*/_react["default"].cloneElement(children, childProps_1));
    } else {
      (0, _error["default"])(!name, 'Form.Item', 'Must set `name` or use render props when `dependencies` is set.');
      childNode = children;
    }
    return renderLayout(childNode, fieldId, meta, isRequired);
  });
};
Item.displayName = 'FormItem';
Item.defaultProps = {
  position: 'default'
};
var _default = exports["default"] = Item;