/**
 * 在有清除图标的输入框中，需要将 focus 的状态共享出来
 *
 * showClear = focus && value
 */
declare const useFocus: <T extends unknown>(value: T, props: {
    onFocus?: ((v: T) => void) | undefined;
    onBlur?: ((v: T) => void) | undefined;
}) => {
    focus: boolean;
    onFocus: () => void;
    onBlur: () => void;
};
export default useFocus;
