"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var React = _interopRequireWildcard(require("react"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
/**
 * 在有清除图标的输入框中，需要将 focus 的状态共享出来
 *
 * showClear = focus && value
 */
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var useFocus = function useFocus(value, props) {
  var tRef = React.useRef();
  var _a = __read(React.useState(false), 2),
    focus = _a[0],
    setFocus = _a[1];
  var clear = function clear() {
    if (tRef.current) {
      clearTimeout(tRef.current);
    }
  };
  React.useEffect(function () {
    return clear;
  }, []);
  function isTouchScreen() {
    return 'ontouchstart' in window;
  }
  var handleFocus = function handleFocus() {
    var _a;
    if (!focus) {
      setFocus(true);
      (_a = props.onFocus) === null || _a === void 0 ? void 0 : _a.call(props, value);
    }
  };
  var handleBlur = function handleBlur() {
    var _a;
    if (focus) {
      setFocus(false);
      (_a = props.onBlur) === null || _a === void 0 ? void 0 : _a.call(props, value);
    }
  };
  return {
    focus: focus,
    onFocus: function onFocus() {
      clear();
      handleFocus();
    },
    onBlur: function onBlur() {
      // hack, 仅在 pc 的时候
      // 可能是 Touchable pc 实现有问题
      if (!isTouchScreen()) {
        tRef.current = setTimeout(function () {
          handleBlur();
        }, 200);
      } else {
        // @hack 解决 input-item clear 问题
        tRef.current = setTimeout(function () {
          handleBlur();
        }, 0);
      }
    }
  };
};
var _default = exports["default"] = useFocus;