"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;
var _react = require("react");
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
function calcScrollPercent(element, container, type) {
  return 100 * element[type === 'left' ? 'scrollLeft' : 'scrollTop'] / (container[type === 'left' ? 'scrollWidth' : 'scrollHeight'] - container[type === 'left' ? 'clientWidth' : 'clientHeight']);
}
function _default() {
  var args = [];
  for (var _i = 0; _i < arguments.length; _i++) {
    args[_i] = arguments[_i];
  }
  var _a = __read((0, _react.useState)({
      left: NaN,
      top: NaN
    }), 2),
    scrollPercent = _a[0],
    setScrollPercent = _a[1];
  var ref = (0, _react.useRef)();
  var hasPassedInElement = args.length === 1;
  var arg = args[0];
  (0, _react.useEffect)(function () {
    var passedInElement = typeof arg === 'function' ? arg() : arg;
    var element = hasPassedInElement ? passedInElement : ref.current;
    if (!element) return;
    function updatePosition(target) {
      var newScrollPostion;
      if (target === document) {
        if (!document.scrollingElement) return;
        newScrollPostion = {
          left: calcScrollPercent(document.scrollingElement, document, 'left'),
          top: calcScrollPercent(document.scrollingElement, document, 'top')
        };
      } else {
        newScrollPostion = {
          left: calcScrollPercent(target, ref.current, 'left'),
          top: calcScrollPercent(target, ref.current, 'top')
        };
      }
      setScrollPercent(newScrollPostion);
    }
    updatePosition(element);
    function listener(event) {
      if (!event.target) return;
      updatePosition(event.target);
    }
    element.addEventListener('scroll', listener);
    return function () {
      element.removeEventListener('scroll', listener);
    };
  }, [ref.current, typeof arg === 'function' ? undefined : arg]);
  return [scrollPercent, ref];
}