"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dtMobileIndexBarPrefix = exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
require("./style/index");
var _index2 = require("../style/index");
var _classnames = _interopRequireDefault(require("classnames"));
var _nativeProps = require("../_internal/native-props");
var _withDefaultProps = require("../_internal/with-default-props");
var _convertPx = require("../_internal/convert-px");
var _context = require("./context");
var _siderbar = require("./siderbar");
var _Panel = require("./Panel");
var _ahooks = require("ahooks");
var _attachPropertiesToComponent = require("../_internal/attach-properties-to-component");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var dtMobileIndexBarPrefix = exports.dtMobileIndexBarPrefix = "".concat(_index2.dtMobilePrefix, "-indexBar");
var defaultProps = {
  sticky: true
};
// 使用forwardRef将ref传入内部组件
var IndexBar = /*#__PURE__*/(0, _react.forwardRef)(function (p, ref) {
  var _a;
  var _b = __read(_react["default"].useState([]), 2),
    indexes = _b[0],
    setIndexes = _b[1]; // 序号
  var _c = __read(_react["default"].useState(indexes[0]), 2),
    activeIndex = _c[0],
    setActiveIndex = _c[1]; // 激活的序号
  var props = (0, _withDefaultProps.mergeProps)(defaultProps, p);
  var titleHeight = (0, _convertPx.convertPx)(35);
  var bodyRef = _react["default"].useRef(null);
  // 定义暴露给IndexBar使用方的实例值，使用方可以用传入IndexBar的ref调用scroolTo函数
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      scrollTo: scrollTo
    };
  });
  _react["default"].useEffect(function () {
    var body = bodyRef.current;
    if (!body) return;
    var children = body.children;
    for (var i = 0; i < children.length; i++) {
      var panel = children.item(i);
      if (!panel) continue;
      var panelIndex = panel.dataset['index'];
      // 得到panel的标题元素
      var titleEle = panel.childNodes[0];
      if (panelIndex === activeIndex) {
        // 标题激活
        titleEle.classList.add("".concat(dtMobileIndexBarPrefix, "-anchor-title-active"));
      } else {
        titleEle.classList.remove("".concat(dtMobileIndexBarPrefix, "-anchor-title-active"));
      }
    }
  }, [activeIndex]);
  /**
   * 滑动函数, 使用方可以使用该函数进行旋转
   * @param index
   * @returns
   */
  function scrollTo(index) {
    var body = bodyRef.current;
    if (!body) return;
    var children = body.children;
    for (var i = 0; i < children.length; i++) {
      var panel = children.item(i);
      if (!panel) continue;
      var panelIndex = panel.dataset['index'];
      if (panelIndex === index) {
        body.scrollTop = panel.offsetTop;
        setActiveIndex(index);
        return;
      }
    }
  }
  /**
   * 防抖函数，
   */
  var checkActiveIndex = (0, _ahooks.useThrottleFn)(function () {
    var body = bodyRef.current;
    if (!body) return;
    var scrollTop = body.scrollTop;
    var children = body.getElementsByClassName("".concat(dtMobileIndexBarPrefix, "-anchor"));
    for (var i = 0; i < children.length; i++) {
      var panel = children.item(i);
      if (!panel) continue;
      var panelIndex = panel.dataset['index'];
      if (!panelIndex) continue;
      if (panel.offsetTop + panel.clientHeight - titleHeight > scrollTop) {
        setActiveIndex(panelIndex);
        return;
      }
    }
  }, {
    wait: 50,
    trailing: true,
    leading: true
  }).run;
  _react["default"].useEffect(function () {
    if (!indexes.length) return;
    checkActiveIndex();
  }, [indexes]);
  var className = props.className;
  var prefixCls = dtMobileIndexBarPrefix;
  var wrapCls = (0, _classnames["default"])(prefixCls, className, (_a = {}, _a["".concat(dtMobileIndexBarPrefix, "-sticky")] = props.sticky, _a));
  var element = (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", {
    className: wrapCls
  }, /*#__PURE__*/_react["default"].createElement(_siderbar.Sidebar, {
    indexes: indexes,
    activeIndex: activeIndex,
    onActive: function onActive(index) {
      scrollTo(index);
    }
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(dtMobileIndexBarPrefix, "-body"),
    ref: bodyRef,
    onScroll: checkActiveIndex
  }, props.children)));
  return /*#__PURE__*/_react["default"].createElement(_context.IndexBarContext.Provider, {
    value: {
      indexes: indexes,
      setIndexes: setIndexes
    }
  }, element);
});
IndexBar.displayName = 'IndexBar';
var _default = exports["default"] = (0, _attachPropertiesToComponent.attachPropertiesToComponent)(IndexBar, {
  Panel: _Panel.Panel
});