"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Sidebar = void 0;
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _index = require("../style/index");
var _popover = _interopRequireDefault(require("../popover"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var dtMobileIndexBarPrefix = "".concat(_index.dtMobilePrefix, "-indexBar");
// 显示的字母侧边栏
var Sidebar = exports.Sidebar = function Sidebar(props) {
  var _a;
  var _b = __read((0, _react.useState)(false), 2),
    interacting = _b[0],
    setInteracting = _b[1];
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(dtMobileIndexBarPrefix, "-sidebar"), (_a = {}, _a["".concat(dtMobileIndexBarPrefix, "-sidebar-interacting")] = interacting, _a)),
    onMouseDown: function onMouseDown() {
      setInteracting(true);
    },
    onMouseUp: function onMouseUp() {
      setInteracting(false);
    },
    onTouchStart: function onTouchStart() {
      setInteracting(true);
    },
    onTouchEnd: function onTouchEnd() {
      setInteracting(false);
    },
    onTouchMove: function onTouchMove(e) {
      if (!interacting) return; // 只有在交互时才会触发
      var _a = e.touches[0],
        clientX = _a.clientX,
        clientY = _a.clientY;
      var target = document.elementFromPoint(clientX, clientY); //计算当前滑动到元素
      if (!target) return;
      var index = target.dataset['index']; // 得到当前元素的序号
      if (index) {
        props.onActive(index); // 激活当前序号
      }
    }
  }, props.indexes.map(function (index, idxPos) {
    var _a;
    var active = index === props.activeIndex;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(dtMobileIndexBarPrefix, "-sidebar-row"),
      onMouseDown: function onMouseDown() {
        props.onActive(index);
      },
      onTouchStart: function onTouchStart() {
        props.onActive(index);
      },
      onMouseEnter: function onMouseEnter() {
        if (interacting) {
          props.onActive(index);
        }
      },
      "data-index": index,
      key: index
    }, /*#__PURE__*/_react["default"].createElement(_popover["default"], {
      placement: "right",
      dark: true,
      overlay: /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("".concat(dtMobileIndexBarPrefix, "-sidebar-popover"))
      }, index),
      visible: interacting && active
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: (0, _classnames["default"])("".concat(dtMobileIndexBarPrefix, "-sidebar-item"), (_a = {}, _a["".concat(dtMobileIndexBarPrefix, "-sidebar-item-active")] = active, _a)),
      "data-index": index
    }, /*#__PURE__*/_react["default"].createElement("div", null, index))));
  }));
};