import React, { FC } from 'react';
import './style/index';
import { NativeProps } from '../_internal/native-props';
export type InfiniteScrollProps = {
    /**
     * @description 加载更多的回调函数
     */
    loadMore: (isRetry?: boolean) => any;
    /**
     * @description 是否还有更多内容
     */
    hasMore: boolean;
    /**
     * @description 触发加载事件的滚动触底距离阈值，单位为像素
     */
    threshold?: number;
    /**
     * @description 滚动方向
     * @default 'column'
     */
    direction?: 'column' | 'row';
    /**
     * @decrption 渲染自定义指引内容
     */
    children?: React.ReactNode | ((hasMore: boolean, failed: boolean, retry: () => void) => React.ReactNode);
} & NativeProps;
declare const InfiniteScroll: FC<React.PropsWithChildren<InfiniteScrollProps>>;
export default InfiniteScroll;
