"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _style = require("../style");
var _ahooks = require("ahooks");
require("./style/index");
var _nativeProps = require("../_internal/native-props");
var _getScrollParent = require("../_internal/get-scroll-parent");
var _withDefaultProps = require("../_internal/with-default-props");
var _configProvider = require("../config-provider");
var _hooks = require("../hooks");
var _classnames = _interopRequireDefault(require("classnames"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var __generator = void 0 && (void 0).__generator || function (thisArg, body) {
  var _ = {
      label: 0,
      sent: function sent() {
        if (t[0] & 1) throw t[1];
        return t[1];
      },
      trys: [],
      ops: []
    },
    f,
    y,
    t,
    g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;
  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");
    while (g && (g = 0, op[0] && (_ = 0)), _) try {
      if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
      if (y = 0, t) op = [op[0] & 2, t.value];
      switch (op[0]) {
        case 0:
        case 1:
          t = op;
          break;
        case 4:
          _.label++;
          return {
            value: op[1],
            done: false
          };
        case 5:
          _.label++;
          y = op[1];
          op = [0];
          continue;
        case 7:
          op = _.ops.pop();
          _.trys.pop();
          continue;
        default:
          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
            _ = 0;
            continue;
          }
          if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
            _.label = op[1];
            break;
          }
          if (op[0] === 6 && _.label < t[1]) {
            _.label = t[1];
            t = op;
            break;
          }
          if (t && _.label < t[2]) {
            _.label = t[2];
            _.ops.push(op);
            break;
          }
          if (t[2]) _.ops.pop();
          _.trys.pop();
          continue;
      }
      op = body.call(thisArg, _);
    } catch (e) {
      op = [6, e];
      y = 0;
    } finally {
      f = t = 0;
    }
    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var dtMobileInfiniteScrollPrefix = "".concat(_style.dtMobilePrefix, "-infinite-scroll");
function isWindow(element) {
  return element === window;
}
var InfiniteScrollContent = function InfiniteScrollContent(_a) {
  var _b;
  var hasMore = _a.hasMore,
    _c = _a.direction,
    direction = _c === void 0 ? 'column' : _c,
    failed = _a.failed,
    _d = _a.retry,
    retry = _d === void 0 ? function () {} : _d;
  var locale = (0, _configProvider.useConfig)().locale;
  var isMobile = (0, _hooks.useMobile)();
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(direction === 'column' ? "".concat(dtMobileInfiniteScrollPrefix, "-content") : "".concat(dtMobileInfiniteScrollPrefix, "-content-row"), (_b = {}, _b["".concat(dtMobileInfiniteScrollPrefix, "-desktop")] = !isMobile, _b))
  }, failed ? (/*#__PURE__*/_react["default"].createElement("span", null, locale.InfiniteScroll.failed, " ", /*#__PURE__*/_react["default"].createElement("a", {
    onClick: retry
  }, locale.InfiniteScroll.retry))) : (/*#__PURE__*/_react["default"].createElement("span", null, hasMore ? locale.InfiniteScroll.loading : locale.InfiniteScroll.noMore)));
};
var defaultProps = {
  threshold: 250,
  children: function children(hasMore, failed, retry) {
    return /*#__PURE__*/_react["default"].createElement(InfiniteScrollContent, {
      hasMore: hasMore,
      failed: failed,
      retry: retry
    });
  }
};
var InfiniteScroll = /*#__PURE__*/_react["default"].memo(function (p) {
  var props = (0, _withDefaultProps.mergeProps)(defaultProps, p);
  var _a = __read(_react["default"].useState(false), 2),
    failed = _a[0],
    setFailed = _a[1];
  var doLoadMore = (0, _ahooks.useLockFn)(function (isRetry) {
    return __awaiter(void 0, void 0, void 0, function () {
      var e_1;
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            _a.trys.push([0, 2,, 3]);
            return [4 /*yield*/, props.loadMore(isRetry)];
          case 1:
            _a.sent();
            return [3 /*break*/, 3];
          case 2:
            e_1 = _a.sent();
            setFailed(true);
            return [3 /*break*/, 3];
          case 3:
            return [2 /*return*/];
        }
      });
    });
  });
  var elementRef = (0, _react.useRef)(null);
  var _b = __read(_react["default"].useState({}), 2),
    flag = _b[0],
    setFlag = _b[1];
  var _c = __read(_react["default"].useState(), 2),
    scrollParent = _c[0],
    setScrollParent = _c[1];
  var nextFlagRef = (0, _react.useRef)(flag);
  var check = (0, _ahooks.useThrottleFn)(function () {
    return __awaiter(void 0, void 0, void 0, function () {
      var element, parent, rect, elementTop, current, nextFlag;
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            if (nextFlagRef.current !== flag) return [2 /*return*/];
            if (!props.hasMore) return [2 /*return*/];
            element = elementRef.current;
            if (!element) return [2 /*return*/];
            if (!element.offsetParent) return [2 /*return*/];
            parent = (0, _getScrollParent.getScrollParent)(element);
            setScrollParent(parent);
            if (!parent) return [2 /*return*/];
            if (failed) return [2 /*return*/];
            rect = element.getBoundingClientRect();
            elementTop = rect.top;
            current = isWindow(parent) ? window.innerHeight : parent.getBoundingClientRect().bottom;
            if (!(current >= elementTop - props.threshold)) return [3 /*break*/, 2];
            nextFlag = {};
            nextFlagRef.current = nextFlag;
            return [4 /*yield*/, doLoadMore(false)];
          case 1:
            _a.sent();
            setFlag(nextFlag);
            _a.label = 2;
          case 2:
            return [2 /*return*/];
        }
      });
    });
  }, {
    wait: 100,
    leading: true,
    trailing: true
  }).run;
  // 确保在内容不足时会自动触发加载事件
  (0, _react.useEffect)(function () {
    check();
  });
  (0, _react.useEffect)(function () {
    var element = elementRef.current;
    if (!element) return;
    if (!scrollParent) return;
    function onScroll() {
      check();
    }
    scrollParent.addEventListener('scroll', onScroll);
    return function () {
      scrollParent.removeEventListener('scroll', onScroll);
    };
  }, [scrollParent]);
  function retry() {
    return __awaiter(this, void 0, void 0, function () {
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            setFailed(false);
            return [4 /*yield*/, doLoadMore(true)];
          case 1:
            _a.sent();
            setFlag(nextFlagRef.current);
            return [2 /*return*/];
        }
      });
    });
  }
  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", {
    ref: elementRef
  }, typeof props.children === 'function' ? props.children(props.hasMore, failed, retry) : props.children));
});
InfiniteScroll.displayName = 'InfiniteScroll';
var _default = exports["default"] = InfiniteScroll;