import React from 'react';
import { IBaseProps } from 'dingtalk-design-shared';
import './style/index';
interface IInpageGuideProps extends IBaseProps {
    /**
     * 风格类型
     * @default 'normal'
     */
    type?: 'normal' | 'blue';
    /**
     * 左侧 Icon 显示
     */
    icon?: React.ReactNode;
    /**
     * 是否关闭
     * @default true
     */
    closable?: boolean;
    /**
     * 标题
     */
    title?: string;
    /**
     * 描述
     */
    desc?: string;
    /**
     * 行动按钮
     */
    actionText: string;
    /**
     * 行动按钮点击回调
     */
    onActionClick?: () => void;
    /**
     * 插画
     */
    imgSrc?: string;
}
declare const InpageGuide: React.FC<IInpageGuideProps>;
export default InpageGuide;
