import './style/index';
import * as React from 'react';
import { BasePropsType, BaseFormItemType } from '../_internal';
export interface InputItemProps extends BasePropsType, BaseFormItemType<string> {
    value?: string;
    defaultValue?: string;
    placeholder?: string;
    clear?: boolean;
    maxLength?: number;
    readonly?: boolean;
    /**
     * @description 输入框的类型
     * @default "text"
     */
    type?: string;
    onCompositionStart?: (event: React.CompositionEvent<HTMLInputElement>) => void;
    onCompositionEnd?: (event: React.CompositionEvent<HTMLInputElement>) => void;
    inputMode?: 'search' | 'text' | 'none' | 'tel' | 'url' | 'email' | 'numeric' | 'decimal';
}
/**
 * @deprecated 请使用 Input 组件替代，功能保持一致。
 */
export declare const InputItem: React.FC<InputItemProps>;
declare const _default: (React.MemoExoticComponent<React.ForwardRefExoticComponent<Pick<InputItemProps, "className" | "tabIndex" | "clear" | "disabled" | "type" | "autoFocus" | "onFocus" | "onBlur" | "value" | "id" | "onChange" | "defaultValue" | "placeholder" | "inputMode" | "onCompositionEnd" | "onCompositionStart" | "maxLength" | "name" | "readonly"> & React.RefAttributes<{}>>> | React.NamedExoticComponent<InputItemProps>) & React.FC<InputItemProps>;
export default _default;
