"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.InputItem = void 0;
require("./style/index");
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _CloseCircleFilled = _interopRequireDefault(require("dingtalk-design-icons/lib/CloseCircleFilled"));
var _internal = require("../_internal");
var _hooks = require("../hooks");
var _rmc = require("../rmc");
var _useCompositionChange = _interopRequireDefault(require("./useCompositionChange"));
var _ahooks = require("ahooks");
var _index2 = require("../style/index");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
/**
 * @deprecated 请使用 Input 组件替代，功能保持一致。
 */
var InputItem = exports.InputItem = function InputItem(props) {
  var _a;
  var id = props.id,
    name = props.name,
    className = props.className,
    placeholder = props.placeholder,
    disabled = props.disabled,
    autoFocus = props.autoFocus,
    clear = props.clear,
    type = props.type,
    maxLength = props.maxLength,
    inputMode = props.inputMode,
    readonly = props.readonly,
    // provide by withError
    // @ts-ignore
    forwardRef = props.forwardRef;
  var isMobile = (0, _hooks.useMobile)();
  var dataProps = (0, _internal.getDataAttr)(props);
  var _b = __read((0, _ahooks.useControllableValue)(props), 2),
    value = _b[0],
    onChange = _b[1];
  var _c = (0, _hooks.useFocus)(value, props),
    focus = _c.focus,
    onFocus = _c.onFocus,
    onBlur = _c.onBlur;
  var inputRef = /*#__PURE__*/React.createRef();
  React.useImperativeHandle(forwardRef, function () {
    return {
      focus: function focus() {
        var _a, _b;
        (_b = (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.focus) === null || _b === void 0 ? void 0 : _b.call(_a);
      },
      blur: function blur() {
        var _a, _b;
        (_b = (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.blur) === null || _b === void 0 ? void 0 : _b.call(_a);
      }
    };
  });
  var _d = (0, _useCompositionChange["default"])(value, onChange),
    fixedValue = _d.value,
    onComposition = _d.onComposition,
    fixedOnChange = _d.onChange;
  // 清除按钮
  var handleClear = function handleClear() {
    fixedOnChange('');
  };
  var showClear = clear && focus && value && value.length > 0;
  var wrap = function wrap() {
    var _a, _b;
    var _c, _d;
    var inputCls = (0, _classnames["default"])("".concat(_index2.dtMobileInputItemPrefix, "-input"), (_a = {}, _a["".concat(_index2.dtMobileInputItemPrefix, "-input-clear")] = showClear, _a));
    var inputComp = /*#__PURE__*/React.createElement("input", {
      id: id,
      name: name,
      ref: inputRef,
      value: fixedValue,
      inputMode: inputMode,
      type: type,
      placeholder: placeholder,
      readOnly: readonly,
      disabled: disabled,
      className: inputCls,
      autoFocus: autoFocus,
      onBlur: onBlur,
      onFocus: onFocus,
      maxLength: maxLength,
      onCompositionStart: (_c = props.onCompositionStart) !== null && _c !== void 0 ? _c : onComposition,
      onCompositionEnd: (_d = props.onCompositionEnd) !== null && _d !== void 0 ? _d : onComposition,
      onChange: function onChange(e) {
        return fixedOnChange(e.target.value);
      }
    });
    var clearComp = showClear ? (/*#__PURE__*/React.createElement(_CloseCircleFilled["default"], {
      className: "".concat(_index2.dtMobileInputItemPrefix, "-clear"),
      onClick: handleClear
    })) : null;
    return /*#__PURE__*/React.createElement("label", null, isMobile ? (/*#__PURE__*/React.createElement(React.Fragment, null, inputComp, clearComp)) : (/*#__PURE__*/React.createElement("span", {
      className: (0, _classnames["default"])("".concat(_index2.dtMobileInputItemPrefix, "-desktop-input"), (_b = {}, _b["".concat(_index2.dtMobileInputItemPrefix, "-desktop-input-focus")] = focus, _b["".concat(_index2.dtMobileInputItemPrefix, "-desktop-input-disabled")] = disabled, _b))
    }, inputComp, clearComp)));
  };
  var itemCls = (0, _classnames["default"])(_index2.dtMobileInputItemPrefix, className, (_a = {}, _a["".concat(_index2.dtMobileInputItemPrefix, "-disabled")] = disabled, _a["".concat(_index2.dtMobileInputItemPrefix, "-desktop-input-item")] = !isMobile, _a));
  return /*#__PURE__*/React.createElement("div", __assign({
    className: itemCls
  }, dataProps), wrap());
};
InputItem.displayName = 'InputItem';
InputItem.defaultProps = {
  className: '',
  disabled: false,
  placeholder: '',
  autoFocus: false,
  defaultValue: '',
  clear: false,
  type: 'text'
};
var _default = exports["default"] = (0, _rmc.withError)(InputItem, {
  forwardRef: true
});