"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var React = _interopRequireWildcard(require("react"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
// 修复中文输入法 onChange 的问题
var useCompositionChange = function useCompositionChange(value, onChange) {
  var _a = __read(React.useState(null), 2),
    cpValue = _a[0],
    setCpValue = _a[1];
  var cpLock = React.useRef(false);
  var handleChange = function handleChange(v, forceChange) {
    if (forceChange === void 0) {
      forceChange = false;
    }
    if (cpLock.current && !forceChange) {
      // 临时值锁
      setCpValue(v);
      return;
    }
    // 没有 lock 的时候，清除临时值
    cpValue !== null && setCpValue(null);
    onChange(v);
  };
  return {
    value: cpValue || value,
    onComposition: function onComposition(e) {
      if (e.type === 'compositionend' && cpLock.current) {
        var v = e.target.value;
        // hack safari 可能会触发两次 end, 所以需要在 lock 的时候才强制触发 change
        // hack chrome 的 onChange 先于 onCompositionEnd 触发，这里需要补充一次
        handleChange(v, true);
        cpLock.current = false;
      } else {
        cpLock.current = true;
      }
    },
    onChange: function onChange(v) {
      return handleChange(v);
    }
  };
};
var _default = exports["default"] = useCompositionChange;