"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dtMobileIntroBoardPrefix = exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
require("./style/index");
var _index2 = require("../style/index");
var _classnames = _interopRequireDefault(require("classnames"));
var _nativeProps = require("../_internal/native-props");
var _CloseOutlined = _interopRequireDefault(require("dd-icons/lib/CloseOutlined"));
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var dtMobileIntroBoardPrefix = exports.dtMobileIntroBoardPrefix = "".concat(_index2.dtMobilePrefix, "-intro-board");
var IntroBoard = /*#__PURE__*/_react["default"].memo(function (props) {
  var _a;
  var _b = __read(_react["default"].useState(true), 2),
    visible = _b[0],
    setVisible = _b[1];
  var className = props.className,
    title = props.title,
    desc = props.desc,
    jumpLink = props.jumpLink,
    emotion = props.emotion;
  var prefixCls = dtMobileIntroBoardPrefix;
  var wrapCls = (0, _classnames["default"])(prefixCls, className);
  var _onClick = _react["default"].useCallback(function () {
    if (jumpLink && typeof jumpLink.onClick === 'function') {
      jumpLink.onClick();
    }
  }, [jumpLink]);
  var onClose = _react["default"].useCallback(function () {
    setVisible(false);
    if (props.onClose && typeof props.onClose === 'function') {
      props.onClose();
    }
  }, [props.onClose]);
  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", {
    className: wrapCls,
    style: {
      visibility: visible ? 'visible' : 'hidden'
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-info-container"),
    onClick: function onClick() {
      return _onClick();
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-info-title-container")
  }, emotion, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-info-title")
  }, title)), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-info-desc")
  }, desc)), /*#__PURE__*/_react["default"].createElement("div", {
    onClick: function onClick() {
      return _onClick();
    },
    className: "".concat(prefixCls, "-jump-link")
  }, (_a = props.jumpLink) === null || _a === void 0 ? void 0 : _a.title), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-close-hot-spot"),
    onClick: function onClick() {
      return onClose();
    }
  }, /*#__PURE__*/_react["default"].createElement(_CloseOutlined["default"], {
    className: "".concat(prefixCls, "-close-icon")
  }))));
});
IntroBoard.displayName = 'IntroBoard';
var _default = exports["default"] = IntroBoard;