import * as React from 'react';
import { NativeProps } from '../_internal/native-props';
export type ListItemProps = {
    /**
     * @description 是否禁用
     * @default false
     */
    disabled?: boolean;
    /**
     * @description 列表项左侧区域
     * @default false
     */
    thumb?: React.ReactNode;
    /**
     * @description 辅助说明，用于显示第二行
     * @default React.ReactNode
     */
    brief?: React.ReactNode;
    /**
     * @description 列表项右侧区域
     * @default React.ReactNode
     */
    extra?: React.ReactNode;
    /**
     * @description 是否显示箭头，默认右箭头，也可设置上箭头 `up` 或者下箭头 `down`
     * @default false
     */
    arrow?: 'down' | 'up' | 'empty' | 'horizontal' | boolean;
    /**
     * @description 是否换行，默认情况下，文字超长会被隐藏
     * @default false
     */
    wrap?: boolean;
    /**
     * @description 列表项的点击事件，当设置了 onClick 属性时，列表项会有点击效果
     */
    onClick?: (e: React.MouseEvent) => void;
    /**
     * @description  extra 子元素对齐方式，可选`top`,`middle`,`bottom`
     * @default 'middle'
     * @deprecated 已废弃
     */
    align?: 'top' | 'middle' | 'bottom';
    /**
     * @description 报错样式,右侧文字颜色变成橙色
     * @deprecated 已废弃
     */
    error?: boolean;
    /**
     * @description 是否隐藏底部分割线
     */
    hideDivider?: boolean;
} & NativeProps;
export declare const Item: React.FC<React.PropsWithChildren<ListItemProps>>;
export default Item;
