"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Item = void 0;
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _RightArrow2Outlined = _interopRequireDefault(require("dd-icons/lib/RightArrow2Outlined"));
var _rmcFeedback = _interopRequireDefault(require("rmc-feedback"));
var _index = require("../style/index");
var _hooks = require("../hooks");
var _nativeProps = require("../_internal/native-props");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var Brief = /*#__PURE__*/React.memo(function (props) {
  if (!props.children) {
    return null;
  }
  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])("".concat(_index.dtMobileListPrefix, "-brief"), props.className)
  }, props.children);
});
Brief.displayName = 'Brief';
var Item = exports.Item = /*#__PURE__*/React.memo(function (props) {
  var _a, _b, _c, _d, _e;
  var _f = props.hideDivider,
    hideDivider = _f === void 0 ? false : _f,
    className = props.className,
    error = props.error,
    align = props.align,
    wrap = props.wrap,
    disabled = props.disabled,
    children = props.children,
    brief = props.brief,
    thumb = props.thumb,
    extra = props.extra,
    arrow = props.arrow,
    onClick = props.onClick,
    rest = __rest(props, ["hideDivider", "className", "error", "align", "wrap", "disabled", "children", "brief", "thumb", "extra", "arrow", "onClick"]);
  var isMobile = (0, _hooks.useMobile)();
  var _g = __read(React.useState({
      coverRippleStyle: {
        display: 'none'
      },
      RippleClicked: false
    }), 2),
    ripple = _g[0],
    setRipple = _g[1];
  var debounceTimeout = React.useRef(null);
  React.useEffect(function () {
    if (ripple.RippleClicked) {
      debounceTimeout.current = setTimeout(function () {
        setRipple({
          coverRippleStyle: {
            display: 'none'
          },
          RippleClicked: false
        });
      }, 1000);
    }
    return function () {
      if (debounceTimeout.current) {
        clearTimeout(debounceTimeout.current);
        debounceTimeout.current = null;
      }
    };
  }, [ripple]);
  var RippleClicked = ripple.RippleClicked,
    coverRippleStyle = ripple.coverRippleStyle;
  var handlePress = function handlePress(ev) {
    onClick === null || onClick === void 0 ? void 0 : onClick(ev);
  };
  var wrapCls = (0, _classnames["default"])("".concat(_index.dtMobileListPrefix, "-item"), className, (_a = {}, _a["".concat(_index.dtMobileListPrefix, "-item-disabled")] = disabled, _a["".concat(_index.dtMobileListPrefix, "-item-error")] = error, _a["".concat(_index.dtMobileListPrefix, "-item-top")] = align === 'top', _a["".concat(_index.dtMobileListPrefix, "-item-middle")] = align === 'middle', _a["".concat(_index.dtMobileListPrefix, "-item-bottom")] = align === 'bottom', _a["".concat(_index.dtMobileListPrefix, "-item-desktop")] = !isMobile, _a["".concat(_index.dtMobileListPrefix, "-item-hover")] = !isMobile && onClick, _a));
  var rippleCls = (0, _classnames["default"])("".concat(_index.dtMobileListPrefix, "-ripple"), (_b = {}, _b["".concat(_index.dtMobileListPrefix, "-ripple-animate")] = RippleClicked, _b));
  var lineCls = (0, _classnames["default"])("".concat(_index.dtMobileListPrefix, "-line"), (_c = {}, _c["".concat(_index.dtMobileListPrefix, "-line-wrap")] = wrap, _c["".concat(_index.dtMobileListPrefix, "-line-desktop")] = !isMobile, _c["".concat(_index.dtMobileListPrefix, "-line-mobile")] = isMobile, _c["".concat(_index.dtMobileListPrefix, "-line-hide-divider")] = hideDivider, _c));
  var arrowCls = (0, _classnames["default"])("".concat(_index.dtMobileListPrefix, "-arrow"), (_d = {}, _d["".concat(_index.dtMobileListPrefix, "-arrow-horizontal")] = arrow === true || arrow !== 'down' && arrow !== 'up' && arrow !== 'empty', _d["".concat(_index.dtMobileListPrefix, "-arrow-vertical")] = arrow === 'down' || arrow === 'up', _d["".concat(_index.dtMobileListPrefix, "-arrow-vertical-up")] = arrow === 'up', _d));
  var thumbCls = (0, _classnames["default"])("".concat(_index.dtMobileListPrefix, "-thumb"), (_e = {}, _e["".concat(_index.dtMobileListPrefix, "-thumb-brief")] = !!brief, _e));
  var content = /*#__PURE__*/React.createElement("div", {
    onClick: handlePress,
    className: wrapCls
  }, thumb ? (/*#__PURE__*/React.createElement("div", {
    className: thumbCls
  }, typeof thumb === 'string' ? /*#__PURE__*/React.createElement("img", {
    className: "".concat(thumbCls, "-img"),
    src: thumb
  }) : thumb)) : null, /*#__PURE__*/React.createElement("div", {
    className: lineCls
  }, children !== undefined && (/*#__PURE__*/React.createElement("div", {
    className: "".concat(_index.dtMobileListPrefix, "-content")
  }, children, brief && /*#__PURE__*/React.createElement(Brief, null, brief))), extra !== undefined && /*#__PURE__*/React.createElement("div", {
    className: "".concat(_index.dtMobileListPrefix, "-extra")
  }, extra), (arrow || onClick) && arrow !== 'empty' && (/*#__PURE__*/React.createElement(_RightArrow2Outlined["default"], {
    className: arrowCls,
    "aria-hidden": "true"
  }))), /*#__PURE__*/React.createElement("div", {
    style: coverRippleStyle,
    className: rippleCls
  }));
  return (
    /*#__PURE__*/
    // @ts-ignore
    React.createElement(_rmcFeedback["default"], __assign({}, rest, {
      activeClassName: "".concat(_index.dtMobileListPrefix, "-item-active"),
      disabled: disabled || !onClick
    }), (0, _nativeProps.withNativeProps)(props, content))
  );
});
Item.displayName = 'ListItem';
Item.defaultProps = {
  align: 'middle',
  error: false,
  wrap: false
};
var _default = exports["default"] = Item;