"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _mergeLocale = require("../_internal/merge-locale");
var _base = require("./base");
// const typeTemplate = '${label}不是一个有效的${type}'
var zhCN = (0, _mergeLocale.mergeLocale)(_base.base, {
  locale: 'zh-CH',
  common: {
    confirm: '确定',
    cancel: '取消',
    loading: '加载中'
  },
  NoticeBar: {
    text: '默认文案'
  },
  Calendar: {
    markItems: ['一', '二', '三', '四', '五', '六', '日'],
    toDay: '今',
    begin: '开始',
    end: '结束',
    renderToday: function renderToday(today) {
      return "\u4ECA";
    },
    renderYearAndMonth: function renderYearAndMonth(year, month) {
      return "".concat(year, "\u5E74").concat(month, "\u6708");
    }
  },
  Empty: {
    network: {
      title: '网络链接发生问题',
      describe: '请检查网络设置或刷新页面重试',
      btnName: '刷新',
      subBtnName: '网络诊断'
    },
    permission: {
      title: '暂无权限',
      describe: '可向管理员申请权限',
      define: '暂无权限'
    },
    exception: {
      title: '页面异常',
      describe: '刷新页面重试',
      btnName: '刷新'
    },
    search: {
      title: '暂无相关结果',
      describe: '请检查输入是否正确或尝试其他搜索词'
    },
    noContent: {
      title: '暂无内容',
      describe: '请检查输入是否正确或尝试其他搜索词'
    },
    recycleBinCleared: {
      title: '回收站已清空'
    },
    uploadFile: {
      title: '上传文件'
    },
    messageRead: {
      title: '已读'
    },
    noNotice: {
      title: '暂无公告'
    },
    noConv: {
      title: '暂无会话'
    }
  },
  InfiniteScroll: {
    noMore: '--- 我是有底线的 ---',
    loading: '加载中...',
    failed: '加载失败',
    retry: '重新加载'
  }
});
var _default = exports["default"] = zhCN;