import React from 'react';
import { NativeProps } from '../_internal/native-props';
import { GetContainer } from '../_internal/render-to-container';
import { PropagationEvent } from '../_internal/with-stop-propagation';
import 'regenerator-runtime/runtime.js';
import './style/index.less';
export type MaskProps = {
    visible?: boolean;
    maskShow?: boolean;
    onMaskClick?: (event: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
    destroyOnClose?: boolean;
    forceRender?: boolean;
    disableBodyScroll?: boolean;
    color?: 'black' | 'white';
    opacity?: 'default' | 'thin' | 'thick' | number;
    getContainer?: GetContainer;
    afterShow?: () => void;
    afterClose?: () => void;
    stopPropagation?: PropagationEvent[];
    children?: React.ReactNode;
} & NativeProps<'--z-index'>;
declare const Mask: React.FC<MaskProps>;
export default Mask;
