"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _ahooks = require("ahooks");
var _nativeProps = require("../_internal/native-props");
var _useLockScroll = require("../_internal/use-lock-scroll");
var _ddReactSpringWeb = require("dd-react-spring-web");
var _renderToContainer = require("../_internal/render-to-container");
var _withDefaultProps = require("../_internal/with-default-props");
var _configProvider = require("../config-provider");
var _shouldRender = require("../_internal/should-render");
var _withStopPropagation = require("../_internal/with-stop-propagation");
require("regenerator-runtime/runtime.js");
var _style = require("../style");
require("./style/index.css");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var classPrefix = "".concat(_style.dtMobilePrefix, "-mask");
var opacityRecord = {
  "default": 0.55,
  thin: 0.35,
  thick: 0.75
};
var defaultProps = {
  visible: true,
  maskShow: true,
  destroyOnClose: false,
  forceRender: false,
  color: 'black',
  opacity: 'default',
  disableBodyScroll: true,
  getContainer: null,
  stopPropagation: ['click']
};
var colorRecord = {
  black: '0, 0, 0',
  white: '255, 255, 255'
};
var Mask = function Mask(p) {
  var props = (0, _withDefaultProps.mergeProps)(defaultProps, p);
  var locale = (0, _configProvider.useConfig)().locale;
  var ref = (0, _react.useRef)(null);
  (0, _useLockScroll.useLockScroll)(ref, props.visible && props.disableBodyScroll);
  var background = (0, _react.useMemo)(function () {
    var _a;
    var opacity = (_a = opacityRecord[props.opacity]) !== null && _a !== void 0 ? _a : props.opacity;
    var rgb = colorRecord[props.color];
    return rgb ? "rgba(".concat(rgb, ", ").concat(opacity, ")") : props.color;
  }, [props.color, props.opacity]);
  var _a = __read((0, _react.useState)(props.visible), 2),
    active = _a[0],
    setActive = _a[1];
  var unmountedRef = (0, _ahooks.useUnmountedRef)();
  var opacity = (0, _ddReactSpringWeb.useSpring)({
    opacity: props.visible ? 1 : 0,
    config: {
      precision: 0.01,
      mass: 1,
      tension: 250,
      friction: 30,
      clamp: true
    },
    onStart: function onStart() {
      setActive(true);
    },
    onRest: function onRest() {
      var _a, _b;
      if (unmountedRef.current) return;
      setActive(props.visible);
      if (props.visible) {
        (_a = props.afterShow) === null || _a === void 0 ? void 0 : _a.call(props);
      } else {
        (_b = props.afterClose) === null || _b === void 0 ? void 0 : _b.call(props);
      }
    }
  }).opacity;
  var style = (0, _react.useMemo)(function () {
    var result = __assign(__assign({}, props.style), {
      background: background,
      opacity: opacity,
      display: active ? undefined : 'none'
    });
    if (props.maskShow) {
      return result;
    } else {
      return __assign(__assign({}, result), {
        background: 'rgba(0 ,0 ,0 ,0)'
      });
    }
  }, [props.maskShow, props.style, opacity, active]);
  var node = (0, _withStopPropagation.withStopPropagation)(props.stopPropagation, (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement(_ddReactSpringWeb.animated.div, {
    className: classPrefix,
    ref: ref,
    style: style,
    onClick: function onClick(e) {
      var _a;
      if (e.target === e.currentTarget) {
        (_a = props.onMaskClick) === null || _a === void 0 ? void 0 : _a.call(props, e);
      }
    }
  }, props.onMaskClick && (/*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(classPrefix, "-aria-button"),
    role: "button",
    "aria-label": locale.Mask.name,
    onClick: props.onMaskClick
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(classPrefix, "-content")
  }, props.children))));
  return /*#__PURE__*/_react["default"].createElement(_shouldRender.ShouldRender, {
    active: active,
    forceRender: props.forceRender,
    destroyOnClose: props.destroyOnClose
  }, (0, _renderToContainer.renderToContainer)(props.getContainer, node));
};
var _default = exports["default"] = Mask;