"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _rmcDialog = _interopRequireDefault(require("rmc-dialog"));
var _rmcFeedback = _interopRequireDefault(require("rmc-feedback"));
var _classnames = _interopRequireDefault(require("classnames"));
var _interface = require("./interface");
var _hooks = require("../hooks");
require("./style/index");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var Dialog = function Dialog(props) {
  var _a;
  var children = props.children,
    actions = props.actions,
    visible = props.visible,
    onClose = props.onClose,
    className = props.className,
    title = props.title,
    fullContent = props.fullContent,
    transitionName = props.transitionName,
    maskClosable = props.maskClosable,
    otherProps = __rest(props, ["children", "actions", "visible", "onClose", "className", "title", "fullContent", "transitionName", "maskClosable"]);
  var isMobile = (0, _hooks.useMobile)();
  var footer = (0, _react.useMemo)(function () {
    if (actions && actions.length) {
      var operation = false;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("".concat(_interface.dtMobileModalPrefix, "-button-group-").concat(actions.length === 2 && !operation ? 'h' : 'v'), "".concat(_interface.dtMobileModalPrefix, "-button-group-").concat(operation ? 'operation' : 'normal')),
        role: "group"
      }, actions === null || actions === void 0 ? void 0 : actions.map(function (item, i) {
        var button = {
          style: item.style,
          text: item.text,
          onClick: item.onClick
        };
        var buttonStyle = {};
        if (button.style) {
          buttonStyle = button.style;
          if (typeof buttonStyle === 'string') {
            var styleMap = {
              cancel: {},
              "default": {},
              destructive: {
                color: 'red'
              }
            };
            buttonStyle = styleMap[buttonStyle] || {};
          }
        }
        var onClickFn = function onClickFn(e) {
          e.preventDefault();
          if (button.onClick) {
            button.onClick();
          }
        };
        return (
          /*#__PURE__*/
          // @ts-ignore
          _react["default"].createElement(_rmcFeedback["default"], {
            activeClassName: "".concat(_interface.dtMobileModalPrefix, "-button-active"),
            key: i
          }, /*#__PURE__*/_react["default"].createElement("a", {
            className: "".concat(_interface.dtMobileModalPrefix, "-button"),
            role: "button",
            style: buttonStyle,
            onClick: onClickFn
          }, button.text || "Button"))
        );
      }));
    }
  }, [actions]);
  var cls = (0, _classnames["default"])(className, (_a = {}, _a["".concat(_interface.dtMobileModalPrefix, "-transparent")] = true, _a["".concat(_interface.dtMobileModalPrefix, "-full-content")] = fullContent, _a["".concat(_interface.dtMobileModalPrefix, "-desktop")] = !isMobile, _a));
  return /*#__PURE__*/_react["default"].createElement(_rmcDialog["default"], __assign({}, otherProps, {
    closable: false,
    title: title,
    maskClosable: maskClosable,
    visible: visible,
    onClose: onClose,
    className: cls,
    prefixCls: _interface.dtMobileModalPrefix,
    footer: footer,
    // transitionName={transitionName || `${dtMobilePrefix}-fade`}
    // maskTransitionName={`${dtMobilePrefix}-fade`}
    bodyStyle: !children ? {
      padding: 8
    } : {}
  }), children);
};
var _default = exports["default"] = Dialog;