"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactDom = _interopRequireDefault(require("react-dom"));
var _Dialog = _interopRequireDefault(require("./Dialog"));
var _interface = require("./interface");
var _style = require("../style");
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var alert = function alert(title, message, actions, maskClosable) {
  if (actions === void 0) {
    actions = [{
      text: '确定'
    }];
  }
  if (!title && !message) {
    // console.log('Must specify either an alert title, or message, or both');
    return {
      close: function close() {}
    };
  }
  var div = document.createElement('div');
  document.body.appendChild(div);
  function close() {
    _reactDom["default"].unmountComponentAtNode(div);
    if (div && div.parentNode) {
      div.parentNode.removeChild(div);
    }
  }
  var renderActions = (actions || []).map(function (item) {
    var originClick = item.onClick;
    return __assign(__assign({}, item), {
      onClick: function onClick() {
        close();
        originClick && originClick();
      }
    });
  });
  var prefixCls = _interface.dtMobileModalPrefix;
  _reactDom["default"].render(/*#__PURE__*/_react["default"].createElement(_Dialog["default"], {
    title: title,
    actions: renderActions,
    visible: true,
    transitionName: "".concat(_style.dtMobilePrefix, "-zoom"),
    onClose: function onClose() {
      close();
    },
    maskClosable: maskClosable
  }, !!message && /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-alert-content")
  }, message)), div);
  return {
    close: close
  };
};
var _default = exports["default"] = alert;