"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var React = _interopRequireWildcard(require("react"));
var ReactDOM = _interopRequireWildcard(require("react-dom"));
var _Dialog = _interopRequireDefault(require("./Dialog"));
var _interface = require("./interface");
var _style = require("../style");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var __spreadArray = void 0 && (void 0).__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
/* eslint-disable no-nested-ternary */

var prompt = function prompt(title, message, callbackOrActions, type, defaultValue, placeholders, maskClosable) {
  if (type === void 0) {
    type = 'default';
  }
  if (defaultValue === void 0) {
    defaultValue = '';
  }
  if (placeholders === void 0) {
    placeholders = ['', ''];
  }
  if (maskClosable === void 0) {
    maskClosable = false;
  }
  defaultValue = typeof defaultValue === 'string' ? defaultValue : typeof defaultValue === 'number' ? "".concat(defaultValue) : '';
  if (!callbackOrActions) {
    // console.log('Must specify callbackOrActions');
    return {
      close: function close() {}
    };
  }
  var prefixCls = _interface.dtMobileModalPrefix;
  var data = {
    text: defaultValue
  };
  function innerOnChange(e) {
    var target = e.target;
    var inputType = target.getAttribute('type');
    if (inputType !== null) {
      data[inputType] = target.value;
    }
  }
  // hotfix issue: https://github.com/ant-design/ant-design-mobile/issues/2177
  function onClick(e) {
    var target = e.currentTarget || e.target;
    if (target) {
      target.focus();
    }
  }
  function onBlurFixWechat() {
    // https://github.com/ant-design/ant-design-mobile/issues/3137
    if (/MicroMessenger/.test(navigator.userAgent)) {
      document.body.scrollTop = document.body.scrollTop;
    }
  }
  var inputDom;
  var focusFn = function focusFn(input) {
    setTimeout(function () {
      if (input) {
        input.focus();
      }
    }, 500);
  };
  switch (type) {
    case 'login-password':
      inputDom = /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-input-container")
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-input")
      }, /*#__PURE__*/React.createElement("label", null, /*#__PURE__*/React.createElement("input", {
        type: "text",
        defaultValue: data.text,
        ref: function ref(input) {
          return focusFn(input);
        },
        onClick: onClick,
        onChange: innerOnChange,
        placeholder: placeholders[0],
        onBlur: onBlurFixWechat
      }))), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-input")
      }, /*#__PURE__*/React.createElement("label", null, /*#__PURE__*/React.createElement("input", {
        type: "password",
        defaultValue: data.password,
        onClick: onClick,
        onChange: innerOnChange,
        placeholder: placeholders[1],
        onBlur: onBlurFixWechat
      }))));
      break;
    case 'secure-text':
      inputDom = /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-input-container")
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-input")
      }, /*#__PURE__*/React.createElement("label", null, /*#__PURE__*/React.createElement("input", {
        type: "password",
        defaultValue: data.password,
        ref: function ref(input) {
          return focusFn(input);
        },
        onClick: onClick,
        onChange: innerOnChange,
        placeholder: placeholders[0],
        onBlur: onBlurFixWechat
      }))));
      break;
    case 'default':
    default:
      inputDom = /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-input-container")
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-input")
      }, /*#__PURE__*/React.createElement("label", null, /*#__PURE__*/React.createElement("input", {
        type: "text",
        defaultValue: data.text,
        ref: function ref(input) {
          return focusFn(input);
        },
        onClick: onClick,
        onChange: innerOnChange,
        placeholder: placeholders[0],
        onBlur: onBlurFixWechat
      }))));
  }
  var content = /*#__PURE__*/React.createElement("div", null, message, inputDom);
  var div = document.createElement('div');
  document.body.appendChild(div);
  function close() {
    ReactDOM.unmountComponentAtNode(div);
    if (div && div.parentNode) {
      div.parentNode.removeChild(div);
    }
  }
  function handleConfirm(callback) {
    if (typeof callback !== 'function') {
      return;
    }
    var _a = data.text,
      text = _a === void 0 ? '' : _a,
      _b = data.password,
      password = _b === void 0 ? '' : _b;
    var callbackArgs = type === 'login-password' ? [text, password] : type === 'secure-text' ? [password] : [text];
    return callback.apply(void 0, __spreadArray([], __read(callbackArgs), false));
  }
  var actions;
  if (typeof callbackOrActions === 'function') {
    actions = [{
      text: '取消',
      onClick: function onClick() {}
    }, {
      text: '确定',
      onClick: function onClick() {
        handleConfirm(callbackOrActions);
      }
    }];
  } else {
    actions = callbackOrActions.map(function (item) {
      return {
        text: item.text,
        style: item.style,
        onClick: function onClick() {
          return handleConfirm(item.onClick);
        }
      };
    });
  }
  var renderActions = (actions || []).map(function (item) {
    var originClick = item.onClick;
    return __assign(__assign({}, item), {
      onClick: function onClick() {
        close();
        originClick && originClick();
      }
    });
  });
  ReactDOM.render(/*#__PURE__*/React.createElement(_Dialog["default"], {
    visible: true,
    actions: renderActions,
    title: title,
    maskClosable: maskClosable,
    transitionName: "".concat(_style.dtMobilePrefix, "-zoom"),
    onClose: function onClose() {
      close();
    },
    className: "".concat(prefixCls, "-propmt")
  }, !!content && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-propmt-content")
  }, content)), div);
  return {
    close: close
  };
};
var _default = exports["default"] = prompt;