import React from 'react';
import './style/index';
import { NativeProps } from '../_internal/native-props';
export declare enum NoticeBarType {
    INFO = "info",
    WARN = "warn",
    ERROR = "error"
}
export interface NoticeBarProps extends NativeProps {
    /**
     * @description 文案
     */
    text?: React.ReactNode;
    /**
     * @description 点击关闭或者操作区域的回调函数(建议使用onClose)
     */
    onClick?: () => void;
    /**
     * @description 点击关闭时的回调函数
     */
    onClose?: () => void;
    /**
     * @description 组件类型，主要描述颜色
     * @default "info"
     */
    type?: NoticeBarType | 'info' | 'warn' | 'error';
    /**
     * @description 通告栏模式
     */
    mode?: 'link' | 'closable';
    /**
     * @description 自定义 Icon
     */
    icon?: JSX.Element;
    /**
     * @description 右侧操作区，mode === 'closable'时失效
     */
    extra?: React.ReactNode;
}
declare const NoticeBar: React.FC<React.PropsWithChildren<NoticeBarProps>>;
export default NoticeBar;
