"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.NoticeBarType = void 0;
var _NoticeBar = _interopRequireDefault(require("../rmc/NoticeBar"));
var _classnames = _interopRequireDefault(require("classnames"));
var _react = _interopRequireWildcard(require("react"));
require("./style/index");
var _index2 = require("../style/index");
var _NoticeTipOutlined = _interopRequireDefault(require("dingtalk-design-icons/lib/NoticeTipOutlined"));
var _EliminateOutlined = _interopRequireDefault(require("dd-icons/lib/EliminateOutlined"));
var _WarningOutlined = _interopRequireDefault(require("dd-icons/lib/WarningOutlined"));
var _nativeProps = require("../_internal/native-props");
var _configProvider = require("../config-provider");
var _hooks = require("../hooks");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var NoticeBarType;
(function (NoticeBarType) {
  NoticeBarType["INFO"] = "info";
  NoticeBarType["WARN"] = "warn";
  NoticeBarType["ERROR"] = "error";
})(NoticeBarType || (exports.NoticeBarType = NoticeBarType = {}));
var NoticeBar = function NoticeBar(props) {
  var _a;
  var type = props.type,
    text = props.text,
    className = props.className,
    onClick = props.onClick,
    onClose = props.onClose,
    icon = props.icon,
    children = props.children,
    _props = __rest(props, ["type", "text", "className", "onClick", "onClose", "icon", "children"]);
  var isMobile = (0, _hooks.useMobile)();
  var wrapCls = (0, _classnames["default"])("".concat(_index2.dtMobileNoticeBarPrefix, "-").concat(type), className, (_a = {}, _a["".concat(_index2.dtMobileNoticeBarPrefix, "-desktop")] = !isMobile, _a["".concat(_index2.dtMobileNoticeBarPrefix, "-trigger")] = !!onClick, _a));
  var locale = (0, _configProvider.useConfig)().locale;
  var handleClick = (0, _react.useCallback)(function () {
    typeof onClose === 'function' && onClose() || typeof onClick === 'function' && onClick();
  }, [onClick, onClose]);
  var showIcon = /*#__PURE__*/_react["default"].createElement(_NoticeTipOutlined["default"], null);
  switch (type) {
    case NoticeBarType.ERROR:
      showIcon = /*#__PURE__*/_react["default"].createElement(_EliminateOutlined["default"], null);
      break;
    case NoticeBarType.WARN:
      showIcon = /*#__PURE__*/_react["default"].createElement(_WarningOutlined["default"], null);
      break;
  }
  if (icon) {
    showIcon = icon;
  }
  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement(_NoticeBar["default"], __assign({
    prefixCls: _index2.dtMobileNoticeBarPrefix,
    onClick: onClick,
    onClose: onClose,
    marqueeProps: {
      loop: false,
      leading: 0,
      trailing: 0,
      className: 'abc',
      style: {
        whiteSpace: 'pre-wrap',
        display: '-webkit-box',
        WebkitBoxOrient: 'vertical'
      }
    },
    icon: showIcon,
    className: wrapCls
  }, _props), text !== null && text !== void 0 ? text : locale.NoticeBar.text));
};
NoticeBar.displayName = 'NoticeBar';
var _default = exports["default"] = NoticeBar;