"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "PageContainerActionType", {
  enumerable: true,
  get: function get() {
    return _interface.PageContainerActionType;
  }
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
require("dingtalk-jsapi/entry/union");
var _setTitle = _interopRequireDefault(require("dingtalk-jsapi/api/biz/navigation/setTitle"));
var _setLeft = _interopRequireDefault(require("dingtalk-jsapi/api/biz/navigation/setLeft"));
var _setRight = _interopRequireDefault(require("dingtalk-jsapi/api/biz/navigation/setRight"));
var _setMenu = _interopRequireDefault(require("dingtalk-jsapi/api/biz/navigation/setMenu"));
var _quit = _interopRequireDefault(require("dingtalk-jsapi/api/biz/navigation/quit"));
var _close = _interopRequireDefault(require("dingtalk-jsapi/api/biz/navigation/close"));
var _LeftArrow2Outlined = _interopRequireDefault(require("dd-icons/lib/LeftArrow2Outlined"));
var _CloseOutlined = _interopRequireDefault(require("dd-icons/lib/CloseOutlined"));
var _env = require("../_internal/env");
var _hooks = require("../hooks");
var _button = _interopRequireDefault(require("../button"));
var _interface = require("./interface");
var _index = require("../style/index");
require("./style/index");
var _setSafeHeight = require("../_internal/set-safe-height");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var prefixCls = "".concat(_index.dtMobilePrefix, "-page-container");
var PageContainer = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var _a, _b;
  var children = props.children,
    className = props.className,
    _native = props["native"],
    title = props.title,
    _c = props.full,
    full = _c === void 0 ? true : _c,
    hasBack = props.hasBack,
    actions = props.actions,
    extra = props.extra,
    strongMainAction = props.strongMainAction,
    fullScreen = props.fullScreen,
    onBeforeBack = props.onBeforeBack,
    onBeforeClose = props.onBeforeClose,
    restProps = __rest(props, ["children", "className", "native", "title", "full", "hasBack", "actions", "extra", "strongMainAction", "fullScreen", "onBeforeBack", "onBeforeClose"]);
  var isMobile = (0, _hooks.useMobile)();
  var mainAction = (0, _react.useMemo)(function () {
    return (actions || []).find(function (item) {
      return item.type === _interface.PageContainerActionType.OK;
    });
  }, [actions]);
  var closeAction = (0, _react.useMemo)(function () {
    return (actions || []).find(function (item) {
      return item.type === _interface.PageContainerActionType.CANCEL;
    });
  }, [actions]);
  var otherAction = (0, _react.useMemo)(function () {
    return (actions || []).find(function (item) {
      return item.type === _interface.PageContainerActionType.DEFAULT || item.type === undefined;
    });
  }, [actions]);
  var normalActions = (0, _react.useMemo)(function () {
    return (actions || []).filter(function (item) {
      return !item.type;
    });
  }, [actions]);
  var back = (0, _react.useCallback)(function () {
    history.back();
  }, []);
  var close = (0, _react.useCallback)(function () {
    if (isMobile) {
      (0, _close["default"])({});
    } else {
      (0, _quit["default"])({});
    }
  }, []);
  (0, _react.useEffect)(function () {
    if (fullScreen) {
      (0, _setSafeHeight.setSafeHeight)();
    }
    if (isMobile) {
      if (_native && _env.isInDingTalk) {
        if (title) {
          (0, _setTitle["default"])({
            title: title
          });
        }
        if (hasBack) {
          (0, _setLeft["default"])({
            android: true,
            control: true,
            onSuccess: function onSuccess() {
              if (onBeforeBack) {
                onBeforeBack(back);
              } else {
                back();
              }
            }
          });
        }
        // 移动端右上角动作按钮
        if (mainAction && otherAction && !strongMainAction && typeof mainAction.text === 'string' && typeof otherAction.text === 'string') {
          (0, _setMenu["default"])({
            items: [{
              id: _interface.PageContainerActionType.DEFAULT,
              text: otherAction.text
            }, {
              id: _interface.PageContainerActionType.OK,
              text: mainAction.text
            }],
            onSuccess: function onSuccess(data) {
              var _a, _b;
              if (data.id === _interface.PageContainerActionType.DEFAULT) {
                (_a = otherAction.onClick) === null || _a === void 0 ? void 0 : _a.call(otherAction, close);
              } else if (data.id === _interface.PageContainerActionType.OK) {
                (_b = mainAction.onClick) === null || _b === void 0 ? void 0 : _b.call(mainAction, close);
              }
            }
          });
        } else if (mainAction && !strongMainAction && typeof mainAction.text === 'string') {
          (0, _setRight["default"])({
            show: true,
            control: 'onClick' in mainAction,
            text: mainAction.text,
            onSuccess: function onSuccess() {
              if (mainAction.onClick) {
                mainAction.onClick(close);
              }
            },
            // @ts-ignore
            style: '2'
          });
        } else {
          (0, _setRight["default"])({
            show: false
          });
        }
      }
    }
  }, [_native, title, onBeforeBack, mainAction, strongMainAction, fullScreen]);
  var Header = (0, _react.useMemo)(function () {
    if (_native && _env.isInDingTalk) {
      return null;
    }
    var Close = /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-icon-action"),
      onClick: function onClick() {
        if (onBeforeClose) {
          onBeforeClose(close);
        } else {
          close();
        }
      }
    }, /*#__PURE__*/_react["default"].createElement(_CloseOutlined["default"], null));
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-header")
    }, (hasBack || isMobile) && (/*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-header-left")
    }, hasBack ? (/*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-icon-action"),
      onClick: function onClick() {
        if (onBeforeBack) {
          onBeforeBack(back);
        } else {
          back();
        }
      }
    }, /*#__PURE__*/_react["default"].createElement(_LeftArrow2Outlined["default"], null))) : isMobile && Close)), /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-header-title")
    }, title), /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-header-right")
    }, (normalActions || []).map(function (item, index) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        key: index,
        className: "".concat(prefixCls, "-icon-action"),
        onClick: function onClick() {
          item.onClick && item.onClick(close);
        }
      }, item.icon);
    }), !!normalActions.length && !isMobile && (/*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-header-right-divider")
    })), isMobile ? mainAction && !strongMainAction && (/*#__PURE__*/_react["default"].createElement("div", {
      style: {
        marginRight: '16px'
      },
      onClick: function onClick() {
        mainAction.onClick && mainAction.onClick(close);
      }
    }, mainAction.text)) : Close));
  }, [_native, title, onBeforeClose, onBeforeBack, normalActions, mainAction, strongMainAction, close]);
  var Footer = (0, _react.useMemo)(function () {
    if (!extra) {
      if (isMobile) {
        if (!mainAction || !strongMainAction) {
          return null;
        }
      } else {
        if (!mainAction && !closeAction) {
          return null;
        }
      }
    }
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-footer")
    }, !!extra && /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-extra")
    }, extra), /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-footer-actions")
    }, !!otherAction && !closeAction && (/*#__PURE__*/_react["default"].createElement(_button["default"], {
      className: "".concat(prefixCls, "-footer-action"),
      disabled: otherAction.disabled,
      loading: otherAction.loading,
      icon: otherAction.icon,
      onClick: function onClick() {
        otherAction.onClick && otherAction.onClick(close);
      }
    }, otherAction.text)), !!closeAction && (/*#__PURE__*/_react["default"].createElement(_button["default"], {
      className: "".concat(prefixCls, "-footer-action"),
      disabled: closeAction.disabled,
      loading: closeAction.loading,
      icon: closeAction.icon,
      onClick: function onClick() {
        if (onBeforeClose) {
          onBeforeClose(close);
        } else {
          close();
        }
      }
    }, closeAction.text)), !!mainAction && (/*#__PURE__*/_react["default"].createElement(_button["default"], {
      className: "".concat(prefixCls, "-footer-action"),
      type: "primary",
      disabled: mainAction.disabled,
      loading: mainAction.loading,
      icon: mainAction.icon,
      onClick: function onClick() {
        mainAction.onClick && mainAction.onClick(close);
      }
    }, mainAction.text))));
  }, [strongMainAction, extra, onBeforeClose, mainAction, closeAction]);
  var sharedCls = (0, _classnames["default"])(prefixCls, (_a = {}, _a["".concat(prefixCls, "-pc")] = !isMobile, _a), className);
  if (Header || Footer) {
    return /*#__PURE__*/_react["default"].createElement("div", __assign({}, restProps, {
      className: (0, _classnames["default"])(sharedCls, (_b = {}, _b["".concat(prefixCls, "-full")] = full, _b)),
      ref: ref
    }), fullScreen && !_native && /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-safe-area-header")
    }), Header, /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-body")
    }, children), Footer);
  } else {
    return /*#__PURE__*/_react["default"].createElement("div", __assign({}, restProps, {
      className: (0, _classnames["default"])(sharedCls, "".concat(prefixCls, "-simple")),
      ref: ref
    }), children);
  }
});
PageContainer.displayName = 'PageContainer';
var _default = exports["default"] = PageContainer;