import React from 'react';
import { NativeProps } from '../_internal/native-props';
import './style/index';
export interface IPageIndicatorProps extends NativeProps<'--dot-color' | '--active-dot-color' | '--dot-width' | '--dot-height' | '--dot-border-radius' | '--active-dot-width' | '--active-dot-height' | '--active-dot-border-radius'> {
    /**
     * @description 总页数
     * @default '-''
     */
    total: number;
    /**
     * @description 当前页数
     * @default '-'
     */
    current: number;
    /**
     * @description 颜色主题
     * @default 'light'
     */
    color?: 'light' | 'dark';
    /**
     * @description 点击dot触发的index事件
     * @default '(index: number) => {}'
     */
    onClick?: (index: number) => void;
}
export declare const dtMobilePageIndicatorPrefix: string;
declare const PageIndicator: React.NamedExoticComponent<IPageIndicatorProps>;
export default PageIndicator;
