"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _popover = _interopRequireDefault(require("../popover"));
var _classnames = _interopRequireDefault(require("classnames"));
var _CloseOutlined = _interopRequireDefault(require("dingtalk-design-icons/lib/CloseOutlined"));
var _index = require("../style/index");
require("./style/index");
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var TextItem = /*#__PURE__*/_react["default"].memo(function (props) {
  var prefix = "".concat(_index.dtPopoverPrefix, "-text-item");
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(prefix)
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefix, "-text"))
  }, props.text), props.closable && /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefix, "-close")),
    onClick: props.onClose
  }, /*#__PURE__*/_react["default"].createElement(_CloseOutlined["default"], null)));
});
TextItem.defaultProps = {
  text: '',
  closable: true
};
TextItem.displayName = 'PopoverTextItem';
var ImgTextItem = /*#__PURE__*/_react["default"].memo(function (props) {
  var _a;
  var prefix = "".concat(_index.dtPopoverPrefix, "-img-text-item");
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(prefix)
  }, props.imgSrc && /*#__PURE__*/_react["default"].createElement("img", {
    className: (0, _classnames["default"])("".concat(prefix, "-img")),
    src: props.imgSrc
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefix, "-text-content"))
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefix, "-text-content-title"))
  }, props.title), props.desc && /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefix, "-text-content-desc"))
  }, props.desc)), props.closable && /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(prefix, "-close"), (_a = {}, _a["".concat(prefix, "-close-center")] = !props.desc || !props.title, _a)),
    onClick: props.onClose
  }, /*#__PURE__*/_react["default"].createElement(_CloseOutlined["default"], null)));
});
ImgTextItem.defaultProps = {
  title: '',
  closable: true
};
ImgTextItem.displayName = 'PopoverImgTextItem';
var Popguide = function Popguide(props) {
  var placement = props.placement,
    visible = props.visible,
    title = props.title,
    subTitle = props.subTitle,
    image = props.image,
    onClose = props.onClose,
    onVisibleChange = props.onVisibleChange,
    otherProps = __rest(props, ["placement", "visible", "title", "subTitle", "image", "onClose", "onVisibleChange"]);
  var overlay = null;
  var onInnerClose = _react["default"].useCallback(function () {
    if (onVisibleChange) {
      onVisibleChange(false);
    }
    if (onClose) {
      onClose();
    }
  }, [onClose, onVisibleChange]);
  if (image || subTitle) {
    overlay = /*#__PURE__*/_react["default"].createElement(ImgTextItem, {
      title: title,
      imgSrc: image,
      desc: subTitle,
      onClose: onInnerClose
    });
  } else {
    overlay = /*#__PURE__*/_react["default"].createElement(TextItem, {
      text: title,
      onClose: onInnerClose
    });
  }
  // @ts-ignore
  return /*#__PURE__*/_react["default"].createElement(_popover["default"], __assign({
    overlayClassName: "".concat(_index.dtPopguidePrefix, "-popover"),
    dark: true,
    placement: placement,
    visible: visible,
    overlay: overlay,
    onVisibleChange: onVisibleChange
  }, otherProps));
};
Popguide.displayName = 'Popguide';
var _default = exports["default"] = Popguide;