"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Popup = void 0;
var _classnames = _interopRequireDefault(require("classnames"));
var _react = _interopRequireWildcard(require("react"));
var _ahooks = require("ahooks");
var _nativeProps = require("../_internal/native-props");
var _withDefaultProps = require("../_internal/with-default-props");
var _mask = _interopRequireDefault(require("../mask"));
var _useLockScroll = require("../_internal/use-lock-scroll");
var _renderToContainer = require("../_internal/render-to-container");
var _ddReactSpringWeb = require("dd-react-spring-web");
var _withStopPropagation = require("../_internal/with-stop-propagation");
var _shouldRender = require("../_internal/should-render");
var _CloseOutlined = _interopRequireDefault(require("dd-icons/lib/CloseOutlined"));
var _popupBaseProps = require("./popup-base-props");
var _useInnerVisible = require("../_internal/use-inner-visible");
var _configProvider = require("../config-provider");
var _ddUseGestureReact = require("dd-use-gesture-react");
var _style = require("../style");
var _convertToPx = require("../_internal/convertToPx");
var _hooks = require("../hooks");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var classPrefix = "".concat(_style.dtMobilePrefix, "-popup");
var defaultProps = __assign(__assign({}, _popupBaseProps.defaultPopupBaseProps), {
  position: 'bottom'
});
var Popup = exports.Popup = function Popup(p) {
  var _a, _b;
  var props = (0, _withDefaultProps.mergeProps)(defaultProps, p);
  var locale = (0, _configProvider.useConfig)().locale;
  var isMobile = (0, _hooks.useMobile)();
  var bodyCls = (0, _classnames["default"])("".concat(classPrefix, "-body"), props.bodyClassName, "".concat(classPrefix, "-body-position-").concat(props.position));
  var _c = __read((0, _react.useState)(props.visible), 2),
    active = _c[0],
    setActive = _c[1];
  (0, _ahooks.useIsomorphicLayoutEffect)(function () {
    if (props.visible) {
      setActive(true);
    }
  }, [props.visible]);
  var ref = (0, _react.useRef)(null);
  var _d = __read(_react["default"].useState((0, _convertToPx.convertToPx)((_a = props.bodyStyle) === null || _a === void 0 ? void 0 : _a.width, true, ref.current)), 2),
    width = _d[0],
    setWidth = _d[1];
  (0, _useLockScroll.useLockScroll)(ref, props.disableBodyScroll && active ? 'strict' : false);
  // const springProps = useSpring({ width, immediate: (key) => key === 'width' });
  var unmountedRef = (0, _ahooks.useUnmountedRef)();
  var percent = (0, _ddReactSpringWeb.useSpring)({
    percent: props.visible ? 0 : 100,
    config: {
      precision: 0.1,
      mass: 1,
      tension: 300,
      friction: 30
    },
    onRest: function onRest() {
      var _a, _b;
      if (unmountedRef.current) return;
      setActive(props.visible);
      if (props.visible) {
        (_a = props.afterShow) === null || _a === void 0 ? void 0 : _a.call(props);
      } else {
        (_b = props.afterClose) === null || _b === void 0 ? void 0 : _b.call(props);
      }
    }
  }).percent;
  var bind = (0, _ddUseGestureReact.useDrag)(function (_a) {
    var _b;
    var _c = __read(_a.swipe, 2),
      swipeY = _c[1];
    if (swipeY === 1 && props.position === 'bottom' || swipeY === -1 && props.position === 'top') {
      (_b = props.onClose) === null || _b === void 0 ? void 0 : _b.call(props);
    }
  }, {
    axis: 'y',
    enabled: ['top', 'bottom'].includes(props.position)
  });
  var maskVisible = (0, _useInnerVisible.useInnerVisible)(active && props.visible);
  _react["default"].useEffect(function () {
    if (!props.canDrag || !ref.current) {
      return;
    }
    var resizeHandle = document.getElementById('resize-handle');
    var isResizing = false;
    function mouseDownHandler(e) {
      var _a;
      isResizing = true;
      var prevX = e.clientX;
      (_a = window.getSelection()) === null || _a === void 0 ? void 0 : _a.removeAllRanges(); // 取消复制的部分
      var mouseMoveHandler = function mouseMoveHandler(e) {
        var _a, _b, _c;
        (_a = window.getSelection()) === null || _a === void 0 ? void 0 : _a.removeAllRanges(); // 取消复制的部分
        if (!isResizing) return;
        if (!ref.current) return;
        var rect = ref.current.getBoundingClientRect();
        var newWidth = Math.min(Math.max(rect.width, props.minWidth), (_b = props.maxWidth) !== null && _b !== void 0 ? _b : document.body.clientWidth);
        var width = newWidth + (prevX - e.clientX);
        ref.current.style.width = width + 'px';
        (_c = props.onWidthChange) === null || _c === void 0 ? void 0 : _c.call(props, width);
        prevX = e.clientX;
      };
      function mouseUpHandler() {
        window.removeEventListener('mousemove', mouseMoveHandler);
        window.removeEventListener('mouseup', mouseUpHandler);
        isResizing = false;
      }
      window.addEventListener('mousemove', mouseMoveHandler);
      window.addEventListener('mouseup', mouseUpHandler);
    }
    resizeHandle === null || resizeHandle === void 0 ? void 0 : resizeHandle.addEventListener('mousedown', mouseDownHandler);
    return function () {
      resizeHandle === null || resizeHandle === void 0 ? void 0 : resizeHandle.removeEventListener('mousedown', mouseDownHandler);
    };
  }, [ref.current, props.canDrag, props.minWidth, props.maxWidth, props.onWidthChange]);
  _react["default"].useEffect(function () {
    var _a;
    setWidth((0, _convertToPx.convertToPx)((_a = props.bodyStyle) === null || _a === void 0 ? void 0 : _a.width, true, ref.current));
  }, [(_b = props.bodyStyle) === null || _b === void 0 ? void 0 : _b.width, ref.current]);
  var node = (0, _withStopPropagation.withStopPropagation)(props.stopPropagation, (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", __assign({
    className: classPrefix,
    onClick: props.onClick,
    style: {
      visibility: active ? 'visible' : 'hidden',
      touchAction: ['top', 'bottom'].includes(props.position) ? 'none' : 'auto'
    }
  }, bind()), props.mask && (/*#__PURE__*/_react["default"].createElement(_mask["default"], {
    visible: maskVisible,
    forceRender: props.forceRender,
    destroyOnClose: props.destroyOnClose,
    onMaskClick: function onMaskClick(e) {
      var _a, _b;
      (_a = props.onMaskClick) === null || _a === void 0 ? void 0 : _a.call(props, e);
      if (props.closeOnMaskClick) {
        (_b = props.onClose) === null || _b === void 0 ? void 0 : _b.call(props);
      }
    },
    className: props.maskClassName,
    opacity: props.maskTransparent ? 0 : undefined,
    style: props.maskStyle,
    disableBodyScroll: false,
    stopPropagation: props.stopPropagation
  })), /*#__PURE__*/_react["default"].createElement(_ddReactSpringWeb.animated.div, {
    className: bodyCls,
    style: __assign(__assign({}, props.bodyStyle), {
      width: width,
      minWidth: !isMobile ? props.minWidth : undefined,
      maxWidth: !isMobile ? props.maxWidth : undefined,
      userSelect: 'none',
      transform: percent.to(function (v) {
        if (props.position === 'bottom') {
          return "translate(0, ".concat(v, "%)");
        }
        if (props.position === 'top') {
          return "translate(0, -".concat(v, "%)");
        }
        if (props.position === 'left') {
          return "translate(-".concat(v, "%, 0)");
        }
        if (props.position === 'right') {
          return "translate(".concat(v, "%, 0)");
        }
        return 'none';
      })
    }),
    ref: ref
  }, props.showCloseButton && (/*#__PURE__*/_react["default"].createElement("a", {
    className: (0, _classnames["default"])("".concat(classPrefix, "-close-icon"), 'adm-plain-anchor'),
    onClick: function onClick() {
      var _a;
      (_a = props.onClose) === null || _a === void 0 ? void 0 : _a.call(props);
    },
    role: "button"
  }, /*#__PURE__*/_react["default"].createElement(_CloseOutlined["default"], null))), props.canDrag && /*#__PURE__*/_react["default"].createElement("div", {
    id: "resize-handle",
    className: "".concat(classPrefix, "-resize-handle")
  }), props.children))));
  return /*#__PURE__*/_react["default"].createElement(_shouldRender.ShouldRender, {
    active: active,
    forceRender: props.forceRender,
    destroyOnClose: props.destroyOnClose
  }, (0, _renderToContainer.renderToContainer)(props.getContainer, node));
};