"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ProgressCircle = void 0;
var _react = _interopRequireDefault(require("react"));
require("./style/index");
var _index2 = require("./index");
var _CheckOutlined = _interopRequireDefault(require("dd-icons/lib/CheckOutlined"));
var _WarnFilled = _interopRequireDefault(require("dd-icons/lib/WarnFilled"));
var _classnames = _interopRequireDefault(require("classnames"));
var _nativeProps = require("../_internal/native-props");
var _hooks = require("../hooks");
var ProgressCircle = exports.ProgressCircle = /*#__PURE__*/_react["default"].memo(function (p) {
  var _a;
  var percent = p.percent,
    status = p.status,
    circleSize = p.circleSize;
  var isMobile = (0, _hooks.useMobile)();
  var Tag = _react["default"].useMemo(function () {
    var _a, _b, _c;
    switch (status) {
      case _index2.ProgressStatus.loading:
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])("".concat(_index2.dtProgressBarPrefix, "-circle-tag ").concat(_index2.dtProgressBarPrefix, "-circle-tag-loading"), (_a = {}, _a["".concat(_index2.dtProgressBarPrefix, "-circle-tag-desktop")] = !isMobile, _a))
        }, percent, "%");
      case _index2.ProgressStatus.error:
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])("".concat(_index2.dtProgressBarPrefix, "-circle-tag ").concat(_index2.dtProgressBarPrefix, "-circle-tag-error"), (_b = {}, _b["".concat(_index2.dtProgressBarPrefix, "-circle-tag-desktop")] = !isMobile, _b))
        }, /*#__PURE__*/_react["default"].createElement(_WarnFilled["default"], null));
      case _index2.ProgressStatus.success:
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])("".concat(_index2.dtProgressBarPrefix, "-circle-tag ").concat(_index2.dtProgressBarPrefix, "-circle-tag-success"), (_c = {}, _c["".concat(_index2.dtProgressBarPrefix, "-circle-tag-desktop")] = !isMobile, _c))
        }, /*#__PURE__*/_react["default"].createElement(_CheckOutlined["default"], null));
      default:
        return null;
    }
  }, [status, percent]);
  var style = {
    '--percent': (_a = percent === null || percent === void 0 ? void 0 : percent.toString()) !== null && _a !== void 0 ? _a : '0'
  };
  return (0, _nativeProps.withNativeProps)(p, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(_index2.dtProgressBarPrefix, "-circle"), "".concat(_index2.dtProgressBarPrefix, "-circle-").concat(circleSize)),
    style: style
  }, /*#__PURE__*/_react["default"].createElement("svg", {
    className: (0, _classnames["default"])("".concat(_index2.dtProgressBarPrefix, "-circle-svg"))
  }, /*#__PURE__*/_react["default"].createElement("circle", {
    className: "".concat(_index2.dtProgressBarPrefix, "-circle-track")
  }), /*#__PURE__*/_react["default"].createElement("circle", {
    className: (0, _classnames["default"])("".concat(_index2.dtProgressBarPrefix, "-circle-fill"), "".concat(_index2.dtProgressBarPrefix, "-circle-").concat(status))
  })), Tag));
});