"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dtProgressBarPrefix = exports["default"] = exports.ProgressStatus = void 0;
var _react = _interopRequireDefault(require("react"));
require("./style/index");
var _index2 = require("../style/index");
var _classnames = _interopRequireDefault(require("classnames"));
var _nativeProps = require("../_internal/native-props");
var _withDefaultProps = require("../_internal/with-default-props");
var _ProgressLine = require("./ProgressLine");
var _ProgressCircle = require("./ProgressCircle");
var dtProgressBarPrefix = exports.dtProgressBarPrefix = "".concat(_index2.dtMobilePrefix, "-progress-bar");
var ProgressStatus;
(function (ProgressStatus) {
  ProgressStatus["loading"] = "loading";
  ProgressStatus["error"] = "error";
  ProgressStatus["success"] = "success";
})(ProgressStatus || (exports.ProgressStatus = ProgressStatus = {}));
var defaultProps = {
  percent: 0,
  type: 'line',
  status: 'loading',
  circleSize: 'normal'
};
var ProgressBar = /*#__PURE__*/_react["default"].memo(function (p) {
  var props = (0, _withDefaultProps.mergeProps)(defaultProps, p);
  var className = props.className,
    percent = props.percent,
    type = props.type,
    status = props.status,
    circleSize = props.circleSize;
  var wrapCls = (0, _classnames["default"])(dtProgressBarPrefix, className);
  var newStatus = ProgressStatus.loading;
  if (percent && percent >= 100) {
    newStatus = ProgressStatus.success;
  } else if (status === 'error') {
    newStatus = ProgressStatus.error;
  }
  var limitPercent = _react["default"].useMemo(function () {
    if (percent) {
      return percent <= 100 ? percent : 100;
    } else {
      return 0;
    }
  }, [percent]);
  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", {
    className: wrapCls
  }, type === 'line' ? /*#__PURE__*/_react["default"].createElement(_ProgressLine.ProgressLine, {
    percent: limitPercent,
    status: newStatus
  }) : /*#__PURE__*/_react["default"].createElement(_ProgressCircle.ProgressCircle, {
    percent: limitPercent,
    status: newStatus,
    circleSize: circleSize
  })));
});
ProgressBar.displayName = 'ProgressBar';
var _default = exports["default"] = ProgressBar;