"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultProps = exports["default"] = exports.PullStatusEnum = void 0;
var _react = _interopRequireWildcard(require("react"));
var _withDefaultProps = require("../_internal/with-default-props");
var _ddReactSpringWeb = require("dd-react-spring-web");
var _ddUseGestureReact = require("dd-use-gesture-react");
var _getScrollParent = require("../_internal/get-scroll-parent");
var _supportsPassive = require("../_internal/supports-passive");
var _rubberband = require("../_internal/rubberband");
var _sleep = require("../_internal/sleep");
var _vibrate = _interopRequireDefault(require("dingtalk-jsapi/api/device/notification/vibrate"));
var _internal = require("../_internal");
var _style = require("../style");
var _SucceedOutlined = _interopRequireDefault(require("dd-icons/lib/SucceedOutlined"));
require("regenerator-runtime/runtime.js");
var _spin = _interopRequireDefault(require("../spin"));
require("./style/index");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var __generator = void 0 && (void 0).__generator || function (thisArg, body) {
  var _ = {
      label: 0,
      sent: function sent() {
        if (t[0] & 1) throw t[1];
        return t[1];
      },
      trys: [],
      ops: []
    },
    f,
    y,
    t,
    g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;
  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");
    while (g && (g = 0, op[0] && (_ = 0)), _) try {
      if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
      if (y = 0, t) op = [op[0] & 2, t.value];
      switch (op[0]) {
        case 0:
        case 1:
          t = op;
          break;
        case 4:
          _.label++;
          return {
            value: op[1],
            done: false
          };
        case 5:
          _.label++;
          y = op[1];
          op = [0];
          continue;
        case 7:
          op = _.ops.pop();
          _.trys.pop();
          continue;
        default:
          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
            _ = 0;
            continue;
          }
          if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
            _.label = op[1];
            break;
          }
          if (op[0] === 6 && _.label < t[1]) {
            _.label = t[1];
            t = op;
            break;
          }
          if (t && _.label < t[2]) {
            _.label = t[2];
            _.ops.push(op);
            break;
          }
          if (t[2]) _.ops.pop();
          _.trys.pop();
          continue;
      }
      op = body.call(thisArg, _);
    } catch (e) {
      op = [6, e];
      y = 0;
    } finally {
      f = t = 0;
    }
    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var classPrefix = "".concat(_style.dtMobilePrefix, "-pull-to-refresh");
var PullStatusEnum;
(function (PullStatusEnum) {
  PullStatusEnum["Init"] = "init";
  PullStatusEnum["Pulling"] = "pulling";
  PullStatusEnum["CanRelease"] = "canRelease";
  PullStatusEnum["Refreshing"] = "refreshing";
  PullStatusEnum["Complete"] = "Complete";
})(PullStatusEnum || (exports.PullStatusEnum = PullStatusEnum = {}));
var defaultProps = exports.defaultProps = {
  completeDelay: 500,
  disabled: false,
  onRefresh: function onRefresh() {}
};
function getScrollTop(element) {
  return 'scrollTop' in element ? element.scrollTop : element.scrollY;
}
var PullToRefresh = function PullToRefresh(p) {
  var _a;
  var props = (0, _withDefaultProps.mergeProps)(defaultProps, {
    refreshingText: '',
    pullingText: '',
    canReleaseText: '',
    completeText: ''
  }, p);
  var headHeight = (_a = props.headHeight) !== null && _a !== void 0 ? _a : 40;
  var threshold = 58;
  var _b = __read((0, _react.useState)(PullStatusEnum.Init), 2),
    status = _b[0],
    setStatus = _b[1];
  var _c = __read((0, _ddReactSpringWeb.useSpring)(function () {
      return {
        from: {
          height: 0
        },
        config: {
          tension: 300,
          friction: 30,
          clamp: true
        }
      };
    }), 2),
    springStyles = _c[0],
    api = _c[1];
  var elementRef = (0, _react.useRef)(null);
  var pullingRef = (0, _react.useRef)(false);
  var disableContainerTouchMove = _react["default"].useCallback(function (event) {
    if (status === PullStatusEnum.Refreshing) {
      event.preventDefault();
      event.stopPropagation();
    }
  }, [status]);
  //防止下拉时抖动
  (0, _react.useEffect)(function () {
    var _a;
    //@ts-ignore
    (_a = elementRef.current) === null || _a === void 0 ? void 0 : _a.addEventListener('touchmove', disableContainerTouchMove);
    return function () {
      var _a;
      //@ts-ignore
      (_a = elementRef.current) === null || _a === void 0 ? void 0 : _a.removeEventListener('touchmove', disableContainerTouchMove);
    };
  }, [disableContainerTouchMove]);
  (0, _react.useEffect)(function () {
    var _a;
    (_a = props.onStatusChange) === null || _a === void 0 ? void 0 : _a.call(props, status);
  }, [status, props.onStatusChange]);
  function doRefresh() {
    return __awaiter(this, void 0, void 0, function () {
      var e_1;
      var _this = this;
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            api.start({
              height: headHeight
            });
            setStatus(PullStatusEnum.Refreshing);
            _a.label = 1;
          case 1:
            _a.trys.push([1, 3,, 4]);
            return [4 /*yield*/, props.onRefresh()];
          case 2:
            _a.sent();
            setStatus(PullStatusEnum.Complete);
            return [3 /*break*/, 4];
          case 3:
            e_1 = _a.sent();
            api.start({
              to: function to(next) {
                return __awaiter(_this, void 0, void 0, function () {
                  return __generator(this, function (_a) {
                    switch (_a.label) {
                      case 0:
                        return [4 /*yield*/, next({
                          height: 0
                        })];
                      case 1:
                        _a.sent();
                        setStatus(PullStatusEnum.Init);
                        return [2 /*return*/];
                    }
                  });
                });
              }
            });
            throw e_1;
          case 4:
            if (!(props.completeDelay > 0)) return [3 /*break*/, 6];
            return [4 /*yield*/, (0, _sleep.sleep)(props.completeDelay)];
          case 5:
            _a.sent();
            _a.label = 6;
          case 6:
            api.start({
              to: function to(next) {
                return __awaiter(_this, void 0, void 0, function () {
                  return __generator(this, function (_a) {
                    switch (_a.label) {
                      case 0:
                        return [4 /*yield*/, next({
                          height: 0
                        })];
                      case 1:
                        _a.sent();
                        setStatus(PullStatusEnum.Init);
                        return [2 /*return*/];
                    }
                  });
                });
              }
            });
            return [2 /*return*/];
        }
      });
    });
  }
  (0, _react.useEffect)(function () {
    if (!_internal.isInDingTalk) return;
    if (status === PullStatusEnum.CanRelease) {
      (0, _vibrate["default"])({
        duration: 100,
        // @ts-ignore
        type: 'short'
      });
    }
  }, [status]);
  var disabled = _react["default"].useMemo(function () {
    if (typeof props.disabled === 'function') {
      return props.disabled();
    }
    return props.disabled;
  }, [props.disabled]);
  (0, _ddUseGestureReact.useDrag)(function (state) {
    if (status === PullStatusEnum.Refreshing || status === PullStatusEnum.Complete) return;
    var event = state.event;
    //@ts-ignore
    if (state.last) {
      pullingRef.current = false;
      if (status === PullStatusEnum.CanRelease) {
        doRefresh();
      } else {
        api.start({
          height: 0
        });
        setStatus(PullStatusEnum.Init);
      }
      return;
    }
    //@ts-ignore
    var _a = __read(state.movement, 2),
      y = _a[1];
    //@ts-ignore
    if (state.first && y > 0) {
      var target = state.event.target;
      if (!target || !(target instanceof Element)) return;
      var scrollParent = (0, _getScrollParent.getScrollParent)(target);
      while (true) {
        if (!scrollParent) return;
        var scrollTop = getScrollTop(scrollParent);
        if (scrollTop > 0) {
          return;
        }
        if (scrollParent instanceof Window) {
          break;
        }
        scrollParent = (0, _getScrollParent.getScrollParent)(scrollParent.parentNode);
      }
      pullingRef.current = true;
    }
    if (!pullingRef.current) return;
    if (event.cancelable) {
      event.preventDefault();
    }
    event.stopPropagation();
    var height = Math.max((0, _rubberband.rubberbandIfOutOfBounds)(y, 0, 0, headHeight * 5, 0.5), 0);
    api.start({
      height: height
    });
    setStatus(height > threshold ? PullStatusEnum.CanRelease : PullStatusEnum.Pulling);
  }, {
    pointer: {
      touch: true
    },
    axis: 'y',
    target: elementRef,
    enabled: !disabled,
    eventOptions: _supportsPassive.supportsPassive ? {
      passive: false
    } : false
  });
  var renderStatusText = function renderStatusText() {
    var _a;
    if (props.renderText) {
      return (_a = props.renderText) === null || _a === void 0 ? void 0 : _a.call(props, status);
    }
    var renderText = function renderText(status, text, played) {
      if (played === void 0) {
        played = true;
      }
      if (typeof text === 'string') {
        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, status === PullStatusEnum.Complete ? (/*#__PURE__*/_react["default"].createElement(_SucceedOutlined["default"], {
          className: "".concat(classPrefix, "-icon"),
          style: {
            fontSize: '16px'
          }
        })) : (/*#__PURE__*/_react["default"].createElement(_spin["default"], {
          className: "".concat(classPrefix, "-icon"),
          style: {
            '--spin-size': '24px'
          },
          played: played
        })), text);
      }
      return text;
    };
    if (status === PullStatusEnum.Pulling) return renderText(status, props.pullingText, false);
    if (status === PullStatusEnum.CanRelease) return renderText(status, props.canReleaseText, false);
    if (status === PullStatusEnum.Refreshing) return renderText(status, props.refreshingText);
    if (status === PullStatusEnum.Complete) return renderText(status, props.completeText);
  };
  return /*#__PURE__*/_react["default"].createElement(_ddReactSpringWeb.animated.div, {
    ref: elementRef,
    className: classPrefix
  }, /*#__PURE__*/_react["default"].createElement(_ddReactSpringWeb.animated.div, {
    style: springStyles,
    className: "".concat(classPrefix, "-head")
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(classPrefix, "-head-content"),
    style: {
      height: headHeight
    }
  }, renderStatusText())), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(classPrefix, "-content")
  }, props.children));
};
PullToRefresh.displayName = 'PullToRefresh';
var _default = exports["default"] = PullToRefresh;