"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _rmc = require("../rmc");
var _hooks = require("../hooks");
var _list = _interopRequireDefault(require("../list"));
var _index2 = require("../style/index");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var Group = function Group(props) {
  var className = props.className,
    name = props.name,
    disabled = props.disabled,
    children = props.children,
    renderHeader = props.renderHeader,
    renderFooter = props.renderFooter;
  var _a = (0, _hooks.useControlledByValue)(props),
    value = _a.value,
    onChange = _a.onChange;
  var cls = (0, _classnames["default"])(_index2.dtMobileRadioGroupPrefix, className);
  return /*#__PURE__*/React.createElement(_list["default"], {
    renderHeader: renderHeader,
    renderFooter: renderFooter,
    className: cls
  }, React.Children.map(children, function (child, _index) {
    // 如果 child 不是 React.Element 直接报错
    return /*#__PURE__*/React.cloneElement(child, __assign({
      name: name,
      onChange: onChange,
      checkedValue: value
    }, !!disabled ? {
      disabled: disabled
    } : {}));
  }));
};
Group.displayName = 'RadioGroup';
Group.defaultProps = {
  defaultValue: ''
};
var _default = exports["default"] = (0, _rmc.withError)(Group);