"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Item = void 0;
var React = _interopRequireWildcard(require("react"));
var _Radio = _interopRequireDefault(require("./Radio"));
var _internal = require("../_internal");
var _hooks = require("../hooks");
var _list = _interopRequireDefault(require("../list"));
var _index = require("../style/index");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var prefixCls = _index.dtMobileRadioPrefix;
var Item = exports.Item = function Item(props) {
  // 以下属性从 group cloneElement 传递而来
  // @ts-ignore
  var name = props.name,
    _onChange = props.onChange,
    checkedValue = props.checkedValue,
    brief = props.brief;
  var checked = checkedValue === props.value;
  var isMobile = (0, _hooks.useMobile)();
  return /*#__PURE__*/React.createElement("label", __assign({
    className: prefixCls
  }, (0, _internal.getDataAttr)(props)), isMobile ? (/*#__PURE__*/React.createElement(_list["default"].Item, {
    disabled: props.disabled,
    hideDivider: props.hideDivider,
    extra: /*#__PURE__*/React.createElement(_Radio["default"], {
      value: props.value,
      disabled: props.disabled,
      name: name,
      id: props.id,
      onChange: function onChange(bingo) {
        return _onChange(props.value, bingo);
      },
      checked: checked
    }),
    brief: brief
  }, props.children)) : (/*#__PURE__*/React.createElement(_list["default"].Item, {
    className: "dtd-radio-item",
    disabled: props.disabled,
    hideDivider: props.hideDivider,
    brief: brief,
    thumb: /*#__PURE__*/React.createElement(_Radio["default"], {
      value: props.value,
      disabled: props.disabled,
      name: name,
      id: props.id,
      onChange: function onChange(bingo) {
        return _onChange(props.value, bingo);
      },
      checked: checked
    })
  }, props.children)));
};
Item.displayName = 'RadioItem';
var _default = exports["default"] = Item;