"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Radio = void 0;
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _SelectedOutlined = _interopRequireDefault(require("dingtalk-design-icons/lib/SelectedOutlined"));
var _rmc = require("../rmc");
var _hooks = require("../hooks");
var _style = require("../style");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var Radio = exports.Radio = function Radio(props) {
  var _a = (0, _hooks.useControlledByChecked)(props),
    checked = _a.checked,
    onChange = _a.onChange;
  var isMobile = (0, _hooks.useMobile)();
  var handleLableChange = (0, _react.useCallback)(function (e) {
    var v = e.target.checked;
    onChange(v);
  }, [onChange]);
  var radioIcon = null;
  if (isMobile) {
    radioIcon = checked && /*#__PURE__*/_react["default"].createElement(_SelectedOutlined["default"], {
      className: "".concat(_style.dtMobileRadioPrefix, "-checked-icon")
    });
  } else {
    radioIcon = /*#__PURE__*/_react["default"].createElement("span", {
      className: (0, _classnames["default"])('dtd-radio-inner', {
        'dtd-radio-inner-checked': checked,
        'dtd-radio-inner-disabled': props.disabled
      })
    });
  }
  return /*#__PURE__*/_react["default"].createElement(_rmc.Labelable, __assign({
    onChange: handleLableChange
  }, _rmc.Labelable.getProps(props), {
    checked: checked,
    value: props.value,
    type: "radio"
  }), radioIcon);
};
Radio.defaultProps = {
  defaultChecked: false
};
var _default = exports["default"] = Radio;