"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Rate = void 0;
var _react = _interopRequireDefault(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _nativeProps = require("../_internal/native-props");
var _StarFilled = _interopRequireDefault(require("dd-icons/lib/StarFilled"));
var _hooks = require("../hooks");
var _toast = _interopRequireDefault(require("../toast"));
var classPrefix = "dtm-rate";
var Rate = exports.Rate = function Rate(props) {
  var _a;
  var _b;
  var _c = (0, _hooks.useControlledByValue)(props),
    value = _c.value,
    onChange = _c.onChange;
  var starList = Array(props.count).fill(null);
  function renderStar(v, half) {
    var _a;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: (0, _classnames["default"])("".concat(classPrefix, "-star"), (_a = {}, _a["".concat(classPrefix, "-star-active")] = value >= v, _a["".concat(classPrefix, "-star-half")] = half, _a["".concat(classPrefix, "-star-readonly")] = props.readOnly, _a)),
      onClick: function onClick() {
        if (props.readOnly) {
          if (props.warningDesc) {
            _toast["default"].fail({
              content: props.warningDesc
            });
          }
          return;
        }
        ;
        if (props.allowClear && value === v) {
          onChange(0);
        } else {
          onChange(v);
        }
      }
    }, props.character);
  }
  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", {
    className: classPrefix
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(classPrefix, "-star-container")
  }, starList.map(function (_, i) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: i,
      className: (0, _classnames["default"])("".concat(classPrefix, "-box"))
    }, props.allowHalf && renderStar(i + 0.5, true), renderStar(i + 1, false));
  })), props.showLabel && ((_b = props.labels) === null || _b === void 0 ? void 0 : _b[value]) && (/*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(classPrefix, "-label"), (_a = {}, _a["".concat(classPrefix, "-label-nostar")] = value === 0, _a))
  }, props.labels[value]))));
};
Rate.defaultProps = {
  count: 5,
  allowHalf: false,
  character: /*#__PURE__*/_react["default"].createElement(_StarFilled["default"], null),
  defaultValue: 0,
  readOnly: false,
  allowClear: true,
  labels: ['你的反馈很重要', '非常不满意，我要吐槽', '不满意，我要吐槽', '一般般，还需要改善', '比较满意，仍待提升', '太棒了，我想夸一夸']
};
Rate.displayName = 'Rate';