"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var React = _interopRequireWildcard(require("react"));
var _reactDom = require("react-dom");
var _rmcDialog = _interopRequireDefault(require("rmc-dialog"));
var _classnames = _interopRequireDefault(require("classnames"));
var _hooks = require("../../hooks");
require("./index.css");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var Dialog = function Dialog(props) {
  var prefixCls = 'amd-dialog';
  var dom = (0, _hooks.useContainer)('dialog', props.visible);
  (0, _hooks.useBodyScrollLock)(props.visible);
  var cls = (0, _classnames["default"])(props.className, "".concat(prefixCls, "-").concat(props.position));
  var transitionNameMap = {
    center: 'amd-zoom',
    top: 'amd-slide-down',
    bottom: 'amd-slide-up',
    left: 'amd-slide-right',
    right: 'amd-slide-left'
  };
  // 这里不需要 fade-out/zoom-out 的动效，直接关掉
  if (!props.visible) {
    return null;
  }
  return /*#__PURE__*/(0, _reactDom.createPortal)(
  /*#__PURE__*/
  // @ts-ignore
  React.createElement(_rmcDialog["default"], {
    visible: props.visible,
    title: "",
    className: cls,
    prefixCls: prefixCls,
    transitionName: transitionNameMap[props.position],
    maskTransitionName: "amd-fade",
    maskClosable: props.maskClosable,
    onClose: props.onClose,
    footer: props.footer,
    closable: false
  }, props.children), dom);
};
Dialog.defaultProps = {
  position: 'center'
};
var _default = exports["default"] = Dialog;