"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.withError = withError;
var React = _interopRequireWildcard(require("react"));
var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __extends = void 0 && (void 0).__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};

// @ts-ignore

var ErrorBoundary = /** @class */function (_super) {
  __extends(ErrorBoundary, _super);
  function ErrorBoundary() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  ErrorBoundary.prototype.componentDidCatch = function (error) {
    var _a, _b;
    (_b = (_a = this.props).onError) === null || _b === void 0 ? void 0 : _b.call(_a, error);
  };
  ErrorBoundary.prototype.render = function () {
    return this.props.children;
  };
  return ErrorBoundary;
}(React.Component);
function withError(BaseComponent, options) {
  var C = function C(props, ref) {
    var handleError = React.useCallback(function (error) {
      // 这个错误再抛给上层，免得外层捕获不到错误了
      throw error;
    }, []);
    var forwardRefProps = (options === null || options === void 0 ? void 0 : options.forwardRef) ? {
      forwardRef: ref
    } : {};
    return /*#__PURE__*/React.createElement(ErrorBoundary, {
      onError: handleError
    }, /*#__PURE__*/React.createElement(BaseComponent, __assign({}, props, forwardRefProps)));
  };
  var memoComponent;
  if (options === null || options === void 0 ? void 0 : options.forwardRef) {
    memoComponent = /*#__PURE__*/React.memo(/*#__PURE__*/React.forwardRef(C));
  } else {
    memoComponent = /*#__PURE__*/React.memo(C);
  }
  (0, _hoistNonReactStatics["default"])(memoComponent, BaseComponent);
  memoComponent.displayName = BaseComponent.displayName;
  return memoComponent;
}
var _default = exports["default"] = ErrorBoundary;