"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classnames = _interopRequireDefault(require("classnames"));
var React = _interopRequireWildcard(require("react"));
var _Marquee = _interopRequireDefault(require("./Marquee"));
var _NoticeTipOutlined = _interopRequireDefault(require("dingtalk-design-icons/lib/NoticeTipOutlined"));
var _CloseOutlined = _interopRequireDefault(require("dingtalk-design-icons/lib/CloseOutlined"));
var _internal = require("../../_internal");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __extends = void 0 && (void 0).__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var NoticeBar = /** @class */function (_super) {
  __extends(NoticeBar, _super);
  function NoticeBar(props) {
    var _this = _super.call(this, props) || this;
    _this.onClick = function (event) {
      var _a = _this.props,
        mode = _a.mode,
        onClick = _a.onClick;
      if (onClick) {
        onClick();
        event.stopPropagation();
      }
    };
    _this.onClose = function (event) {
      var _a, _b;
      var mode = _this.props.mode;
      if (mode === 'closable') {
        _this.setState({
          show: false
        });
      }
      (_b = (_a = _this.props).onClose) === null || _b === void 0 ? void 0 : _b.call(_a);
      event.stopPropagation();
    };
    _this.state = {
      show: true
    };
    return _this;
  }
  NoticeBar.prototype.render = function () {
    var _a;
    var _b = this.props,
      mode = _b.mode,
      icon = _b.icon,
      onClick = _b.onClick,
      children = _b.children,
      className = _b.className,
      prefixCls = _b.prefixCls,
      action = _b.action,
      extra = _b.extra,
      marqueeProps = _b.marqueeProps,
      restProps = __rest(_b, ["mode", "icon", "onClick", "children", "className", "prefixCls", "action", "extra", "marqueeProps"]);
    var extraProps = {};
    var operationDom = null;
    if (extra) {
      operationDom = /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-extra")
      }, extra);
    }
    if (mode === 'closable') {
      operationDom = /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-operation"),
        role: "button",
        "aria-label": "close",
        onClick: this.onClose
      }, action ? action : /*#__PURE__*/React.createElement(_CloseOutlined["default"], null));
    }
    var wrapCls = (0, _classnames["default"])(prefixCls, className);
    return this.state.show ? (/*#__PURE__*/React.createElement("div", __assign({
      className: wrapCls
    }, restProps, extraProps, {
      role: "alert",
      onClick: this.onClick
    }), icon && (
    /*#__PURE__*/
    // tslint:disable-next-line:jsx-no-multiline-js
    React.createElement("div", {
      className: (0, _classnames["default"])("".concat(prefixCls, "-icon"), (_a = {}, _a["".concat(prefixCls, "-icon-desktop")] = !_internal.isMobile, _a)),
      "aria-hidden": "true"
    }, icon)), /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-content")
    }, /*#__PURE__*/React.createElement(_Marquee["default"], __assign({
      prefixCls: prefixCls,
      text: children
    }, marqueeProps))), operationDom)) : null;
  };
  NoticeBar.defaultProps = {
    prefixCls: 'am-notice-bar',
    mode: '',
    icon: /*#__PURE__*/React.createElement(_NoticeTipOutlined["default"], null),
    onClick: function onClick() {}
  };
  return NoticeBar;
}(React.Component);
var _default = exports["default"] = NoticeBar;