"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var React = _interopRequireWildcard(require("react"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var ScrollView = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var divRef = /*#__PURE__*/React.createRef();
  React.useImperativeHandle(ref, function () {
    return divRef.current;
  });
  var handleScroll = function handleScroll() {
    var _a, _b, _c, _d, _e;
    var offsetLeft = (_a = divRef.current) === null || _a === void 0 ? void 0 : _a.scrollLeft;
    var offsetRight = ((_b = divRef.current) === null || _b === void 0 ? void 0 : _b.scrollWidth) - ((_c = divRef.current) === null || _c === void 0 ? void 0 : _c.offsetWidth) - ((_d = divRef.current) === null || _d === void 0 ? void 0 : _d.scrollLeft);
    (_e = props.onScroll) === null || _e === void 0 ? void 0 : _e.call(props, {
      offsetLeft: offsetLeft,
      offsetRight: offsetRight
    });
  };
  React.useLayoutEffect(function () {
    // hack, 初始化的时候计算不准确，设置延迟
    setTimeout(function () {
      var _a;
      handleScroll();
      (_a = props.onInit) === null || _a === void 0 ? void 0 : _a.call(props);
    }, 100);
  }, []);
  return /*#__PURE__*/React.createElement("div", {
    ref: divRef,
    className: props.className,
    onScroll: handleScroll
  }, props.children);
});
var _default = exports["default"] = ScrollView;