"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tabs = exports.StateType = void 0;
var _react = _interopRequireDefault(require("react"));
var __extends = void 0 && (void 0).__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    };
    return _extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    _extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var StateType = exports.StateType = /** @class */function () {
  function StateType() {}
  return StateType;
}();
var instanceId = 0;
var Tabs = exports.Tabs = /** @class */function (_super) {
  __extends(Tabs, _super);
  function Tabs(props) {
    var _this = _super.call(this, props) || this;
    _this.tabCache = {};
    _this.isTabVertical = function (direction) {
      if (direction === void 0) {
        direction = _this.props.tabDirection;
      }
      return direction === 'vertical';
    };
    _this.shouldRenderTab = function (idx) {
      var _a = _this.props.prerenderingSiblingsNumber,
        prerenderingSiblingsNumber = _a === void 0 ? 0 : _a;
      var _b = _this.state.currentTab,
        currentTab = _b === void 0 ? 0 : _b;
      return currentTab - prerenderingSiblingsNumber <= idx && idx <= currentTab + prerenderingSiblingsNumber;
    };
    _this.getOffsetIndex = function (current, width, threshold) {
      if (threshold === void 0) {
        threshold = _this.props.distanceToChangeTab || 0;
      }
      var ratio = Math.abs(current / width);
      var direction = ratio > _this.state.currentTab ? '<' : '>';
      var index = Math.floor(ratio);
      switch (direction) {
        case '<':
          return ratio - index > threshold ? index + 1 : index;
        case '>':
          return 1 - ratio + index > threshold ? index : index + 1;
        default:
          return Math.round(ratio);
      }
    };
    _this.getSubElements = function () {
      var children = _this.props.children;
      var subElements = {};
      return function (defaultPrefix, allPrefix) {
        if (defaultPrefix === void 0) {
          defaultPrefix = '$i$-';
        }
        if (allPrefix === void 0) {
          allPrefix = '$ALL$';
        }
        if (Array.isArray(children)) {
          children.forEach(function (child, index) {
            if (child.key) {
              subElements[child.key] = child;
            }
            subElements["".concat(defaultPrefix).concat(index)] = child;
          });
        } else if (children) {
          subElements[allPrefix] = children;
        }
        return subElements;
      };
    };
    _this.state = {
      currentTab: _this.getTabIndex(props)
    };
    _this.nextCurrentTab = _this.state.currentTab;
    _this.instanceId = instanceId++;
    return _this;
  }
  Tabs.prototype.getTabIndex = function (props) {
    var page = props.page,
      initialPage = props.initialPage,
      tabs = props.tabs;
    var param = (page !== undefined ? page : initialPage) || 0;
    var index = 0;
    if (typeof param === 'string') {
      tabs.forEach(function (t, i) {
        if (t.key === param) {
          index = i;
        }
      });
    } else {
      index = param || 0;
    }
    return index < 0 ? 0 : index;
  };
  Tabs.prototype.componentWillReceiveProps = function (nextProps) {
    if (this.props.page !== nextProps.page && nextProps.page !== undefined) {
      this.goToTab(this.getTabIndex(nextProps), true, {}, nextProps);
    }
  };
  Tabs.prototype.componentDidMount = function () {
    this.prevCurrentTab = this.state.currentTab;
  };
  Tabs.prototype.componentDidUpdate = function () {
    this.prevCurrentTab = this.state.currentTab;
  };
  Tabs.prototype.goToTab = function (index, force, newState, props) {
    if (force === void 0) {
      force = false;
    }
    if (newState === void 0) {
      newState = {};
    }
    if (props === void 0) {
      props = this.props;
    }
    if (!force && this.nextCurrentTab === index) {
      return false;
    }
    this.nextCurrentTab = index;
    var _a = props,
      tabs = _a.tabs,
      onChange = _a.onChange;
    if (index >= 0 && index < tabs.length) {
      if (!force) {
        onChange && onChange(tabs[index], index);
        if (props.page !== undefined) {
          return false;
        }
      }
      this.setState(__assign({
        currentTab: index
      }, newState));
    }
    return true;
  };
  Tabs.prototype.tabClickGoToTab = function (index) {
    this.goToTab(index);
  };
  Tabs.prototype.getTabBarBaseProps = function () {
    var currentTab = this.state.currentTab;
    var _a = this.props,
      animated = _a.animated,
      onTabClick = _a.onTabClick,
      tabBarActiveTextColor = _a.tabBarActiveTextColor,
      tabBarBackgroundColor = _a.tabBarBackgroundColor,
      tabBarInactiveTextColor = _a.tabBarInactiveTextColor,
      tabBarPosition = _a.tabBarPosition,
      tabBarTextStyle = _a.tabBarTextStyle,
      tabBarUnderlineStyle = _a.tabBarUnderlineStyle,
      tabs = _a.tabs;
    return {
      activeTab: currentTab,
      animated: !!animated,
      goToTab: this.tabClickGoToTab.bind(this),
      onTabClick: onTabClick,
      tabBarActiveTextColor: tabBarActiveTextColor,
      tabBarBackgroundColor: tabBarBackgroundColor,
      tabBarInactiveTextColor: tabBarInactiveTextColor,
      tabBarPosition: tabBarPosition,
      tabBarTextStyle: tabBarTextStyle,
      tabBarUnderlineStyle: tabBarUnderlineStyle,
      tabs: tabs,
      instanceId: this.instanceId
    };
  };
  Tabs.prototype.renderTabBar = function (tabBarProps, DefaultTabBar) {
    var renderTabBar = this.props.renderTabBar;
    if (renderTabBar === false) {
      return null;
    } else if (renderTabBar) {
      // return React.cloneElement(this.props.renderTabBar(props), props);
      return renderTabBar(tabBarProps);
    } else {
      return /*#__PURE__*/_react["default"].createElement(DefaultTabBar, __assign({}, tabBarProps));
    }
  };
  Tabs.prototype.getSubElement = function (tab, index, subElements, defaultPrefix, allPrefix) {
    if (defaultPrefix === void 0) {
      defaultPrefix = '$i$-';
    }
    if (allPrefix === void 0) {
      allPrefix = '$ALL$';
    }
    var key = tab.key || "".concat(defaultPrefix).concat(index);
    var elements = subElements(defaultPrefix, allPrefix);
    var component = elements[key] || elements[allPrefix];
    if (component instanceof Function) {
      component = component(tab, index);
    }
    return component || null;
  };
  Tabs.defaultProps = {
    tabBarPosition: 'top',
    initialPage: 0,
    swipeable: true,
    animated: true,
    prerenderingSiblingsNumber: 1,
    tabs: [],
    destroyInactiveTab: false,
    usePaged: true,
    tabDirection: 'horizontal',
    distanceToChangeTab: 0.3
  };
  return Tabs;
}(_react["default"].PureComponent);