import React from 'react';
import { IGestureStatus } from 'rc-gesture';
import { PropsType as BasePropsType } from './PropsType';
import { DefaultTabBar } from './DefaultTabBar';
import { Tabs as Component, StateType as BaseStateType } from './Tabs.base';
export interface PropsType extends BasePropsType {
    /** prefix class | default: rmc-tabs */
    prefixCls?: string;
    /** d-design new */
    size?: 'large' | 'medium' | 'small';
    /** tab bar 上额外的元素	 */
    tabBarExtraContent?: React.ReactNode;
}
export declare class StateType extends BaseStateType {
    contentPos?: string | undefined;
    isMoving?: boolean | undefined;
}
export declare class Tabs extends Component<React.PropsWithChildren<PropsType>, StateType> {
    static DefaultTabBar: typeof DefaultTabBar;
    static defaultProps: PropsType;
    layout: HTMLDivElement;
    onPan: {
        onPanStart: (status: IGestureStatus) => void;
        onPanMove: (status: IGestureStatus) => void;
        onPanEnd: () => void;
        setCurrentOffset: (offset: number | string) => string | number;
    };
    constructor(props: PropsType);
    goToTab(index: number, force?: boolean, usePaged?: boolean | undefined, props?: Readonly<React.PropsWithChildren<PropsType>> & Readonly<{
        children?: React.ReactNode;
    }>): boolean;
    tabClickGoToTab(index: number): void;
    getContentPosByIndex(index: number, isVertical: boolean, useLeft?: boolean): string;
    onSwipe: (status: IGestureStatus) => void;
    setContentLayout: (div: HTMLDivElement | null) => void;
    renderContent(getSubElements?: (defaultPrefix?: string, allPrefix?: string) => {
        [key: string]: React.ReactNode;
    }): React.JSX.Element;
    render(): React.JSX.Element;
}
