"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getPxStyle = getPxStyle;
exports.getTransformPropValue = getTransformPropValue;
exports.setPxStyle = setPxStyle;
exports.setTransform = setTransform;
function getTransformPropValue(v) {
  return {
    transform: v,
    WebkitTransform: v,
    MozTransform: v
  };
}
function getPxStyle(value, unit, vertical) {
  if (unit === void 0) {
    unit = 'px';
  }
  if (vertical === void 0) {
    vertical = false;
  }
  value = vertical ? "0px, ".concat(value).concat(unit, ", 0px") : "".concat(value).concat(unit, ", 0px, 0px");
  return "translate3d(".concat(value, ")");
}
function setPxStyle(el, value, unit, vertical, useLeft) {
  if (unit === void 0) {
    unit = 'px';
  }
  if (vertical === void 0) {
    vertical = false;
  }
  if (useLeft === void 0) {
    useLeft = false;
  }
  if (useLeft) {
    if (vertical) {
      el.style.top = "".concat(value).concat(unit);
    } else {
      el.style.left = "".concat(value).concat(unit);
    }
  } else {
    setTransform(el.style, getPxStyle(value, unit, vertical));
  }
}
function setTransform(style, v) {
  style.transform = v;
  style.webkitTransform = v;
  style.mozTransform = v;
}