"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _SearchBar = _interopRequireDefault(require("../rmc/SearchBar"));
var _classnames = _interopRequireDefault(require("classnames"));
var _hooks = require("../hooks");
require("./style/index");
var _index2 = require("../style/index");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var SearchBar = /*#__PURE__*/_react["default"].memo(/*#__PURE__*/_react["default"].forwardRef(function (props, forwardRef) {
  var _a;
  var isMobile = (0, _hooks.useMobile)();
  var className = props.className,
    onChange = props.onChange,
    onBlur = props.onBlur,
    onFocus = props.onFocus,
    cancelText = props.cancelText,
    _props = __rest(props, ["className", "onChange", "onBlur", "onFocus", "cancelText"]);
  var inputRef = (0, _react.useRef)();
  var _b = __read((0, _react.useState)(function () {
      if (typeof _props.value !== 'undefined') {
        return _props.value;
      }
      return _props.defaultValue || '';
    }), 2),
    privateValue = _b[0],
    setPrivateValue = _b[1];
  var _c = __read((0, _react.useState)(false), 2),
    focus = _c[0],
    setFocus = _c[1];
  (0, _react.useEffect)(function () {
    if (typeof _props.value !== 'undefined' && privateValue !== _props.value) {
      setPrivateValue(_props.value);
    }
  }, [_props.value, privateValue]);
  var handleChange = (0, _react.useCallback)(function (value) {
    if (typeof onChange === 'function') {
      onChange(value);
    }
    if (typeof _props.value === 'undefined') {
      setPrivateValue(value);
    }
  }, [_props]);
  (0, _react.useImperativeHandle)(forwardRef, function () {
    return {
      focus: function focus() {
        var _a, _b;
        (_b = (_a = inputRef === null || inputRef === void 0 ? void 0 : inputRef.current) === null || _a === void 0 ? void 0 : _a.focus) === null || _b === void 0 ? void 0 : _b.call(_a);
      },
      blur: function blur() {
        var _a, _b;
        (_b = (_a = inputRef === null || inputRef === void 0 ? void 0 : inputRef.current) === null || _a === void 0 ? void 0 : _a.blur) === null || _b === void 0 ? void 0 : _b.call(_a);
      }
    };
  });
  var handleFocus = function handleFocus() {
    if (!focus) {
      setFocus(true);
    }
    if (typeof onFocus === 'function') {
      onFocus(privateValue);
    }
  };
  var handleBlur = function handleBlur() {
    if (focus) {
      setFocus(false);
    }
    if (typeof onBlur === 'function') {
      onBlur(privateValue);
    }
  };
  var wrapCls = (0, _classnames["default"])(privateValue ? "".concat(_index2.dtMobileSearchbarPrefix, "-has-value") : '', cancelText === undefined ? "".concat(_index2.dtMobileSearchbarPrefix, "-hidden-cancel") : '', (_a = {}, _a["".concat(_index2.dtMobileSearchbarPrefix, "-desktop")] = !isMobile, _a["".concat(_index2.dtMobileSearchbarPrefix, "-desktop-focus")] = !isMobile && focus, _a["".concat(_index2.dtMobileSearchbarPrefix, "-focus")] = focus, _a), className);
  return /*#__PURE__*/_react["default"].createElement(_SearchBar["default"], __assign({}, _props, {
    cancelText: cancelText,
    onFocus: handleFocus,
    onBlur: handleBlur,
    prefixCls: _index2.dtMobileSearchbarPrefix,
    onChange: handleChange,
    className: wrapCls,
    ref: function ref(_ref) {
      return inputRef.current = _ref;
    },
    showCancelButton: cancelText !== undefined
  }));
}));
SearchBar.displayName = 'SearchBar';
var _default = exports["default"] = SearchBar;