"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
require("./style/index");
var _rmcFeedback = _interopRequireDefault(require("rmc-feedback"));
var _style = require("../style");
var _classnames = _interopRequireDefault(require("classnames"));
var _hooks = require("../hooks");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var dtMobileSegmentedControlPrefix = "".concat(_style.dtMobilePrefix, "-segment");
var SegmentedControl = function SegmentedControl(props) {
  var _a;
  var _b, _c;
  var isMobile = (0, _hooks.useMobile)();
  var defaultActiveIndex = props.defaultActiveIndex,
    texts = props.texts,
    disabled = props.disabled,
    onChange = props.onChange;
  var _d = __read((0, _react.useState)((_c = (_b = props.activeIndex) !== null && _b !== void 0 ? _b : defaultActiveIndex) !== null && _c !== void 0 ? _c : 0), 2),
    innerActiveIndex = _d[0],
    setInnerActiveIndex = _d[1];
  var activeIndex = (0, _react.useMemo)(function () {
    var _a;
    return (_a = props.activeIndex) !== null && _a !== void 0 ? _a : innerActiveIndex;
  }, [props.activeIndex, innerActiveIndex]);
  var $setActiveIndex = (0, _react.useCallback)(function (idx) {
    if (idx !== activeIndex) {
      onChange && onChange(idx);
    }
    setInnerActiveIndex(idx);
  }, [activeIndex, setInnerActiveIndex]);
  var _onClick = (0, _react.useCallback)(function (idx) {
    if (disabled) return;
    $setActiveIndex(idx);
  }, [disabled, $setActiveIndex]);
  var renderSegmentItem = (0, _react.useCallback)(function (idx, text) {
    var _a;
    var selected = activeIndex === idx;
    var itemCls = (0, _classnames["default"])("".concat(dtMobileSegmentedControlPrefix, "-item"), (_a = {}, _a["".concat(dtMobileSegmentedControlPrefix, "-item-selected")] = selected, _a["".concat(dtMobileSegmentedControlPrefix, "-item-desktop")] = !isMobile, _a["".concat(dtMobileSegmentedControlPrefix, "-hidden-divide")] = selected || activeIndex === idx + 1, _a));
    return (
      /*#__PURE__*/
      // @ts-ignore
      _react["default"].createElement(_rmcFeedback["default"], {
        key: idx,
        disabled: disabled,
        activeClassName: "".concat(dtMobileSegmentedControlPrefix, "-item-active")
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: itemCls,
        role: "tab",
        "aria-selected": selected && !disabled,
        "aria-disabled": disabled,
        onClick: function onClick() {
          return _onClick(idx);
        }
      }, text))
    );
  }, [activeIndex]);
  var wrapCls = (0, _classnames["default"])(props.className, dtMobileSegmentedControlPrefix, (_a = {}, _a["".concat(dtMobileSegmentedControlPrefix, "-disabled")] = disabled, _a));
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: wrapCls,
    role: "tablist"
  }, (texts !== null && texts !== void 0 ? texts : []).map(function (text, idx) {
    return renderSegmentItem(idx, text);
  }));
};
SegmentedControl.displayName = 'SegmentedControl';
var _default = exports["default"] = SegmentedControl;