"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _CloseOutlined = _interopRequireDefault(require("dingtalk-design-icons/lib/CloseOutlined"));
var _drawer = _interopRequireDefault(require("../drawer"));
var _popover = _interopRequireDefault(require("../popover"));
var _hooks = require("../hooks");
var _list = _interopRequireDefault(require("../list"));
var _navBar = _interopRequireDefault(require("../nav-bar"));
var _radio = _interopRequireDefault(require("../radio"));
var _style = require("../style");
require("./style");
var _checkbox = _interopRequireDefault(require("../checkbox"));
var _usePropsValue = require("../_internal/use-props-value");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var __spreadArray = void 0 && (void 0).__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
function renderSingleSelect(_a) {
  var disabled = _a.disabled,
    value = _a.value,
    options = _a.options,
    handleSelect = _a.handleSelect,
    isMobile = _a.isMobile;
  if (isMobile) {
    return /*#__PURE__*/_react["default"].createElement(_radio["default"].Group, {
      disabled: disabled,
      value: value,
      onChange: function onChange(v) {
        return handleSelect(v);
      }
    }, options.map(function (data) {
      var _a;
      return /*#__PURE__*/_react["default"].createElement(_radio["default"].Item, {
        key: data.value,
        value: data.value,
        disabled: data === null || data === void 0 ? void 0 : data.disabled
      }, (_a = data.label) !== null && _a !== void 0 ? _a : data.value);
    }));
  } else {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(_style.dtSelectPrefix, "-overlay")
    }, options.map(function (data) {
      var _a;
      var _b;
      return /*#__PURE__*/_react["default"].createElement("div", {
        key: data.value,
        className: (0, _classnames["default"])("".concat(_style.dtSelectPrefix, "--item"), (_a = {}, _a["".concat(_style.dtSelectPrefix, "--item-active")] = value === data.value, _a["".concat(_style.dtSelectPrefix, "--item-disabled")] = data === null || data === void 0 ? void 0 : data.disabled, _a)),
        onClick: function onClick() {
          if (!data.disabled) {
            handleSelect(data.value);
          }
        }
      }, (_b = data.label) !== null && _b !== void 0 ? _b : data.value);
    }));
  }
}
function formatSelection(selected) {
  var selectedArray = Array.isArray(selected) ? selected : [selected];
  return selectedArray.map(function (o) {
    var _a;
    return (_a = o.label) !== null && _a !== void 0 ? _a : o.value;
  }).join(',');
}
function renderMultipleSelect(_a) {
  var disabled = _a.disabled,
    value = _a.value,
    options = _a.options,
    handleSelect = _a.handleSelect,
    isMobile = _a.isMobile;
  if (isMobile) {
    return /*#__PURE__*/_react["default"].createElement(_checkbox["default"].Group, {
      disabled: disabled,
      value: value,
      onChange: function onChange(v) {
        return handleSelect(v);
      }
    }, options.map(function (data) {
      var _a;
      return /*#__PURE__*/_react["default"].createElement(_checkbox["default"].Item, {
        key: data.value,
        value: data.value,
        disabled: data.disabled
      }, (_a = data.label) !== null && _a !== void 0 ? _a : data.value);
    }));
  } else {
    var selectedValue_1 = value || [];
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(_style.dtSelectPrefix, "-overlay")
    }, options.map(function (data) {
      var _a;
      var _b;
      var isSelected = selectedValue_1.indexOf(data.value) !== -1;
      return /*#__PURE__*/_react["default"].createElement(_checkbox["default"], {
        className: (0, _classnames["default"])("".concat(_style.dtSelectPrefix, "-checkbox"), "".concat(_style.dtSelectPrefix, "--item"), (_a = {}, _a["".concat(_style.dtSelectPrefix, "--item-active")] = isSelected, _a)),
        checked: isSelected,
        disabled: !!(data === null || data === void 0 ? void 0 : data.disabled),
        onChange: function onChange(checked) {
          if (checked) {
            selectedValue_1 = __spreadArray(__spreadArray([], __read(selectedValue_1), false), [data.value], false);
          } else {
            selectedValue_1 = selectedValue_1.filter(function (item) {
              return item !== data.value;
            });
          }
          handleSelect(selectedValue_1);
        }
      }, (_b = data.label) !== null && _b !== void 0 ? _b : data.value);
    }));
  }
}
function Select(props) {
  var _a = props.options,
    options = _a === void 0 ? [] : _a,
    _b = props.disabled,
    disabled = _b === void 0 ? false : _b,
    _c = props.mode,
    mode = _c === void 0 ? 'single' : _c,
    defaultValue = props.defaultValue,
    okText = props.okText,
    renderSelection = props.renderSelection,
    getContainer = props.getContainer,
    _d = props.maskClosable,
    maskClosable = _d === void 0 ? true : _d,
    children = props.children,
    visible = props.visible,
    onVisibleChange = props.onVisibleChange;
  var isMobile = (0, _hooks.useMobile)();
  var _e = __read((0, _usePropsValue.usePropsValue)({
      value: visible,
      defaultValue: visible,
      onChange: onVisibleChange
    }), 2),
    innervisible = _e[0],
    setInnerVisible = _e[1];
  // 实际修改 value
  var innerOnChange = (0, _react.useCallback)(function (v) {
    if (props.onChange) {
      if (Array.isArray(v)) {
        var selectOptions = options.filter(function (o) {
          return v.includes(o.value);
        });
        props.onChange(props.usedetailValue ? selectOptions : v, selectOptions);
      } else {
        var selectOption = options.find(function (o) {
          return o.value === v;
        });
        props.onChange(props.usedetailValue ? selectOption : v, selectOption);
      }
    }
  }, [options, props.onChange, props.usedetailValue]);
  var _f = (0, _hooks.useControlled)(props.value, defaultValue !== null && defaultValue !== void 0 ? defaultValue : '', innerOnChange),
    value = _f.value,
    onChange = _f.onChange;
  // 预览选中状态
  var _g = __read((0, _react.useState)(value), 2),
    selected = _g[0],
    setSelected = _g[1];
  (0, _react.useEffect)(function () {
    var timer = window.setTimeout(function () {
      setSelected(value);
    }, 0);
    return function () {
      window.clearTimeout(timer);
    };
  }, [value, innervisible]);
  var handleSelect = (0, _react.useCallback)(function (v) {
    setSelected(v);
    // 单选模式直接关闭浮层, 多选移动端点击确定之后触发onChange
    if (!Array.isArray(v)) {
      onChange(v);
      setInnerVisible(false);
    }
    // 多选桌面端点击每一项都触发onChange
    if (!isMobile && Array.isArray(v)) {
      onChange(v);
    }
  }, [mode, setSelected, onChange]);
  var getSelections = (0, _react.useCallback)(function (selected) {
    if (Array.isArray(selected)) {
      var selectOptions = options.filter(function (o) {
        return selected.includes(o.value);
      });
      return selectOptions;
    } else {
      var selectOption = options.find(function (o) {
        return o.value === selected;
      });
      return selectOption;
    }
  }, [mode, options]);
  var innerRenderSelectionComp = (0, _react.useMemo)(function () {
    var _a;
    var selectedOptions = (_a = getSelections(props.usedetailValue ? value.value : value)) !== null && _a !== void 0 ? _a : [];
    return renderSelection ? renderSelection(selectedOptions) : formatSelection(selectedOptions);
  }, [renderSelection, value, getSelections, props.usedetailValue]);
  var itemsRenderByDataSource = (0, _react.useMemo)(function () {
    var renderFunc = mode === 'single' ? renderSingleSelect : renderMultipleSelect;
    return renderFunc({
      options: options,
      value: selected,
      handleSelect: handleSelect,
      disabled: disabled,
      isMobile: isMobile
    });
  }, [mode, options, selected, handleSelect, disabled]);
  var okContentComp = (0, _react.useMemo)(function () {
    return mode === 'multiple' ? (/*#__PURE__*/_react["default"].createElement("div", {
      onClick: function onClick() {
        onChange(selected);
        setInnerVisible(false);
      },
      className: "".concat(_style.dtSelectPrefix, "-nav-right")
    }, okText || '确定')) : (/*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null));
  }, [mode, okText, onChange, selected]);
  var showPlaceholder = (0, _react.useMemo)(function () {
    return !value && value !== 0;
  }, [value, props.defaultValue]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _style.dtSelectPrefix
  }, isMobile ? (/*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, children && /*#__PURE__*/_react["default"].isValidElement(children) ? (/*#__PURE__*/_react["default"].cloneElement(children, {
    onClick: function onClick() {
      var _a, _b;
      (_b = (_a = children.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a);
      setInnerVisible(!innervisible);
    }
  })) : (/*#__PURE__*/_react["default"].createElement(_list["default"].Item, {
    className: "".concat(_style.dtSelectPrefix, "-default-item"),
    onClick: props.readonly ? undefined : function (e) {
      setInnerVisible(true);
    },
    arrow: props.arrow,
    disabled: disabled
  }, showPlaceholder ? (/*#__PURE__*/_react["default"].createElement("span", {
    className: "".concat(_style.dtSelectPrefix, "-placeholder")
  }, props.placeholder)) : innerRenderSelectionComp)), /*#__PURE__*/_react["default"].createElement(_drawer["default"], {
    maskClosable: maskClosable,
    getContainer: getContainer,
    visible: innervisible,
    onVisibleChange: function onVisibleChange(visible) {
      return setInnerVisible(visible);
    }
  }, /*#__PURE__*/_react["default"].createElement(_navBar["default"], {
    leftContent: /*#__PURE__*/_react["default"].createElement(_CloseOutlined["default"], {
      onClick: function onClick() {
        return setInnerVisible(false);
      }
    }),
    onLeftClick: function onLeftClick() {
      return setInnerVisible(false);
    },
    rightContent: okContentComp
  }, props.title), itemsRenderByDataSource))) : (/*#__PURE__*/_react["default"].createElement(_popover["default"], {
    maskClosable: maskClosable,
    getPopupContainer: getContainer,
    visible: innervisible && !disabled,
    onVisibleChange: function onVisibleChange(visible) {
      return setInnerVisible(visible);
    },
    placement: 'bottomRight',
    arrow: false,
    align: {
      offset: [-16, 0]
    },
    overlay: /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(_style.dtSelectPrefix, "-desktop-popover")
    }, itemsRenderByDataSource)
  }, children && /*#__PURE__*/_react["default"].isValidElement(children) ? (/*#__PURE__*/_react["default"].cloneElement(children, {
    onClick: function onClick() {
      var _a, _b;
      (_b = (_a = children.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a);
      setInnerVisible(!innervisible);
    }
  })) : (/*#__PURE__*/_react["default"].createElement(_list["default"].Item, {
    className: "".concat(_style.dtSelectPrefix, "-default-item"),
    onClick: function onClick() {
      return setInnerVisible(true);
    },
    arrow: true,
    disabled: disabled
  }, showPlaceholder ? (/*#__PURE__*/_react["default"].createElement("span", {
    className: "".concat(_style.dtSelectPrefix, "-placeholder")
  }, props.placeholder)) : innerRenderSelectionComp)))));
}
Select.displayName = 'Select';
var _default = exports["default"] = Select;