"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dtMobileSideBarPrefix = exports["default"] = exports.SideBarItem = void 0;
var _react = _interopRequireDefault(require("react"));
require("./style/index");
var _index2 = require("../style/index");
var _classnames = _interopRequireDefault(require("classnames"));
var _nativeProps = require("../_internal/native-props");
var _usePropsValue = require("../_internal/use-props-value");
var _attachPropertiesToComponent = require("../_internal/attach-properties-to-component");
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var dtMobileSideBarPrefix = exports.dtMobileSideBarPrefix = "".concat(_index2.dtMobilePrefix, "-sidebar");
var SideBarItem = exports.SideBarItem = function SideBarItem() {
  return null;
};
var SideBar = /*#__PURE__*/_react["default"].memo(function (props) {
  var _a;
  var className = props.className;
  var prefixCls = dtMobileSideBarPrefix;
  var firstActiveKey = '';
  var items = [];
  _react["default"].Children.forEach(props.children, function (child, index) {
    if (! /*#__PURE__*/_react["default"].isValidElement(child)) return;
    var key = child.key;
    if (typeof key !== 'string') return;
    if (index === 0) {
      firstActiveKey = key;
    }
    items.push(child);
  });
  var _b = __read((0, _usePropsValue.usePropsValue)({
      value: props.activeKey,
      defaultValue: (_a = props.defaultActiveKey) !== null && _a !== void 0 ? _a : firstActiveKey,
      onChange: props.onChange
    }), 2),
    activeKey = _b[0],
    setActiveKey = _b[1];
  var wrapCls = (0, _classnames["default"])(prefixCls, className);
  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", {
    className: wrapCls
  }, items.map(function (item) {
    var _a;
    var active = item.key === activeKey;
    return (0, _nativeProps.withNativeProps)(item.props, /*#__PURE__*/_react["default"].createElement("div", {
      key: item.key,
      className: (0, _classnames["default"])("".concat(dtMobileSideBarPrefix, "-item"), (_a = {}, _a["".concat(dtMobileSideBarPrefix, "-item-active")] = active, _a)),
      onClick: function onClick() {
        var key = item.key;
        if (key === undefined || key === null) return;
        setActiveKey(key.toString());
      }
    }, item.props.icon, /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(dtMobileSideBarPrefix, "-item-text")
    }, item.props.title, item.props.badge && (/*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(dtMobileSideBarPrefix, "-item-badge-container")
    }, item.props.badge)))));
  })));
});
SideBar.displayName = 'SideBar';
var _default = exports["default"] = (0, _attachPropertiesToComponent.attachPropertiesToComponent)(SideBar, {
  Item: SideBarItem
});