"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Marks = void 0;
var _react = _interopRequireDefault(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _index = require("./index");
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var Marks = exports.Marks = function Marks(_a) {
  var _b;
  var marks = _a.marks,
    upperBound = _a.upperBound,
    lowerBound = _a.lowerBound,
    max = _a.max,
    min = _a.min,
    step = _a.step;
  var innerMarks = {};
  if (typeof marks === 'boolean') {
    for (var cur = min; cur <= max; cur += step) {
      innerMarks = __assign(__assign({}, innerMarks), (_b = {}, _b[cur] = cur, _b));
    }
  } else {
    innerMarks = marks;
  }
  var marksKeys = Object.keys(innerMarks);
  var range = max - min;
  var elements = marksKeys.map(parseFloat).sort(function (a, b) {
    return a - b;
  }).filter(function (point) {
    return point >= min && point <= max;
  }).map(function (point) {
    var _a;
    var markPoint = innerMarks[point];
    if (!markPoint && markPoint !== 0) {
      return null;
    }
    var isActive = point <= upperBound && point >= lowerBound;
    var markClassName = (0, _classnames["default"])((_a = {}, _a["".concat(_index.dtSliderPrefix, "-mark-text")] = true, _a["".concat(_index.dtSliderPrefix, "-mark-text-active")] = isActive, _a));
    var style = {
      left: "".concat((point - min) / range * 100, "%")
    };
    return /*#__PURE__*/_react["default"].createElement("span", {
      className: markClassName,
      style: style,
      key: point
    }, markPoint);
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(_index.dtSliderPrefix, "-mark")
  }, elements);
};