"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Thumb = void 0;
var _react = _interopRequireDefault(require("react"));
var _ddUseGestureReact = require("dd-use-gesture-react");
var _index = require("./index");
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
;
var Thumb = exports.Thumb = function Thumb(props) {
  var value = props.value,
    min = props.min,
    max = props.max,
    disabled = props.disabled,
    onDrag = props.onDrag;
  var prevValue = _react["default"].useRef(value);
  var currentPosition = _react["default"].useMemo(function () {
    return {
      left: "".concat((value - min) / (max - min) * 100, "%"),
      right: 'auto'
    };
  }, [value, min, max]);
  var bind = (0, _ddUseGestureReact.useDrag)(function (state) {
    var _a;
    if (disabled) return;
    if (state.first) {
      prevValue.current = value;
    }
    var x = state.xy[0] - state.initial[0];
    var sliderOffsetWith = (_a = props.trackRef.current) === null || _a === void 0 ? void 0 : _a.offsetWidth;
    if (!sliderOffsetWith) return;
    var diff = x / Math.ceil(sliderOffsetWith) * (max - min);
    onDrag(prevValue.current + diff, state.first, state.last);
  }, {
    axis: 'x',
    pointer: {
      touch: true
    }
  });
  return /*#__PURE__*/_react["default"].createElement("div", __assign({
    className: "".concat(_index.dtSliderPrefix, "-thumb-container"),
    style: currentPosition
  }, bind()), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(_index.dtSliderPrefix, "-thumb")
  }));
};