"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _rmcNotification = _interopRequireDefault(require("rmc-notification"));
var _classnames = _interopRequireDefault(require("classnames"));
var _style = require("../style");
require("./style/index");
// @ts-ignore

var messageInstance;
var messageNeedHide;
var getMessageInstance = function getMessageInstance(mask, callback, className) {
  var _a;
  _rmcNotification["default"].newInstance({
    prefixCls: _style.dtSnackbarPrefix,
    style: {},
    transitionName: "".concat(_style.dtSnackbarPrefix, "-fade"),
    className: (0, _classnames["default"])(className, (_a = {}, _a["".concat(_style.dtSnackbarPrefix, "-mask")] = mask, _a["".concat(_style.dtSnackbarPrefix, "-nomask")] = !mask, _a))
  }, function (notification) {
    return callback && callback(notification);
  });
};
var notice = function notice(params) {
  messageNeedHide = false;
  getMessageInstance(false, function (notification) {
    var _a;
    var icon = params.icon,
      content = params.content,
      actionText = params.actionText,
      onActionClick = params.onActionClick;
    if (!notification) {
      return;
    }
    if (messageInstance) {
      messageInstance.destroy();
      messageInstance = null;
    }
    if (messageNeedHide) {
      notification.destroy();
      messageNeedHide = false;
      return;
    }
    messageInstance = notification;
    var handleClose = function handleClose() {
      setTimeout(function () {
        if (notification) {
          notification.destroy();
        }
        notification = null;
        messageInstance = null;
      }, 300);
    };
    var handleActionClick = function handleActionClick() {
      if (onActionClick) {
        onActionClick();
      }
      handleClose();
    };
    notification.notice({
      duration: (_a = params.duration) !== null && _a !== void 0 ? _a : 4,
      style: {},
      content: (/*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(_style.dtSnackbarPrefix, "-text"),
        role: "alert",
        "aria-live": "assertive"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(_style.dtSnackbarPrefix, "-icon-wrap")
      }, icon), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(_style.dtSnackbarPrefix, "-pure-text")
      }, content), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(_style.dtSnackbarPrefix, "-action"),
        onClick: handleActionClick
      }, actionText))),
      closable: true,
      onClose: handleClose
    });
  }, params.className);
};
var Snackbar = {
  show: function show(params) {
    return notice(params);
  },
  hide: function hide() {
    if (messageInstance) {
      messageInstance.destroy();
      messageInstance = null;
    } else {
      messageNeedHide = true;
    }
  }
};
var _default = exports["default"] = Snackbar;