import React, { FC } from 'react';
import { NativeProps } from '../_internal/native-props';
export type SpaceProps = {
    /**
     * @description 间距方向
     * @default 'horizontal'
     */
    direction?: 'horizontal' | 'vertical';
    /**
     * @description 交叉轴对齐方式
     */
    align?: 'start' | 'end' | 'center' | 'baseline';
    /**
     * @description 主轴对齐方式
     */
    justify?: 'start' | 'end' | 'center' | 'baseline' | 'between' | 'around' | 'evenly' | 'stretch';
    /**
     * @description 是否自动换行，仅在 horizontal 时有效
     * @default false
     */
    wrap?: boolean;
    /**
     * @description 是否渲染为块级元素
     * @default false
     */
    block?: boolean;
} & NativeProps<'--gap' | '--gap-vertical' | '--gap-horizontal' | '--item-width'>;
export declare const Space: FC<React.PropsWithChildren<SpaceProps>>;
