import * as React from 'react';
import './style/index';
import { BasePropsType } from '../_internal/BasePropsType';
import { NativeProps } from '../_internal/native-props';
export interface ISpinProps extends BasePropsType, NativeProps<'--spin-container-blur-opacity' | '--spin-size'> {
    /**
     * @description loading 下方文字
     * @default ""
     */
    text?: string;
    /**
     * @description 手动控制显示隐藏
     * @default true
     */
    visible?: boolean;
    /**
     * @description 全局固定居中展示
     * @default false
     */
    fixed?: boolean;
    /**
     * @description 延迟显示加载效果的时间（防止闪烁）单位ms
     * @default 0
     */
    delay?: number;
    /**
     * @description 是否播放动画(version>2.2.0)
     */
    played?: boolean;
    /**
     * @description 定制icon的链接地址
     */
    iconSrc?: string;
}
declare const Spin: React.FC<React.PropsWithChildren<ISpinProps>>;
export default Spin;
