import React from 'react';
import { BasePropsType } from '../_internal';
import './style/index';
import { NativeProps } from '../_internal/native-props';
export declare const dtStepperPrefix: string;
export type IStepperProps = {
    /**
     * @description 当前数，受控值
     */
    value?: number;
    /**
     * @description 默认值
     * @default 0
     */
    defaultValue?: number;
    /**
     * @description 最小值
     */
    min?: number;
    /**
     * @description 最大值
     */
    max?: number;
    /**
     * @description 步长,可以为小数
     * @default 1
     */
    step?: number;
    /**
     * @description 尺寸
     * @default 'small'
     */
    size?: 'small' | 'large' | 'medium';
    /**
     * @description 格式化到小数点后固定位数，设置为 0 表示格式化到整数
     */
    digits?: number;
    /**
     * @description 是否禁用
     * @default false
     */
    disabled?: boolean;
    /**
     * @description 是否允许内容为空
     * @default false
     */
    allowEmpty?: false;
    /**
     * @description 输入框是否只读
     * @default false
     */
    inputReadOnly?: boolean;
    /**
     * @description 值变化时的回调
     */
    onChange?: (value: number) => void;
    /**
     * @description 输入框获得焦点时触发
     */
    onFocus?: (v: number) => void;
    /**
     * @description 输入框失去焦点时触发
     */
    onBlur?: (v: number) => void;
} & BasePropsType & NativeProps;
declare const Stepper: React.FC<IStepperProps>;
export default Stepper;
