"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dtStepperPrefix = exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
require("./style/index");
var _index2 = require("../style/index");
var _classnames = _interopRequireDefault(require("classnames"));
var _nativeProps = require("../_internal/native-props");
var _withDefaultProps = require("../_internal/with-default-props");
var _usePropsValue = require("../_internal/use-props-value");
var _bound = require("../_internal/bound");
var _button = _interopRequireDefault(require("../button"));
var _input = _interopRequireDefault(require("../input"));
var _AdditionOutlined = _interopRequireDefault(require("dd-icons/lib/AdditionOutlined"));
var _Reduce2Outlined = _interopRequireDefault(require("dd-icons/lib/Reduce2Outlined"));
var _hooks = require("../hooks");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var dtStepperPrefix = exports.dtStepperPrefix = "".concat(_index2.dtMobilePrefix, "-stepper");
var defaultProps = {
  defaultValue: 0,
  step: 1,
  disabled: false,
  allowEmpty: false,
  size: 'small'
};
function convertValueToText(value) {
  if (value === null) return '';
  return value.toString();
}
function convertTextToValue(text) {
  if (text === '') return null;
  return parseFloat(text);
}
var Stepper = /*#__PURE__*/_react["default"].memo(function (p) {
  var _a, _b;
  var isMobile = (0, _hooks.useMobile)();
  var props = (0, _withDefaultProps.mergeProps)(defaultProps, p);
  var className = props.className,
    disabled = props.disabled,
    step = props.step,
    max = props.max,
    min = props.min,
    defaultValue = props.defaultValue,
    size = props.size,
    inputReadOnly = props.inputReadOnly;
  var _c = __read((0, _usePropsValue.usePropsValue)(props), 2),
    value = _c[0],
    setValue = _c[1];
  var _d = __read((0, _react.useState)(function () {
      return convertValueToText(value);
    }), 2),
    inputValue = _d[0],
    setInputValue = _d[1];
  function setValueWithCheck(v) {
    if (isNaN(v)) return;
    var target = (0, _bound.bound)(v, props.min, props.max);
    if (props.digits || props.digits === 0) {
      target = parseFloat(target.toFixed(props.digits));
    }
    setValue(target);
  }
  var _e = __read((0, _react.useState)(false), 2),
    hasFocus = _e[0],
    setHasFocus = _e[1];
  (0, _react.useEffect)(function () {
    if (!hasFocus) {
      setInputValue(convertValueToText(value));
    }
  }, [hasFocus]);
  (0, _react.useEffect)(function () {
    if (!hasFocus) {
      setInputValue(convertValueToText(value));
    }
  }, [value]);
  var handleInputChange = function handleInputChange(v) {
    setInputValue(v);
    var value = convertTextToValue(v);
    if (value === null) {
      if (props.allowEmpty) {
        setValue(null);
      } else {
        setValue(defaultValue);
      }
    } else {
      setValueWithCheck(value);
    }
  };
  var handleMinus = function handleMinus(event) {
    event.stopPropagation();
    setValueWithCheck((value !== null && value !== void 0 ? value : 0) - step);
  };
  var handlePlus = function handlePlus(event) {
    event.stopPropagation();
    setValueWithCheck((value !== null && value !== void 0 ? value : 0) + step);
  };
  var minusDisabled = function minusDisabled() {
    if (disabled) return true;
    if (value === null) return false;
    if (min !== undefined) {
      return value <= min;
    }
    return false;
  };
  var plusDisabled = function plusDisabled() {
    if (disabled) return true;
    if (value === null) return false;
    if (max !== undefined) {
      return value >= max;
    }
    return false;
  };
  var wrapCls = (0, _classnames["default"])(dtStepperPrefix, className, "".concat(dtStepperPrefix, "-").concat(size), (_a = {}, _a["".concat(dtStepperPrefix, "-active")] = hasFocus, _a["".concat(dtStepperPrefix, "-desktop")] = !isMobile, _a));
  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", {
    className: wrapCls
  }, /*#__PURE__*/_react["default"].createElement(_button["default"], {
    className: "".concat(dtStepperPrefix, "-minus"),
    onClick: function onClick(event) {
      return handleMinus(event);
    },
    disabled: minusDisabled()
  }, /*#__PURE__*/_react["default"].createElement(_Reduce2Outlined["default"], null)), /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])("".concat(dtStepperPrefix, "-middle"), (_b = {}, _b["".concat(dtStepperPrefix, "-middle-disabled")] = disabled, _b))
  }, /*#__PURE__*/_react["default"].createElement(_input["default"], {
    className: "".concat(dtStepperPrefix, "-input"),
    onFocus: function onFocus(v) {
      var _a;
      setHasFocus(true);
      var value = Number(v);
      (_a = props.onFocus) === null || _a === void 0 ? void 0 : _a.call(props, value);
    },
    readonly: inputReadOnly,
    value: inputValue,
    onChange: function onChange(val) {
      disabled || handleInputChange(val);
    },
    disabled: disabled,
    onBlur: function onBlur(v) {
      var _a;
      setHasFocus(false);
      var value = Number(v);
      (_a = props.onBlur) === null || _a === void 0 ? void 0 : _a.call(props, value);
    }
  })), /*#__PURE__*/_react["default"].createElement(_button["default"], {
    className: "".concat(dtStepperPrefix, "-plus"),
    onClick: function onClick(event) {
      return handlePlus(event);
    },
    disabled: plusDisabled()
  }, /*#__PURE__*/_react["default"].createElement(_AdditionOutlined["default"], null))));
});
Stepper.displayName = 'Stepper';
var _default = exports["default"] = Stepper;