"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _withDefaultProps = require("../_internal/with-default-props");
var _ddReactSpringWeb = require("dd-react-spring-web");
var _ddUseGestureReact = require("dd-use-gesture-react");
var _nearest = require("../_internal/nearest");
var _nativeProps = require("../_internal/native-props");
var _withStopPropagation = require("../_internal/with-stop-propagation");
var _style = require("../style");
require("./style/index");
var _hooks = require("../hooks");
var _PcAdapter = _interopRequireDefault(require("./PcAdapter"));
require("regenerator-runtime/runtime.js");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var __generator = void 0 && (void 0).__generator || function (thisArg, body) {
  var _ = {
      label: 0,
      sent: function sent() {
        if (t[0] & 1) throw t[1];
        return t[1];
      },
      trys: [],
      ops: []
    },
    f,
    y,
    t,
    g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;
  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");
    while (g && (g = 0, op[0] && (_ = 0)), _) try {
      if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
      if (y = 0, t) op = [op[0] & 2, t.value];
      switch (op[0]) {
        case 0:
        case 1:
          t = op;
          break;
        case 4:
          _.label++;
          return {
            value: op[1],
            done: false
          };
        case 5:
          _.label++;
          y = op[1];
          op = [0];
          continue;
        case 7:
          op = _.ops.pop();
          _.trys.pop();
          continue;
        default:
          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
            _ = 0;
            continue;
          }
          if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
            _.label = op[1];
            break;
          }
          if (op[0] === 6 && _.label < t[1]) {
            _.label = t[1];
            t = op;
            break;
          }
          if (t && _.label < t[2]) {
            _.label = t[2];
            _.ops.push(op);
            break;
          }
          if (t[2]) _.ops.pop();
          _.trys.pop();
          continue;
      }
      op = body.call(thisArg, _);
    } catch (e) {
      op = [6, e];
      y = 0;
    } finally {
      f = t = 0;
    }
    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var classPrefix = "".concat(_style.dtMobilePrefix, "-swipe-action");
var defaultProps = {
  right: [],
  left: [],
  closeOnTouchOutside: true,
  stopPropagation: [],
  autoClose: false,
  disabled: false
};
var SwipeAction = /*#__PURE__*/(0, _react.forwardRef)(function (p, ref) {
  var _a, _b;
  var props = (0, _withDefaultProps.mergeProps)(defaultProps, p);
  var isMobile = (0, _hooks.useMobile)();
  var rootRef = (0, _react.useRef)(null);
  var animateDivRef = (0, _react.useRef)(null);
  var leftRef = (0, _react.useRef)(null);
  var rightRef = (0, _react.useRef)(null);
  function getWidth(ref) {
    var element = ref.current;
    if (!element) return 0;
    return element.offsetWidth;
  }
  function getLeftWidth() {
    return getWidth(leftRef);
  }
  function getRightWidth() {
    return getWidth(rightRef);
  }
  /**
   * @description 解决action触发弹层动画（如drawer）导致style变化失效的问题，后期补充单测
   * @param v
   */
  var pointEventsChange = function pointEventsChange(v) {
    if (animateDivRef.current && animateDivRef.current.style) {
      animateDivRef.current.style.pointerEvents = v;
    }
  };
  var _c = __read((0, _ddReactSpringWeb.useSpring)(function () {
      return {
        x: 0,
        config: {
          tension: 200,
          friction: 30
        }
      };
    }, []), 2),
    x = _c[0].x,
    api = _c[1];
  var draggingRef = (0, _react.useRef)(false);
  var dragCancelRef = (0, _react.useRef)(null);
  function forceCancelDrag() {
    var _a;
    (_a = dragCancelRef.current) === null || _a === void 0 ? void 0 : _a.call(dragCancelRef);
    draggingRef.current = false;
  }
  var bind = (0, _ddUseGestureReact.useDrag)(function (state) {
    dragCancelRef.current = state.cancel;
    if (props.disabled) return;
    if (!state.intentional) return;
    if (state.down) {
      draggingRef.current = true;
    }
    if (!draggingRef.current) return;
    var _a = __read(state.offset, 1),
      offsetX = _a[0];
    if (state.last) {
      var leftWidth = getLeftWidth();
      var rightWidth = getRightWidth();
      var position = offsetX + state.velocity[0] * state.direction[0] * 50;
      if (offsetX > 0) {
        position = Math.max(0, position);
      } else if (offsetX < 0) {
        position = Math.min(0, position);
      } else {
        position = 0;
      }
      var targetX = (0, _nearest.nearest)([-rightWidth, 0, leftWidth], position);
      api.start({
        x: targetX
      });
      if (targetX !== 0) {
        open(targetX > 0 ? 'left' : 'right');
      } else {
        close();
      }
      window.setTimeout(function () {
        draggingRef.current = false;
      });
    } else {
      api.start({
        x: offsetX,
        immediate: true
      });
    }
  }, {
    from: function from() {
      return [x.get(), 0];
    },
    bounds: function bounds() {
      var leftWidth = getLeftWidth();
      var rightWidth = getRightWidth();
      return {
        left: -rightWidth,
        right: leftWidth
      };
    },
    // rubberband: true,
    axis: 'x',
    preventScroll: true,
    pointer: {
      touch: true
    },
    triggerAllEvents: true
  });
  function close() {
    var _this = this;
    api.start({
      to: function to(next) {
        return __awaiter(_this, void 0, void 0, function () {
          var _a;
          return __generator(this, function (_b) {
            switch (_b.label) {
              case 0:
                return [4 /*yield*/, next({
                  x: 0
                })];
              case 1:
                _b.sent();
                (_a = props.onClose) === null || _a === void 0 ? void 0 : _a.call(props);
                return [2 /*return*/];
            }
          });
        });
      }
    });
    pointEventsChange('auto');
    forceCancelDrag();
  }
  function open(side) {
    var _a;
    pointEventsChange('none');
    (_a = props.onOpen) === null || _a === void 0 ? void 0 : _a.call(props, side);
  }
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      show: function show(side) {
        if (side === void 0) {
          side = 'right';
        }
        if (side === 'right') {
          api.start({
            x: -getRightWidth()
          });
        } else if (side === 'left') {
          api.start({
            x: getLeftWidth()
          });
        }
        open(side);
      },
      close: close
    };
  });
  (0, _react.useEffect)(function () {
    if (!props.closeOnTouchOutside) return;
    function handle(e) {
      if (x.get() === 0) {
        return;
      }
      var root = rootRef.current;
      if (root && !root.contains(e.target)) {
        close();
      }
    }
    document.addEventListener('touchstart', handle);
    return function () {
      document.removeEventListener('touchstart', handle);
    };
  }, [props.closeOnTouchOutside]);
  function renderAction(action, index) {
    var _a, _b;
    var type = action.type;
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: (_a = action.key) !== null && _a !== void 0 ? _a : index,
      className: "".concat(classPrefix, "-action ").concat(classPrefix, "-action-").concat(type, " ").concat((_b = action.className) !== null && _b !== void 0 ? _b : ''),
      style: __assign({
        backgroundColor: action.color
      }, action.style),
      onClick: function onClick(e) {
        var _a, _b;
        if (props.autoClose) {
          close();
        }
        (_a = action.onPress) === null || _a === void 0 ? void 0 : _a.call(action, e);
        (_b = props.onAction) === null || _b === void 0 ? void 0 : _b.call(props, action, e);
      }
    }, action.text);
  }
  if (!isMobile) {
    return /*#__PURE__*/_react["default"].createElement(_PcAdapter["default"], __assign({}, props));
  }
  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", __assign({
    className: classPrefix
  }, bind(), {
    ref: rootRef,
    onClickCapture: function onClickCapture(e) {
      if (draggingRef.current) {
        e.stopPropagation();
        e.preventDefault();
      }
    }
  }), /*#__PURE__*/_react["default"].createElement(_ddReactSpringWeb.animated.div, {
    className: "".concat(classPrefix, "-track"),
    style: {
      x: x
    }
  }, (0, _withStopPropagation.withStopPropagation)(props.stopPropagation, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(classPrefix, "-actions ").concat(classPrefix, "-actions-left"),
    ref: leftRef
  }, (_a = props.left) === null || _a === void 0 ? void 0 : _a.map(renderAction))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(classPrefix, "-content"),
    onClickCapture: function onClickCapture(e) {
      if (x.goal !== 0) {
        e.preventDefault();
        e.stopPropagation();
        close();
      }
    }
  }, /*#__PURE__*/_react["default"].createElement(_ddReactSpringWeb.animated.div, {
    ref: animateDivRef
  }, props.children)), (0, _withStopPropagation.withStopPropagation)(props.stopPropagation, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(classPrefix, "-actions ").concat(classPrefix, "-actions-right"),
    ref: rightRef
  }, (_b = props.right) === null || _b === void 0 ? void 0 : _b.map(renderAction))))));
});
SwipeAction.displayName = 'SwipeAction';
var _default = exports["default"] = SwipeAction;