import React, { PropsWithChildren, FC } from 'react';
import './style/index';
import { NativeProps } from '../_internal/native-props';
export type SwitchProps = {
    /**
     * @description 指定当前是否打开
     */
    checked?: boolean;
    /**
     * @description 初始是否打开
     */
    defaultChecked?: boolean;
    /**
     * @description 禁用状态
     */
    disabled?: boolean;
    /**
     * @description 变化时的回调函数
     */
    onChange?: (checked: boolean) => void | Promise<void>;
} & NativeProps;
export declare const Switch: FC<PropsWithChildren<SwitchProps>>;
declare const _default: React.FC<React.PropsWithChildren<SwitchProps>>;
export default _default;
