"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Switch = void 0;
var _react = _interopRequireDefault(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _rmc = require("../rmc");
var _internal = require("../_internal");
var _hooks = require("../hooks");
require("./style/index");
var _index2 = require("../style/index");
var _rmcFeedback = _interopRequireDefault(require("rmc-feedback"));
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var Switch = exports.Switch = function Switch(props) {
  var _a;
  var isMobile = (0, _hooks.useMobile)();
  var disabled = props.disabled,
    className = props.className;
  var _b = (0, _hooks.useControlledByChecked)(props),
    checked = _b.checked,
    onChange = _b.onChange;
  var handleLabelChange = function handleLabelChange(e) {
    var v = e.target.checked;
    onChange(v);
  };
  var wrapCls = (0, _classnames["default"])(_index2.dtMobileSwitchPrefix, className);
  var fakeInputCls = (0, _classnames["default"])("".concat(_index2.dtMobileSwitchPrefix, "-fake"), (_a = {}, _a["".concat(_index2.dtMobileSwitchPrefix, "-fake-disabled")] = disabled, _a["".concat(_index2.dtMobileSwitchPrefix, "-fake-checked")] = checked, _a["".concat(_index2.dtMobileSwitchPrefix, "-fake-desktop-checked")] = !isMobile && checked, _a["".concat(_index2.dtMobileSwitchPrefix, "-fake-desktop")] = !isMobile, _a));
  return (
    /*#__PURE__*/
    // @ts-ignore
    _react["default"].createElement(_rmcFeedback["default"], {
      activeClassName: "".concat(_index2.dtMobileSwitchPrefix, "-active"),
      disabled: disabled
    }, /*#__PURE__*/_react["default"].createElement("div", __assign({
      className: wrapCls
    }, (0, _internal.getDataAttr)(props)), /*#__PURE__*/_react["default"].createElement(_rmc.Labelable, __assign({
      onClick: function onClick(event) {
        return event.stopPropagation();
      },
      onChange: handleLabelChange
    }, _rmc.Labelable.getProps(props), {
      checked: checked,
      type: "checkbox"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: fakeInputCls
    }))))
  );
};
Switch.displayName = 'Switch';
Switch.defaultProps = {
  disabled: false,
  defaultChecked: false
};
var _default = exports["default"] = (0, _rmc.withError)(Switch);