"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classnames = _interopRequireDefault(require("classnames"));
var _react = _interopRequireWildcard(require("react"));
var _hooks = require("../_internal/hooks");
var _tab = require("./tab");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var prefix = 'dtm-';
var TabItem = function TabItem(props, ref) {
  var _a, _b, _c, _d;
  var className = props.className,
    size = props.size,
    itemKey = props.itemKey,
    _e = props.title,
    title = _e === void 0 ? '' : _e,
    _f = props.icon,
    icon = _f === void 0 ? '' : _f,
    children = props.children,
    _g = props.disabled,
    disabled = _g === void 0 ? false : _g,
    others = __rest(props, ["className", "size", "itemKey", "title", "icon", "children", "disabled"]);
  var _h = (0, _react.useContext)(_tab.TabContext),
    activeKey = _h.activeKey,
    change = _h.change,
    fullWidth = _h.fullWidth;
  var active = "".concat(activeKey) === "".concat(itemKey);
  var clsPrefix = "".concat(prefix, "tab-item");
  var curItemId = (0, _hooks.useGuid)('tab-item-');
  var clses = {
    tab: (0, _classnames["default"])(clsPrefix, "".concat(clsPrefix, "--").concat(size), "".concat(clsPrefix, "--").concat(itemKey), (_a = {}, _a["".concat(clsPrefix, "--active")] = active && !disabled, _a["".concat(clsPrefix, "--fullwidth")] = fullWidth, _a["".concat(clsPrefix, "--disabled")] = disabled, _a), className),
    activeLine: "".concat(clsPrefix, "-active-line ").concat(clsPrefix, "-active-line--normal"),
    tabIcon: (0, _classnames["default"])("".concat(clsPrefix, "-icon"), "".concat(clsPrefix, "-icon--").concat(size), (_b = {}, _b["".concat(clsPrefix, "-icon--active")] = active, _b)),
    tabText: (0, _classnames["default"])("".concat(clsPrefix, "-text"), "".concat(clsPrefix, "-text--").concat(size), (_c = {}, _c["".concat(clsPrefix, "-text--active")] = active, _c))
  };
  var renderTitle = function renderTitle() {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: clses.tabText
    }, title);
  };
  var handleClick = function handleClick() {
    if (!disabled) {
      change(itemKey);
    }
  };
  return /*#__PURE__*/_react["default"].createElement("div", __assign({}, others, {
    id: curItemId,
    ref: ref,
    className: clses.tab,
    onClick: handleClick
  }), /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, icon ? {
    icon: icon
  } : null, renderTitle()), /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(clses.activeLine, (_d = {}, _d["".concat(clsPrefix, "-active-line--enter")] = active, _d["".concat(clsPrefix, "-active-line--exit")] = !active, _d))
  }));
};
TabItem.displayName = 'Tab.Item';
var _default = exports["default"] = /*#__PURE__*/(0, _react.forwardRef)(TabItem);