"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prefix = exports["default"] = void 0;
var _classnames = _interopRequireDefault(require("classnames"));
var _react = _interopRequireWildcard(require("react"));
var _CloseOutlined = _interopRequireDefault(require("dingtalk-design-icons/lib/CloseOutlined"));
var _index = require("../style/index");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var prefix = exports.prefix = "".concat(_index.dtMobilePrefix, "-tag");
var Tag = function Tag(props) {
  var className = props.className,
    children = props.children,
    onClose = props.onClose,
    icon = props.icon,
    _a = props.closable,
    closable = _a === void 0 ? false : _a,
    _b = props.size,
    size = _b === void 0 ? 'small' : _b,
    onClick = props.onClick,
    color = props.color;
  var _c = __read((0, _react.useState)(true), 2),
    show = _c[0],
    setShow = _c[1];
  var type = _react["default"].useMemo(function () {
    var _a;
    if (color) {
      switch (color) {
        case 'default':
          return 'normal';
        case 'primary':
          return 'blue';
        case 'success':
          return 'green';
        case 'warning':
          return 'orange';
        case 'danger':
          return 'red';
      }
    }
    return (_a = props.type) !== null && _a !== void 0 ? _a : 'normal';
  }, [props.type, props.color]);
  var style = _react["default"].useMemo(function () {
    if (color && !props.type) {
      return __assign(__assign({}, props.style), {
        color: color
      });
    }
    return props.style;
  }, [props.style, props.type, color]);
  var isFill = _react["default"].useMemo(function () {
    if (props.fill === 'solid') {
      return true;
    } else if (!props.fill && props.size === 'medium') {
      return true;
    }
    return false;
  }, [props.fill, props.size]);
  var wrapCls = (0, _classnames["default"])("".concat(prefix), "".concat(prefix, "-color-").concat(type), isFill && "".concat(prefix, "-fill"), "".concat(prefix, "-").concat(size === 'small' ? 'small' : 'normal'), className);
  var handleClose = (0, _react.useCallback)(function () {
    if (onClose && typeof onClose === 'function') {
      onClose();
    }
    setShow(false);
  }, [onClose]);
  var closeIcon = (0, _react.useMemo)(function () {
    if (!closable) {
      return null;
    }
    return /*#__PURE__*/_react["default"].createElement("span", {
      className: "".concat(prefix, "-icon ").concat(prefix, "-close-icon"),
      onClick: handleClose
    }, /*#__PURE__*/_react["default"].createElement(_CloseOutlined["default"], null));
  }, [closable, handleClose]);
  var tagIcon = (0, _react.useMemo)(function () {
    if (typeof icon === 'undefined') {
      return null;
    }
    if (typeof icon === 'function') {
      return /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefix, "-icon")
      }, icon());
    }
    return /*#__PURE__*/_react["default"].createElement("span", {
      className: "".concat(prefix, "-icon")
    }, icon);
  }, [icon]);
  return show ? (/*#__PURE__*/_react["default"].createElement("div", {
    className: wrapCls,
    onClick: onClick,
    style: style
  }, tagIcon, /*#__PURE__*/_react["default"].createElement("span", {
    className: "".concat(prefix, "-text")
  }, children), closeIcon)) : null;
};
Tag.displayName = 'Tag';
var _default = exports["default"] = Tag;