import React from 'react';
import { render, RenderResult } from '@testing-library/react';
import type { RenderOptions } from '@testing-library/react';
type UI = Parameters<typeof render>[0];
declare const AllTheProviders: ({ children }: {
    children: React.ReactElement;
}) => React.ReactElement<any, string | React.JSXElementConstructor<any>>;
export interface TestOptions extends Omit<RenderOptions, 'wrapper'> {
    wrapper?: typeof AllTheProviders;
}
/**
 * 通过@testing-library/react自定义render
 * @param ui
 * @param param1
 * @returns
 */
export declare const customRender: (ui: UI, { wrapper: Wrapper, ...options }?: TestOptions) => RenderResult;
/**
 * test Accessibility
 * @param ui
 */
export declare const testA11y: (ui: UI | Element) => Promise<void>;
export declare const getStyleAttribute: (selector: string, attr: string) => any;
export {};
