"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clear = clear;
exports.show = show;
var _react = _interopRequireDefault(require("react"));
var _toast = require("./toast");
var _renderImperatively = require("../_internal/render-imperatively");
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var currentHandler = null;
var currentTimeout = null;
function show(props) {
  var element = /*#__PURE__*/_react["default"].createElement(_toast.InternalToast, __assign({}, props, {
    onClose: function onClose() {
      var _a;
      currentHandler = null;
      (_a = props.onClose) === null || _a === void 0 ? void 0 : _a.call(props);
    }
  }));
  if (currentHandler) {
    currentHandler.replace(element);
  } else {
    currentHandler = (0, _renderImperatively.renderImperatively)(element);
  }
  if (currentTimeout) {
    window.clearTimeout(currentTimeout);
  }
  if (props.duration) {
    currentTimeout = window.setTimeout(function () {
      clear();
    }, props.duration * 1000);
  }
  return currentHandler;
}
function clear() {
  currentHandler === null || currentHandler === void 0 ? void 0 : currentHandler.close();
  currentHandler = null;
}