"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.notice = notice;
var _options = require("./api/options");
var _internal = require("../_internal");
var _adapt = require("./adapt");
var _methods = require("./methods");
var defaultConfig = {
  duration: 2,
  mask: false,
  showType: 'inline',
  maskClickable: false
};
function notice(content, type, duration, onClose, mask, position, showType, icon, maskClickable, adapt, getContainer) {
  if (duration === void 0) {
    duration = defaultConfig.duration;
  }
  if (mask === void 0) {
    mask = defaultConfig.mask;
  }
  if (position === void 0) {
    position = _internal.isMobile ? _options.ToastPosition.MIDDLE : _options.ToastPosition.TOP;
  }
  if (showType === void 0) {
    showType = defaultConfig.showType;
  }
  if (icon === void 0) {
    icon = null;
  }
  if (maskClickable === void 0) {
    maskClickable = defaultConfig.maskClickable;
  }
  if (adapt === void 0) {
    adapt = true;
  }
  // PC 端仅在钉钉内部才改变
  if (!_internal.isMobile && _internal.isInDingTalk && adapt) {
    return (0, _adapt.adaptPC)(type, content, position, duration);
  }
  (0, _methods.show)({
    content: content,
    icon: type !== 'config' ? type : icon,
    duration: duration,
    onClose: onClose,
    maskVisible: mask,
    maskClickable: maskClickable,
    showType: showType,
    position: position,
    getContainer: getContainer
  });
}