import React from 'react';
import { PropagationEvent } from '../_internal/with-stop-propagation';
import { GetContainer } from '../_internal/render-to-container';
import { ToastOptions } from './api/options';
export interface ToastProps extends ToastOptions {
    /**
     * @descrption 蒙层是否可以点击
     */
    maskClickable?: boolean;
    /**
     * @descrption 对应的icon
     */
    icon?: 'success' | 'fail' | 'loading' | React.ReactNode;
    /**
     * @descrption 是否展示
     */
    visible?: boolean;
    /**
     * @descrption 是否展示蒙层
     */
    maskVisible?: boolean;
    duration?: number;
    /**
     * @descrption 自定义dom生成位置
     */
    getContainer?: GetContainer;
    /**
     * @descrption 禁止冒泡的事件
     */
    stopPropagation?: PropagationEvent[];
}
export declare const InternalToast: React.FC<ToastProps>;
