"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InternalToast = void 0;
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _WarningFilled = _interopRequireDefault(require("dd-icons/lib/WarningFilled"));
var _AchieveFilled = _interopRequireDefault(require("dd-icons/lib/AchieveFilled"));
var _CheckOutlined = _interopRequireDefault(require("dd-icons/lib/CheckOutlined"));
var _WarningOutlined = _interopRequireDefault(require("dd-icons/lib/WarningOutlined"));
var _HintFilled = _interopRequireDefault(require("dd-icons/lib/HintFilled"));
var _mask = _interopRequireDefault(require("../mask"));
var _withDefaultProps = require("../_internal/with-default-props");
var _spin = _interopRequireDefault(require("../spin"));
var _style = require("../style");
var _CloseOutlined = _interopRequireDefault(require("dd-icons/lib/CloseOutlined"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var prefixCls = "".concat(_style.dtMobilePrefix, "-toast");
var defaultProps = {
  maskClickable: true,
  stopPropagation: ['click']
};
var InternalToast = exports.InternalToast = function InternalToast(p) {
  var props = (0, _withDefaultProps.mergeProps)(defaultProps, p);
  var maskClickable = props.maskClickable,
    content = props.content,
    icon = props.icon,
    position = props.position;
  var iconElement = (0, _react.useMemo)(function () {
    var _a;
    if (!icon) return null;
    switch (icon) {
      case 'success':
        if (props.showType === 'inline') {
          return /*#__PURE__*/_react["default"].createElement(_AchieveFilled["default"], {
            className: "".concat(prefixCls, "-icon-success")
          });
        } else {
          return /*#__PURE__*/_react["default"].createElement(_CheckOutlined["default"], {
            className: "".concat(prefixCls, "-icon-success")
          });
        }
      case 'fail':
        if (props.showType === 'inline') {
          return /*#__PURE__*/_react["default"].createElement(_WarningFilled["default"], {
            className: "".concat(prefixCls, "-icon-fail")
          });
        } else {
          return /*#__PURE__*/_react["default"].createElement(_WarningOutlined["default"], {
            className: "".concat(prefixCls, "-icon-fail")
          });
        }
      case 'loading':
        return /*#__PURE__*/_react["default"].createElement(_spin["default"], {
          className: (0, _classnames["default"])("".concat(prefixCls, "-icon-loading"), (_a = {}, _a["".concat(prefixCls, "-loading-lightning")] = position === 'middle', _a["".concat(prefixCls, "-loading-lightning-top")] = position === 'top', _a))
        });
      case 'info':
        return /*#__PURE__*/_react["default"].createElement(_HintFilled["default"], {
          className: "".concat(prefixCls, "-icon-info")
        });
      default:
        return icon;
    }
  }, [icon]);
  var top = (0, _react.useMemo)(function () {
    switch (position) {
      case 'top':
        return '12%';
      default:
        return '50%';
    }
  }, [position]);
  return /*#__PURE__*/_react["default"].createElement(_mask["default"], {
    visible: props.visible,
    maskShow: props.maskVisible,
    destroyOnClose: true,
    opacity: 0,
    disableBodyScroll: !maskClickable,
    getContainer: props.getContainer,
    afterClose: props.onClose,
    style: {
      pointerEvents: maskClickable ? 'none' : 'auto'
    },
    className: (0, _classnames["default"])("".concat(prefixCls, "-mask"), !!props.getContainer && "".concat(prefixCls, "-mask-inner")),
    stopPropagation: props.stopPropagation
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(props.showType === 'inline' ? "".concat(prefixCls, "-inline") : "".concat(prefixCls, "-normal"), !!props.getContainer ? "".concat(prefixCls, "-inner") : "".concat(prefixCls, "-wrap"))
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      top: top
    },
    className: (0, _classnames["default"])("".concat(prefixCls, "-main"), icon ? "".concat(prefixCls, "-main-icon") : "".concat(prefixCls, "-main-text"))
  }, iconElement && /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-icon")
  }, iconElement), typeof content === 'string' ? (/*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-content")
  }, content)) : content, icon === 'loading' && props.showType === 'inline' && (/*#__PURE__*/_react["default"].createElement(_CloseOutlined["default"], {
    className: "".concat(prefixCls, "-close"),
    onClick: function onClick() {
      var _a;
      return (_a = props.onClose) === null || _a === void 0 ? void 0 : _a.call(props);
    }
  })))));
};