"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _CloseCircleFilled = _interopRequireDefault(require("dingtalk-design-icons/lib/CloseCircleFilled"));
var _list = _interopRequireDefault(require("../list"));
var _hooks = require("../hooks");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var ListItem = /*#__PURE__*/React.forwardRef(function (_a, ref) {
  var _b, _c, _d, _e;
  var prefixCls = _a.prefixCls,
    className = _a.className,
    style = _a.style,
    listType = _a.listType,
    file = _a.file,
    items = _a.items,
    iconRender = _a.iconRender,
    itemRender = _a.itemRender,
    isImgUrl = _a.isImgUrl,
    showRemoveIcon = _a.showRemoveIcon,
    onPreview = _a.onPreview,
    onClose = _a.onClose,
    previewContent = _a.previewContent,
    showPreviewIcon = _a.showPreviewIcon,
    extraRender = _a.extraRender,
    uploadErrorLabel = _a.uploadErrorLabel;
  var isMobile = (0, _hooks.useMobile)();
  var isError = React.useMemo(function () {
    var _a;
    if (((_a = file.error) === null || _a === void 0 ? void 0 : _a.type) === 'error') {
      return true;
    }
    return false;
  }, [file.error]);
  // This is used for legacy span make scrollHeight the wrong value.
  // We will force these to be `display: block` with non `picture`
  var spanClassName = "".concat(prefixCls, "-span");
  var iconNode = iconRender(file);
  var extraNode = extraRender(file);
  var icon = /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-text-icon")
  }, iconNode);
  if (listType === 'picture') {
    if (file.status === 'uploading' || !file.thumbUrl && !file.url) {
      var uploadingClassName = (0, _classnames["default"])((_b = {}, _b["".concat(prefixCls, "-list-item-thumbnail")] = true, _b["".concat(prefixCls, "-list-item-file")] = file.status !== 'uploading', _b));
      icon = /*#__PURE__*/React.createElement("div", {
        className: uploadingClassName
      }, iconNode);
    } else {
      var thumbnail = (isImgUrl === null || isImgUrl === void 0 ? void 0 : isImgUrl(file)) ? (/*#__PURE__*/React.createElement("img", {
        src: file.thumbUrl || file.url,
        alt: file.name,
        className: "".concat(prefixCls, "-list-item-image")
      })) : iconNode;
      var aClassName = (0, _classnames["default"])((_c = {}, _c["".concat(prefixCls, "-list-item-thumbnail")] = true, _c["".concat(prefixCls, "-list-item-file")] = isImgUrl && !isImgUrl(file), _c));
      icon = /*#__PURE__*/React.createElement("a", {
        className: aClassName,
        onClick: function onClick(e) {
          onPreview(file, e);
        },
        href: file.url || file.thumbUrl,
        target: "_blank",
        rel: "noopener noreferrer"
      }, thumbnail);
    }
  }
  var infoUploadingClass = (0, _classnames["default"])((_d = {}, _d["".concat(prefixCls, "-list-item")] = true, _d["".concat(prefixCls, "-list-item-").concat(file.status)] = true, _d["".concat(prefixCls, "-list-item-list-type-").concat(listType)] = true, _d));
  var linkProps = typeof file.linkProps === 'string' ? JSON.parse(file.linkProps) : file.linkProps;
  var removeIcon = showRemoveIcon && (/*#__PURE__*/React.createElement(_CloseCircleFilled["default"], {
    onClick: function onClick() {
      onClose(file);
    }
  }));
  var downloadOrDelete = /*#__PURE__*/React.createElement("span", {
    key: "download-delete",
    className: (0, _classnames["default"])("".concat(prefixCls, "-list-item-card-actions"), {
      picture: listType === 'picture'
    })
  }, removeIcon);
  var listItemNameClass = (0, _classnames["default"])("".concat(prefixCls, "-list-item-name"));
  var preview = /*#__PURE__*/React.createElement(_list["default"].Item, __assign({
    key: "view",
    wrap: true,
    className: listItemNameClass,
    brief: /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-list-item-brief")
    }, extraNode && !isError && (/*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-list-item-size")
    }, extraNode)), isError && (/*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-list-item-error")
    }, uploadErrorLabel || '上传失败')), showPreviewIcon && !isError && (/*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-list-item-brief-preview"),
      onClick: function onClick(e) {
        return onPreview(file, e);
      }
    }, previewContent))),
    extra: downloadOrDelete
  }, linkProps), /*#__PURE__*/React.createElement("p", {
    className: "".concat(prefixCls, "-list-item-title")
  }, file.name));
  var iconAndPreview = /*#__PURE__*/React.createElement("span", {
    className: spanClassName
  }, icon, listType === 'picture' ? downloadOrDelete : preview);
  var dom = /*#__PURE__*/React.createElement("div", {
    className: infoUploadingClass
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-list-item-info")
  }, iconAndPreview));
  var listContainerNameClass = (0, _classnames["default"])("".concat(prefixCls, "-list-").concat(listType, "-container"), className, (_e = {}, _e["".concat(prefixCls, "-list-").concat(listType, "-container-desktop")] = !isMobile, _e));
  return /*#__PURE__*/React.createElement("div", {
    className: listContainerNameClass,
    style: style,
    ref: ref
  }, itemRender ? itemRender(dom, file, items) : dom);
});
var _default = exports["default"] = ListItem;