"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.useForceUpdate = useForceUpdate;
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _LoadingCircularOutlined = _interopRequireDefault(require("dingtalk-design-icons/lib/LoadingCircularOutlined"));
var _utils = require("./utils");
var _ListItem = _interopRequireDefault(require("./ListItem"));
var _style = require("../style");
var _hooks = require("../hooks");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var __read = void 0 && (void 0).__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
function useForceUpdate() {
  var _a = __read(React.useReducer(function (x) {
      return x + 1;
    }, 0), 2),
    forceUpdate = _a[1];
  return forceUpdate;
}
var InternalUploadList = function InternalUploadList(_a, ref) {
  var _b;
  var listType = _a.listType,
    previewFile = _a.previewFile,
    onPreview = _a.onPreview,
    onRemove = _a.onRemove,
    iconRender = _a.iconRender,
    isImgUrl = _a.isImageUrl,
    _c = _a.items,
    items = _c === void 0 ? [] : _c,
    showPreviewIcon = _a.showPreviewIcon,
    showRemoveIcon = _a.showRemoveIcon,
    itemRender = _a.itemRender,
    previewContent = _a.previewContent,
    extraRender = _a.extraRender,
    uploadErrorLabel = _a.uploadErrorLabel,
    extra = _a.extra;
  var forceUpdate = useForceUpdate();
  var isMobile = (0, _hooks.useMobile)();
  React.useEffect(function () {
    if (listType !== 'picture') {
      return;
    }
    (items || []).forEach(function (file) {
      if (typeof document === 'undefined' || typeof window === 'undefined' || !window.FileReader || !window.File || !(file.originFileObj instanceof File || file.originFileObj && file.originFileObj instanceof Blob) || file.thumbUrl !== undefined) {
        return;
      }
      file.thumbUrl = '';
      if (previewFile) {
        previewFile(file.originFileObj).then(function (previewDataUrl) {
          // Need append '' to avoid dead loop
          file.thumbUrl = previewDataUrl || '';
          forceUpdate();
        });
      }
    });
  }, [listType, items, previewFile]);
  // ============================= Events =============================
  var onInternalPreview = function onInternalPreview(file, e) {
    if (!onPreview) {
      return;
    }
    e.preventDefault();
    return onPreview(file);
  };
  var onInternalClose = function onInternalClose(file) {
    onRemove === null || onRemove === void 0 ? void 0 : onRemove(file);
  };
  var internalExtraRender = function internalExtraRender(file) {
    if (extraRender) {
      return extraRender(file, listType);
    }
    return file.size ? (0, _utils.formatBytes)(file.size) : '';
  };
  var getFileIcon = React.useCallback(function (file) {
    var cls = "".concat(_style.dtUploadPrefix, "-list-icon");
    switch (file.type) {
      case 'application/zip':
        return "".concat(cls, "-zip");
      case 'image/png':
      case 'image/jpg':
      case 'image/jpeg':
        return "".concat(cls, "-image");
      case 'application/pdf':
        return "".concat(cls, "-pdf");
      case 'video/mp4':
        return "".concat(cls, "-video");
      default:
        return "".concat(cls, "-default");
    }
  }, []);
  var internalIconRender = function internalIconRender(file) {
    if (iconRender) {
      return iconRender(file, listType);
    }
    var isLoading = file.status === 'uploading';
    var icon = isLoading ? (/*#__PURE__*/React.createElement(_LoadingCircularOutlined["default"], {
      className: "".concat(_style.dtUploadPrefix, "-loading")
    })) : (/*#__PURE__*/React.createElement("div", {
      className: (0, _classnames["default"])("".concat(_style.dtUploadPrefix, "-list-icon"), getFileIcon(file))
    }));
    return icon;
  };
  // Test needs
  React.useImperativeHandle(ref, function () {
    return {
      handlePreview: onInternalPreview
    };
  });
  var listClassNames = (0, _classnames["default"])((_b = {}, _b["".concat(_style.dtUploadPrefix, "-list")] = true, _b["".concat(_style.dtUploadPrefix, "-list-picture-desktop")] = !isMobile && listType === 'picture', _b["".concat(_style.dtUploadPrefix, "-list-").concat(listType)] = true, _b));
  return /*#__PURE__*/React.createElement("div", {
    className: listClassNames
  }, items.map(function (item) {
    return /*#__PURE__*/React.createElement(_ListItem["default"], {
      prefixCls: _style.dtUploadPrefix,
      key: item.uid,
      file: item,
      isImgUrl: isImgUrl,
      items: items,
      listType: listType,
      showPreviewIcon: showPreviewIcon,
      previewContent: previewContent,
      showRemoveIcon: showRemoveIcon && !item.disableRemove,
      iconRender: internalIconRender,
      itemRender: itemRender,
      extraRender: internalExtraRender,
      onPreview: onInternalPreview,
      onClose: onInternalClose,
      uploadErrorLabel: uploadErrorLabel
    });
  }), extra);
};
var UploadList = /*#__PURE__*/React.forwardRef(InternalUploadList);
UploadList.displayName = 'UploadList';
UploadList.defaultProps = {
  listType: 'text',
  showRemoveIcon: true,
  showPreviewIcon: true,
  previewFile: _utils.previewImage,
  isImageUrl: _utils.isImageUrl
};
var _default = exports["default"] = UploadList;